'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 54,121,360,495,635,970,1362,1416,1600,1696,1952,2024,2172
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--Inc--PRO
'<SMARTFORMAT OFF> do not remove !!!
'
'#################################################################
'#                        ADwin-X.inc                            #
'#              INCLUDE-file for ADwin-X-system                  #
'#################################################################
'#                                                               #
'# Contents: Definition of functions and procedures              #
'#           to access ADwin PRO SYSTEM                          #
'#                                                               #
'#  17.11.2016  mf   creation                                    #
'#  22.02.2017  mf   can                                         #
'#  16.03.2017  mf   rs232                                       #
'#  05.07.2017  mf   LSBus, DAC                                  #
'#  24.07.2017  mf   CAN Baudrate                                #
'#  07.09.2017  mf   ADC                                         #
'#  03.08.2017  mf   LS BUS                                      #
'#  15.09.2017  mf   CNT                                         #
'#  19.09.2017  mf   SSI                                         #
'#  22.09.2017  mf   OUTFIFO                                     #
'#  28.09.2017  mf   syncall                                     #
'#  09.01.2018  mf   M40                                         #
'#  25.06.2018  mf                                               #
'#  25.07.2018  ol   PROFINET-IRT                                #
'#  11.10.2018  ol   ETHERCAT                                    #
'#  11.10.2018  ol   ETHERCAT Zusammenfhrung mit PROFINET-IRT   #
'#  08.01.2019  ol   ETHERCAT Bug behoben bei Datentyperkennung  #
'#  14.02.2019  jk   comment at Set_LED()                        #
'#  14.08.2019  mf   #if make_lib                                #
'#  01.12.2019  mf   new Write_DAC32,DAC32                       #
'#  17.04.2020  mf   bugfix SSI_Set_Clock                        #
'#  17.04.2020  ol   bugfix Profinet/1*64 DWORDS                 #
'#  08.06.2020  ol   bugfix Profinet/1*32 DWORDS                 #
'#  10.09.2020  ks   Description corrected for ADwinC            #
'#  25.01.2021  mf   new function Calc_TicksToNs                 #
'#                                                               #
'# Attention:                                                    #
'#   - Do not copy the first source line (containing             #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                #
'#     Otherwise the Syntax color may be not correct.            #
'#   - This include file requires ADbasic 5 or higher!           #
'#                                                               #
'#################################################################
import ADwin-X-LIB.1.LIC
#include ADwin-X-Globals.inc

#if adwin_system = ADwin_X
#else
#error("This include file can only be used with the ADwin-X")
#endif


'<REGION> Define

'#define SYST_CPU 50000000H


'#define CPU_DIG_ADR 50002100H       
'#define CPU_DIG_ADR1 50002200H     
'#define CPU_DIG_CONFIG 50002000H


#define CAN_SRR 0  ''<HIDE> 
#define CAN_MSR 4  ''<HIDE> 
#define CAN_BRPR 8  ''<HIDE> 
#define CAN_BTR 12  ''<HIDE> 
#define CAN_ECR 10H  ''<HIDE> 
#define CAN_ESR 14H  ''<HIDE> 
#define CAN_SR 18H  ''<HIDE> 
#define CAN_ISR 1CH  ''<HIDE> 
#define CAN_IER 20H  ''<HIDE> 
#define CAN_ICR 24H  ''<HIDE> 
#define CAN_TCR 28H  ''<HIDE> 
#define CAN_WIR 2CH  ''<HIDE> 
#define CAN_TXFIFO_ID 30H   ''<HIDE> 
#define CAN_TXFIFO_DLC 34H  ''<HIDE> 
#define CAN_TXFIFO_Data1 38H  ''<HIDE> 
#define CAN_TXFIFO_Data2 3CH  ''<HIDE> 
#define CAN_TXHPB_ID 40H   ''<HIDE> 
#define CAN_TXHPB_DLC 44H   ''<HIDE> 
#define CAN_TXHPB_DATA1 48H  ''<HIDE> 
#define CAN_TXHPB_DATA2 4CH   ''<HIDE> 
#define CAN_RXFIFO_ID 50H  ''<HIDE> 
#define CAN_RXFIFO_DLC 54H   ''<HIDE> 
#define CAN_RXFIFO_DATA_1 58H  ''<HIDE> 
#define CAN_RXFIFO_DATA_2 5CH   ''<HIDE> 
#define CAN_AFR 60H   ''<HIDE> 
#define CAN_AFMR1 64H   ''<HIDE> 
#define CAN_AFIR1 68H  ''<HIDE> 
#define CAN_AFMR2 6CH  ''<HIDE> 
#define CAN_AFIR2 70H  ''<HIDE> 
#define CAN_AFMR3 74H  ''<HIDE> 
#define CAN_AFIR3 78H  ''<HIDE> 
#define CAN_AFMR4 7CH  ''<HIDE> 
#define CAN_AFIR4 80H  ''<HIDE> 
'

#define SYSTEM_LSBUS_TX_FIFO_COUNT 5C510150h '<HIDE> ' tx FIFO count
#define SYSTEM_LSBUS_TX_FIFO_WR 5C510100h '<HIDE>' tx FIFO write
#define SYSTEM_LSBUS_RX_FIFO_COUNT 5C510120h '<HIDE> 'RX fifo count
#define SYSTEM_LSBUS_RX_FIFO_READ 5C510100h '<HIDE>



#define SYSTEM_BUS_SLEEP 0500ff1f0h '<HIDE>

'''array of 11 elements, holding a CAN message:
'''+  1..8: data bytes 
'''+     9: number (0..8) of used data bytes
'''+    10: CAN identifier (11 bit or 29 bit)
'''+    11: receive time stamp (16 bit)

#If MAKE_LIB = OFF Then
dim CAN_Msg[11] as long
DIM PWM_help_mode as long '<HIDE>
#EndIf

'<ENDREGION>

'<REGION> System

'******************************************************************************
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'******************************************************************************
SUB SUB_BEGIN_CRITICAL_SECTION() ''<HIDE>
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
ENDSUB

SUB SUB_END_CRITICAL_SECTION() ''<HIDE>
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
ENDSUB


SUB SUB_BEGIN_CRITICAL_SECTION_LOW() ''<HIDE>
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION_LOW  
#ENDIF
ENDSUB
  
SUB SUB_END_CRITICAL_SECTION_LOW() ''<HIDE>
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION_LOW
#ENDIF
ENDSUB


Sub System_Array_Debug_Check(array[], startindex, length)  '<HIDE>
#IF DEBUG_MODE = ON THEN
  if ((startindex) + (length) - 1 > Get_Array_Length(array)) then
    PROZESS_FEHLER = 0C1000000H or Get_Array_No(array)
    end_exit
  endif
  ''  
  if ((startindex) < 1) then 
    PROZESS_FEHLER = 0C2000000H or Get_Array_No(array)
    end_exit
  endif
#endif
ENDSUB

SUB System_ADR_Debug_CHECK32(startadr,length,minadr,max_length,errno) '<HIDE>
#IF DEBUG_MODE = ON THEN
  
  if (startadr<minadr) then 
    PROZESS_FEHLER=222000+errno
    end_exit
  endif 
  
  if (startadr+length*4>minadr+max_length*4) then 
    PROZESS_FEHLER=221000+errno    
    end_exit
  endif
  
#endif
ENDSUB

 
sub System_ADC_Variante_Debug_Check(select_value) '<HIDE>
 
#IF DEBUG_MODE = ON THEN
 
  dim system,cnt as long
  dim int_value as long
  dim icnt, i as long
  dim opt as long
  
  opt=System_GET_Option()
  system= shift_right(opt,20) AND 11B 'as long ''<HIDE>
  if (system=1) then 
    cnt=8
  else
    if (system=0) then 
      cnt=1
    else
      if (system=2) then 
        cnt=2
      else
        cnt=4
      endif
    endif
  endif
  
  if (opt AND 100B=0) then cnt=0
  
  int_value=select_value AND 0FFH
  icnt=0
  for i=0 to 7
    icnt=icnt+(shift_right(int_value,i) AND 1) 
  next
  
  if (icnt>cnt) then 
    prozess_fehler=223001   
  endif
  
#endif

endsub


Function SizeOfArrayElement(array[]) As Long '<HIDE>
  SizeOfArrayElement = 1
  If (if_type_byte(array) = 1) then SizeOfArrayElement = 1
  If (if_type_short(array) = 1) then SizeOfArrayElement = 2
  If (if_type_long(array) = 1) then SizeOfArrayElement = 4
  If (if_type_float(array) = 1) then SizeOfArrayElement = 8 ' double!
  If (if_type_float32(array) = 1) then SizeOfArrayElement = 4
EndFunction


FuncTION SYSTEM_SET_CALIBRATION_TO_Factory_Default() as long ''<HIDE> ''0=ok 
  dim buffer[9000] as long
  SYSTEM_SET_CALIBRATION_TO_Factory_Default=SYSTEM_SET_CALIBRATION_TO_Factory_Default_LIB(buffer)
ENDFUNCTION  
  
**************************************************************
''' Converts a process frequency [Hz] into processor ticks (processdelay or cycle time).
''' frequency:  frequency[Hz]
'''*************************************************************
Function Calc_Processdelay(frequency) as long
  calc_processdelay=666666666.6666666666/(frequency)
endfunction


'***************************************************************
''' Converts timer ticks into ns
''' ticks: counter value ticks into ns
'''*************************************************************
Function Calc_TicksToNs(ticks) As float
  dim t1 as long
  t1=ticks  ' important because: if the argument "ticks" is a subtraction of 2 timer values, this substraction is hereby forced to be done in long arithmetics
  Calc_TicksToNs=t1*1.5
endfunction



 
'******************************************************************************
''' Switches one LED on or off. 
'''  led_no: 1..3 
'''+ LED 1 is used by the ADwin operating system.
'''+   After power-on, LED 1 is red, after the "Boot" the LED 1 is blinking green.
'''+   (If you want to use LED 1 for an other purpose, you first have to stop the 
'''+   blinking process with the command Stop_Process(15) ).
'''+ LED 2 ,3 is reserved for customer.
'''  value:  0: off 
'''+         1: green
'''+         2: red
'''+         3: orange 
'''****************************************************************************
SUB Set_LED(led_no,value)
  
  if (led_no=1) then 
    POKE(50001100h, value)
  else
    if (led_no=2) then
      POKE(5C001110h, value)
    else
      POKE(5C001120h, value)
    endif
  endif
ENDSUB


******************************************************************************
'''Returns the status of a LED.
'''+ return value:
'''+         0: off 
'''+         1: green
'''+         2: red
'''+         3: orange 
''' led_no: 1..3 
'''****************************************************************************
FUNCTION Check_LED(led_no) AS Long
  if (led_no=1) then 
    CHECK_LED = (PEEK_P2(50001100h) and 11B)
  else
    if (led_no=2) then 
      CHECK_LED=Peek_P2(5C001110h)
    else
      CHECK_LED=Peek_P2(5C001120h)
    endif
  endif  
ENDFUNCTION

'******************************************************************************
'''Configures the external Event input.
'''min_hold: Minimum time, which an event signal after an edge must be held to be accepted.
'''+         0: 15 ns (default)
'''+         1: 50 ns
'''edge: 
'''+         1: rising edge (default)
'''+         2: falling edge
'''+         3: rising & falling edge
'''prescaler: 1..15 (default 1)
'''****************************************************************************
SUB CPU_Event_Config(min_hold, edge, prescaler)
  DIM old AS Long
  DIM new AS Long
  old = peek_P2(50003000h) AND 7FFFFF00H
  new = shift_left((min_hold AND 1), 31) or (edge AND 3) or (shift_left(prescaler, 4)) or old
  poke(50003000h, new)
ENDSUB

'******************************************************************************
''' Starts specified actions synchronously
''' pattern: Bit pattern selecting the actions (see below) to be started.
'''+  Bit=1: start action synchonously; Bit=0: no effect.
'''+        Bit  0: start ADC conversion, single shot
'''+        Bit  1: start ADC conversion, continuous mode
'''+        Bit  2: Start DAC1 + DAC2 conversion with values of DAC registers
'''+        Bit  3: Transfer status of DIO31:DIO00 to input latch 1
'''+        Bit  4: Transfer status of DIO61:DIO32 to input latch 2
'''+        Bit  5: Write latch 1 to DIO31:DIO00
'''+        Bit  6: Write Latch 2 to DIO61:DIO32
'''+        Bit  7: Start edge output on output FIFO 1
'''+        Bit  8: Start edge output on output FIFO 2
'''+        Bit  9: Clear edge output on output FIFO 1
'''+        Bit 10: Clear edge output on output FIFO 2
'''+        Bit 11: Clear edge detection of input FIFO 1
'''+        Bit 12: Clear edge detection of input FIFO 2
'''+        Bit 13: Clear reference counter of input FIFO 1
'''+        Bit 14: Clear reference counter of input FIFO 2
'''+        Bit 15: Set all counters to zero
'''+        Bit 16: Latch all counter values to buffers
'''+        Bit 17: Start SSI (single shot)
'''****************************************************************************
SUB Sync_All(pattern)
  Poke(5C00e000h,pattern)
endsub


'<ENDREGION>

'<REGION> CAN
*************************************************************************
''' Sets a register of the CAN interface.
''' channel: number of the CAN interface on the CAN module
''' regno: register which should be set (relative address)
''' value: value which should be written to the register.
'''****************************************************************************
Sub CAN_Set_Reg(channel, regno, value) '<HIDE>
  poke(0E0007000H + (regno)+((channel)*1000H),value)
EndSub


'******************************************************************************
''' Reads a register of the CAN interface.
'''+ return value: value of the register
''' channel: number of the CAN interface on the CAN module
''' regno: register to read (relative address)
'''****************************************************************************
Function CAN_Get_Reg(channel, regno) As Long '<HIDE>
  CAN_Get_Reg=peek_P2(0E0007000H + (regno)+((channel)*1000H))
EndFunction  




'******************************************************************************
''' Initializes a CAN interface and sets the baudrate of the CAN bus.
'''+return value: Status of initialization
'''+         0: baudrate is set
'''+         1: selected baudrate is not set
'''+        -1: no can option on this board
'''channel: number (1..2) of the CAN interface
'''+(also necessary if the only one channel is available)
'''baudrate: CAN bus baudrate in bit/second
'''*****************************************************************************
Function CAN_Init(channel, baudrate) as long
  CAN_INIT=CAN_INIT_LIB(channel,baudrate)
ENDFUNCTION


'******************************************************************************
''' sets a receive filter for CAN messages with a selected identifier.
'''+return value:    0: filter ist set.
'''+               <>0: error (no filter is set).
''' channel:         number (1..2) of the CAN interface
''' filter_no:       number (1..4) of the receive filter
''' filter_enable:   Filter status
'''+                 0: disable filter.
'''+                 1: enable filter.
''' id:              identifier of CAN messages which can be received
''' id_extend:       identifier length
'''+                 0: 11 bit, 1: 29 bit
'''*****************************************************************************
function CAN_RX_Set_Filter(channel, filter_no, filter_enable, id, id_extend) as long
  dim _AFRo as long
  dim fb as long
  dim ret as long
  dim _to as long
  dim _t as long

  _AFRo = CAN_Get_reg(channel, CAN_AFR)
  CAN_Set_reg(channel, CAN_AFR, 0)                          ' all Filter disable
  _to = 0
  do
    inc _to
    ret = shift_right(CAN_Get_reg(channel, CAN_SR), 11) and 1  ' check disable ca 120nsec
  until ((ret = 0) or (_to = 100))                          ' ca. 0.012ms TO

  if (ret = 0) then                                         'OK
    if (id_extend = 1) then                               ' 29bit
      CAN_Set_reg(channel, 5CH + ((filter_no) * 8), 0FFFFFFFFh)  'set AFMRx 1..4
      _t = shift_left(id, 21)
      _t = _t or shift_left(1, 20)                          ' SRR
      _t = _t or shift_left(1, 19)                          ' IDE
      _t = _t or (shift_left(shift_right((id and 1FFFF800h), 11), 1))  'ext,18)

      CAN_SET_reg(channel, 60H + ((filter_no) * 8), _t)        'set AFIRx 1..4             
      
    else
      CAN_Set_reg(channel, 5CH + ((filter_no) * 8), 0FFF80000h)  'set AFMRx 1..4
      _t = shift_left(id, 21)
      CAN_SET_reg(channel, 60H + ((filter_no) * 8), _t)        'set AFIRx 1..4             
    endif
    fb = shift_left(1, (filter_no) - 1)
    if (Filter_Enable = 0) then 
      _AFRo = _AFRo AND Not(fb)                             ' disable
    else 
      _AFRo = _AFRo or fb                                   ' enable
    endif
    CAN_Set_reg(channel, CAN_AFR, _AFRo)
    CAN_RX_Set_Filter = 0
  else 
    CAN_Set_reg(channel, CAN_AFR, _AFRo)
    CAN_RX_Set_Filter = -1                                  ' disable not possible
  endif
endfunction



'*******************************************************************************
''' Reads the oldest CAN message from the receive FIFO or returns -1.
'''+The CAN message (if any) is returned in CAN_Msg[].
'''+         Content of CAN_MSG[]:
'''+         [1..8]: CAN data
'''+         [9]: length of CAN Message
'''+         [10]: identifier
'''+         [11]: timestamp of receipt
'''+return value:
'''+         -1: no message in the receive FIFO
'''+        <>-1: identifier of CAN message
''' channel: number (1..2) of CAN interface
'''*****************************************************************************
Function CAN_Receive(channel) as long
  CAN_Receive=CAN_Receive_lib(channel,can_msg)
ENDFUNCTION


'*******************************************************************************
''' Transmits the message in CAN_Msg[] to the send FIFO.
'''+return value: Transmit status
'''+          -1: buffer full, transmit message later.
'''+           0: message is transmitted to send FIFO.
''' channel: number (1..2) of CAN interface
''' priority: Transmit priority
'''+           0: Normal priority, message is sent via output FIFO
'''+           1: High  priority, message is to be sent next
''' id_extend: identifier length
'''+           0: 11 bit, 1: 29 bit
'''****************************************************************************
Function CAN_Transmit(channel, priority, id_extend) as long
  CAN_Transmit=CAN_Transmit_lib(channel,priority,id_extend,can_msg)
endfunction

'<ENDREGION>

'<REGION> RS232
*************************************************************************
''' Sets a register of the RS controller.
''' channel: (1) number of the RS interface
''' regno: register which should be set (relative address)
''' value: value which should be written to the register.
'''****************************************************************************
Sub RS_Set_Reg(channel, regno, value) ''<HIDE>
  poke(0DFFFF000H + (regno)+((channel)*1000H),value)
EndSub


'******************************************************************************
''' Reads a register of the RS controller.
'''+ return value : value of the register
''' channel: 1 number of the RS interface 
''' regno: register to read (relative address)
'''****************************************************************************
Function RS_Get_Reg(channel, regno) As Long ''<HIDE>
  RS_Get_Reg=peek_P2(0DFFFF000H + (regno)+((channel)*1000H))
EndFunction  


'******************************************************************************
'''Initializes a RS232 interface.
'''channel: number (1) of the RS232 interface
'''baud_rate: Baudrate (35..115200) for RS232 communication
'''+        typical rates: 115200, 57600, 38400, 19200, 9600
'''+                         4800,  2400,  1200,   600,  300
'''+        other baudrates possible
'''parity: use of test bits
'''+          0: no parity
'''+          1: even
'''+          2: odd
'''bits: Number (6..8) of data bits for RS232 comunication
'''stop: number of stop bits
'''+          0: 1 stop bit
'''+          1: 1.5 stop bits 
'''+          2: 2 stop bits 
'''handshake: transfer protocol
'''+          0: RS232, no handshake
'''****************************************************************************
sub RS_Init(channel, baud_rate, parity, bits, stop, handshake)
  RS_Init_lib(channel,  baud_rate, parity, bits, stop, handshake) 
endsub


  


'******************************************************************************
'''Writes a byte to the transmit FIFO, if the FIFO is not full.
'''+return value:
'''+write_fifo: 
'''+            0 = byte is written
'''+            1 = FIFO full
'''channel: (1) number of the serial interface 
'''value: value which should be written to the FIFO
'''****************************************************************************
function RS_Write_FIFO(channel, value) as Long
  '
  dim status as long
  
  status=RS_Get_Reg(channel, 2CH) AND 10000B 'status
  if (status>0) then 
    RS_Write_FIFO=1
  else
    RS_Set_Reg(channel, 30H, value) 'write fifo          
    RS_Write_FIFO=0
  endif
    
endfunction


'******************************************************************************
'''Checks if write fifo is full.
'''+ return value:
'''+             0->one or more byte in write fifo is free
'''+             1->FIFO full
'''channel:(1) number of the serial interface
'''***************************************************************
function RS_Write_FIFO_Full(channel) as Long
  dim status as long
  status=RS_Get_Reg(channel, 2CH) AND 10000B 'status
  
  if (status>0) then 
    RS_Write_FIFO_Full=1
  else 
    RS_Write_FIFO_Full=0
  endif
endfunction


'******************************************************************************
'''Checks if write fifo is empty
'''+ return value:
'''+             0->one or more byte in write fifo or shift_register
'''+             1->FIFO and output shift_register empty
'''channel: (1) number of the serial interface
'''***************************************************************
function RS_Write_FIFO_Empty(channel) as Long
  dim status as long
  dim empty as long
  dim shift_register as long
  status=RS_Get_Reg(channel, 2CH) 'status
  empty=status AND 1000B '0 = not empty
  shift_register=shift_right(status,11) AND 1  
  
  if ((empty>0) AND (shift_register=0)) then 
    RS_Write_FIFO_Empty=1
  else 
    RS_Write_FIFO_Empty=0
  endif
endfunction

'******************************************************************************
'''Reads byte from the receive FIFO return value:
'''+read_fifo: 
'''+        0 - 255 = value of the received byte
'''+       -1 = no bytes in the receive FIFO
'''channel: (1) number of the serial interface 
'''****************************************************************************
function RS_Read_FIFO(channel) as Long
 
  dim status as long
  
  status=RS_Get_Reg(channel, 2CH) AND 10B 'status
  
  
  if (status>0) then 
    RS_Read_FIFO=-1
  else
    RS_Read_FIFO=RS_Get_Reg(channel, 30H) 'read fifo
  endif
endfunction



'<ENDREGION>

'<REGION> ADC 
'******************************************************************************
''' Samples, converts and reads out the digital 16 bit ADC-value.
'''+ Attention:                                                 
'''+ This instruction is not prepared to handle an access from  
'''+ a low AND high priority process to the same module.     
'''+ result: 16 bit Long
''' channel: channel number of analog input 1..8
'''****************************************************************************
FUNCTION ADC(channel) as Long
 
  Start_Conv(shift_left(1,(channel)-1),0,1)
 
  Wait_EOC()
  ADC=Read_ADC(channel)

ENDFUNCTION


*****************************************************************************
'''Samples, converts and reads out the digital ADC-value of channel 1-8
'''+ and transfers the input data from channel 1..8 to an array.
'''+ result: 16 bit Long      
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB ADC8(array[], array_idx)
 
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 8)
  
  Start_Conv(0FFH,0,1)
  
  Wait_EOC()
  Read_ADC8_Lib(array,array_idx)
ENDSUB


*****************************************************************************
'''Samples, converts and reads out the digital ADC-value of channel 1-4 or 5-8
'''+ and transfers the input data to an array.
'''+ result: 16 bit Long      
'''array[]: destination array
'''array_idx: start index at the destination array
'''channel_select: 
'''+0 = channels 1..4
'''+1 = channels 5..8
'''*****************************************************************************
SUB ADC4(array[], array_idx, channel_select)
    
  System_Array_Debug_Check(array, array_idx, 4)
  
  if (channel_select=1) then 
    Start_Conv(0F0H,0,1)
  
    Wait_EOC()
    Read_ADC4_Lib(array,array_idx,1)
  else
    Start_Conv(0FH,0,1)
  
    Wait_EOC()
    Read_ADC4_Lib(array,array_idx,0)
  endif
  
ENDSUB



*****************************************************************************
'''Samples, converts and reads the selected digital ADC-value
'''+ and transfers the input data to an array.
'''+ result: 16 bit Long      
'''array[]: destination array
'''array_idx: start index at the destination array
'''channel_select: 
'''+0 = channels 1..2
'''+1 = channels 3..4
'''+2 = channels 5..6
'''+3 = channels 7..8
'''*****************************************************************************
SUB ADC2(array[], array_idx,channel_select)
  System_Array_Debug_Check(array, array_idx, 2)
  Start_Conv(shift_left(11B,(channel_select)*2),0,1)
  Wait_EOC()
  Read_ADC2_Lib(array,array_idx,(channel_select))
ENDSUB

*****************************************************************************
'''Samples, converts and reads out the digital ADC-value of channel 1-8
'''+ and transfers the input data from channel 1..8 to an array.
'''+ result: 24 bit Long      
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB ADC8_24(array[], array_idx)
 
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 8)
  
  Start_Conv(0FFH,0,1)
  
  Wait_EOC()
  
  array[array_idx]=Read_ADC24(1)
  array[array_idx+1]=Read_ADC24(2)
  array[array_idx+2]=Read_ADC24(3)
  array[array_idx+3]=Read_ADC24(4)
  array[array_idx+4]=Read_ADC24(5)
  array[array_idx+5]=Read_ADC24(6)
  array[array_idx+6]=Read_ADC24(7)
  array[array_idx+7]=Read_ADC24(8)
ENDSUB


*****************************************************************************
'''Samples, converts and reads out the digital ADC-value of channel 1-4 or 5-8
'''+ and transfers the input to an array.
'''+ result: 24 bit Long      
'''array[]: destination array
'''array_idx: start index at the destination array
'''channel_select: 
'''+0 = Channel 1 - Channel 4
'''+1 = Channel 5 - Channel 8
'''*****************************************************************************
SUB ADC4_24(array[], array_idx,channel_select)
 
  System_Array_Debug_Check(array, array_idx, 4)
  if (channel_select=1) then
    Start_Conv(0F0H,0,1)
    Wait_EOC()
    array[array_idx]=Read_ADC24(5)
    array[array_idx+1]=Read_ADC24(6)
    array[array_idx+2]=Read_ADC24(7)
    array[array_idx+3]=Read_ADC24(8)
  else
    Start_Conv(0FH,0,1)
    Wait_EOC()
    array[array_idx]=Read_ADC24(1)
    array[array_idx+1]=Read_ADC24(2)
    array[array_idx+2]=Read_ADC24(3)
    array[array_idx+3]=Read_ADC24(4)
  endif
  
ENDSUB



*****************************************************************************
'''Samples, converts and reads the selected digital ADC-value
'''+ and transfers the input data to an array.
'''+ result: 24 bit Long      
'''array[]: destination array
'''array_idx: start index at the destination array: 
'''channel_select: 
'''+0 = Channel 1 - Channel 2
'''+1 = Channel 3 - Channel 4
'''+2 = Channel 5 - Channel 6
'''+3 = Channel 7 - Channel 8
'''*****************************************************************************
SUB ADC2_24(array[], array_idx,channel_select)
   
  dim off as long
  
  System_Array_Debug_Check(array, array_idx, 2)
  Start_Conv(shift_left(11B,(channel_select)*2),0,1)
  off=channel_select*2
  Wait_eoc()
  array[array_idx]=Read_ADC24(1+off)
  array[array_idx+1]=Read_ADC24(2+off)  
ENDSUB




'******************************************************************************
''' Samples, converts and reads out the digital 18 bit ADC-value.                                                     
'''+ result: 24 bit Long
''' channel: channel number of analog input 1..8
'''****************************************************************************
FUNCTION ADC24(channel) as Long  
  Start_Conv(shift_left(1,(channel)-1),0,1)
 
  Wait_EOC()
  ADC24=Read_ADC24(channel)
  
ENDFUNCTION



'*****************************************************************************
'''Transfers the input data from channel 1..8 to an array.
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB Read_ADC8(array[], array_idx)    
  System_Array_Debug_Check(array, array_idx, 8)
  Read_ADC8_Lib(array,array_idx)
ENDSUB




'*****************************************************************************
'''Transfers the input data from channel 1..8 to an array.
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB Read_ADC8_24(array[], array_idx)
  System_Array_Debug_Check(array, array_idx, 8)
  array[array_idx]=Read_ADC24(1)
  array[array_idx+1]=Read_ADC24(2)
  array[array_idx+2]=Read_ADC24(3)
  array[array_idx+3]=Read_ADC24(4)
  array[array_idx+4]=Read_ADC24(5)
  array[array_idx+5]=Read_ADC24(6)
  array[array_idx+6]=Read_ADC24(7)
  array[array_idx+7]=Read_ADC24(8)
ENDSUB







'*****************************************************************************
'''Transfers the input data from channel  
''' channel: 1..8 channel number of analog input 
'''*********************************************
Function Read_ADC(channel) as long  
  Read_ADC=peek_p2(5C310000h+((channel)-1)*16)   
endfunction
  

'*****************************************************************************
'''Transfers the input data from channel
''' channel: channel number of analog input
'''+        1= Channel 1 low 16 bit , 2 high 16 bit
'''+        2= Channel 3 low 16 bit , 4 high 16 bit
'''+        3= Channel 5 low 16 bit , 6 high 16 bit
'''+        4= Channel 7 low 16 bit , 8 high 16 bit
'''*********************************************
Function Read_ADC_Packed(channel) as long    
  Read_ADC_packed=peek_p2(5C320000h+((channel)-1)*16)   
endfunction
  

'*****************************************************************************
'''Transfers the input data from channel 1..8 
''' channel: channel number of analog input
'''*********************************************
Function Read_ADC24(channel) as long 
  Read_ADC24=peek_p2(5C300000h+((channel)-1)*16) 
endfunction


  
'******************************************************************************
''' Waits until EOC-signals of ADC are active.
'''****************************************************************************
SUB Wait_EOC()
  Dim reminder as Long
  do
    reminder =peek_p2(5C380000h) 'and 1
  until (reminder <> 0)
ENDSUB


'******************************************************************************
''' Starts a conversion on selected ADC.
''' channel_select: each bit corresponds to a channel 
''' gain:  
'''+       0 = factor 1 (+-10V)
'''+       1 = factor 2 (+-5V)
'''mode: 
'''+        1 start single shot mode
'''+        2 start continuous mode
SUB Start_Conv(channel_select,gain,mode)
  
  dim help as long
  
  help=shift_left(((channel_select) AND 0FFH),8) or  ((mode) AND 11B)
  
  if (gain=1) then 
    help=help or shift_left(0101010101010101B ,16)
  endif
  
  poke(5C380100h,help) '  
  
  System_ADC_Variante_Debug_Check(channel_select)
  
ENDSUB

'******************************************************************************
''' Starts a conversion on selected ADC.
''' channel_select: each bit corresponds to a channel 
''' gain_select: 
'''+00 +- 10V
'''+01 +-5V 
'''+10 reserved
'''+11 reserved
'''+ Bit 0,1 =Channel 1 
'''+ Bit 2,3= Channel 2
'''+ Bit 4,5= Channel 3
'''+ Bit 6,7= Channel 4
'''+ Bit 8,9= Channel 5
'''+ Bit 10,11=channel 6
'''+ Bit 12,13=channel 7
'''+ Bit 14,15=channel 8 
'''mode: 
'''+        1 start single shot mode
'''+        2 start continuous mode
SUB Start_Conv_PGA(channel_select,gain_select,mode)
  
  dim help as long
  
  help=shift_left(((channel_select) AND 0FFH),8) or  ((mode) AND 11B)
  
  
  help=help or shift_left(gain_select,16)
   
  poke(5C380100h,help) '  
  
  System_ADC_Variante_Debug_Check(channel_select)
  
ENDSUB




  
'<ENDREGION>  

'<REGION> Digital 

'******************************************************************************
''' Initializes the digital I/O module
''' pattern: 
'''+ 0 = input
'''+ 1 = output
'''+ Bit 0 set DIO 0..7
'''+ Bit 1 set DIO 8..15
'''+ Bit 2 set DIO 16..23
'''+ Bit 3 set DIO 24..31
'''+ Bit 4 set DIO 32..35
'''+ Bit 5 set DIO 36..39
'''+ Bit 6 set DIO 40
'''+ Bit 7 set DIO 41
'''****************************************************************************
SUB Conf_DIO(pattern)
  POKE (5C141000h, pattern) 
ENDSUB

******************************************************************************
''' Sets the digital outputs (bits 0..31).
''' pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_Long1(pattern)
  POKE (5C100000h, pattern) 
ENDSUB

******************************************************************************
''' Sets the digital outputs (bits 32..44).
''' pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_Long2(pattern)
  POKE (5C100004h, pattern) 
ENDSUB

'******************************************************************************
''' Reads the digital inputs (channel 0 - 31).
'''****************************************************************************
FUNCTION Digin_Long1() as Long
  digin_Long1 =  Peek_P2(5C101000h)
ENDFUNCTION

'******************************************************************************
''' Reads the digital inputs (channel 32 - 64).
'''****************************************************************************
FUNCTION Digin_Long2() as Long
  digin_Long2 =Peek_P2(5C101004h)
ENDFUNCTION

***************************************************************************
'''Sets output register (channel 0..31).
'''pattern: each bit corresponds to a channel
'''*****************************************************************************
SUB Digout_Write_Latch1(pattern)
  POKE (5C100100h, pattern) 
ENDSUB


***************************************************************************
'''Sets output register (channel 32..64).
'''pattern: each bit corresponds to a channel
'''*****************************************************************************
SUB Digout_Write_Latch2(pattern)
  POKE (5C100104h, pattern) 
ENDSUB



'******************************************************************************
'''Reads the input latch register (channel 0..31).
'''****************************************************************************
FUNCTION Digin_Read_Latch1() AS Long
  Digin_Read_Latch1 = Peek_P2(5C101100h)
ENDFUNCTION


'******************************************************************************
'''Reads the input latch register (channel 32..64).
'''****************************************************************************
FUNCTION Digin_Read_Latch2() AS Long
  Digin_Read_Latch2 = Peek_P2(5C101104h)
ENDFUNCTION



'******************************************************************************
'''Latches the digital I/O module.
'''+ Inputs are latched in the input registers
'''+ Outputs are set according to the output register.
'''pattern: 
'''+ Bit 0 latch input Bits   0..31  read_latch 1 
'''+ Bit 1 latch input Bits  32..63 read_latch 2 
'''+ Bit 2 latch output Bits  0..31 write_latch 1 
'''+ Bit 3 latch output Bits 32..63 write_latch 2
'''******************************************************************************
SUB Dig_Latch(pattern)
  Poke(5C00e000h,shift_left(((pattern) AND 1111B),3))
ENDSUB




'******************************************************************************
''' Sets or resets one channel of a digital output.
''' channel: channel (0..63)
''' value: 
'''+    0 = reset channel
'''+    1 = set channel
'''****************************************************************************
SUB Digout(channel, value)
  if (channel>31) then
    if (value AND 1 = 1) then
      POKE (5C100204h, shift_left(1, ((channel)-32))) 
    else
      POKE (5C100214h, shift_left(1, ((channel)-32))) 
    endif
  else
    if (value AND 1 = 1) then
      poke(5C100200h, shift_left(1, channel))
    else
      poke(5C100210h, shift_left(1, channel))
    endif  
  endif
ENDSUB

'---------------------------------------------------------------
''' Sets and resets selected digital outputs.(bits 0..31).
''' set:    Bitstring indicating the outputs which should be set
''' clear:  Bitstring indicating the outputs which should be reset
'''-------------------------------------------------------------
Sub Digout_Bits1(set, clear)
  poke(5C100200h, set)
  poke(5C100210h, clear)
EndSub

'---------------------------------------------------------------
''' Sets and resets selected digital outputs.(bits 32..).
''' set:    Bitstring indicating the outputs which should be set
''' clear:  Bitstring indicating the outputs which should be reset
'''-------------------------------------------------------------
Sub Digout_Bits2(set, clear)
  poke(5C100204h, set)
  poke(5C100214h, clear)
EndSub

'******************************************************************************
''' Reads the input of one digital input 
'''channel_no: Number (0.63) of digital input.
'''****************************************************************************
FUNCTION Digin(channel_no) as Long
  if (channel_no>31) then 
    Digin=shift_right( Peek_P2(5C101004h), (channel_no)-32) AND 1
  else
    Digin=shift_right( Peek_P2(5C101000h), (channel_no)) AND 1
  endif
ENDFUNCTION

'******************************************************************************
''' Reads back of the output value of the digital outputs (bits 0..31).
'''****************************************************************************
FUNCTION Get_Digout_long1() AS Long
  Get_DIGOUT_long1 =Peek_P2(5C100000h)
ENDFUNCTION

'******************************************************************************
''' Reads back of the output value of the digital outputs (bits 32..63).
'''****************************************************************************
FUNCTION Get_Digout_long2() AS Long
  Get_DIGOUT_long2 = Peek_P2(5C100004h)
ENDFUNCTION

''******************************************************************************
''''Clears the Digin Fifo.
'''fifo_nr: 1..2 
'''****************************************************************************
SUB Digin_FIFO_Clear(fifo_nr)
  if (fifo_nr=1) then 
    Poke(5C148800h, 1B) 'FIFO clear 
  else
    Poke(5C148804h, 1B) 'FIFO clear 
  endif  
ENDSUB

'******************************************************************************
'''Clears the Digout Fifo.
'''fifo_nr: 1..2 
'''****************************************************************************
SUB Digout_FIFO_Clear(fifo_nr) 

  if (fifo_nr=1) then 
    Poke(5C148800h, 10B) 'FIFO clear 
  else
    Poke(5C148804h, 10B) 'FIFO clear 
  endif  
    
ENDSUB

'******************************************************************************
'''Enables the Digin Fifo.
'''fifo_nr: 1..2 
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digin_FIFO_Enable(fifo_nr,pattern)
  if (fifo_nr=1) then 
    Poke(5C148900h, pattern) 
  else
    Poke(5C148904h, pattern) 
  endif

ENDSUB

'******************************************************************************
'''Determines which input channels the edge detection unit will be monitored.
'''fifo_nr: 1..2 
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB Digout_FIFO_Enable(fifo_nr,pattern)
  if (fifo_nr=1) then 
    Poke(5C148A00h, pattern) 
  else
    Poke(5C148A04h, pattern)
  endif
  
ENDSUB

'******************************************************************************
'''Returns the number of saved value pairs in the FIFO of the edge detection unit.
'''fifo_nr: 1..2
'''****************************************************************************
FUNCTION Digin_FIFO_Full(fifo_nr) as Long
  if (fifo_nr=1) then 
    Digin_FIFO_Full=peek_p2(5C148800H)  AND 0FFFFH
  else
    Digin_FIFO_Full=peek_p2(5C148804H)  AND 0FFFFH
  endif
ENDFUNCTION

'******************************************************************************
'''Returns the number of free value pairs in the edge output FIFO.
'''fifo_nr: 1..2
'''****************************************************************************
FUNCTION Digout_FIFO_Empty(fifo_nr) as Long
  if (fifo_nr=1) then 
    Digout_FIFO_Empty=peek_p2(5C148820H)
  else
    Digout_FIFO_Empty=peek_p2(5C148824H)
  endif
ENDFUNCTION

'******************************************************************************
'''Sets the FIFO operation mode: 
'''fifo_nr: 1..2
'''value:
'''+    1 Use FiFo as Output absolute
'''+    2 reserved 
'''+    3 Use FiFo as Output relative
'''****************************************************************************
SUB Digout_FIFO_Mode(fifo_nr,value)

  if (fifo_nr=1) then  
    POKe(5C148700H,value)
  else
    POKe(5C148704H,value)
  endif
ENDSUB

******************************************************************************
'''Starts the output pattern.
''' fifo_pattern: 
'''+ Bit 0 FIFO 1 
'''+ Bit 1 FIFO 2
'''****************************************************************************
SUB Digout_FIFO_Start(fifo_pattern)
  'poke (5C148600H,fifo_pattern)
  Poke(5C00e000h,shift_left(((fifo_pattern) AND 11B),7))
ENDSUB

'******************************************************************************
'''Reads one value pair from the FIFO of the edge detection unit and writes them into 2 variables.
'''fifo_nr: 1..2
'''value_by_ref: Variable where the level status bit pattern is written
'''+Each level status bit corresponds to a digital input (see table below).
'''timestamp_by_ref: Variable where the time stamp is written.
'''****************************************************************************
'''#C;P2:BR;P3:BR;
SUB Digin_FIFO_Read(fifo_nr,value_by_ref,timestamp_by_ref)

  
  if (fifo_nr=1) then 
    value_by_ref=peek_p2(5c103100H) 
    timestamp_by_ref=peek_p2(5c103100H) 
  else
    value_by_ref=peek_p2(5c103104H) 
    timestamp_by_ref=peek_p2(5c103104H) 
  endif

ENDSUB

**************************************************************************
'''Writes value pairs into the output edge FIFO.
'''fifo_nr: 1..2
'''value: Variable where the level status bit pattern is written
'''timestamp: Variable where the time stamp is written
'''****************************************************************************
SUB Digout_FIFO_Write(fifo_nr,value,timestamp)

  if (fifo_nr=1) then 
    Poke(5C103100H,value)
    Poke(5C103100H,timestamp)
  else
    Poke(5C103104H,value)
    Poke(5C103104H,timestamp)
  endif

ENDSUB

''******************************************************************************
'''Reads the 100 MHz FIFO Timer. 
'''fifo_nr: 1..2
'''+In difference to the TiCo timer, this timer will not be set to 0 while core reset.
'''******************************************************************************
FUNCTION Digin_FIFO_Read_Timer(fifo_nr) AS LONG
  
  if (fifo_nr=1) then 
    Digin_FIFO_Read_Timer = peek_p2(5c103110H) 
  else
    Digin_FIFO_Read_Timer = peek_p2(5c103114H) 
  endif

ENDFUNCTION

''******************************************************************************
'''Reads the 100 MHz FIFO Timer. 
'''fifo_nr: 1..2
'''+In difference to the TiCo timer, this timer will not be set to 0 while core reset.
'''******************************************************************************
FUNCTION Digout_FIFO_Read_Timer(fifo_nr) AS LONG
  
  if (fifo_nr=1) then 
    Digout_FIFO_Read_Timer = peek_p2(5c103120H) 
  else
    Digout_FIFO_Read_Timer = peek_p2(5c103124H) 
  endif

ENDFUNCTION
  
''******************************************************************************
'''Sets spike filter for all digin
''' filter_value: Filtering duration, given in cycles (1..65535) of 20 ns length.
'''+ The value 0 disables the filter.
'''+ The filtering duration should be a bit longer than the expected width of spikes.
''''****************************************************************************
SUB Digin_Filter_Init(filter_value)
  Poke(5C148760h, Filter_value) 
  io_sleep(14)
ENDSUB

*************************************************************************
'''Reads the latch registers for detection of rising or falling edges
'''+occured on the digital inputs (channel 0 - 31).
'''+(These registers are cleared on reading)
'''edge:
'''+     0 latch register for the falling edges
'''+     1 latch register for the rising edges
'''****************************************************************************
FUNCTION Digin_Edge1(edge) AS Long
  if (edge = 1) then
    Digin_Edge1=peek_p2(5c103000H) ' read lath register for rising edges
  else
    Digin_Edge1=peek_p2(5c103010H) '  ...  for falling edges
  endif
ENDFUNCTION

*************************************************************************
'''Reads the latch registers for detection of rising or falling edges
'''+occured on the digital inputs (channel 32 - 63).
'''+(These registers are cleared on reading)
'''edge:
'''+     0 latch register for the falling edges
'''+     1 latch register for the rising edges
'''****************************************************************************
FUNCTION Digin_Edge2(edge) AS Long
  if (edge = 1) then
    Digin_Edge2=peek_p2(5c103004H)' read lath register for rising edges
  else
    Digin_Edge2=peek_p2(5c103014H) '  ...  for falling edges
  endif
ENDFUNCTION

'<ENDREGION>

'<REGION> DAC

'******************************************************************************
''' Converts the digitial value to an analog output.
''' dac_no: channel number of analog output
''' value:  output value (0..65535)
'''****************************************************************************
SUB DAC(dac_no, value)
  POKE ((5C422FF0h + (dac_no) * 16) , value) 
ENDSUB

'******************************************************************************
''' Sets DAC-register to desired value.
''' dac_no: channel number of analog output
''' value:  output value (0..65535)
'''****************************************************************************
SUB Write_DAC(dac_no, value)
  POKE ((5C421FF0h + (dac_no) * 16), value) 
ENDSUB

*****************************************************************************
''' Sets DAC-register to desired value.
''' value: output value 32Bit  (channel 1 Bit 0...15 channel 2 Bit 16..31)
'''******************************************************************************
SUB Write_DAC32(value)
  poke (5C424000h,value)
endsub  

'******************************************************************************
''' Converts the digitial value to an analog output.
''' value: output value 32Bit  (channel 1 Bit 0...15 channel 2 Bit 16..31)
'''****************************************************************************
SUB DAC32(value)
  poke (5C425000h,value)
endsub

'******************************************************************************
''' Simultaneously starts conversion of all DACs.
'''****************************************************************************
SUB Start_DAC()
  POKE (5C470020h, 0)
ENDSUB

'******************************************************************************
''' Converts the digitial value to an 12 Bit analog output.
''' dac_no: channel number of analog output (1..2)
''' value:  output value (0..65535)
'''****************************************************************************
SUB DAC12(dac_no,value)   
  poke(5C423004h+((dac_no)-1)*16,value)
ENDSUB

'<ENDREGION>

'<REGION> LS-BUS 


'******************************************************************************
'''Resets the watchdog timer, sets digital outputs and
'''+reads digital inputs.
'''+Return: state of digital outputs and inputs
'''+ ls_module: device nr lsbus (FIX 1)
'''value: each bit corresponds to a channel
'''****************************************************************************
Function LS_Dig_IO(value) As Long

  Dim cnt_i As Long
  dim invalue as long
  invalue=0
  For cnt_i = 0 To 24 step 8           
    invalue=invalue OR Shift_left( Peek_p2(SYSTEM_LSBUS_RX_FIFO_READ),cnt_i)          ' rx data read
  Next cnt_i
  LS_Dig_IO = invalue
                                               
  I_Send_BC8(44h, 1) ' WD trigger

  I_Send_NA32(1, 7Ch,value)                         ' channel 1..32
  LS_Read_Req(1, 7Ch, 4)                           ' request new in data
EndFunction

'******************************************************************************
'''Enables, disables and configures the watchdog.
'''+Return: error code (0->ok)
'''ls_module: device nr lsbus (1..15)
'''enable:  
'''+           0->disable
'''+           1->enable
'''time:  trigger time [ms]
'''****************************************************************************
Function LS_Watchdog_Init(ls_module, enable, time) As Long
  Dim ld[2] As Long
  Dim ret, t As Long

  ld[1] = 0ADh   'Watchdog disable
  ld[2] = 0
  ret = I_Send( ls_module, 45h, 2, ld)
  'Watchdog time
  t = time * 40000                                          't = time / 25e-6

  ret = ret Or (I_Send32( ls_module, 48h,t))
  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable And 1
  LS_Watchdog_Init = ret Or (I_Send(ls_module, 45h, 2, ld))
  LS_Watchdog_Init  = LS_Watchdog_Init  AND NOT(8)
EndFunction

'******************************************************************************
'''Resets the watchdog timer.
'''+If the watchdog is activated, the user program has to call
'''+this function at least every ....
'''****************************************************************************
Sub LS_Watchdog_Reset()
  I_Send_BC8(44h, 1)
EndSub

'******************************************************************************
'''Initializes a digital I/O module (channel 0 - 31).
'''+Return: error code (0->ok)
'''ls_module: module address on the LS bus (1..15)
'''value: each bit corresponds to 8 channel
'''+           0 -> input
'''+           1 -> output
'''+           bit 0: channels 1..8
'''+               1: channels 9..16
'''+               2: channels 17..24
'''+               3: channels 25..32
'''****************************************************************************
Function LS_DigProg(ls_module, value) As Long
  Dim ld[2] As Long 
  Dim ret As Long

  ld[1] = (Shift_Left(value, 3) And 8h) OR (Shift_Left(value, 7) And 80h) OR 11H
  ld[2] = (Shift_Left(value, 2) And 8h) OR (Shift_Left(value, 6) And 80h) OR 11H
  ret = I_Send(ls_module, 16h, 2, ld)
  ld[1] = (Shift_Left(value, 1) And 8h) Or (Shift_Left(value, 5) And 80h) OR 11H
  ld[2] = (value And 8h) OR (Shift_Left(value, 4) And 80h) OR 11H
  LS_DigProg = ret Or (I_Send(ls_module, 20h + 16h, 2, ld))
EndFunction

'******************************************************************************
'''Sets or clears all digital outputs (channel 0..31).
'''ls_module: module address on the LS bus (1..15)
'''value: each bit corresponds to a channel
'''****************************************************************************
Sub LS_Digout_Long(ls_module, value)
  I_Send_NA32(ls_module, 7Ch, value)                 ' channel 1..32
EndSub

'******************************************************************************
'''Sets or clears all digital outputs (channel 0..31) and returns the bus error status.
'''ls_module: module address on the LS bus (1..15)
'''pattern: Bit pattern, setting the digital outputs.
'''+    Bit=0: Set output to level Low.
'''+    Bit=1: Set output to level High.
'''+    Bit 0..31 = channel 1..32
'''bus_stat: Error Code 0=OK
'''****************************************************************************
Sub LS_Digout_Long_BS(ls_module, pattern, bus_stat)
  BUS_Stat=I_Send32(ls_module, 7Ch, pattern)                 ' channel 1..32
EndSub

'******************************************************************************
'''Reads the digital inputs (channel 0 - 31).
'''+return value: state of digital outputs and inputs
'''+    Bit=0: Input has level Low.
'''+    Bit=1: Input has level High.
'''ls_module: module address on the LS bus (1..15)
'''****************************************************************************
Function LS_Digin_Long(ls_module) As Long
  Dim ret As Long
  ret = I_Receive32(ls_module, 7Ch,LS_Digin_Long )
EndFunction

'******************************************************************************
'''Reads the digital inputs (channel 0 - 31) and returns the bus error status.
'''+return value: state of digital outputs and inputs
'''+    Bit=0: Input has level Low.
'''+    Bit=1: Input has level High.
'''ls_module: module address on the LS bus (1..15)
'''bus_stat: Error Code 0=OK 
'''****************************************************************************
Function LS_Digin_Long_BS(ls_module,bus_stat) As Long
  BUS_Stat = I_Receive32(ls_module, 7Ch,LS_Digin_Long_BS)
EndFunction

'******************************************************************************
'''Reads the digital output status (overcurrent) (channel 0 - 31)
'''+Return: each bit corresponds a channel 0 = OK 1 = Error
'''ls_module: device nr lsbus
'''****************************************************************************
Function LS_Get_Output_Status(ls_module) As Long
  Dim t As Long
  t = I_Receive32(ls_module, 50h, LS_Get_Output_Status)
EndFunction

'******************************************************************************
'''Initializes an LS-Module.
'''+Return: error code (0->ok)
'''ls_module: module address on the LS bus (1..15)
'''****************************************************************************
Function LS_DIO_Init(ls_module) As Long
  Dim ld[4] As Long
  Dim ret As Long
  Dim addr As Long
  
  Poke(5C510130h, 1)                    ' ' autoreset rx ON
  io_sleep(14)
  ld[1] = 3
  ret = I_Send(ls_module, 40h, 1, ld)              ' Reset JX 1, 2
  ld[1] = 1
  ret = ret Or (I_Send(ls_module, 5Ch, 1, ld))     ' timeout reset
  ld[1] = 4
  ret = ret Or (I_Send(ls_module, 4Ch, 1, ld))     ' Set default direction time
  ld[1] = 0
  ld[2] = 0
  ld[3] = 0
  ld[4] = 0
  LS_DIO_Init = ret Or (I_Send(ls_module, 50h, 4, ld))  ' overcurrent reset
  ld[1] = 30h
  LS_DIO_Init = ret Or (I_Send(ls_module, 43h, 1, ld))  ' overtemperature reset
  
  LS_DIO_Init =LS_DIO_Init AND NOT(8)
  
EndFunction

'******************************************************************************
'''Reset the LS - Controller
'''****************************************************************************
SUB LS_Reset() 
  Poke(5C510110h, 11B)                    'clear rx und tx
  io_sleep(30)
  Poke(5C510130h, 1)                    ' ' autoreset rx ON
ENDSUB


'<ENDREGION>

'<REGION> eMMC
Function EMMC_Write_Internal(start_sector, sector_count, source_array[], array_idx) As Long '<HIDE>
  Dim ValuesPerSector, remaining_sectors, current_sector, current_sector_count, current_array_start_index As Long
  
  ValuesPerSector = EMMC_SECTOR_SIZE / SizeOfArrayElement(source_array)
  remaining_sectors = sector_count
  current_sector = start_sector
  current_array_start_index = array_idx
  EMMC_Write_Internal = 0
  
#IF DEBUG_MODE = ON THEN 
  If (start_sector < 0) then prozess_fehler = 200411
  System_Array_Debug_Check(source_array, array_idx, (sector_count * ValuesPerSector))
#endif
  
  Do
    ' write max 128 sectors in each run
    current_sector_count = Min_Long(remaining_sectors, EMMC_TRANSACTION_MAX_SECTORS)
    EMMC_Write_Internal = Int_Emmc_Write_Long(source_array[current_array_start_index], current_sector, current_sector_count)
#IF DEBUG_MODE = ON THEN 
    If (EMMC_Write_Internal = EMMC_RET_INVALID_SECTOR) then prozess_fehler = 200410
#endif

    ' update array pointer
    current_array_start_index = current_array_start_index + ValuesPerSector * current_sector_count
    ' update sector pointer
    current_sector = current_sector + current_sector_count
    remaining_sectors = remaining_sectors - current_sector_count
  Until ((remaining_sectors <= 0) or (EMMC_Write_Internal <> 0))
EndFunction


'*******************************************************************************
''' Writes values to eMMC.
'''+ return value: 
'''+    EMMC_RET_OK              (0) - Access was OK
'''+    EMMC_RET_ACCESS_ERROR    (1) - Read or Write error
'''+    EMMC_RET_INVALID_SECTOR  (4) - Invalid sector
'''+    EMMC_RET_NOT_AVAILABLE (100) -  option not available on this hardware
''' start_sector: 0 to EMMC_SECTORS_MAX
''' sector_count: Number of sectors to be written. A sector contains EMMC_SECTOR_SIZE bytes.
''' source_array[]: Array from which data is read.
''' array_idx: Index (1..n) of the first array element to be transferred.
'''*****************************************************************************
Function EMMC_Write(start_sector, sector_count, source_array[], array_idx) As Long
#IF DEBUG_MODE = ON THEN 
  If (start_sector < 0) then prozess_fehler = 200411
#endif
  If (start_sector >= 0) Then
    EMMC_Write = EMMC_Write_Internal(start_sector, sector_count, source_array, array_idx)
  EndIf
EndFunction


'*******************************************************************************
''' Reads values from eMMC.
'''+ return value: 
'''+    EMMC_RET_OK              (0) - Access was OK
'''+    EMMC_RET_ACCESS_ERROR    (1) - Read or Write error
'''+    EMMC_RET_INVALID_SECTOR  (4) - Invalid sector
'''+    EMMC_RET_NOT_AVAILABLE (100) -  option not available on this hardware
''' start_sector: 0 to EMMC_SECTORS_MAX
''' sector_count: Number of sectors to be read. A sector contains EMMC_SECTOR_SIZE bytes.
''' dest_array[]: Array to which data is written.
''' array_idx: Index (1..n) of the first array element to be written.
'''*****************************************************************************
Function EMMC_Read(start_sector, sector_count, dest_array[], array_idx) As Long
  Dim ValuesPerSector, remaining_sectors, current_sector, current_sector_count, current_array_start_index As Long
  
  ValuesPerSector = EMMC_SECTOR_SIZE / SizeOfArrayElement(dest_array)
  remaining_sectors = sector_count
  current_sector = start_sector
  current_array_start_index = array_idx
  EMMC_Read = 0
  
#IF DEBUG_MODE = ON THEN 
  If (start_sector < 0) then prozess_fehler = 200401
  System_Array_Debug_Check(dest_array, array_idx, (sector_count * ValuesPerSector))
#endif
  
  Do
    ' read max 128 sectors in each run
    current_sector_count = Min_Long(remaining_sectors, EMMC_TRANSACTION_MAX_SECTORS)
    EMMC_Read = Int_Emmc_Read_Long(dest_array[current_array_start_index], current_sector, current_sector_count)
#IF DEBUG_MODE = ON THEN 
    If (EMMC_Read = EMMC_RET_INVALID_SECTOR) then prozess_fehler = 200400
#endif
    ' update array pointer
    current_array_start_index = current_array_start_index + ValuesPerSector * current_sector_count
    ' update sector pointer
    current_sector = current_sector + current_sector_count
    remaining_sectors = remaining_sectors - current_sector_count
  Until ((remaining_sectors <= 0) or (EMMC_Read <> 0))
EndFunction
'<ENDREGION>

'<REGION> CNT 

'******************************************************************************
'''Sets mode for counter.
'''channel: number of the counter 1..7
'''mode:
'''+   Bit 0 CNT MODE
'''+           0->TAKT/Richtung
'''+           1->AB
'''+   Bit 1 CLEAR MODE
'''+           0->normal mode
'''+           1->clear IF A=1 B=1 C=1
'''+   Bit 2 INV CLK
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 3 INV DIR
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 4 CLEAR or LATCH
'''+           0->C use for clear
'''+           1->C use for latch
'''+   Bit 5 Ext Clear/Latch Enable
'''+           0=disable
'''+           1=enable
'''+   Bit 6 PWM reference edge
'''+           0->positive
'''+           1->negative
'''+   Bit 7, 8 PWM INPUT_SELECT
'''+           00->A
'''+           01->B
'''+           10->C
'''****************************************************************************
SUB Cnt_Mode(channel, mode)
#If MAKE_LIB = ON Then
  #error("CNT_Mode does NOT work in Libraries!")
#else
  
  DIM modei as Long
  poke(5C2109F0h + (channel) * 16, mode)
  modei = shift_right(mode, 6) AND 1
  PWM_help_mode = ((NOT(shift_left(1, channel - 1))) AND PWM_help_mode) OR shift_left(modei, channel - 1)
#endif
ENDSUB

'******************************************************************************
''' Activates or deactivates counter.
''' pattern: Bit 0-6 VR counter E
'''****************************************************************************
SUB Cnt_Enable(pattern)
  poke(5C210B50h, pattern)
ENDSUB


'******************************************************************************
''' Activates or deactivates PW counter.
''' pattern: Bit 0-6 PW counter 
'''****************************************************************************
SUB Cnt_PW_Enable(pattern)
  poke(5C210B60h, pattern)
ENDSUB

'******************************************************************************
''' Reads vr-latch register.
''' channel: number of the counter
'''****************************************************************************
FUNCTION Cnt_Read_Latch(channel) as Long
  CNT_READ_LATCH = peek_P2(5C20FF60h + (channel) * 256)
ENDFUNCTION

'******************************************************************************
''' Latches vr-counter to vr-latch and read vr-latch register (counter value).
''' channel: number of the counter
'''****************************************************************************
FUNCTION Cnt_Read(channel) as Long
  poke(5C210B00h, shift_left(1, channel - 1))
  CNT_READ = peek_p2(5C20FF60h + (channel) * 256)
ENDFUNCTION

'******************************************************************************
''' Clears counter.
''' pattern: each bit corresponds to a counter
'''****************************************************************************
SUB Cnt_Clear(pattern)
  poke(5C210B10h,pattern) ' shift_left(pattern, 8) AND 0FF00H)
ENDSUB

'******************************************************************************
''' Reads the status of a counter input.
'''+ return:
'''+Bit 0= A Input
'''+Bit 1= B Input
'''+Bit 2= C/L Input
'''+Bit 3=Cable error
'''+Bit 4=Phase error
''' channel: number of the counter
'''****************************************************************************
FUNCTION Cnt_Get_Status(channel) as Long
  cnt_get_status=peek_P2(5C20FFF0h + (channel) * 256)
ENDFUNCTION

'******************************************************************************
'''Reads a register.
'''channel: 1..7
'''regnr: 0 pos_pwm_latch 1
'''+        1 pos_pwm_latch 2
'''+        2 pos_pwm_latch 3
'''+        3 neg_pwm_latch 1
'''+        4 neg_pwm_latch 2
'''+        5 neg_pwm_latch 3
'''+        6 vr latch
'''+        7 pwm latch shadow
'''+        8 pos_pwm_latch 1 shadow
'''+        9 pos_pwm_latch 2 shadow
'''+        10 pos_pwm_latch 3 shadow
'''+        11 neg_pwm_latch 1 shadow
'''+        12 neg_pwm_latch 2 shadow
'''+        13 neg_pwm_latch 3 shadow
'''+        14 vr_latch shadow
'''+        15 status
'''****************************************************************************
FUNCTION Cnt_Read_Int_Register(channel, regnr) as Long
  Cnt_Read_Int_Register = peek_P2(5C20FF00h +  (channel) * 256 + (regnr) * 16)
ENDFUNCTION



'******************************************************************************
''' Latches vr-counter to vr-latch.
''' pattern: each bit corresponds to a counter
'''****************************************************************************
SUB Cnt_Latch(pattern)
  poke(5C210B00h, pattern)
ENDSUB


'******************************************************************************
''' Copies pw-latches and vr-latches to shadow register.
''' pattern: each bit corresponds to a counter
'''****************************************************************************
SUB Cnt_PW_Latch(pattern)
  poke(5C210B20h,pattern) ' shift_left((pattern) AND 0FH, 24))
ENDSUB

'******************************************************************************
''' Does two steps (at one timestep):
'''+ 1. latches vr-counter to vr-latch
'''+ 2. copies pw-latches and vr-latches to shadow registers
''' pattern: each bit corresponds to a counter
'''****************************************************************************
SUB Cnt_Sync_Latch(pattern)
  poke(5c210CF0h,pattern) 
ENDSUB

'******************************************************************************
''' Reads registers and calculates pw frequency and dutycycle.
'''+ Remark: use cnt_pw_latch before (to get actual values)
'''channel: PWM counter number: 1..7.
'''frequency: Frequency in Hertz: 0.023 Hz..20 MHz (float constant)
'''dutycycle: Duty cycle in percent: 0.0 .. 100.0 (float constant)
'''****************************************************************************
'''#C;P2:F;P2:BR;P3:F;P3:BR;
SUB Cnt_Get_PW(channel, frequency, dutycycle) 

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long

  DIM period as Long
  DIM pulse as Long
  DIM ref_edge as Long

#If MAKE_LIB = ON Then
  #error("CNT_Get_PW does NOT work in Libraries!")
#else

  pos3 = peek_P2(5C20FFA0h + (channel) * 256) '
  neg3 = peek_p2(5C20FFD0h + (channel) * 256) '

  ref_edge = shift_right(PWM_help_mode, channel - 1) AND 1

  IF (ref_edge = 1) then                                    'negative reference edge
    neg2 = peek_p2(5C20FFC0h + (channel) * 256) '
    period = neg2 - neg3
    pulse = neg2 - pos3
  ELSE                                                      'positive reference edge
    pos2 = peek_p2(5C20FF90h + (channel) * 256) '
    
    period = pos2 - pos3
    pulse = neg3 - pos3
  ENDIF

  if (period <> 0) then
    frequency = 100000000 / period                          'Frequenz [Hz] '100 MHz
    dutyCycle = pulse * 100 / (period)                      'PWM Verhltnis
  else
    frequency = 0
    dutyCycle = 0
  endif
  
#endif
  
ENDSUB

'******************************************************************************
''' Reads registers and calculates pw hightime and lowtime.
'''+ Remark: use cnt_pw_latch before (to get actual values)
''' channel: PWM counter number: 1..7.
''' hightime: Pulse duration in units of 10 ns: PWM high level time
''' lowtime: Pulse period in units of 10 ns: PWM low level time
'''****************************************************************************
'''#C;P2:BR;P3:BR;
SUB Cnt_Get_PW_HL(channel, hightime, lowtime)

#If MAKE_LIB = ON Then
  #error("CNT_Get_PW_HL does NOT work in Libraries!")
#else

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long

  ' DIM period as Long
  DIM pulse as Long
  DIM pause as Long
  DIM ref_edge as Long


  pos3 = peek_P2(5C20FFA0h + (channel) * 256) '
  neg3 = peek_p2(5C20FFD0h + (channel) * 256) '
  
  
  
  ref_edge = shift_right(PWM_help_mode, channel - 1) AND 1

  IF (ref_edge = 1) then                                    'negative reference edge
    '  period=neg2-neg3
    neg2 = peek_p2(5C20FFC0h + (channel) * 256) '
    pulse = neg2 - pos3
    pause = pos3 - neg3
  ELSE                                                      'positive reference edge
    ' period=pos2-pos3
    pos2 = peek_p2(5C20FF90h + (channel) * 256) '
    pulse = neg3 - pos3
    pause = pos2 - neg3
  ENDIF
  hightime = pulse
  lowtime = pause
  
#endif
  
ENDSUB

'<ENDREGION>

'<REGION> SSI 
'******************************************************************************
''' Reads SSI encoder value 32 Bit.
''' dcdr_no: number of the ssi decoder (1)
'''****************************************************************************
FUNCTION SSI_Read(dcdr_no) AS long
  SSI_Read = Peek_P2 (5C2107C0h + ((dcdr_no)-1) * 16)
ENDFUNCTION

'******************************************************************************
''' Sets the number of databits for the SSI Interface.
''' dcdr_no: number of the ssi decoder (1)
''' no_bits: number of bits (1..32)
'''****************************************************************************
SUB SSI_Set_Bits(dcdr_no, no_bits)
  POKE ((5C210C30h + ((dcdr_no)-1) * 16) , no_bits)
ENDSUB

'******************************************************************************
''' Sets frequency of the SSI clock.
''' dcdr_no: number of the ssi decoder (1)
''' prescale: frequency = 25MHZ / value
'''****************************************************************************
SUB SSI_Set_Clock(dcdr_no,prescale)
  POKE ((5C210C20h+(dcdr_no)-1) , prescale)
ENDSUB

'******************************************************************************
''' Starts the SSI interface.
''' pattern: Bit pattern each bit corresponds to one ssi counter
'''****************************************************************************
SUB SSI_Start(pattern)
  POKE (5C210C00h, pattern)
ENDSUB

'******************************************************************************
''' Sets the SSI mode.
''' pattern: Bit pattern each bit corresponds to one counter
'''+         0 = single start mode
'''+         1 = continuous start mode
'''****************************************************************************
sub SSI_Mode(pattern)
  POKE (5C210C10h , pattern)
endsub

'******************************************************************************
''' Reads the SSI status.
'''+return value: 
'''+                0 = SSI value compleated
'''+                1 = SSI transfer running
'''dcdr_no: number of the ssi decoder (1)
'''****************************************************************************
FUNCTION SSI_Status(dcdr_no) AS long
  dim value2 as long
  value2 = Peek_P2 (5C210C00h+ ((dcdr_no)-1) * 16)
  ssi_status = shift_right(value2, ((dcdr_no) - 1)) AND 01H
ENDFUNCTION

*************************************************************
'''Sets the delay in continuous mode.
'''dcdr_no: number of the ssi decoder (1..2)
'''delay: 16 Bit / 20 ns  [default 25s / 1250]
'''************************************************************
SUB SSI_Set_Delay(dcdr_no, delay)
  POKE ((5C210CA0h + ((dcdr_no)-1) * 16) , delay)
ENDSUB




'<ENDREGION>

'<REGION> SYSTEM M40




SUB M40_SET_Command(SPI_CTRL,Messg_len,pd_len,app_stat,int_mask) '<HIDE>
  POKE(5C600000H,SPI_CTRL)
  POKE(5C600020H,Messg_len)
  POKE(5C600030H,pd_len)
  POKE(5C600040H,app_stat)
  POKE(5C600050H,int_mask)  
ENDSUB



SUB M40_Start() '<HIDE>
  poke(5C680000H,1)
ENDSUB


'Bit 0 0=run 1=stop
'Bit 8 1=CRC OK , 0= CRC Error
Function M40_Status() as long  '<HIDE>
  
  M40_Status=Peek_P2(5C680000H)
  
ENDFUNCTION


SUB M40_Get_Stat(LED_State,ANDStat,SPI_Stat,NET_TIME) '<HIDE>
  LED_State=peek_p2(5C600200H)
  ANDStat=peek_p2(5C600300H)
  SPI_Stat=peek_p2(5C600400H)
  NET_TIME=peek_p2(5C600500H)
ENDSUB





'startindex_ram 1 .. 768
SUB M40_SET_MESSAGE_RAM(ar[],startindex,startindex_ram,count) '<HIDE>
  dim i as long
  dim adr as long
  dim b as long
  CHECK_TYPE_LONG (ar)
  System_Array_Debug_Check(ar,startindex,count)

  adr=5C610000H+(startindex_ram)*4-4  '
  System_ADR_Debug_CHECK32(adr,count,5C610000H,768,1)
  
  b=global_adr_pointer(ar[startindex])

  
  
  for i=1 to count
    POKE(adr,peek(b))
    b=b+4
    adr=adr+4  
  next  

    
    
ENDSUB
  

'startindex_ram 1 .. 768
SUB M40_GET_MESSAGE_RAM(destination_ar[],startindex,startindex_ram,count) ''<HIDE>
  dim i as long
  dim adr as long
  dim b as long
  
  CHECK_TYPE_LONG (destination_ar)
  System_Array_Debug_Check(destination_ar,startindex,count)
  
  adr=5C610000H+(startindex_ram)*4-4 
  System_ADR_Debug_CHECK32(adr,count,5C610000H,768,2)
  
  b=global_adr_pointer(destination_ar[startindex])
  
  for i=1 to count
    poke(b,peek_P2(adr))
    adr=adr+4
    b=b+4
  next  
 
    
    
ENDSUB
  



'startindex_ram 1 .. 2048
SUB M40_SET_ProcessData_RAM(ar[],startindex,startindex_ram,count) '<HIDE>
  dim i as long
  dim adr as long
  dim b as long
  
  CHECK_TYPE_LONG (ar)
  System_Array_Debug_Check(ar,startindex,count)
  
  adr=5C620000H+(startindex_ram)*4-4 '
  System_ADR_Debug_CHECK32(adr,count*2,5C620000H,2048,3)
  
  b=global_adr_pointer(ar[startindex])
  
  for i=1 to count
    POKE(adr,peek(b))
    adr=adr+4  
    POKE(adr,SHIFT_RIGHT(peek(b),16))
    b=b+4  
    adr=adr+4  
  next  
   
ENDSUB
  

'startindex_ram 1 .. 2048
SUB M40_GET_ProcessData_RAM(destination_ar[],startindex,startindex_ram,count) '<HIDE>
  dim i as long
  dim adr as long
  dim b as long
  dim buf as long
  
  CHECK_TYPE_LONG (destination_ar)
  System_Array_Debug_Check(destination_ar,startindex,count)
  
  adr=5C620000H+(startindex_ram)*4-4 
  System_ADR_Debug_CHECK32(adr,count*2,5C620000H,2048,4)
  
  b=global_adr_pointer(destination_ar[startindex])
  for i=1 to count
    buf = peek_P2(adr)
    adr=adr+4
    buf = buf OR SHIFT_LEFT(peek_P2(adr),16)
    poke(b,buf)
    adr=adr+4
    b=b+4
  next  

ENDSUB
  



'<ENDREGION>

'<REGION> ANYBUS CC M40
#define AB_START_MSG_HEADER_OUT   800h                                          ''<HIDE>   
#define AB_START_MSG_HEADER_IN    400h                                          ''<HIDE> 
#define AB_MSG_DATA_SIZE 0                                                      ''<HIDE>   
#define AB_MSG_SOURCE_ID_OBJ 2                                                  ''<HIDE>       
#define AB_MSG_INSTANCE 3                                                       ''<HIDE> 
#define AB_MSG_COMMAND 4                                                        ''<HIDE>       
#define AB_MSG_CMD_EXT 5                                                        ''<HIDE>
#define AB_MSG_DATA 6                                                           ''<HIDE>
                      
#define AB_SOURCE_ID_OUT 03FEH                                                  ''<HIDE>  
#define AB_OBJECT_OUT 03FFH                                                     ''<HIDE>          

#define MSG_SETUP_COMPLETE 8                                                    ''<HIDE>                                 

#define ABP_MSG_HEADER_C_BIT        040h                                        ''<HIDE>                                 
#define ABP_MSG_HEADER_E_BIT        080h                                        ''<HIDE>                                 
#define ABP_MSG_HEADER_CMD_BITS     03Fh                                        ''<HIDE>                                 

#define ABP_CMD_GET_ATTR 01h              'Get attribute                        ''<HIDE>
#define ABP_CMD_SET_ATTR 02h              'Set attribute                        ''<HIDE>

#define ABP_BOOL_SIZEOF             1     'Boolean                              ''<HIDE>     
#define ABP_ANB_IA_SETUP_COMPLETE   5                                           ''<HIDE>
#define ABP_ANB_STATE_PROCESS_ACTIVE 4                                          ''<HIDE>
#define ABS_BIT_ANB_STATE 07H                                                   ''<HIDE> 

#define ABS_BIT_CMDCNT 06H                                                      ''<HIDE> 
#define ABS_BIT_CRC 0100H                                                       ''<HIDE>
#define ABS_BIT_SPI_EOF 0001H                                                   ''<HIDE>
#define ABS_BIT_SPI_CTRL_PD_VALID 001H     'Process data from ADwin is valid    ''<HIDE>
#define ABS_BIT_SPI_CTRL_CMDCNT 006H       'ADwin is fast enough to process all amounts of data           ''<HIDE>
#define ABS_BIT_SPI_CTRL_M 008H                                                 ''<HIDE>
#define ABS_BIT_SPI_CTRL_LAST 010H                                              ''<HIDE>
#define ABS_BIT_SPI_CTRL_TOGGLE 080H                                            ''<HIDE>

#define ABS_BIT_ANB_STAT_S 07H                                                  ''<HIDE>
#define ABS_BIT_SPI_STAT_M 008H                                                 ''<HIDE>
#define ABS_BIT_SPI_STAT_LAST 010H                                              ''<HIDE>


#define ABS_SPI_STATE 25                                                        ''<HIDE>
#define ABS_SPI_STATE_INIT 1                                                    ''<HIDE>
#define ABS_SPI_STATE_WRITE 2                                                   ''<HIDE>
#define ABS_SPI_STATE_START_CYCLE 3                                             ''<HIDE>    
#define ABS_SPI_STATE_CHECK_STATE 4                                             ''<HIDE>
#define ABS_SPI_STATE_READ 5                                                    ''<HIDE>
#define ABS_SPI_MSG_SIZE 26                                                     ''<HIDE>
#define ABS_SPI_PD_SIZE 27                                                      ''<HIDE>
#define ABS_SPI_HDL 28                                                          ''<HIDE>
#define ABS_SPI_CYCLE_CNT 29                                                    ''<HIDE>  
#define ABS_SPI_ERROR_CNT 30                                                    ''<HIDE>
#define ABS_LED_STAT 31                                                         ''<HIDE>
#define ABS_ANB_STAT 32                                                         ''<HIDE>
#define ABS_SPI_STAT 33                                                         ''<HIDE>
#define ABS_NETTIME 34                                                          ''<HIDE>
#define ABS_SPI_CTRL 35                                                         ''<HIDE>
#define ABS_SPI_APP_STATE 36                                                    ''<HIDE>
#define ABS_SPI_INT_MASK 37                                                     ''<HIDE>
#define ABS_MSG_OUT_PENDING 38                                                  ''<HIDE>
#define ABS_DO_MSG 39                                                           ''<HIDE>
#define AB_ERROR_BASE 40                                                        ''<HIDE>
#define AB_ERROR_Extention1 41                                                  ''<HIDE>
#define AB_ERROR_Extention2 42                                                  ''<HIDE>
#define AB_ERROR_Extention3 43                                                  ''<HIDE>
#define AB_OUTSTANDING_COMMANDS 44                                              ''<HIDE>
#define AB_CmdState 45                                                          ''<HIDE>
#define AB_PROC_TYPE_IN 46                                                      ''<HIDE>
#define AB_PROC_CNT_IN 47                                                       ''<HIDE>
#define AB_PROC_TYPE_OUT 48                                                     ''<HIDE>  
#define AB_PROC_CNT_OUT 49                                                      ''<HIDE>
#define ABS_SPI_NEW 50                                                          ''<HIDE>  
#define AB_INSTANCE_READ_REQUEST 51                                             ''<HIDE>
#define AB_READ_SOURCE_ID 52                                                    ''<HIDE>  
#define AB_READ_OBJ_NUM 53                                                      ''<HIDE>
#define AB_READ_INST_NUM 54                                                     ''<HIDE>  
#define AB_READ_ATTR_NUM 55                                                     ''<HIDE>
#define AB_MAPPING_CNT_IN 56                                                    ''<HIDE>
#define AB_MAPPING_CNT_OUT 57                                                   ''<HIDE>
#define AB_MAPPING_SIZE_IN 58                                                   ''<HIDE>
#define AB_MAPPING_SIZE_OUT 59                                                  ''<HIDE>
#define AB_MAPPING_DATA_TYPE 60                                                 ''<HIDE>
#define AB_DATA_TYPE_SINT32 3                                                   ''<HIDE>
#define AB_DATA_TYPE_UINT32 6                                                   ''<HIDE>
#define AB_DATA_TYPE_FLOAT 18                                                   ''<HIDE>
#define AB_DIR_IN 1                                                             ''<HIDE>  
#define AB_DIR_OUT 2                                                            ''<HIDE>  
#define AB_MAPPING_DEV_ADR 61                                                   ''<HIDE>
#define AB_USER_BUS_TYPE 66                                                     ''<HIDE>

'From this point the definitions are imported from the HMS C-driver example
'------------------------------------------------------------------------------
' Host application objects
'------------------------------------------------------------------------------

#define ABP_OBJ_NUM_PNIO            246   'PROFINET IO                          ''<HIDE>
#define ABP_OBJ_NUM_CCL             247   'CC-Link                              ''<HIDE>                    
#define ABP_OBJ_NUM_EIP             248   'EtherNet/IP                          ''<HIDE>
#define ABP_OBJ_NUM_ETN             249   'Ethernet                             ''<HIDE>
#define ABP_OBJ_NUM_MOD             250   'Modbus                               ''<HIDE>
#define ABP_OBJ_NUM_COP             251   'CANopen                              ''<HIDE>
#define ABP_OBJ_NUM_DEV             252   'DeviceNet                            ''<HIDE>
#define ABP_OBJ_NUM_DPV1            253   'PROFIBUS DP-V1                       ''<HIDE>
#define ABP_OBJ_NUM_APPD            254   'Application Data                     ''<HIDE>
#define ABP_OBJ_NUM_APP             255   'Application                          ''<HIDE>

'------------------------------------------------------------------------------
'State variable that keeps track of which initialization command to send next
'It is also used as a "source ID" to simplify the identification of responses
'from the Anybus-CC.
'------------------------------------------------------------------------------
#define MSG_NODE_ADR 1                                                          ''<HIDE>                   
#define MSG_BAUDRATE 2                                                          ''<HIDE>                                                          
#define MSG_MAP_IO_1 3                                                          ''<HIDE>
#define MSG_MAP_IO_2 4                                                          ''<HIDE>  
#define MSG_MAP_IO_3 5                                                          ''<HIDE>
#define MSG_MAP_IO_4 6                                                          ''<HIDE> 
#define MSG_DATA_FORMAT 7                                                       ''<HIDE>
#define MSG_SETUP_COMPLETE 8                                                    ''<HIDE>
#define MSG_DONE 9                                                              ''<HIDE> 
#define MSG_READ_REQUEST 10                                                     ''<HIDE>

'------------------------------------------------------------------------------
'Anybus module objects
'------------------------------------------------------------------------------

#define ABP_OBJ_NUM_ANB               1   'Anybus                               ''<HIDE>     
#define ABP_OBJ_NUM_DI                2   'Diagnostic                           ''<HIDE>
#define ABP_OBJ_NUM_NW                3   'Network                              ''<HIDE>
#define ABP_OBJ_NUM_NC                4   'Network Configuration                ''<HIDE>
#define ABP_OBJ_NUM_ADD               5   'PROFIBUS DP-V1 Additional Diag       ''<HIDE>
#define ABP_OBJ_NUM_RSV1              6   'Reserved                             ''<HIDE>
#define ABP_OBJ_NUM_SOC               7   'Socket Interface                     ''<HIDE>
#define ABP_OBJ_NUM_NWCCL             8   'Network CC-Link                      ''<HIDE>
#define ABP_OBJ_NUM_SMTP              9   'SMTP Client                          ''<HIDE>
#define ABP_OBJ_NUM_FSI              10   'File System Interface                ''<HIDE>
#define ABP_OBJ_NUM_NWDPV1           11   'Network PROFIBUS DP-V1               ''<HIDE>
#define ABP_OBJ_NUM_NWETN            12   'Network Ethernet                     ''<HIDE>
#define ABP_OBJ_NUM_CPC              13   'CIP Port Configuration               ''<HIDE>
#define ABP_OBJ_NUM_NWPNIO           14   'Network PROFINET IO                  ''<HIDE>
#define ABP_OBJ_NUM_PNIOADD          15   'PROFINET IO Additional Diag          ''<HIDE>

'------------------------------------------------------------------------------
'The Network object specific message commands.
'------------------------------------------------------------------------------

#define ABP_NW_CMD_MAP_ADI_WRITE_AREA        010h                               ''<HIDE>                            
#define ABP_NW_CMD_MAP_ADI_READ_AREA         011h                               ''<HIDE>
#define ABP_NW_CMD_MAP_ADI_WRITE_EXT_AREA    012h                               ''<HIDE>                            
#define ABP_NW_CMD_MAP_ADI_READ_EXT_AREA     013h                               ''<HIDE>

'The object instance number.
'------------------------------------------------------------------------------

#define ABP_INST_OBJ                0                                           ''<HIDE>

'------------------------------------------------------------------------------
'The object standard attributes.
'------------------------------------------------------------------------------

#define ABP_OA_NAME                 1     'Object name                          ''<HIDE>
#define ABP_OA_REV                  2     'Object revision                      ''<HIDE>
#define ABP_OA_NUM_INST             3     'Current number of instances          ''<HIDE>
#define ABP_OA_HIGHEST_INST         4     'Current highest instance number      ''<HIDE>

'------------------------------------------------------------------------------
'The data size of the object standard attributes (in bytes).
'------------------------------------------------------------------------------

#define ABP_OA_REV_DS               1                                           ''<HIDE>
#define ABP_OA_NUM_INST_DS          2                                           ''<HIDE>
#define ABP_OA_HIGHEST_INST_DS      2                                           ''<HIDE>
'------------------------------------------------------------------------------
'The Application data object specific message commands.
'------------------------------------------------------------------------------

#define ABP_APPD_CMD_GET_INST_BY_ORDER    010h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_NEXT_GUARDED     011h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_INST_NUMBERS     015h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_NAME        001h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_DATA_TYPE   002h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_NO_ELEMENTS 003h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_DISCRIPTOR  004h                                  ''<HIDE>


'Networktypes
#define AB_NETWORK_TYPE_PROFINET_IRT      089H                                  ''<HIDE>
#define AB_NETWORK_TYPE_PROFINET_FO       09DH                                  ''<HIDE>
#define AB_NETWORK_TYPE_PROFIBUS          005H                                  ''<HIDE>
#define AB_NETWORK_TYPE_ETHERCAT          087H                                  ''<HIDE>

'ADWIN ERRORCODES
#define AB_ERROR_CODE_UNSUP_OBJECT 3                                            ''<HIDE>
#define AB_ERROR_CODE_UNSUP_INSTANCE 4                                          ''<HIDE>
#define AB_ERROR_CODE_ATTR_NOT_GETTABLE 6                                       ''<HIDE>
#define AB_ERROR_CODE_UNSUP_COMMAND 5                                           ''<HIDE>
#define AB_ERROR_CODE_SETUP_FAILED 20                                            ''<HIDE>

#define AB_TRUE 1                                                               ''<HIDE>                               
#define AB_FALSE 0                                                              ''<HIDE>
#define AB_SENT 2                                                               ''<HIDE>
#define AB_HEADER_SIZE 6                                                        ''<HIDE>
#define AB_SPI_SEND_SIZE 32                                                     ''<HIDE>
#define AB_WORK_ARR_LEN 5000                                                    'Lenght of work-array      


'***************************************************************
'''Reads and writes process data from/to Anybus module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         4: Active
'''+     other: Error (configuration correct?)
'''out_pd_arr[]: array with output data
'''out_pd_arr_len: number of output elements
'''in_pd_arr[]: array for input data
'''in_pd_arr_len: number of input elements
'''work_arr[]: array for communication T121 <-> Anybus-Module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Run_ANYBUS_CC_M40(out_pd_arr[], in_pd_arr[], pd_arr_len, work_arr[]) AS LONG  ''<HIDE>
  DIM map_cnt_in, map_cnt_out, id_counter,i AS LONG
  Check_Type_Long (work_arr[1])
  System_Array_Debug_Check(work_arr, 1, AB_WORK_ARR_LEN)
  SELECTCASE work_arr[ABS_SPI_STATE]  
    CASE ABS_SPI_STATE_INIT
      work_arr[ABS_SPI_MSG_SIZE] = 0
      work_arr[ABS_SPI_PD_SIZE] = 0
      work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_START_CYCLE
      map_cnt_in = 0
      map_cnt_out = 0
      id_counter = 0
    CASE ABS_SPI_STATE_WRITE
      M40_SET_ProcessData_RAM(out_pd_arr, 1, 1, pd_arr_len)
      work_arr[ABS_SPI_PD_SIZE] = pd_arr_len * 2                  'Spi = 16 Bit ; ADwin = 32 Bit
      IF (work_arr[ABS_MSG_OUT_PENDING] = AB_TRUE) THEN
        IF ((work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] AND ABP_MSG_HEADER_C_BIT) = ABP_MSG_HEADER_C_BIT) THEN 'Message is a command
          work_arr[ABS_MSG_OUT_PENDING] = AB_SENT
        ELSE                                                                                  'Message is a response
          work_arr[ABS_MSG_OUT_PENDING] = AB_FALSE
        ENDIF
        work_arr[ABS_SPI_CTRL] = work_arr[ABS_SPI_CTRL] OR ABS_BIT_SPI_CTRL_M OR ABS_BIT_SPI_CTRL_LAST
        M40_SET_MESSAGE_RAM(work_arr, AB_START_MSG_HEADER_OUT, 1, work_arr[ABS_SPI_MSG_SIZE])
      ENDIF
      work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_START_CYCLE
    CASE ABS_SPI_STATE_START_CYCLE
      work_arr[ABS_SPI_CTRL] = work_arr[ABS_SPI_CTRL] XOR ABS_BIT_SPI_CTRL_TOGGLE 
      M40_SET_Command(work_arr[ABS_SPI_CTRL], AB_SPI_SEND_SIZE, work_arr[ABS_SPI_PD_SIZE], work_arr[ABS_SPI_APP_STATE], work_arr[ABS_SPI_INT_MASK]) 
      M40_start()
      work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_CHECK_STATE
    CASE ABS_SPI_STATE_CHECK_STATE
      work_arr[ABS_SPI_HDL] = m40_status()  
      IF (work_arr[ABS_SPI_HDL] AND ABS_BIT_SPI_EOF = ABS_BIT_SPI_EOF) THEN      'SPI Cycle finished
        IF (work_arr[ABS_SPI_HDL] AND ABS_BIT_CRC = ABS_BIT_CRC) THEN            'CRC_OK
          INC work_arr[ABS_SPI_CYCLE_CNT]
          work_arr[ABS_SPI_CTRL] = work_arr[ABS_SPI_CTRL] AND NOT(ABS_BIT_SPI_CTRL_M OR ABS_BIT_SPI_CTRL_LAST)
          work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_READ
        ELSE                                                                      'CRC error
          INC work_arr[ABS_SPI_ERROR_CNT]
          work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_START_CYCLE
        ENDIF
      ENDIF
    CASE ABS_SPI_STATE_READ
      M40_Get_Stat(work_arr[ABS_LED_STAT], work_arr[ABS_ANB_STAT], work_arr[ABS_SPI_STAT], work_arr[ABS_NETTIME]) 
      IF ((work_arr[ABS_SPI_STAT] AND ABS_BIT_SPI_STAT_M) = ABS_BIT_SPI_STAT_M) THEN 
        IF ((work_arr[ABS_SPI_STAT] AND ABS_BIT_SPI_STAT_LAST) = ABS_BIT_SPI_STAT_LAST) THEN 
          work_arr[ABS_MSG_OUT_PENDING] = AB_FALSE
        ENDIF
        M40_GET_MESSAGE_RAM(work_arr, AB_START_MSG_HEADER_IN, 1, 768) 
      ENDIF
      work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_SOURCE_ID_OBJ] AND 0FFH
      work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT] = SHIFT_RIGHT(work_arr[AB_START_MSG_HEADER_IN + AB_MSG_SOURCE_ID_OBJ], 8) AND 0FFH

      work_arr[ABS_SPI_NEW] = AB_TRUE
      work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_WRITE
  ENDSELECT 
  
  
  IF (work_arr[ABS_SPI_NEW] = AB_TRUE) THEN 
    work_arr[ABS_SPI_NEW] = AB_FALSE
  
    IF ((work_arr[ABS_SPI_STAT] AND ABS_BIT_SPI_STAT_M) = ABS_BIT_SPI_STAT_M) THEN       'There is a message available.
      IF ((work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_C_BIT) = ABP_MSG_HEADER_C_BIT) THEN 'Message is a command
        FOR i = 0 TO AB_HEADER_SIZE
          work_arr[AB_START_MSG_HEADER_OUT + i] = work_arr[AB_START_MSG_HEADER_IN + i]
        NEXT i
        work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT]
        work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] AND NOT(ABP_MSG_HEADER_C_BIT)
        SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
          CASE ABP_OBJ_NUM_APPD
            work_arr[ABS_DO_MSG] = AB_TRUE
            IF (ApplicationDataObject(work_arr) = AB_FALSE) THEN 
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
            ENDIF
          CASE ABP_OBJ_NUM_APP
            work_arr[ABS_DO_MSG] = AB_TRUE
            IF (ApplicationObject(work_arr) = AB_FALSE) THEN
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
            ENDIF
          CASEELSE
            work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_OBJECT
            work_arr[AB_ERROR_Extention1] = work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
            work_arr[ABS_DO_MSG] = AB_TRUE
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
        ENDSELECT
      ELSE 'Message is a response to a command we have sent
        DEC work_arr[AB_OUTSTANDING_COMMANDS]
        SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT]
          CASE MSG_SETUP_COMPLETE
            IF ((work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_E_BIT) = ABP_MSG_HEADER_E_BIT) THEN
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_SETUP_FAILED
            ENDIF
        ENDSELECT
      ENDIF
    ENDIF  ' End of message availible
    
    IF (((work_arr[ABS_SPI_STAT] AND ABS_BIT_CMDCNT) > 0) AND (work_arr[ABS_DO_MSG] = AB_FALSE)) THEN 'The Anybus-CC is ready to accept commands, and the WriteMsg buffer is free
      SELECTCASE work_arr[AB_CmdState]
        CASE MSG_NODE_ADR
          IF (work_arr[AB_MAPPING_DEV_ADR] <> 0) THEN
            inc id_counter
            work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
            work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NC
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_SET_ATTR
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 5                        'Node ID
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_DEV_ADR]
            work_arr[ABS_DO_MSG] = AB_TRUE
          ENDIF
          work_arr[AB_CmdState] = MSG_MAP_IO_1
        CASE MSG_MAP_IO_1
          inc id_counter
          work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] =  id_counter and 0ffH
          work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NW
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_NW_CMD_MAP_ADI_WRITE_EXT_AREA
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 7
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1 + map_cnt_out
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = work_arr[AB_MAPPING_SIZE_OUT]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 0100H OR work_arr[AB_MAPPING_SIZE_OUT] 
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = work_arr[AB_PROC_TYPE_OUT]
          work_arr[ABS_DO_MSG] = AB_TRUE
          INC  map_cnt_out
          IF (work_arr[AB_MAPPING_CNT_OUT] = map_cnt_out) THEN work_arr[AB_CmdState] = MSG_MAP_IO_3
        CASE MSG_MAP_IO_3
          inc id_counter
          work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
          work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NW
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_NW_CMD_MAP_ADI_READ_EXT_AREA
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 7
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1 + map_cnt_out + map_cnt_in 
          IF((work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_PNIO) AND (work_arr[AB_MAPPING_SIZE_IN] = 64)) THEN work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 6 + map_cnt_in 'Profinet
          IF(work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_DPV1) THEN work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 6 + map_cnt_in 'Profibus
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = work_arr[AB_MAPPING_SIZE_IN]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 0100H OR work_arr[AB_MAPPING_SIZE_IN] 
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = work_arr[AB_PROC_TYPE_IN]
          work_arr[ABS_DO_MSG] = AB_TRUE
          INC  map_cnt_in
          IF (work_arr[AB_MAPPING_CNT_IN] = map_cnt_in) THEN work_arr[AB_CmdState] = MSG_SETUP_COMPLETE
        CASE MSG_SETUP_COMPLETE
          IF (work_arr[AB_OUTSTANDING_COMMANDS] = 0) THEN
            'All the configuration commands have been processed by the Anybus - CC.
            'Go ahead and end the setup phase by sending SETUP_COMPLETE.
            inc id_counter
            work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
            work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_ANB
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_SET_ATTR
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_BOOL_SIZEOF
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = ABP_ANB_IA_SETUP_COMPLETE
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = AB_TRUE
            work_arr[ABS_DO_MSG] = AB_TRUE
            work_arr[AB_CmdState] = MSG_DONE
          ENDIF
        CASE MSG_DONE
          IF (work_arr[AB_INSTANCE_READ_REQUEST] = AB_TRUE) THEN
            work_arr[AB_INSTANCE_READ_REQUEST] = AB_FALSE
            work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = work_arr[AB_READ_SOURCE_ID]
            work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = work_arr[AB_READ_OBJ_NUM]
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = work_arr[AB_READ_INST_NUM]
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_GET_ATTR
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 0
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = work_arr[AB_READ_ATTR_NUM]
            work_arr[ABS_DO_MSG] = AB_TRUE
          ENDIF 
      ENDSELECT
      IF (work_arr[ABS_DO_MSG] = AB_TRUE) THEN
        'A new command has been posted to the Anybus - CC.
        'Increment counter for outstanding commands.
        INC work_arr[AB_OUTSTANDING_COMMANDS]
      ENDIF
    ENDIF
    IF (work_arr[ABS_DO_MSG] = AB_TRUE) THEN
      IF (Write_Msg_To_Anybus(work_arr) = AB_TRUE) THEN
        work_arr[ABS_DO_MSG] = AB_FALSE
      endif
    ENDIF
    IF ((work_arr[ABS_ANB_STAT] AND ABS_BIT_ANB_STATE) = ABP_ANB_STATE_PROCESS_ACTIVE) THEN
      '      'The "read process data" is only valid in the PROCESS_ACTIVE state.
      '      'Retrieve the new "read process data" from the Anybus - CC.
      M40_GET_ProcessData_RAM(in_pd_arr, 1, 1, pd_arr_len)
      work_arr[ABS_SPI_CTRL] = work_arr[ABS_SPI_CTRL] OR ABS_BIT_SPI_CTRL_PD_VALID
    ENDIF
  ENDIF
  Run_ANYBUS_CC_M40 = work_arr[ABS_ANB_STAT] AND ABS_BIT_ANB_STAT_S

ENDFUNCTION

'***************************************************************
'''Reads and writes process data from/to EtherCAT module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Slave waits for bus start by master
'''+         3: Idle
'''+         4: Active
'''+     other: Error (check configuration)
'''out_pd_arr[]: array with output data, size is pd_arr_len
'''in_pd_arr[]: array for input data, size is pd_arr_len
'''pd_arr_len: number (1..360) of elements to be transferred
'''work_arr[]: array for communication T121 <-> EtherCAT module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Run_EtherCAT(out_pd_arr[], in_pd_arr[], pd_arr_len, work_arr[]) AS LONG 
  Run_EtherCAT = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr, pd_arr_len, work_arr)
ENDFUNCTION


'***************************************************************
'''Reads and writes process data from/to ProfinetIO module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         3: Idle
'''+         4: Active
'''+     other: Error (configuration correct?)
'''out_pd_arr[]: array with output data
'''in_pd_arr[]: array for input data
'''pd_arr_len: number of input/output elements
'''work_arr[]: array for communication T121 <-> ProfinetIO module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Run_ProfinetIO(out_pd_arr[], in_pd_arr[], pd_arr_len, work_arr[]) AS LONG
  Run_ProfinetIO = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr, pd_arr_len, work_arr)
ENDFUNCTION

'***************************************************************
'''Reads and writes process data from/to Profibus module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         3: Idle
'''+         4: Active
'''+     other: Error (configuration correct?)
'''out_pd_arr[]: array with output data
'''in_pd_arr[]: array for input data
'''pd_arr_len: number of input/output elements
'''work_arr[]: array for communication T12.1 <-> Profibus module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Run_Profibus(out_pd_arr[], in_pd_arr[], pd_arr_len, work_arr[]) AS LONG
  Run_Profibus = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr, pd_arr_len, work_arr)
ENDFUNCTION


'***************************************************************
'''Reads and writes process data from/to EtherNetIP module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         4: Active
'''+     other: Error (configuration correct?)
'''out_pd_arr[]: array with output data
'''in_pd_arr[]: array for input data
'''pd_arr_len: number of input/output elements
'''work_arr[]: array for communikation T12.1 <-> EtherNetIP-Module 
'''+ min. size 4096 elements
'''***************************************************************
FUNCTION Run_EtherNetIP(out_pd_arr[], in_pd_arr[],pd_arr_len, work_arr[]) AS LONG  '<HIDE>
  Run_EtherNetIP = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr, pd_arr_len, work_arr)
ENDFUNCTION







  
FUNCTION Write_Msg_To_Anybus(work_arr[]) AS LONG   ''<HIDE>
  IF (work_arr[ABS_MSG_OUT_PENDING] = AB_FALSE) THEN
    work_arr[ABS_MSG_OUT_PENDING] = AB_TRUE
    work_arr[ABS_SPI_MSG_SIZE] = AB_HEADER_SIZE + work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] 
    work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_SOURCE_ID_OBJ] = SHIFT_LEFT(work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT], 8) OR work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT]
    Write_Msg_To_Anybus = AB_TRUE
  ELSE
    Write_Msg_To_Anybus = AB_FALSE
  ENDIF
ENDFUNCTION

FUNCTION ApplicationObject(work_arr[]) AS LONG      ''<HIDE>
  ApplicationObject = AB_TRUE
  SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE]
    CASE 1
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationObject = AB_FALSE
          ENDSELECT 
        CASE ABP_CMD_SET_ATTR
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 0
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_COMMAND
          ApplicationObject = AB_FALSE
      ENDSELECT
    CASEELSE
      work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_INSTANCE
      ApplicationObject = AB_FALSE
  ENDSELECT 
ENDFUNCTION 


FUNCTION ApplicationDataObject(work_arr[]) AS LONG      ''<HIDE>
  DIM i AS LONG
  ApplicationDataObject = AB_TRUE
  SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE]
    CASE ABP_INST_OBJ
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            CASE ABP_OA_NAME
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 65         '"Application data"
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = 112
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 112
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = 108
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 4] = 105
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 5] = 99
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 6] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 7] = 116
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 8] = 105
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 9] = 111
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 10] = 110
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 11] = 32
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 12] = 100
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 13] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 14] = 116
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 15] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 32
            CASE ABP_OA_REV
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_REV_DS
            CASE ABP_OA_NUM_INST
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] =  work_arr[AB_MAPPING_CNT_OUT] + work_arr[AB_MAPPING_CNT_IN]     
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_NUM_INST_DS
            CASE ABP_OA_HIGHEST_INST
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] =  work_arr[AB_MAPPING_CNT_OUT] + work_arr[AB_MAPPING_CNT_IN]      
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_HIGHEST_INST_DS
            CASE 11          'No mappabel read data
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 0
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
            CASE 12          'No mappabel write data
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 0
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationDataObject = AB_FALSE
          ENDSELECT 
        CASE ABP_APPD_CMD_GET_INST_BY_ORDER
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] 
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
        CASE ABP_APPD_CMD_GET_INST_NUMBERS
          FOR i = 1 TO work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA + 1]
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + (i-1)] = i
          NEXT i
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_COMMAND
          ApplicationDataObject = AB_FALSE
      ENDSELECT
    CASEELSE
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            case ABP_APPD_CMD_GET_ATTR_NAME
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 050H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = 061H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 072H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = 061H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 4] = 06DH
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 5] = (030H + work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE])
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 6
            case ABP_APPD_CMD_GET_ATTR_DATA_TYPE
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_DATA_TYPE]
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            case ABP_APPD_CMD_GET_ATTR_NO_ELEMENTS
              IF (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE] <= work_arr[AB_MAPPING_CNT_IN]) THEN
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_SIZE_IN]
              ELSE
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_SIZE_OUT]
              ENDIF
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            case ABP_APPD_CMD_GET_ATTR_DISCRIPTOR
              IF (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE] <= work_arr[AB_MAPPING_CNT_IN]) THEN
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 09H             'Get access ; Mappable as write process data
              ELSE
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 013H            'Get access; Set access; Mappable as read process data
              ENDIF
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationDataObject = AB_FALSE
          ENDSELECT 
      ENDSELECT 
  ENDSELECT 
ENDFUNCTION 
FUNCTION Check_Range_EtherCAT(count, data_type, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  DIM type_size AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  Check_Range_EtherCAT = AB_FALSE
  type_size = -1
  IF (data_type = AB_DATA_TYPE_UINT32) THEN type_size = 4
  IF (data_type = AB_DATA_TYPE_FLOAT) THEN type_size = 4
  IF (data_type = AB_DATA_TYPE_SINT32) THEN type_size = 4
  IF (((count * type_size) >= 0) AND ((count * type_size) <=1440))THEN
    Check_Range_EtherCAT = AB_TRUE
    work_arr[AB_MAPPING_DATA_TYPE] = data_type
    work_arr[size_adr] = 001H
    work_arr[cnt_adr] = count
  ENDIF
ENDFUNCTION

FUNCTION Check_Range_Profibus(dev_adr,count,  direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  DIM type_size AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_DPV1
  Check_Range_Profibus = AB_FALSE
  work_arr[AB_MAPPING_DEV_ADR] = dev_adr
  work_arr[cnt_adr] = 1
  IF (count = 001H) THEN
    Check_Range_Profibus = AB_TRUE
    work_arr[size_adr] = 001H
  ENDIF
  IF (count = 002H) THEN 
    Check_Range_Profibus = AB_TRUE
    work_arr[size_adr] = 002H
  ENDIF
  IF (count = 004H) THEN 
    Check_Range_Profibus = AB_TRUE
    work_arr[size_adr] = 004H
  ENDIF
  IF (count = 008H) THEN 
    Check_Range_Profibus = AB_TRUE
    work_arr[size_adr] = 008H
  ENDIF
  IF (count = 010H) THEN 
    Check_Range_Profibus = AB_TRUE
    work_arr[size_adr] = 010H
  ENDIF
  IF (count = 020H) THEN
    Check_Range_Profibus = AB_TRUE
    work_arr[size_adr] = 020H
  ENDIF
  IF (count = 03DH) THEN
    Check_Range_Profibus = AB_TRUE
    'work_arr[cnt_adr] = 2
    work_arr[size_adr] = 03DH
  ENDIF
ENDFUNCTION

FUNCTION Check_Range_PROFINET(count, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_PNIO
  Check_Range_PROFINET = AB_FALSE
  work_arr[cnt_adr] = 1
  IF (count = 001H) THEN
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 001H
  ENDIF
  IF (count = 002H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 002H
  ENDIF
  IF (count = 004H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 004H
  ENDIF
  IF (count = 008H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 008H
  ENDIF
  IF (count = 010H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 010H
  ENDIF
  IF (count = 020H) THEN
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 020H
  ENDIF
  IF (count = 040H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 080H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 2
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0C0H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 3
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0100H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 4
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0140H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 5
    work_arr[size_adr] = 040H
  ENDIF
ENDFUNCTION

FUNCTION Check_Range_EtherNetIP(count, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_EIP
  Check_Range_EtherNetIP = AB_FALSE
  work_arr[cnt_adr] = 1
  IF ((count >= 0) AND (count <= 125)) THEN
    Check_Range_EtherNetIP = AB_TRUE
    work_arr[size_adr] = count
  ENDIF
   
ENDFUNCTION



'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+ProfinetIO module.
'''+return value:
'''+         0: OK
'''+         -1: Wrong no of IO data elements
'''in_mod_cnt: number of in elements {1,2,4,8,16,32,64,128,196,256,320}
'''out_mod_cnt: number of out elements {1,2,4,8,16,32,64,128,196,256,320}
'''work_arr[]: array for communication T121 <-> ProfinetIO module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Init_ProfinetIO(in_mod_cnt, out_mod_cnt, work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_PROFINET(in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_PROFINET(out_mod_cnt,  AB_DIR_OUT, work_arr) 
  Init_ProfinetIO = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt,AB_DATA_TYPE_UINT32 , check_result, work_arr) 
ENDFUNCTION
'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+ETHERCAT module.
'''+return value:
'''+         0: OK
'''+         -1: Wrong IO size; the size of processdata in and 
'''+             processdata out must be in the range of 0 .. 1440 byte
'''in_mod_cnt: number of in elements 0..360
'''out_mod_cnt: number of out elements 0..360
'''data_type: AB_DATA_TYPE_UINT32; AB_DATA_TYPE_SINT32; AB_DATA_TYPE_FLOAT
'''work_arr[]: array for communication T121 <-> EtherCAT module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Init_EtherCAT(in_mod_cnt, out_mod_cnt, data_type, work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_EtherCAT(in_mod_cnt, data_type, AB_DIR_IN, work_arr) AND Check_Range_EtherCAT(out_mod_cnt, data_type, AB_DIR_OUT, work_arr) 
  Init_EtherCAT = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, data_type, check_result, work_arr) 
ENDFUNCTION

'***************************************************************
'''Initializes arrays and variables for the communication to the 
'''+Profibus module.
'''+return value:
'''+         0: OK
'''+         -1: Error, size of data ranges is wrong.
'''dev_adr: Slave node address / station address (1..125) on the Profibus.
'''in_mod_cnt: Size (1,2,4,8,16,32,61) of the input area in the Profibus slave in double words.
'''out_mod_cnt: Size (1,2,4,8,16,32,61) of the output area in the Profibus slave in double words.
'''work_arr[]: array for communication T121 <-> Profibus module 
'''+ min. size AB_WORK_ARR_LEN
'''***************************************************************
FUNCTION Init_Profibus(dev_adr,in_mod_cnt, out_mod_cnt,  work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_Profibus(dev_adr,in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_Profibus(dev_adr,out_mod_cnt,  AB_DIR_OUT, work_arr) 
  Init_Profibus = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, AB_DATA_TYPE_UINT32, check_result, work_arr) 
ENDFUNCTION



'***************************************************************
'''Resets the EtherNetIP module and initializes several variables.
'''+return value: Status of initialization:
'''+          0: Initialization successful.
'''+         -1: Error, size of data ranges is wrong.
'''in_mod_cnt: number of input elements
'''in_mod_type: input data type
'''+         1: 1 Byte
'''+         2: 2 Bytes
'''+         3: 4 Bytes
'''+        16: 8 Bytes
'''out_mod_cnt: number of output elements
'''out_mod_type: output data type
'''+         1: 1 Byte
'''+         2: 2 Bytes
'''+         3: 4 Bytes
'''+        16: 8 Bytes
'''work_arr[]: array for communication T12 <-> EtherNetIP-Module
'''+ min. size 4096 elements
'''***************************************************************
Function Init_EtherNetIP(in_mod_cnt, in_mod_type, out_mod_cnt, out_mod_type, work_arr[]) as long '<HIDE>
  DIM check_result AS LONG
  check_result =  Check_Range_EtherNetIP(in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_EtherNetIP(out_mod_cnt,  AB_DIR_OUT, work_arr) 
  Init_EtherNetIP = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, AB_DATA_TYPE_UINT32, check_result, work_arr) 
ENDFUNCTION



'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+Anybus module.
'''+return value:
'''+         0: OK
'''+         -1: Wrong no of IO data elements
'''in_mod_cnt: number of in elements {1,2,4,8,16,32,64,128,196,256,320}
'''out_mod_cnt: number of out elements {1,2,4,8,16,32,64,128,196,256,320}
'''work_arr[]: array for communication T121 <-> Anybus module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, data_type, check_result, work_arr[]) AS LONG     ''<HIDE>
  DIM i AS LONG
  Check_Type_Long (work_arr[1])
  System_Array_Debug_Check(work_arr,1,AB_WORK_ARR_LEN)

#if Prioritaet = low
  IF (check_result = AB_FALSE) THEN
    Init_ANYBUS_CC_M40 = -1
  ELSE
    Init_ANYBUS_CC_M40 = 0
  
    ABM40_Reset()
    FOR i = 1 TO AB_WORK_ARR_LEN
      IF ((i < AB_MAPPING_CNT_IN) OR (i > AB_USER_BUS_TYPE))THEN work_arr[i] = 0
    NEXT i

    work_arr[ABS_SPI_CTRL] = ABS_BIT_CMDCNT
    work_arr[AB_PROC_TYPE_IN] = data_type
    work_arr[AB_PROC_CNT_IN] = in_mod_cnt
    work_arr[AB_PROC_TYPE_OUT] = data_type 
    work_arr[AB_PROC_CNT_OUT] = out_mod_cnt
    work_arr[AB_CmdState] = MSG_NODE_ADR
    work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = AB_TRUE
    work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_INIT
    work_arr[ABS_SPI_APP_STATE] = 0
    work_arr[ABS_SPI_INT_MASK] = 0
  ENDIF
#else
  Error_If_High("the command Init_ProfinetIO can only be used in low priority section ")
#endif
ENDFUNCTION


SUB ABM40_Reset()     ''<HIDE>
  poke(5C6F8000h, 0)'Reset low
  io_sleep(100000)                                        '1  ms
  poke(5C6F8000h, 1)'Reset high
  io_sleep(150000000)                                     '1.5sec (in 10 nsec)
ENDSUB

SUB Request_Attribute(Source_ID, Object, Instance, Attribute, work_arr[])      ''<HIDE>
  work_arr[AB_INSTANCE_READ_REQUEST] = AB_TRUE
  work_arr[AB_READ_SOURCE_ID] = Source_ID
  work_arr[AB_READ_OBJ_NUM] = Object
  work_arr[AB_READ_INST_NUM] = Instance
  work_arr[AB_READ_ATTR_NUM] = Attribute
ENDSUB
FUNCTION Read_Attribute(response_array[], work_arr[]) AS LONG      ''<HIDE>
  DIM i AS LONG
  Read_Attribute = AB_FALSE
  IF (work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT] = work_arr[AB_READ_SOURCE_ID]) THEN
    FOR i = 0 TO (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA_SIZE]/2) 
      response_array[i + 1] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA + i]
    NEXT i
    Read_Attribute = AB_TRUE
  ENDIF
ENDFUNCTION 



'<ENDREGION>









