'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 32,367,773,930,1089,1454,2025,2085,2395,2484,2708,2841,3673,3709,3735
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--Inc--PRO
'<SMARTFORMAT OFF> do not remove !!!
'
'#################################################################
'#                        ADwinGoldIII.inc                       #
'#              INCLUDE-file for ADwin-Gold-III-system           #
'#################################################################
'#                                                               #
'# Contents: Definition of functions and procedures              #
'#           to access ADwin Gold III                            #
'#                                                               #
'#  28.07.2023  mf   creation                                    #
'#  11.01.2024  mf bugfix run ethercat                           #
'#                                                               #
'#                                                               #
'# Attention:                                                    #
'#   - Do not copy the first source line (containing             #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                #
'#     Otherwise the Syntax color may be not correct.            #
'#                                                               #
'#################################################################

import ADwin-GoldIII-Lib.LIC
import ADNetLib.Lic


#if adwin_system = ADwin_GoldIII
#else
#error("This include file can only be used with the ADwin-Gold-III")
#endif

'<REGION> Define

'#define SYST_CPU 50000000H
#define SYSTEM_LSBUS_RX_FIFO_COUNT 5C510120h '<HIDE> 'RX fifo count
#define SYSTEM_LSBUS_RX_FIFO_READ 5C510100h '<HIDE>

#define CAN_SRR 0  ''<HIDE> 
#define CAN_MSR 4  ''<HIDE> 
#define CAN_BRPR 8  ''<HIDE> 
#define CAN_BTR 12  ''<HIDE> 
#define CAN_ECR 10H  ''<HIDE> 
#define CAN_ESR 14H  ''<HIDE> 
#define CAN_SR 18H  ''<HIDE> 
#define CAN_ISR 1CH  ''<HIDE> 
#define CAN_IER 20H  ''<HIDE> 
#define CAN_ICR 24H  ''<HIDE> 
#define CAN_TCR 28H  ''<HIDE> 
#define CAN_WIR 2CH  ''<HIDE> 
#define CAN_TXFIFO_ID 30H   ''<HIDE> 
#define CAN_TXFIFO_DLC 34H  ''<HIDE> 
#define CAN_TXFIFO_Data1 38H  ''<HIDE> 
#define CAN_TXFIFO_Data2 3CH  ''<HIDE> 
#define CAN_TXHPB_ID 40H   ''<HIDE> 
#define CAN_TXHPB_DLC 44H   ''<HIDE> 
#define CAN_TXHPB_DATA1 48H  ''<HIDE> 
#define CAN_TXHPB_DATA2 4CH   ''<HIDE> 
#define CAN_RXFIFO_ID 50H  ''<HIDE> 
#define CAN_RXFIFO_DLC 54H   ''<HIDE> 
#define CAN_RXFIFO_DATA_1 58H  ''<HIDE> 
#define CAN_RXFIFO_DATA_2 5CH   ''<HIDE> 
#define CAN_AFR 60H   ''<HIDE> 
#define CAN_AFMR1 64H   ''<HIDE> 
#define CAN_AFIR1 68H  ''<HIDE> 
#define CAN_AFMR2 6CH  ''<HIDE> 
#define CAN_AFIR2 70H  ''<HIDE> 
#define CAN_AFMR3 74H  ''<HIDE> 
#define CAN_AFIR3 78H  ''<HIDE> 
#define CAN_AFMR4 7CH  ''<HIDE> 
#define CAN_AFIR4 80H  ''<HIDE> 


#define SYSTEM_BUS_SLEEP 0500ff1f0h '<HIDE>

#define bit0 1H
#define bit1 2H
#define bit2 4H
#define bit3 8H
#define bit4 10H
#define bit5 20H
#define bit6 40H
#define bit7 80H
#define bit8 100H
#define bit9 200H
#define bit10 400H
#define bit11 800H
#define bit12 1000H
#define bit13 2000H
#define bit14 4000H
#define bit15 8000H
#define bit16 10000H
#define bit17 20000H
#define bit18 40000H
#define bit19 80000H
#define bit20 100000H
#define bit21 200000H
#define bit22 400000H
#define bit23 800000H
#define bit24 1000000H
#define bit25 2000000H
#define bit26 4000000H
#define bit27 8000000H
#define bit28 10000000H
#define bit29 20000000H
#define bit30 40000000H
#define bit31 80000000H




#If MAKE_LIB = OFF Then
'''array of 11 elements, holding a CAN message:
'''+  1..8: data bytes 
'''+     9: number (0..8) of used data bytes
'''+    10: CAN identifier (11 bit or 29 bit)
'''+    11: receive time stamp (16 bit)
dim CAN_Msg[11] as long
DIM PWM_help_mode as long '<HIDE>
#EndIf

'anybus
#define AB_START_MSG_HEADER_OUT   800h                                          ''<HIDE>   
#define AB_START_MSG_HEADER_IN    400h                                          ''<HIDE> 
#define AB_MSG_DATA_SIZE 0                                                      ''<HIDE>   
#define AB_MSG_SOURCE_ID_OBJ 2                                                  ''<HIDE>       
#define AB_MSG_INSTANCE 3                                                       ''<HIDE> 
#define AB_MSG_COMMAND 4                                                        ''<HIDE>       
#define AB_MSG_CMD_EXT 5                                                        ''<HIDE>
#define AB_MSG_DATA 6                                                           ''<HIDE>
                      
#define AB_SOURCE_ID_OUT 03FEH                                                  ''<HIDE>  
#define AB_OBJECT_OUT 03FFH                                                     ''<HIDE>          

#define MSG_SETUP_COMPLETE 8                                                    ''<HIDE>                                 

#define ABP_MSG_HEADER_C_BIT        040h                                        ''<HIDE>                                 
#define ABP_MSG_HEADER_E_BIT        080h                                        ''<HIDE>                                 
#define ABP_MSG_HEADER_CMD_BITS     03Fh                                        ''<HIDE>                                 

#define ABP_CMD_GET_ATTR 01h              'Get attribute                        ''<HIDE>
#define ABP_CMD_SET_ATTR 02h              'Set attribute                        ''<HIDE>

#define ABP_BOOL_SIZEOF             1     'Boolean                              ''<HIDE>     
#define ABP_ANB_IA_SETUP_COMPLETE   5                                           ''<HIDE>
#define ABP_ANB_STATE_PROCESS_ACTIVE 4                                          ''<HIDE>
#define ABS_BIT_ANB_STATE 07H                                                   ''<HIDE> 

#define ABS_BIT_CMDCNT 06H                                                      ''<HIDE> 
#define ABS_BIT_CRC 0100H                                                       ''<HIDE>
#define ABS_BIT_SPI_EOF 0001H                                                   ''<HIDE>
#define ABS_BIT_SPI_CTRL_PD_VALID 001H     'Process data from ADwin is valid    ''<HIDE>
#define ABS_BIT_SPI_CTRL_CMDCNT 006H       'ADwin is fast enough to process all amounts of data           ''<HIDE>
#define ABS_BIT_SPI_CTRL_M 008H                                                 ''<HIDE>
#define ABS_BIT_SPI_CTRL_LAST 010H                                              ''<HIDE>
#define ABS_BIT_SPI_CTRL_TOGGLE 080H                                            ''<HIDE>

#define ABS_BIT_ANB_STAT_S 07H                                                  ''<HIDE>
#define ABS_BIT_SPI_STAT_M 008H                                                 ''<HIDE>
#define ABS_BIT_SPI_STAT_LAST 010H                                              ''<HIDE>


#define ABS_SPI_STATE 25                                                        ''<HIDE>
#define ABS_SPI_STATE_INIT 1                                                    ''<HIDE>
#define ABS_SPI_STATE_WRITE 2                                                   ''<HIDE>
#define ABS_SPI_STATE_START_CYCLE 3                                             ''<HIDE>    
#define ABS_SPI_STATE_CHECK_STATE 4                                             ''<HIDE>
#define ABS_SPI_STATE_READ 5                                                    ''<HIDE>
#define ABS_SPI_MSG_SIZE 26                                                     ''<HIDE>
#define ABS_SPI_PD_SIZE 27                                                      ''<HIDE>
#define ABS_SPI_HDL 28                                                          ''<HIDE>
#define ABS_SPI_CYCLE_CNT 29                                                    ''<HIDE>  
#define ABS_SPI_ERROR_CNT 30                                                    ''<HIDE>
#define ABS_LED_STAT 31                                                         ''<HIDE>
#define ABS_ANB_STAT 32                                                         ''<HIDE>
#define ABS_SPI_STAT 33                                                         ''<HIDE>
#define ABS_NETTIME 34                                                          ''<HIDE>
#define ABS_SPI_CTRL 35                                                         ''<HIDE>
#define ABS_SPI_APP_STATE 36                                                    ''<HIDE>
#define ABS_SPI_INT_MASK 37                                                     ''<HIDE>
'#define ABS_MSG_OUT_PENDING 38                                                  ''<HIDE>
#define ABS_DO_MSG 39                                                           ''<HIDE>
#define AB_ERROR_BASE 40                                                        ''<HIDE>
#define AB_ERROR_Extention1 41                                                  ''<HIDE>
#define AB_ERROR_Extention2 42                                                  ''<HIDE>
#define AB_ERROR_Extention3 43                                                  ''<HIDE>
#define AB_OUTSTANDING_COMMANDS 44                                              ''<HIDE>
#define AB_CmdState 45                                                          ''<HIDE>
#define AB_PROC_TYPE_IN 46                                                      ''<HIDE>
#define AB_PROC_CNT_IN 47                                                       ''<HIDE>
#define AB_PROC_TYPE_OUT 48                                                     ''<HIDE>  
#define AB_PROC_CNT_OUT 49                                                      ''<HIDE>
#define ABS_SPI_NEW 50                                                          ''<HIDE>  
#define AB_INSTANCE_READ_REQUEST 51                                             ''<HIDE>
#define AB_READ_SOURCE_ID 52                                                    ''<HIDE>  
#define AB_READ_OBJ_NUM 53                                                      ''<HIDE>
#define AB_READ_INST_NUM 54                                                     ''<HIDE>  
#define AB_READ_ATTR_NUM 55                                                     ''<HIDE>
#define AB_MAPPING_CNT_IN 56                                                    ''<HIDE>
#define AB_MAPPING_CNT_OUT 57                                                   ''<HIDE>
#define AB_MAPPING_SIZE_IN 58                                                   ''<HIDE>
#define AB_MAPPING_SIZE_OUT 59                                                  ''<HIDE>
#define AB_MAPPING_DATA_TYPE 60                                                 ''<HIDE>
#define AB_DATA_TYPE_SINT32 3                                                   ''<HIDE>
#define AB_DATA_TYPE_UINT32 6                                                   ''<HIDE>
#define AB_DATA_TYPE_FLOAT 18                                                   ''<HIDE>
#define AB_DIR_IN 1                                                             ''<HIDE>  
#define AB_DIR_OUT 2                                                            ''<HIDE>  
#define AB_MAPPING_DEV_ADR 61                                                   ''<HIDE>
#define AB_MODUL_NUMBER 62                                                      ''<HIDE>
#define ABP_BUFFER_CONTROL_IDX 63                                               ''<HIDE>
#define ABP_TEMP_IDX 64                                                         ''<HIDE>
#define ABP_STATUS_REGISTER_IDX 65                                              ''<HIDE>
#define AB_USER_BUS_TYPE 66                                                     ''<HIDE>


#define ABP_BUFFER_CONTROL_ADR 01FFCH                                           ''<HIDE>
#define ABP_STATUS_REGISTER_ADR 01FFBH                                          ''<HIDE>
#define ABP_BIT_WRPD 01H                                                        ''<HIDE>
#define ABP_BIT_RDPD 02H                                                        ''<HIDE>
#define ABP_BIT_WRMSG 04H                                                       ''<HIDE>
#define ABP_BIT_RDMSG 08H                                                       ''<HIDE>
#define ABP_BIT_ANBR 010H                                                       ''<HIDE>
#define ABP_BIT_APPR 020H                                                       ''<HIDE>
#define ABP_PROCESS_DATA_WRITE_ADR 00000H                                       ''<HIDE>
#define ABP_PROCESS_DATA_READ_ADR 00800H                                        ''<HIDE>
#define ABP_MSG_DATA_WRITE_ADR 01000H                                           ''<HIDE>
#define ABP_MSG_DATA_READ_ADR 01800H                                            ''<HIDE>
#define ABP_MSG_DATA_LENGH 1536                                                 ''<HIDE>
'From this point the definitions are imported from the HMS C-driver example
'------------------------------------------------------------------------------
' Host application objects
'------------------------------------------------------------------------------

#define ABP_OBJ_NUM_PNIO            246   'PROFINET IO                          ''<HIDE>
#define ABP_OBJ_NUM_CCL             247   'CC-Link                              ''<HIDE>                    
#define ABP_OBJ_NUM_EIP             248   'EtherNet/IP                          ''<HIDE>
#define ABP_OBJ_NUM_ETN             249   'Ethernet                             ''<HIDE>
#define ABP_OBJ_NUM_MOD             250   'Modbus                               ''<HIDE>
#define ABP_OBJ_NUM_COP             251   'CANopen                              ''<HIDE>
#define ABP_OBJ_NUM_DEV             252   'DeviceNet                            ''<HIDE>
#define ABP_OBJ_NUM_DPV1            253   'PROFIBUS DP-V1                       ''<HIDE>
#define ABP_OBJ_NUM_APPD            254   'Application Data                     ''<HIDE>
#define ABP_OBJ_NUM_APP             255   'Application                          ''<HIDE>

'------------------------------------------------------------------------------
'State variable that keeps track of which initialization command to send next
'It is also used as a "source ID" to simplify the identification of responses
'from the Anybus-CC.
'------------------------------------------------------------------------------
#define MSG_INIT 0                                                              ''<HIDE>
#define MSG_NODE_ADR 1                                                          ''<HIDE>                   
#define MSG_BAUDRATE 2                                                          ''<HIDE>                                                          
#define MSG_MAP_IO_1 3                                                          ''<HIDE>
#define MSG_MAP_IO_2 4                                                          ''<HIDE>  
#define MSG_MAP_IO_3 5                                                          ''<HIDE>
#define MSG_MAP_IO_4 6                                                          ''<HIDE> 
#define MSG_DATA_FORMAT 7                                                       ''<HIDE>
#define MSG_SETUP_COMPLETE 8                                                    ''<HIDE>
#define MSG_DONE 9                                                              ''<HIDE> 
#define MSG_READ_REQUEST 10                                                     ''<HIDE>

'------------------------------------------------------------------------------
'Anybus module objects
'------------------------------------------------------------------------------

#define ABP_OBJ_NUM_ANB               1   'Anybus                               ''<HIDE>     
#define ABP_OBJ_NUM_DI                2   'Diagnostic                           ''<HIDE>
#define ABP_OBJ_NUM_NW                3   'Network                              ''<HIDE>
#define ABP_OBJ_NUM_NC                4   'Network Configuration                ''<HIDE>
#define ABP_OBJ_NUM_ADD               5   'PROFIBUS DP-V1 Additional Diag       ''<HIDE>
#define ABP_OBJ_NUM_RSV1              6   'Reserved                             ''<HIDE>
#define ABP_OBJ_NUM_SOC               7   'Socket Interface                     ''<HIDE>
#define ABP_OBJ_NUM_NWCCL             8   'Network CC-Link                      ''<HIDE>
#define ABP_OBJ_NUM_SMTP              9   'SMTP Client                          ''<HIDE>
#define ABP_OBJ_NUM_FSI              10   'File System Interface                ''<HIDE>
#define ABP_OBJ_NUM_NWDPV1           11   'Network PROFIBUS DP-V1               ''<HIDE>
#define ABP_OBJ_NUM_NWETN            12   'Network Ethernet                     ''<HIDE>
#define ABP_OBJ_NUM_CPC              13   'CIP Port Configuration               ''<HIDE>
#define ABP_OBJ_NUM_NWPNIO           14   'Network PROFINET IO                  ''<HIDE>
#define ABP_OBJ_NUM_PNIOADD          15   'PROFINET IO Additional Diag          ''<HIDE>

'------------------------------------------------------------------------------
'The Network object specific message commands.
'------------------------------------------------------------------------------

#define ABP_NW_CMD_MAP_ADI_WRITE_AREA        010h                               ''<HIDE>                            
#define ABP_NW_CMD_MAP_ADI_READ_AREA         011h                               ''<HIDE>
#define ABP_NW_CMD_MAP_ADI_WRITE_EXT_AREA    012h                               ''<HIDE>                            
#define ABP_NW_CMD_MAP_ADI_READ_EXT_AREA     013h                               ''<HIDE>

'The object instance number.
'------------------------------------------------------------------------------

#define ABP_INST_OBJ                0                                           ''<HIDE>

'------------------------------------------------------------------------------
'The object standard attributes.
'------------------------------------------------------------------------------

#define ABP_OA_NAME                 1     'Object name                          ''<HIDE>
#define ABP_OA_REV                  2     'Object revision                      ''<HIDE>
#define ABP_OA_NUM_INST             3     'Current number of instances          ''<HIDE>
#define ABP_OA_HIGHEST_INST         4     'Current highest instance number      ''<HIDE>

'------------------------------------------------------------------------------
'The data size of the object standard attributes (in bytes).
'------------------------------------------------------------------------------

#define ABP_OA_REV_DS               1                                           ''<HIDE>
#define ABP_OA_NUM_INST_DS          2                                           ''<HIDE>
#define ABP_OA_HIGHEST_INST_DS      2                                           ''<HIDE>
'------------------------------------------------------------------------------
'The Application data object specific message commands.
'------------------------------------------------------------------------------

#define ABP_APPD_CMD_GET_INST_BY_ORDER    010h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_NEXT_GUARDED     011h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_INST_NUMBERS     015h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_NAME        001h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_DATA_TYPE   002h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_NO_ELEMENTS 003h                                  ''<HIDE>
#define ABP_APPD_CMD_GET_ATTR_DISCRIPTOR  004h                                  ''<HIDE>


'Networktypes
#define AB_NETWORK_TYPE_PROFINET_IRT      089H                                  ''<HIDE>
#define AB_NETWORK_TYPE_PROFINET_FO       09DH                                  ''<HIDE>
#define AB_NETWORK_TYPE_PROFIBUS          005H                                  ''<HIDE>
#define AB_NETWORK_TYPE_ETHERCAT          087H                                  ''<HIDE>

'ADWIN ERRORCODES
#define AB_ERROR_CODE_UNSUP_OBJECT 3                                            ''<HIDE>
#define AB_ERROR_CODE_UNSUP_INSTANCE 4                                          ''<HIDE>
#define AB_ERROR_CODE_ATTR_NOT_GETTABLE 6                                       ''<HIDE>
#define AB_ERROR_CODE_UNSUP_COMMAND 5                                           ''<HIDE>
#define AB_ERROR_CODE_SETUP_FAILED 20                                            ''<HIDE>

#define AB_TRUE 1                                                               ''<HIDE>                               
#define AB_FALSE 0                                                              ''<HIDE>
#define AB_SENT 2                                                               ''<HIDE>
#define AB_HEADER_SIZE 6                                                        ''<HIDE>
#define AB_SPI_SEND_SIZE 32                                                     ''<HIDE>
'''min. length of work array
#define AB_WORK_ARR_LEN 5000



''' EMMC: number of bytes per sector
#define EMMC_SECTOR_SIZE 512 ' in bytes
''' EMMC: maximum number of sectors to be read/written with one library call
#define EMMC_TRANSACTION_MAX_SECTORS 128 ''<HIDE> 

''' EMMC: Access was OK
#define EMMC_RET_OK               0
''' EMMC: Read or Write error
#define EMMC_RET_ACCESS_ERROR     1
''' EMMC: Invalid sector
#define EMMC_RET_INVALID_SECTOR   4
''' EMMC: option not available on this hardware
#define EMMC_RET_NOT_AVAILABLE  100




'<ENDREGION>

'<REGION> System

'******************************************************************************
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'******************************************************************************
SUB SUB_BEGIN_CRITICAL_SECTION() ''<HIDE>
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
ENDSUB

SUB SUB_END_CRITICAL_SECTION() ''<HIDE>
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
ENDSUB


SUB SUB_BEGIN_CRITICAL_SECTION_LOW() ''<HIDE>
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION_LOW  
#ENDIF
ENDSUB
  
SUB SUB_END_CRITICAL_SECTION_LOW() ''<HIDE>
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION_LOW
#ENDIF
ENDSUB


Sub System_Array_Debug_Check(array[], startindex, length)  '<HIDE>
#IF DEBUG_MODE = ON THEN
  if ((startindex) + (length) - 1 > Get_Array_Length(array)) then
    PROZESS_FEHLER = 0C1000000H or Get_Array_No(array)
    end_exit
  endif
  ''  
  if ((startindex) < 1) then 
    PROZESS_FEHLER = 0C2000000H or Get_Array_No(array)
    end_exit
  endif
#endif
ENDSUB


sub System_ADC_Variante_Debug_Check(select_value) '<HIDE>
 
#IF DEBUG_MODE = ON THEN
 
  dim system,cnt as long
  dim int_value as long
  dim icnt, i,icnt2 as long
  dim opt as long
  
  opt=System_GET_Option()
  system= shift_right(opt,20) AND 11B 'as long ''<HIDE>
  if (system=1) then 
    cnt=8
  else
    if (system=0) then 
      cnt=1
    else
      if (system=2) then 
        cnt=2
      else
        cnt=4
      endif
    endif
  endif
  
  if (opt AND 100B=0) then cnt=0
  
  int_value=select_value AND 0FFH
  icnt=0
  for i=0 to 7
    icnt=icnt+(shift_right(int_value,i) AND 1) 
  next
  
  int_value=shift_right(select_value,8) AND 0FFH
  icnt2=0
 
  for i=0 to 7
    icnt2=icnt2+(shift_right(int_value,i) AND 1) 
  next
  
  
  if ((icnt>cnt) or (icnt2>cnt)) then 
    prozess_fehler=223001   
  endif
  
#endif

endsub



Function SizeOfArrayElement(array[]) As Long '<HIDE>
  SizeOfArrayElement = 1
  If (if_type_byte(array) = 1) then SizeOfArrayElement = 1
  If (if_type_short(array) = 1) then SizeOfArrayElement = 2
  If (if_type_long(array) = 1) then SizeOfArrayElement = 4
  If (if_type_float(array) = 1) then SizeOfArrayElement = 8 ' double!
  If (if_type_float32(array) = 1) then SizeOfArrayElement = 4
  If (if_type_int64(array) = 1) then SizeOfArrayElement = 8
EndFunction

 
**************************************************************
''' Converts a process frequency into processor ticks (processdelay or cycle time).
'''+return value: processor ticks
''' frequency:  frequency [Hz]
'''*************************************************************
Function Calc_Processdelay(frequency) as long
  calc_processdelay=1000000000.0/(frequency)
endfunction


'***************************************************************
''' Converts timer ticks into ns.
'''+return value: time in ns
''' ticks: counter value in ticks
'''*************************************************************
Function Calc_TicksToNs(ticks) As float
  dim t1 as long
  t1=ticks  ' important because: if the argument "ticks" is a subtraction of 2 timer values, this substraction is hereby forced to be done in long arithmetics
  Calc_TicksToNs=t1*1.0
endfunction


****************************************************************************
'''Configures the external Event input.
'''min_hold: Minimum time, which an event signal after an edge must be held to be accepted.
'''+         0: 15 ns (default)
'''+         1: 50 ns
'''edge: Type of edge, which is accepted
'''+         1: rising edge (default)
'''+         2: falling edge
'''+         3: rising & falling edge
'''prescaler: Number (1..15) of edges, after which an event signal is triggered (default 1)
'''****************************************************************************
SUB CPU_Event_Config(min_hold, edge, prescaler)
  DIM old AS Long
  DIM new AS Long
  old = peek_P2(50003000h) AND 7FFFFF00H
  new = shift_left((min_hold AND 1), 31) or (edge AND 3) or (shift_left(prescaler, 4)) or old
  poke(50003000h, new)
ENDSUB


'******************************************************************************
''' Resets the watchdog counter to the start value. The counter remains active.
'''****************************************************************************
Sub Watchdog_Reset()
  poke(5c009010h, 1)
EndSub

'******************************************************************************
''' Configures and activates the watchdog counter.
''' enable: set operating status of watchdog
'''+         1: activate and start Watchdog
'''+         0: deactivate Watchdog
''' time: start value (1..0FFFEh = 0..655ms) of watchdog counter in units of [10 s]
''' mode: bit pattern setting the resulting action of the watchdog
'''+   Bit 0=1: Reset processor. Hardware must then be booted.
'''+   Bit 2=1: Set output "Watchdog Out" to TTL level low
'''+   Bit 3=1: Set analog outputs OUT1..OUT8 to TTL level low
'''****************************************************************************
SUB Watchdog_Init(enable, time, mode)
  dim value as long
  value = enable AND 1
  
  if (value = 1) then
    value = value or shift_left((time + 1) AND 0FFFFH, 16) or shift_left(mode AND 1111B, 1)
  endif
  
  poke(5c009000h, value)
  
endsub

'******************************************************************************
'''Sets the output "Watchdog out" to a defined TTL level.
'''+ The output level can only be set if the watchdog is deactivated or the output
'''+ action is disabled (see Watchdog_init, parameter mode, bit 2).
'''level: TTL level of the output "Watchdog Out"
'''+         0: TTL level low
'''+         1: TTL level high
'''****************************************************************************
Sub Watchdog_Standby_Value(level)                          
  poke(5c009030h,  level)                     
endsub

'******************************************************************************
''' Gets watchdog state.
'''+     Bit 0: Operating mode
'''+       Bit 0=0: watchdog counter is disabled.
'''+       Bit 0=1: watchdog counter is enabled.
'''+     Bit 1: Detection of malfunction
'''+       Bit 1=0: no malfunction, watchdog is counting.
'''+       Bit 1=1: malfunction, watchdog counter has reached zero.
'''****************************************************************************
Function Watchdog_Status() as long                          'error clear by watchdog_init
  Watchdog_Status = peek_p2(5c009000h)
endfunction


'******************************************************************************
''' Starts specified actions synchronously
''' pattern: Bit pattern selecting the actions (see below) to be started.
'''+  Bit=1: start action synchronously; Bit=0: no effect.
'''+        Bit 0: Start ADC1 (channels 1..8) conversion, single shot
'''+        Bit 1: Start ADC1 (channels 1..8) conversion, continuous mode
'''+               Bits 0 and 1  must not be set at the same time.
'''+               You must run Start_Conv with single shot mode first, to set the used channels und the gain (if applicable).
'''+        Bit 2: Start ADC2 (channels 9..16) conversion, single shot
'''+        Bit 3: Start ADC2 (channels 9..16) conversion, continuous mode
'''+               Bits 2 and 3 must not be set at the same time.
'''+               You must run Start_Conv with single shot mode first, to set the used channels und the gain (if applicable).
'''+        Bit 4: Start conversion on all DAC1..DAC8 with values of DAC registers
'''+        Bit 5: Transfer status of DIO31:DIO00 to input latch 1
'''+        Bit 6: Transfer status of DIO61:DIO32 to input latch 2
'''+        Bit 7: Transfer status of DIO95:DIO62 to input latch 3
'''+        Bit 8: Write latch 1 to outputs DIO31:DIO00
'''+        Bit 9: Write Latch 2 to outputs DIO61:DIO32
'''+        Bit 10: Start edge output on output FIFO 1
'''+        Bit 11: Start edge output on output FIFO 2
'''+        Bit 12: Clear edge output on output FIFO 1
'''+        Bit 13: Clear edge output on output FIFO 2
'''+        Bit 14: Digin_FIFO_Clear 1  Clear edge detection of input FIFO 1
'''+        Bit 15: Digin_FIFO_Clear 2  Clear edge detection of input FIFO 2
'''+        Bit 16: Digin_FIFO_Clear 3  Clear edge detection of input FIFO 3
'''+        Bit 17: Clear reference counter of input FIFO 1
'''+        Bit 18: Clear reference counter of input FIFO 2
'''+        Bit 19: Clear reference counter of input FIFO 3
'''+        Bit 20: Set all counters to zero
'''+        Bit 21: Latch all counter values to buffers
'''+        Bit 22: Start SSI (single shot)
'''+        Bit 31: Creates an event for the T12 CPU
'''+                May be useful to process measurement values which are provided by a triggered action.
'''****************************************************************************
SUB Sync_All(pattern)
  Poke(5C00e000h,pattern)
endsub


'******************************************************************************
''' Starts specified actions synchronously from extern input 
''' pattern: Bit pattern selecting the actions (see below) to be started. 
'''+  Bit=1: start action synchronously; Bit=0: no effect.
'''+        Bit 0: Start ADC1 (channels 1..8) conversion, single shot
'''+        Bit 1: Start ADC1 (channels 1..8) conversion, continuous mode
'''+               Bits 0 and 1 must not be set at the same time.
'''+               You must run Start_Conv with single shot mode first, to set the used channels und the gain (if applicable).
'''+        Bit 2: Start ADC2 (channels 9..16) conversion, single shot
'''+        Bit 3: Start ADC2 (channels 9..16) conversion, continuous mode
'''+               Bits 2 and 3 must not be set at the same time.
'''+               You must run Start_Conv with single shot mode first, to set the used channels und the gain (if applicable).
'''+        Bit 4: Start conversion on all DAC1..DAC8 with values of DAC registers
'''+        Bit 5: Transfer status of DIO31:DIO00 to input latch 1
'''+        Bit 6: Transfer status of DIO61:DIO32 to input latch 2
'''+        Bit 7: Transfer status of DIO95:DIO62 to input latch 3
'''+        Bit 8: Write latch 1 to outputs DIO31:DIO00
'''+        Bit 9: Write Latch 2 to outputs DIO61:DIO32
'''+        Bit 10: Start edge output on output FIFO 1
'''+        Bit 11: Start edge output on output FIFO 2
'''+        Bit 12: Clear edge output on output FIFO 1
'''+        Bit 13: Clear edge output on output FIFO 2
'''+        Bit 14: Digin_FIFO_Clear 1  Clear edge detection of input FIFO 1
'''+        Bit 15: Digin_FIFO_Clear 2  Clear edge detection of input FIFO 2
'''+        Bit 16: Digin_FIFO_Clear 3  Clear edge detection of input FIFO 3
'''+        Bit 17: Clear reference counter of input FIFO 1
'''+        Bit 18: Clear reference counter of input FIFO 2
'''+        Bit 19: Clear reference counter of input FIFO 3
'''+        Bit 20: Set all counters to zero
'''+        Bit 21: Latch all counter values to buffers
'''+        Bit 22: Start SSI (single shot)
'''+        Bit 31: Creates an event for the T12 CPU
'''+                May be useful to process measurement values which are provided by a triggered action.
''' channel:  Select input channel where an incoming signal triggers actions.
'''+          0: off
'''+          1: DIO00 (TTL)
'''+          2: DIO16 (TTL)
'''+          3: DIO41 (Diff. I/O 2)
'''+          4: DIO36 (OPT In 1)
'''+          5: DIO85 (CNT8 CMP A In)
''' edge:     Edge type at the input channel which triggers the sync signal.
'''+          1=rising 
'''+          2=falling 
'''+          3=rising and falling
'''****************************************************************************
SUB Sync_All_Extern_Config(pattern,channel,edge)
  dim ed as long
  dim mode as long
 
  Poke(5C00e010h,pattern)
  mode=((channel) AND (111B))
  
  mode=mode or shift_left((edge) AND 11B,8)  
  Poke(5C00e020h,mode)
  
endsub



 
'******************************************************************************
''' Switches one LED on or off. 
'''  led_no: number (1..2) of the LED
'''+ LED 1 is used by the ADwin operating system, LED 2 is reserved for customer.
'''+   After power-on, LED 1 is red, after the "Boot" the LED 1 is blinking green.
'''+   (If you want to use LED 1 for an other purpose, you first have to stop the 
'''+   blinking process with the command Stop_Process(15) ).
'''  value:  0: off 
'''+         1: green
'''+         2: red
'''+         3: yellow
'''+         4: blue 
'''+         5: cyan
'''+         6: magenta
'''+         7: white
'''****************************************************************************
SUB Set_LED(led_no,value)
  if (led_no=1) then 
    POKE(50001100h, value)
  else
    POKE(50001200h, value)
  endif
ENDSUB


******************************************************************************
'''Returns the status of a LED.
'''+ return value: LED status.
'''+         0: off 
'''+         1: green
'''+         2: red
'''+         3: yellow
'''+         4: blue 
'''+         5: cyan
'''+         6: magenta
'''+         7: white
''' led_no: 1..2
'''****************************************************************************
FUNCTION Check_LED(led_no) AS Long
  if (led_no=1) then 
    CHECK_LED = (PEEK_P2(50001100h) and 111B)
  else
    CHECK_LED= (PEEK_P2(50001200h) and 111B)
  endif  
ENDFUNCTION


******************************************************************************
''' Switches one LED off or sets to rgb color. 
'''+Use (0,0,0) to switch off the LED.
'''+If you use Set_LED_RGB on a LED, the command check_led doesn't work.
'''  led_no: number (1..2) of the LED
'''+ LED 1 is used by the ADwin operating system, LED 2 is reserved for customer.
'''+   After power-on, LED 1 is red, after booting the LED 1 is blinking green.
'''+   (If you want to use LED 1 for an other purpose, you first have to stop the 
'''+   blinking process with the command Stop_Process(15) ).
'''  red:   Red component (0..255) of the LED color.
'''  green: Green component (0..255) of the LED color.
'''  blue:  Blue component (0..255) of the LED color.
'''+ examples
'''+  white   (255,255,255)
'''+  red     (255,  0,  0)
'''+  green   (  0,255,  0)
'''+  blue    (  0,  0,255)
'''+  yellow  (255,255,  0)
'''+  cyan    (  0,255,255)
'''+  magenta (255,  0,255)
'''+  gold    (255,215,  0)
'''+  gray    (128,128,128)
'''****************************************************************************
SUB Set_LED_RGB(led_no,red,green,blue)
  dim value as long
  
  value=blue or shift_left(green,8) or shift_left(red,16)
  
  if (led_no=1) then 
    POKE(50001120h, value)
  else
    POKE(50001220h, value)
  endif
  
ENDSUB

'
'''****************************************************************************
'''' Get compile dateTime as string
'''' timestamp[]: Return value as string
''''*******************************************************************************
'Sub Process_Compile_on(timestamp[]) 
'  REM --> Alternative: Process_Compile_Time()
'  dim i3[50] as string
'  BEGIN_C{
'  strcpy(I3, "Compiled on: " __TIME__ " " __DATE__); 
'  }END_C
'  timestamp=i3
'ENDSUB


'<ENDREGION>

'<REGION> CAN
*************************************************************************
''' Sets a register of the CAN interface.
''' channel: number of the CAN interface on the CAN module
''' regno: register which should be set (relative address)
''' value: value which should be written to the register.
'''****************************************************************************
Sub CAN_Set_Reg(channel, regno, value) '<HIDE>
  poke(0E0007000H + (regno)+((channel)*1000H),value)
EndSub


'******************************************************************************
''' Reads a register of the CAN interface.
'''+ return value: value of the register
''' channel: number of the CAN interface on the CAN module
''' regno: register to read (relative address)
'''****************************************************************************
Function CAN_Get_Reg(channel, regno) As Long '<HIDE>
  CAN_Get_Reg=peek_P2(0E0007000H + (regno)+((channel)*1000H))
EndFunction  




'******************************************************************************
''' Initializes a CAN interface and sets the baudrate of the CAN bus.
'''+return value: Status of initialization
'''+         0: baudrate is set
'''+         1: selected baudrate is not set
'''+        -1: no can option on this board
'''channel: number (1..2) of the CAN interface
'''+(also necessary if only one channel is available)
'''baudrate: CAN bus baudrate in bit/second
'''*****************************************************************************
Function CAN_Init(channel, baudrate) as long
  CAN_INIT=CAN_INIT_LIB(channel,baudrate)
ENDFUNCTION


'******************************************************************************
''' Sets a receive filter for CAN messages with a selected identifier.
'''+return value: Filter status
'''+         0: filter ist configured.
'''+       <>0: error (no filter is set).
''' channel: Number (1..2) of the CAN interface
''' filter_no: Number (1..4) of the receive filter
''' filter_enable: Filter status
'''+         0: disable filter.
'''+         1: enable filter.
''' id: Identifier of CAN messages which can be received
''' id_extend: identifier length
'''+         0: 11 bit
'''+         1: 29 bit
'''*****************************************************************************
function CAN_RX_Set_Filter(channel, filter_no, filter_enable, id, id_extend) as long
  dim _AFRo as long
  dim fb as long
  dim ret as long
  dim _to as long
  dim _t as long

  _AFRo = CAN_Get_reg(channel, CAN_AFR)
  CAN_Set_reg(channel, CAN_AFR, 0)                          ' all Filter disable
  _to = 0
  do
    inc _to
    ret = shift_right(CAN_Get_reg(channel, CAN_SR), 11) and 1  ' check disable ca 120nsec
  until ((ret = 0) or (_to = 100))                          ' ca. 0.012ms TO

  if (ret = 0) then                                         'OK
    if (id_extend = 1) then                               ' 29bit
      CAN_Set_reg(channel, 5CH + ((filter_no) * 8), 0FFFFFFFFh)  'set AFMRx 1..4
      _t = shift_left(id, 21)
      _t = _t or shift_left(1, 20)                          ' SRR
      _t = _t or shift_left(1, 19)                          ' IDE
      _t = _t or (shift_left(shift_right((id and 1FFFF800h), 11), 1))  'ext,18)

      CAN_SET_reg(channel, 60H + ((filter_no) * 8), _t)        'set AFIRx 1..4             
      
    else
      CAN_Set_reg(channel, 5CH + ((filter_no) * 8), 0FFF80000h)  'set AFMRx 1..4
      _t = shift_left(id, 21)
      CAN_SET_reg(channel, 60H + ((filter_no) * 8), _t)        'set AFIRx 1..4             
    endif
    fb = shift_left(1, (filter_no) - 1)
    if (Filter_Enable = 0) then 
      _AFRo = _AFRo AND Not(fb)                             ' disable
    else 
      _AFRo = _AFRo or fb                                   ' enable
    endif
    CAN_Set_reg(channel, CAN_AFR, _AFRo)
    CAN_RX_Set_Filter = 0
  else 
    CAN_Set_reg(channel, CAN_AFR, _AFRo)
    CAN_RX_Set_Filter = -1                                  ' disable not possible
  endif
endfunction



'*******************************************************************************
''' Reads the oldest CAN message from the receive FIFO or returns -1.
'''+return value:
'''+         -1: no message in the receive FIFO
'''+       <>-1: identifier of CAN message
'''+The CAN message (if any) is returned in CAN_Msg[].
'''+         Content of CAN_MSG[]:
'''+         [1..8]: CAN data
'''+            [9]: length of CAN Message
'''+           [10]: identifier
'''+           [11]: timestamp of receipt
''' channel: number (1..2) of CAN interface
'''*****************************************************************************
Function CAN_Receive(channel) as long
  CAN_Receive=CAN_Receive_lib(channel,can_msg)
ENDFUNCTION


'*******************************************************************************
''' Transmits the message in CAN_Msg[] to the send FIFO.
'''+return value: Transmit status
'''+        -1: buffer full, transmit message later.
'''+         0: message is transmitted to send FIFO.
''' channel: number (1..2) of CAN interface
''' priority: Transmit priority
'''+         0: Normal priority, message is sent via output FIFO
'''+         1: High  priority, message is to be sent next
''' id_extend: identifier length
'''+         0: 11 bit identifier
'''+         1: 29 bit identifier
'''****************************************************************************
Function CAN_Transmit(channel, priority, id_extend) as long
  CAN_Transmit=CAN_Transmit_lib(channel,priority,id_extend,can_msg)
endfunction



'---------------------------------------------------------------
''' Reads the register where the bus error pin of the tranceiver
'''+ is stored.
'''+ The register is set when  a bus error occurs and is reset by
'''+ reading the register.
'''+ Attention: This command is only for low-speed CAN
'''+ return value: Bus status 
'''+         0: no error
'''+         1: error
''' channel: number of the CAN interface on the CAN module
'''---------------------------------------------------------------
Function CAN_Get_Line_Status(channel) As Long 
  dim value as long
  value = Peek_P2(5C00d800H) 
  value=value XOR 11B
  CAN_Get_Line_Status = shift_right(value, ((channel)-1)) AND 1
EndFunction

'<ENDREGION>

'<REGION> RS232
*************************************************************************
''' Sets a register of the RS controller.
''' channel: (1) number of the RS interface
''' regno:   register which should be set (relative address)
''' value:   value which should be written to the register.
'''****************************************************************************
Sub RS_Set_Reg(channel, regno, value) ''<HIDE>
  ' poke(0DFFFF000H + (regno)+((channel)*1000H),value)
  poke(0E0002000H + (regno)-((channel)*1000H),value)
  
EndSub


'******************************************************************************
''' Reads a register of the RS controller.
'''+ return value: value of the register
''' channel: 1 number of the RS interface 
''' regno:   register to read (relative address)
'''****************************************************************************
Function RS_Get_Reg(channel, regno) As Long ''<HIDE>
  RS_Get_Reg=peek_P2(0E0002000H + (regno)-((channel)*1000H))
EndFunction  


'******************************************************************************
'''Initializes a serial interface.
'''channel: number (1) of the serial interface
'''baud_rate: Baudrate (35..115200) for RS232 communication
'''+        typical rates: 115200, 57600, 38400, 19200, 9600
'''+                         4800,  2400,  1200,   600,  300
'''+        other baudrates possible
'''parity: use of test bits
'''+          0: no parity
'''+          1: even
'''+          2: odd
'''bits: Number (6..8) of data bits for RS232 communication
'''stop: number of stop bits
'''+          0: 1 stop bit
'''+          1: 1.5 stop bits 
'''+          2: 2 stop bits 
'''handshake: transfer protocol
'''+          0: RS232, no handshake
'''+          1: RS232, hardware handshake (RTS/CTS)
'''+          3: RS485
'''****************************************************************************
sub RS_Init(channel, baud_rate, parity, bits, stop, handshake)
  RS_Init_lib(channel,  baud_rate, parity, bits, stop, handshake) 
endsub


  


'******************************************************************************
'''Writes a byte value to the transmit FIFO, if the FIFO is not full.
'''+return value: status of send FIFO
'''+          0: value is written to the FIFO
'''+          1: FIFO full, try again
'''channel: number (1) of the serial interface
'''value: value which should be written to the FIFO
'''****************************************************************************
function RS_Write_FIFO(channel, value) as Long
  '
  dim status as long
  
  status=RS_Get_Reg(channel, 2CH) AND 10000B 'status
  if (status>0) then 
    RS_Write_FIFO=1
  else
    RS_Set_Reg(channel, 30H, value) 'write fifo          
    RS_Write_FIFO=0
  endif
    
endfunction


'******************************************************************************
'''Checks if write fifo is full.
'''+ return value:
'''+          0: one or more byte in write fifo is free
'''+          1: FIFO full
'''channel: number (1) of the serial interface
'''***************************************************************
function RS_Write_FIFO_Full(channel) as Long
  dim status as long
  status=RS_Get_Reg(channel, 2CH) AND 10000B 'status
  
  if (status>0) then 
    RS_Write_FIFO_Full=1
  else 
    RS_Write_FIFO_Full=0
  endif
endfunction


'******************************************************************************
'''Checks if write fifo is empty
'''+ return value:
'''+          0: one or more byte in write fifo or shift_register
'''+          1: FIFO and output shift_register empty
'''channel: (1) number of the serial interface
'''***************************************************************
function RS_Write_FIFO_Empty(channel) as Long
  dim status as long
  dim empty as long
  dim shift_register as long
  status=RS_Get_Reg(channel, 2CH) 'status
  empty=status AND 1000B '0 = not empty
  shift_register=shift_right(status,11) AND 1  
  
  if ((empty>0) AND (shift_register=0)) then 
    RS_Write_FIFO_Empty=1
  else 
    RS_Write_FIFO_Empty=0
  endif
endfunction

'******************************************************************************
'''Reads byte from the receive FIFO return value:
'''+read_fifo: 
'''+     0..255: value of the received byte
'''+         -1: no bytes in the receive FIFO
'''channel: (1) number of the serial interface 
'''****************************************************************************
function RS_Read_FIFO(channel) as Long
 
  dim status as long
  
  status=RS_Get_Reg(channel, 2CH) AND 10B 'status
  
  
  if (status>0) then 
    RS_Read_FIFO=-1
  else
    RS_Read_FIFO=RS_Get_Reg(channel, 30H) 'read fifo
  endif
endfunction


'******************************************************************************
'''Selects whether the interface is sending data or is listening on the bus.
'''+Only for RS485.
'''channel: number of the serial interface
'''value:        
'''+          0: Listening  (default)
'''+          1: Sending Data
'''****************************************************************************
sub RS_485_Send(channel, value)
  ' poke(0c000418h + 8 * (channel), value + 1)                'write read adress
  ' poke(5c00d000h,shift_left(value,1)) 'rs 485
  
  poke(5c00d000h,shift_left(value,1) or 1) '
  
endsub


'<ENDREGION>

'<REGION> ADC 

'******************************************************************************
''' Samples, converts and reads out an ADC-value with 16 bit resolution.
'''+ Attention:                                                 
'''+ This instruction is not prepared to handle an access from  
'''+ a low AND high priority process to the same module.     
'''+ return value: 16 bit Long
''' channel: channel number (1..16) of analog input
'''****************************************************************************
FUNCTION ADC(channel) as Long

  if (channel<9) then 
    Start_Conv(shift_left(1,(channel)-1),1)
    wait_eoc(1)
  else
    Start_Conv(shift_left(1,(channel)-1),100B)
    wait_eoc(2)
  endif
  
    
  ADC=Read_ADC(channel)

ENDFUNCTION



'******************************************************************************
''' Samples, converts and reads out an ADC-value with 24 bit resolution.
'''+ Attention:                                                 
'''+ This instruction is not prepared to handle an access from  
'''+ a low AND high priority process to the same module.     
'''+ return value: 24 bit Long
''' channel: channel number (1..16) of analog input
'''****************************************************************************
FUNCTION ADC24(channel) as Long
 
  if (channel<9) then 
    Start_Conv(shift_left(1,(channel)-1),1)
    wait_eoc(1)
  else
    Start_Conv(shift_left(1,(channel)-1),100B)
    wait_eoc(2)
  endif
  ADC24=Read_ADC24(channel)
ENDFUNCTION





'*****************************************************************************
'''Reads one ADC-value with 16 bit resolution.
''' channel: channel number (1..16) of analog input 
'''*********************************************
Function Read_ADC(channel) as long   
  Read_ADC=peek_p2(5C310000h+((channel)-1)*16)   
endfunction

'*****************************************************************************
'''Returns the ADC-values (16 bit) from a channel pair as packed value.
'''+return value: 32 bit value holding 2 values of 16 bit each:
'''+          Bits  0..15: Value of channel n
'''+          Bits 16..31: Value of channel n+1
''' ch_pair: Number (1..8) to select channel pair of analog inputs
'''+          1: Channels 1 and 2
'''+          2: Channels 3 and 4
'''+          3: Channels 5 and 6
'''+          4: Channels 7 and 8
'''+          5: Channels 9 and 10
'''+          6: Channels 11 and 12
'''+          7: Channels 13 and 14
'''+          8: Channels 15 and 16
'''*********************************************
Function Read_ADC_Packed(ch_pair) as long    
  Read_ADC_packed=peek_p2(5C320000h+((ch_pair)-1)*16)     
endfunction

'*****************************************************************************
'''Reads one ADC-value with 24 bit resolution.
''' channel: channel number (1..16) of analog input 
'''*********************************************
Function Read_ADC24(channel) as long 
  Read_ADC24=peek_p2(5C300000h+((channel)-1)*16)
endfunction


'******************************************************************************
''' Waits until EOC signals of all selected ADCs are active.
''' pattern: bit pattern to select the ADCs
'''+          bit 0 = 1: ADC 1 (channels 1..8)
'''+          bit 1 = 1: ADC 2 (channels 9..15)
'''****************************************************************************
SUB Wait_EOC(pattern)
  Dim reminder as Long
  do
    reminder =peek_p2(5C380000h) and pattern
  until (reminder = pattern)
ENDSUB

'******************************************************************************
'''Starts a conversion on the selected channels and ADCs.
'''channel_select: bit pattern, each bit corresponds to a channel.
'''+  Set bit to 1 to start a conversion on this channel.
'''+        bit 0: channel 1  (ADC 1)
'''+        ...
'''+        bit 7: channel 8  (ADC 1)
'''+        bit 8: channel 9  (ADC 2)
'''+        ...
'''+        bit 15: channel 16 (ADC 2)
'''+ with version M1, you can select only one channel per ADC.
'''mode: select ADC and operating mode; ADC must fit to selected channels
'''+        bit 0 = 1: start single shot mode on ADC1, channels 1..8
'''+        bit 1 = 1: start continuous mode on ADC1, channels 1..8
'''+        bit 2 = 1: start single shot mode on ADC2, channels 9..16
'''+        bit 3 = 1: start continuous mode on ADC2, channels 9..16
SUB Start_Conv(channel_select,mode)
  
  dim help as long
  
  help=shift_left(((channel_select) AND 0FFFFH),8) or  ((mode) AND 1111B)  
  poke(5C380000h,help) '  
 
  System_ADC_Variante_Debug_Check(channel_select)
  
ENDSUB


'---------------------------------------------------------------
''' Sets the input range (only Gold III fast option) of the input channels.
''' gain_pattern: each bit pair corresponds to a channel
'''+        00b: +-10V
'''+        01b: +-5V 
'''+        10b, 11b: reserved
'''+        Bit pair 0,1:   channel 1 
'''+        Bit pair 2,3:   channel 2
'''+        Bit pair 4,5:   channel 3
'''+        Bit pair 6,7:   channel 4
'''+        Bit pair 8,9:   channel 5
'''+        Bit pair 10,11: channel 6
'''+        Bit pair 12,13: channel 7
'''+        Bit pair 14,15: channel 8 
'''+        Bit pair 16,17: channel 9 
'''+        Bit pair 18,19: channel 10
'''+        Bit pair 20,21: channel 11
'''+        Bit pair 22,23: channel 12
'''+        Bit pair 24,25: channel 13
'''+        Bit pair 26,27: channel 14
'''+        Bit pair 28,29: channel 15
'''+        Bit pair 30,31: channel 16
'''---------------------------------------------------------------
Sub Set_Gain(gain_pattern)
  poke(5C380080h,gain_pattern) '  
EndSub


*****************************************************************************
'''Measures the voltages of the analog inputs 1..16 and returns the corresponding
'''+digital values (24 bit) in a destination array (only Gold III fast option)
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB ADC16_24(array[], array_idx)
 
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 16)
  
  Start_Conv(0FFFFH,101B)
  
  Wait_EOC(11B)
  for i=0 to 15
    array[array_idx+i]=read_adc24(i+1)
  next  
  
ENDSUB

*****************************************************************************
'''Measures the voltages of 8 selected analog inputs and returns the corresponding
'''+digital values (24 bit) in a destination array (only Gold III fast option)
'''channel_group: number (0..1) of channel group
'''+          0: channels 1,2,3,4,9,10,11,12
'''+          1: channels 5,6,7,8,13,14,15,16
'''array[]: destination array
'''array_idx: start index at the destination array[]
'''*****************************************************************************
SUB ADC8_24(channel_group,array[], array_idx)
  dim index as long
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 8)
  
  if (channel_group=0) then 
    Start_Conv(00F0FH,101B)
    index=1
  else
    Start_Conv(0F0F0H,101B)
    index=5
  endif
  
  Wait_EOC(11B)

  for i=0 to 7
    array[array_idx+i]=read_adc24(index)
    inc index
    if (i=3) then index=index+4
  next  
  
ENDSUB


*****************************************************************************
'''Measures the voltages of 4 selected analog inputs and returns the corresponding
'''+digital values (24 bit) in a destination array (only Gold III fast option)
'''channel_group: number (0..3) of selected channel group
'''+          0: channels 1,2,9,10
'''+          1: channels 3,4,11,12
'''+          2: channels 5,6,13,14
'''+          3: channels 7,8,15,16
'''array[]: destination array
'''array_idx: start index at the destination array[]
'''*****************************************************************************
SUB ADC4_24(channel_group,array[], array_idx)
  dim index as long
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 4)
  
  if (channel_group=0) then 
    Start_Conv(shift_left(303H,0),101B)
    index=1
  else
    if (channel_group=1) then 
      Start_Conv(shift_left(303H,2),101B)
      index=3
    else
     
      if (channel_group=2) then 
        Start_Conv(shift_left(303H,4),101B)
        index=5
      else
        Start_Conv(shift_left(303H,6),101B)
        index=7
      endif
    endif
  endif
  
      
  Wait_EOC(11B)

  for i=0 to 3
    array[array_idx+i]=read_adc24(index)
    inc index
    if (i=1) then index=index+6
  next  
  
ENDSUB



*****************************************************************************
'''Measures the voltages of the analog inputs 1..16 and returns the corresponding
'''+digital values (16 bit) in a destination array (only Gold III fast option)
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB ADC16_16(array[], array_idx)
 
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 16)
  
  Start_Conv(0FFFFH,101B)
  
  Wait_EOC(11B)
  for i=0 to 15
    array[array_idx+i]=read_adc(i+1)
  next  
  
ENDSUB

*****************************************************************************
'''Measures the voltages of 8 selected analog inputs and returns the corresponding
'''+digital values (16 bit) in a destination array (only Gold III fast option)
'''channel_group: number (0..1) of channel group
'''+          0: channels 1,2,3,4,9,10,11,12
'''+          1: channels 5,6,7,8,13,14,15,16
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB ADC8_16(channel_group,array[], array_idx)
  dim index as long
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 8)
  
  if (channel_group=0) then 
    Start_Conv(00F0FH,101B)
    index=1
  else
    Start_Conv(0F0F0H,101B)
    index=5
  endif
  
  Wait_EOC(11B)

  for i=0 to 7
    array[array_idx+i]=read_adc(index)
    inc index
    if (i=3) then index=index+4
  next  
  
ENDSUB


*****************************************************************************
'''Measures the voltages of 4 selected analog inputs and returns the corresponding
'''+digital values (16 bit) in a destination array (only Gold III fast option)
'''channel_group: number (0..3) of selected channel group
'''+          0: channels 1,2,9,10
'''+          1: channels 3,4,11,12
'''+          2: channels 5,6,13,14
'''+          3: channels 7,8,15,16
'''array[]: destination array
'''array_idx: start index at the destination array
'''*****************************************************************************
SUB ADC4_16(channel_group,array[], array_idx)
  dim index as long
  dim i as long
    
  System_Array_Debug_Check(array, array_idx, 4)
  
  if (channel_group=0) then 
    Start_Conv(shift_left(303H,0),101B)
    index=1
  else
    if (channel_group=1) then 
      Start_Conv(shift_left(303H,2),101B)
      index=3
    else
     
      if (channel_group=2) then 
        Start_Conv(shift_left(303H,4),101B)
        index=5
      else
        Start_Conv(shift_left(303H,6),101B)
        index=7
      endif
    endif
  endif
  
      
  Wait_EOC(11B)

  for i=0 to 3
    array[array_idx+i]=read_adc(index)
    inc index
    if (i=1) then index=index+6
  next  
  
ENDSUB


'<ENDREGION>

'<REGION> Digital 

'******************************************************************************
''' Initializes the digital I/O as inputs or outputs.
''' pattern: Bit pattern that configures digital channels as inputs or outputs
'''+          bit=0: channels as inputs
'''+          bit=1: channels as outputs
'''+          Bit 0: DIO00..DIO07
'''+          Bit 1: DIO08..DIO15
'''+          Bit 2: DIO16..DIO23
'''+          Bit 3: DIO24..DIO31
'''+          Bit 4: DIO40
'''+          Bit 5: DIO41
'''+          Bit 6: DIO42
'''+          Bit 7: DIO43
'''****************************************************************************
SUB Conf_DIO(pattern)
  POKE (5C141000h, pattern)
ENDSUB

******************************************************************************
''' Sets the digital outputs (bits 0..31) to defined TTL levels.
''' pattern: Bit pattern representing the TTL levels at the outputs
'''+          bit=0: set TTL level low
'''+          bit=1: set TTL level high
'''+          Bit 0:  DIO00
'''+          ..
'''+          Bit 31: DIO31
'''****************************************************************************
SUB Digout_Long1(pattern)
  POKE (5C100000h, pattern) 
ENDSUB

******************************************************************************
''' Sets the digital outputs (bits 32..35;40..43).
''' pattern: Bit pattern representing the TTL levels at the outputs
'''+          bit=0: set TTL level low
'''+          bit=1: set TTL level high
'''+          Bit 32: DIO32
'''+          ..
'''+          Bit 32: DIO35
'''+          Bit 40: DIO40
'''+          ..
'''+          Bit 43: DIO43
'''****************************************************************************
SUB Digout_Long2(pattern)
  POKE (5C100004h, pattern) 
ENDSUB

'******************************************************************************
''' Reads the digital inputs (channels 0..31).
'''+return value: Bit pattern representing the TTL levels at the inputs
'''+          bit=0: TTL level low
'''+          bit=1: TTL level high
'''+          Bit 0:  DIO00
'''+          ..
'''+          Bit 31: DIO31
'''+If a channel is configured as output, its bit will return an undefined value.
'''+After power-on, all digital channels are configured as inputs.
'''+Use Conf_DIO to configure channels as inputs or outputs in groups of 8.
'''****************************************************************************
FUNCTION Digin_Long1() as Long
  digin_long1=Peek_P2(5C101000h)
ENDFUNCTION

'******************************************************************************
''' Reads the digital inputs (channels 32..59).
'''+return value: Bit pattern representing the TTL levels at the inputs
'''+          bit=0: TTL level low
'''+          bit=1: TTL level high
'''+          Bit 0:  DIO32
'''+          ..
'''+          Bit 27: DIO59
''''+Please note: DIO63:DIO60 are reserved and not available.
'''+If a channel is configured as output, its bit will return an undefined value.
'''+Channels DIO39:36 and DIO51:48 are always inputs; DIO47:44 can be individually
'''+configured as inputs or outputs with Conf_DIO.
''****************************************************************************
FUNCTION Digin_Long2() as Long
  digin_Long2 =Peek_P2(5C101004h)
ENDFUNCTION


'******************************************************************************
''' Reads the digital inputs (channel 64..91).
'''+return value: Bit pattern representing the TTL levels at the inputs
'''+          bit=0: TTL level low
'''+          bit=1: TTL level high
'''+          Bit 0:  DIO64
'''+          ..
'''+          Bit 27: DIO91
'''+Please note: DIO95:DIO92 are reserved and not available.
'''****************************************************************************
FUNCTION Digin_Long3() as Long
  digin_Long3 =Peek_P2(5C101008h)
ENDFUNCTION


***************************************************************************
'''Sets output register (channel 0..31).
'''pattern: each bit corresponds to a channel
'''*****************************************************************************
SUB Digout_Write_Latch1(pattern)
  POKE (5C100100h, pattern) 
ENDSUB


***************************************************************************
'''Sets output register (channel 32..64).
'''pattern: each bit corresponds to a channel
'''*****************************************************************************
SUB Digout_Write_Latch2(pattern)
  POKE (5C100104h, pattern) 
ENDSUB



'******************************************************************************
'''Reads the input latch register (channel 0..31).
'''+return value: Bit pattern representing the TTL levels at the inputs
'''+          bit=0: TTL level low
'''+          bit=1: TTL level high
'''+          Bit 0:  DIO00
'''+          ..
'''+          Bit 31: DIO31
'''****************************************************************************
FUNCTION Digin_Read_Latch1() AS Long
  Digin_Read_Latch1 = Peek_P2(5C101100h)
ENDFUNCTION


'******************************************************************************
'''Reads the input latch register (channel 32..59).
'''+return value: Bit pattern representing the TTL levels at the inputs
'''+          bit=0: TTL level low
'''+          bit=1: TTL level high
'''+          Bit 0:  DIO32
'''+          ..
'''+          Bit 27: DIO59
''''+Please note: DIO63:DIO60 are reserved and not available.
'''+If a channel is configured as output, its bit will return an undefined value.
'''+Channels DIO39:36 and DIO51:48 are always inputs; DIO47:44 can be individually
'''+configured as inputs or outputs with Conf_DIO.
'''****************************************************************************
FUNCTION Digin_Read_Latch2() AS Long
  Digin_Read_Latch2 = Peek_P2(5C101104h)
ENDFUNCTION



'******************************************************************************
'''Reads the input latch register (channel 64..95).
'''****************************************************************************
FUNCTION Digin_Read_Latch3() AS Long
  Digin_Read_Latch3 = Peek_P2(5C101108h)
ENDFUNCTION


'******************************************************************************
'''Latches the digital I/Os
'''+ Inputs are latched in the input registers.
'''+ Outputs are set according to the output register.
'''pattern: Bit pattern to select the channel groups to be latched
'''+          Bit 0: latch input channels DIO00..DIO31 to input register
'''+          Bit 1: latch input channels DIO63..DIO32 to input register
'''+          Bit 2: latch input channels DIO95..DIO64 to input register
'''+          Bit 3: write output register to output channels DIO00..DIO31
'''+          Bit 4: write output register to output channels DIO63..DIO32
'''******************************************************************************
SUB Dig_Latch(pattern)
  Poke(5C00e000h,shift_left(((pattern) AND 11111B),5))
ENDSUB



'******************************************************************************
''' Sets or resets one channel of a digital output.
''' channel: channel number (0..63)
''' value: TTL level to which the output is set.
'''+          0: Set to TTL level low.
'''+          1: Set to TTL level high.
'''****************************************************************************
SUB Digout(channel, value)
  if (channel>31) then
    if (value AND 1 = 1) then
      POKE (5C100204h, shift_left(1, ((channel)-32))) 
    else
      POKE (5C100214h, shift_left(1, ((channel)-32))) 
    endif
  else
    if (value AND 1 = 1) then
      poke(5C100200h, shift_left(1, channel))
    else
      poke(5C100210h, shift_left(1, channel))
    endif  
  endif
ENDSUB

'---------------------------------------------------------------
''' Sets and clears selected digital outputs (0..31).
''' set:    Bit pattern indicating the outputs which should be set
'''+          bit=0: do not change TTL Level.
'''+          bit=1: Set to TTL level high.
'''+          Bit 0:  DIO00
'''+          ..
'''+          Bit 31: DIO31
''' clear:  Bitstring indicating the outputs which should be reset
'''+          bit=0: do not change TTL Level.
'''+          bit=1: Set to TTL level low.
'''+          Bit 0:  DIO00
'''+          ..
'''+          Bit 31: DIO31
'''-------------------------------------------------------------
Sub Digout_Bits1(set, clear)
  poke(5C100200h, set)
  poke(5C100210h, clear)
EndSub

'---------------------------------------------------------------
''' Sets and resets selected digital outputs.(bits 32..59).
''' set:    Bit pattern indicating the outputs which should be set
'''+          bit=0: do not change TTL Level.
'''+          bit=1: Set to TTL level high.
'''+          Bit 0:  DIO32
'''+          ..
'''+          Bit 27: DIO59
''' clear:  Bitstring indicating the outputs which should be reset
'''+          bit=0: do not change TTL Level.
'''+          bit=1: Set to TTL level low.
'''+          Bit 0:  DIO32
'''+          ..
'''+          Bit 27: DIO59
'''-------------------------------------------------------------
Sub Digout_Bits2(set, clear)
  poke(5C100204h, set)
  poke(5C100214h, clear)
EndSub

'******************************************************************************
''' Reads the input of one digital input.
'''+return value: TTL level of the digital input
'''+          0: TTL level low
'''+          1: TTL level high
'''channel: Number (0..91) of digital input.
'''****************************************************************************
FUNCTION Digin(channel) as Long
  if (channel<32) then 
    Digin=shift_right( Peek_P2(5C101000h), (channel)) AND 1
  else
    if (channel<64) then 
      Digin=shift_right( Peek_P2(5C101004h), (channel)-32) AND 1
    else
      Digin=shift_right( Peek_P2(5C101008h), (channel)-64) AND 1
    endif    
  endif
ENDFUNCTION

'******************************************************************************
''' Reads back the output values of the digital outputs (0..31).
'''+return value: Bit pattern indicating the output levels
'''+          bit=0: TTL Level low
'''+          bit=1: TTL level high
'''+          Bit 0:  DIO00
'''+          ..
'''+          Bit 31: DIO31
'''****************************************************************************
FUNCTION Get_Digout_Long1() AS Long
  Get_DIGOUT_long1 =Peek_P2(5C100000h)
ENDFUNCTION

'******************************************************************************
''' Reads back the output values of the digital outputs (bits 32..59).
'''+return value: Bit pattern indicating the output levels
'''+          bit=0: TTL Level low
'''+          bit=1: TTL level high
'''+          Bit 0:  DIO32
'''+          ..
'''+          Bit 27: DIO59
''''+Please note: DIO63:DIO60 are reserved and not available.
'''****************************************************************************
FUNCTION Get_Digout_Long2() AS Long
  Get_DIGOUT_long2 = Peek_P2(5C100004h)
ENDFUNCTION

''******************************************************************************
''''Clears the selected Digin Fifos.
'''fifo_pattern: bit pattern to select the Digin FIFOs
'''+          bit=0: ignore FIFO
'''+          bit=1: clear FIFO
'''+          Bit 0: Fifo 1
'''+          Bit 1: Fifo 2 
'''+          Bit 2: Fifo 3 
'''****************************************************************************
SUB Digin_FIFO_Clear(fifo_pattern)
  Poke(5C00e000h,shift_left(((fifo_pattern) AND 111B),14))
ENDSUB

'******************************************************************************
'''Clears the selected Digout Fifos.
'''fifo_pattern: bit pattern to select the Digout FIFOs
'''+          bit=0: ignore FIFO
'''+          bit=1: clear FIFO
'''+          Bit 0: Fifo 1
'''+          Bit 1: Fifo 2 
'''****************************************************************************
SUB Digout_FIFO_Clear(fifo_pattern) 
  Poke(5C00e000h,shift_left(((fifo_pattern) AND 11B),12))
ENDSUB

'******************************************************************************
'''Sets the input channels for the edge detection unit, which are monitored 
'''+on the selected input FIFO.
'''fifo_no: Number (1..3) of the input FIFO.
'''pattern: Bit pattern to select input channels on input FIFO 1 / 2 / 3
'''+          Bit 0:  DIO00 / DIO32 / DIO64
'''+          ..      ..      ..      ..
'''+          Bit 31: DIO31 / DIO63 / DIO95
'''+Please note: DIO63:DIO60, DIO95:DIO92 are reserved and not available.
'''****************************************************************************
SUB Digin_FIFO_Enable(fifo_no,pattern)
  if (fifo_no=1) then 
    Poke(5C148900h, pattern) 
  else
    if (fifo_no=2) then 
      Poke(5C148904h, pattern) 
    else
      Poke(5C148908h, pattern) 
    endif
  endif

ENDSUB

'******************************************************************************
'''Determines which input channels the edge detection unit will be monitored.
'''fifo_no: Number (1..2) of the output FIFO.
'''pattern: Bit pattern to select input channels on input FIFO 1 / 2
'''+          Bit 0:  DIO00 / DIO32
'''+          ..      ..      ..
'''+          Bit 31: DIO31 / DIO63
'''+Please note: DIO63:DIO60 are reserved and not available.
'''****************************************************************************
SUB Digout_FIFO_Enable(fifo_no,pattern)
  if (fifo_no=1) then 
    Poke(5C148A00h, pattern) 
  else
    Poke(5C148A04h, pattern)
  endif
ENDSUB

'******************************************************************************
'''Returns the number of saved value pairs in the FIFO of a edge detection unit.
'''+return value: Number (0..8191) of saved value pairs.
'''fifo_no: Number (1..3) of the input FIFO.
'''****************************************************************************
FUNCTION Digin_FIFO_Full(fifo_no) as Long
  if (fifo_no=1) then 
    Digin_FIFO_Full=peek_p2(5C148800H)  AND 0FFFFH
  else
   
    if (fifo_no=2) then 
      Digin_FIFO_Full=peek_p2(5C148804H)  AND 0FFFFH
    else
      Digin_FIFO_Full=peek_p2(5C148808H)  AND 0FFFFH
    endif
  endif
ENDFUNCTION

'******************************************************************************
'''Returns the number of free value pairs in the edge output FIFO.
'''+return value: Number (0..8191) of free value pairs.
'''fifo_no: Number (1..2) of the output FIFO.
'''****************************************************************************
FUNCTION Digout_FIFO_Empty(fifo_no) as Long
  if (fifo_no=1) then 
    Digout_FIFO_Empty=peek_p2(5C148820H)
  else
    Digout_FIFO_Empty=peek_p2(5C148824H)
  endif
ENDFUNCTION

'******************************************************************************
'''Sets the FIFO operation mode: 
'''fifo_no: Number (1..2) of the output FIFO.
'''mode: Operating mode of the output FIFO
'''+          1: Output FIFO with edge output, time values with absolute reference
'''+          2: reserved 
'''+          3: Output FIFO with edge output, time values with relative reference
'''****************************************************************************
SUB Digout_FIFO_Mode(fifo_no,mode)
  if (fifo_no=1) then  
    POKe(5C148700H,mode)
  else
    POKe(5C148704H,mode)
  endif
ENDSUB

******************************************************************************
'''Starts the output pattern.
'''fifo_pattern: bit pattern to select the Digout FIFOs
'''+          bit=0: ignore FIFO
'''+          bit=1: start the edge output on output FIFO
'''+          Bit 0: Fifo 1
'''+          Bit 1: Fifo 2 
'''****************************************************************************
SUB Digout_FIFO_Start(fifo_pattern)
  Poke(5C00e000h,shift_left(((fifo_pattern) AND 11B),10))
ENDSUB

'******************************************************************************
'''Reads one value pair from the FIFO of an edge detection unit and writes them into 2 variables.
'''fifo_no: Number (1..3) of the input FIFO.
'''value_by_ref: Level status bit pattern on input FIFO 1 / 2 / 3.
'''+             Each level status bit corresponds to a digital input.
'''+          Bit 0:  DIO00 / DIO32 / DIO64
'''+          ..      ..      ..      ..
'''+          Bit 31: DIO31 / DIO63 / DIO95
'''+Please note: DIO63:DIO60, DIO95:DIO92 are reserved and not available.
'''timestamp_by_ref: Variable where the time stamp is written.
'''****************************************************************************
'''#C;P2:BR;P3:BR;
SUB Digin_FIFO_Read(fifo_no,value_by_ref,timestamp_by_ref)
  
  if (fifo_no=1) then 
    value_by_ref=peek_p2(5c103100H) 
    timestamp_by_ref=peek_p2(5c103100H) 
  else
    if (fifo_no=2) then 
      value_by_ref=peek_p2(5c103104H) 
      timestamp_by_ref=peek_p2(5c103104H) 
    else
      value_by_ref=peek_p2(5c103108H) 
      timestamp_by_ref=peek_p2(5c103108H) 
    endif
  endif
ENDSUB

**************************************************************************
'''Writes value pairs into the output edge FIFO.
'''fifo_no: Number (1..2) of the output FIFO.
'''value: Variable where the level status bit pattern is written
'''+          Bit 0:  DIO00 / DIO32 
'''+          ..      ..      ..
'''+          Bit 31: DIO31 / DIO63 
'''timestamp: Variable where the time stamp (in steps of 4ns) is written
'''+          The time stamp depends on the mode which was set with Digout_Fifo_Mode.
'''****************************************************************************
SUB Digout_FIFO_Write(fifo_no,value,timestamp)
  if (fifo_no=1) then 
    Poke(5C103100H,value)
    Poke(5C103100H,timestamp)
  else
    Poke(5C103104H,value)
    Poke(5C103104H,timestamp)
  endif
ENDSUB

''******************************************************************************
'''Reads the 250 MHz FIFO Timer. 
'''+return value: current timer value (-2^31-1 .. 2^31)
'''fifo_no: Number (1..3) of the input FIFO.
'''+This timer will not be set to 0 while core reset.
'''******************************************************************************
FUNCTION Digin_FIFO_Read_Timer(fifo_no) AS LONG
  if (fifo_no=1) then 
    Digin_FIFO_Read_Timer = peek_p2(5c103110H) 
  else
    if (fifo_no=2) then
      Digin_FIFO_Read_Timer = peek_p2(5c103114H) 
    else
      Digin_FIFO_Read_Timer = peek_p2(5c103118H) 
    endif
  endif
ENDFUNCTION

''******************************************************************************
'''Reads the 250 MHz output FIFO timer. 
'''+return value: current timer value (-2^31-1 .. 2^31)
'''fifo_no: Number (1..2) of the output FIFO.
'''+This timer will not be set to 0 while core reset.
'''******************************************************************************
FUNCTION Digout_FIFO_Read_Timer(fifo_no) AS LONG
  if (fifo_no=1) then 
    Digout_FIFO_Read_Timer = peek_p2(5c103120H) 
  else
    Digout_FIFO_Read_Timer = peek_p2(5c103124H) 
  endif
ENDFUNCTION
  
''******************************************************************************
'''Sets spike filter duration for all digital inputs.
'''filter_value: Filtering duration, given in units (1..65535) of 20 ns length.
'''+The value 0 disables the filter.
'''+The filtering duration should be a bit longer than the expected width of spikes.
''''****************************************************************************
SUB Digin_Filter_Init(filter_value)
  Poke(5C148760h, Filter_value) 
  io_sleep(14)
ENDSUB

*************************************************************************
'''Reads the latch registers for detection of rising or falling edges
'''+occured on the digital inputs 0..31.
'''+Registers are cleared on reading.
'''+return value: Bit pattern of occurred edges.
'''+          bit=0: No edge occurred.
'''+          bit=1: Edge detected.
'''+          Bit 0:  DIO00
'''+          ..
'''+          ..
'''+          Bit 31: DIO31
'''edge: Kind of detected edge
'''+          0: Detect falling edges.
'''+          1: Detect rising edges.
'''****************************************************************************
FUNCTION Digin_Edge1(edge) AS Long
  if (edge = 1) then
    Digin_Edge1=peek_p2(5c103000H) ' read lath register for rising edges
  else
    Digin_Edge1=peek_p2(5c103010H) '  ...  for falling edges
  endif
ENDFUNCTION

*************************************************************************
'''Reads the latch registers for detection of rising or falling edges
'''+occured on the digital inputs 32..63.
'''+Registers are cleared on reading.
'''+return value: Bit pattern of occurred edges.
'''+          bit=0: No edge occurred.
'''+          bit=1: Edge detected.
'''+          Bit 0:  DIO32
'''+          ..
'''+          Bit 31: DIO63
''''+Please note: DIO63:DIO60 are reserved and not available.
'''edge: Kind of detected edge
'''+          0: Detect falling edges.
'''+          1: Detect rising edges.
'''****************************************************************************
FUNCTION Digin_Edge2(edge) AS Long
  if (edge = 1) then
    Digin_Edge2=peek_p2(5c103004H)' read lath register for rising edges
  else
    Digin_Edge2=peek_p2(5c103014H) '  ...  for falling edges
  endif
ENDFUNCTION

*************************************************************************
'''Reads the latch registers for detection of rising or falling edges
'''+occured on the digital inputs 64..95.
'''+Registers are cleared on reading.
'''+return value: Bit pattern of occurred edges.
'''+          bit=0: No edge occurred.
'''+          bit=1: Edge detected.
'''+          Bit 0:  DIO64
'''+          ..
'''+          Bit 31: DIO95
''''+Please note: DIO95:DIO92 are reserved and not available.
'''edge: Kind of detected edge
'''+          0: Detect falling edges.
'''+          1: Detect rising edges.
'''****************************************************************************
FUNCTION Digin_Edge3(edge) AS Long
  if (edge = 1) then
    Digin_Edge3=peek_p2(5c103008H)' read lath register for rising edges
  else
    Digin_Edge3=peek_p2(5c103018H) '  ...  for falling edges
  endif
ENDFUNCTION



'<ENDREGION>

'<REGION> DAC

'******************************************************************************
''' Converts the digital value to an analog output.
''' dac_no: channel number (1..8) of analog output
''' value:  output value (0..65535)
'''****************************************************************************
SUB DAC(dac_no, value)
  poke(5c422FF0h+(dac_no)*16,value)
ENDSUB

'******************************************************************************
''' Sets DAC-register to desired value.
''' dac_no: channel number of analog output (1..8)
''' value:  output value (0..65535)
'''****************************************************************************
SUB Write_DAC(dac_no, value)
  poke(5c421FF0h+(dac_no)*16,value)
ENDSUB

*****************************************************************************
''' Writes two 16 bit values to the output registers on 2 DACs.
''' dac_pair: Pair number (1..4) of DACs
'''+          1: DAC 1 & 2
'''+          2: DAC 3 & 4
'''+          3: DAC 5 & 6
'''+          4: DAC 7 & 8     
''' value32: 32 bit value with 2 16 bit measurement values
'''+          bits 0..15 (low word): value for odd numbered DAC
'''+          bits 16..31 (high word): value for even numbered DAC
'''******************************************************************************
SUB Write_DAC32(dac_pair,value32)
  poke(5c423FF0h+(dac_pair)*16,value32)
endsub  

'******************************************************************************
''' Outputs two 16 bit values on 2 DACs (simultaneously).
''' dac_pair: Pair number (1..4) of DACs
'''+          1: DAC 1 & 2
'''+          2: DAC 3 & 4
'''+          3: DAC 5 & 6
'''+          4: DAC 7 & 8     
''' value32: 32 bit value with 2 16 bit measurement values
'''+          bits 0..15 (low word): value for odd numbered DAC
'''+          bits 16..31 (high word): value for even numbered DAC
'''****************************************************************************
SUB DAC32(dac_pair,value32)
  poke(5c424FF0h+(dac_pair)*16,value32)
endsub

'******************************************************************************
''' Simultaneously starts conversion of all DACs.
'''****************************************************************************
SUB Start_DAC()
  Poke(5C00e000h,10000B)
ENDSUB


'<ENDREGION>

'<REGION> CNT 

'******************************************************************************
'''Sets operating mode for one counter.
'''counter_no: Number (1..9) of the counter.
'''mode: Bit pattern to set the operating mode of the counter.
'''+          Bit 0: Counter mode
'''+            bit=0: mode clock/direction
'''+            bit=1: mode A-B
'''+          Bit 1: Clear mode. Signal condition, which clears the counter.
'''+            bit=0: TTL level High at input CLR
'''+            bit=1: TTL level High at all inputs A, B, CLR. Available in A-B mode only.
'''+          Bit 2: Invert input A / CLK in mode clock/direction.
'''+            bit=0: Input is not inverted.
'''+            bit=1: Input is inverted.
'''+          Bit 3: Invert input B / DIR in mode clock/direction.
'''+            bit=0: Input is not inverted.
'''+            bit=1: Input is inverted.
'''+          Bit 4: Set use of input CLR / LATCH.
'''+            bit=0: CLR input: clear counter.
'''+            bit=1: LATCH input: latch counter.
'''+          Bit 5 Enable input CLR / LATCH.
'''+            bit=0: Input CLR / LATCH is disabled.
'''+            bit=1: Input CLR / LATCH is enabled.
'''+          Bit 6: Select edge for PW analysis.
'''+            bit=0: rising edge.
'''+            bit=1: falling edge.
'''+          Bits 7:8: Select input for PW analysis.
'''+            bits=00: Input A / CLK
'''+            bits=01: Input B / DIR
'''+            bits=10: Input CLR / LATCH
'''****************************************************************************
SUB Cnt_Mode(counter_no, mode)
#If MAKE_LIB = ON Then
  #error("CNT_Mode does NOT work in Libraries!")
#else
  
  DIM modei as Long
  poke(5C2109F0h + (counter_no) * 16, mode)  
  modei = shift_right(mode, 6) AND 1
  PWM_help_mode = ((NOT(shift_left(1, counter_no - 1))) AND PWM_help_mode) OR shift_left(modei, counter_no - 1)
#endif
ENDSUB

'******************************************************************************
''' Disables or enables the specified VR counters.
''' pattern: Bit pattern to select counters.
'''+          bit=0: Disable counter.
'''+          bit=1: Enable counter.
'''+          Bit 0:  Counter 1
'''+          ..
'''+          Bit 8:  Counter 9
'''****************************************************************************
SUB Cnt_Enable(pattern)
  poke(5C210B50h, pattern)
ENDSUB


'******************************************************************************
''' Disables or enables the specified PW counters.
''' pattern: Bit pattern to select PW counters.
'''+          bit=0: Disable counter.
'''+          bit=1: Enable counter.
'''+          Bit 0: PW counter 1
'''+          ..
'''+          Bit 8: PW counter 9
'''****************************************************************************
SUB Cnt_PW_Enable(pattern)
  poke(5C210B60h, pattern)
ENDSUB

'******************************************************************************
'''Returns the value of a counters Latch A.
'''+return value: Content of counter Latch A.
'''counter_no: Number (1..9) of the counter.
'''****************************************************************************
FUNCTION Cnt_Read_Latch(counter_no) as Long
  CNT_READ_LATCH = peek_P2(5C20FF60h + (counter_no) * 256)
ENDFUNCTION

'******************************************************************************
'''Transfers the current counter value into Latch A and returns the value.
'''+return value: Counter value.
'''counter_no: Number (1..9) of the counter.
'''****************************************************************************
FUNCTION Cnt_Read(counter_no) as Long
  poke(5C210B00h, shift_left(1, counter_no - 1))
  CNT_READ = peek_p2(5C20FF60h + (counter_no) * 256)
ENDFUNCTION

'******************************************************************************
''' Clears the specified counters.
''' pattern: bit pattern to select counters
'''+          bit=0: No action.
'''+          bit=1: Clear counter.
'''+          Bit 0:  Counter 1
'''+          ..
'''+          Bit 8:  Counter 9
'''****************************************************************************
SUB Cnt_Clear(pattern)
  poke(5C210B10h,pattern) ' shift_left(pattern, 8) AND 0FF00H)
ENDSUB

'******************************************************************************
''' Reads the status of a counter input.
'''+return value: Content of status register, hint for potential error sources.
'''+          Bit 0: Signal A (static)
'''+          Bit 1: Signal B (static)
'''+          Bit 2: Clr/Latch input (static)
'''+          Bit 3: Line error (cable not connected or the line is broken)
'''+          Bit 4: Correlation error (signals A and B are identical,
'''+                 i. e. they are not phase-shifted by approx. 90)
''' counter_no: Number (1..9) of the counter
'''****************************************************************************
FUNCTION Cnt_Get_Status(counter_no) as Long
  cnt_get_status=peek_P2(5C20FFF0h + (counter_no) * 256)
ENDFUNCTION

'******************************************************************************
'''Returns the content of a counter register.
'''counter_no: Number (1..9) of the counter.
'''reg_no: Key number (015) for a counter register.
'''+          0: Latch 1 for positive edges.
'''+          1: Latch 2 for positive edges.
'''+          2: Latch 3 for positive edges.
'''+          3: Latch 1 for negative edges.
'''+          4: Latch 2 for negative edges.
'''+          5: Latch 3 for negative edges.
'''+          6: Software latch for VR counter.
'''+          7: Software latch for PW counter.
'''+          8: Shadow register for Latch 1, positive edges.
'''+          9: Shadow register for Latch 2, positive edges.
'''+         10: Shadow register for Latch 3, positive edges.
'''+         11: Shadow register for Latch 1, negative edges.
'''+         12: Shadow register for Latch 2, negative edges.
'''+         13: Shadow register for Latch 3, negative edges.
'''+         14: Shadow register for software latch, VR counter.
'''+         15: Counter status.
'''****************************************************************************
FUNCTION Cnt_Read_Int_Register(counter_no, reg_no) as Long
  Cnt_Read_Int_Register = peek_P2(5C20FF00h +  (counter_no) * 256 + (reg_no) * 16)
ENDFUNCTION

'******************************************************************************
'''Transfers the current counter values of the specified counters into the relevant Latch A.
''' pattern: bit pattern to select counters
'''+          bit=0: No action.
'''+          bit=1: Transfer counter value into Latch A.
'''+          Bit 0:  Counter 1
'''+          ..
'''+          Bit 8:  Counter 9
'''****************************************************************************
SUB Cnt_Latch(pattern)
  poke(5C210B00h, pattern)
ENDSUB

'******************************************************************************
''' Copies values of the specified PW and VR counters to their shadow registers.
'''+Read  shadow registers with Cnt_Get_PW, Cnt_Get_PW_HL and Cnt_Read_Int_Register.
''' pattern: each bit corresponds to a counter
'''+          bit=0: No action.
'''+          bit=1: Transfer PW and VR counter values into the shadow registers.
'''+          Bit 0:  Counter 1
'''+          ..
'''+          Bit 8:  Counter 9
'''****************************************************************************
SUB Cnt_PW_Latch(pattern)
  poke(5C210B20h,pattern) ' shift_left((pattern) AND 0FH, 24))
ENDSUB

'******************************************************************************
'''Copies the contents of the selected counters and PW counters into shadow registers.
'''+In more detail (at the same time):
'''+ 1. latches VR counter to VR latch.
'''+ 2. copies PW latches and VR latches to shadow registers.
''' pattern: each bit corresponds to a counter
'''+          bit=0: No action.
'''+          bit=1: Transfer PW and VR counter values into shadow registers.
'''+          Bit 0:  Counter 1
'''+          ..
'''+          Bit 8:  Counter 9
'''****************************************************************************
SUB Cnt_Sync_Latch(pattern)
  poke(5c210BA0h,pattern) ' 5c210CF0h
ENDSUB

'******************************************************************************
'''Returns frequency and duty cycle of a PW counter.
'''+Use Cnt_PW_Latch before to get current values.
'''counter_no: Number (1..9) of the PW counter.
'''frequency: Frequency in Hertz: 0.023 Hz..20 MHz (float constant)
'''dutycycle: Duty cycle in percent: 0.0..100.0 (float constant)
'''****************************************************************************
'''#C;P2:F;P2:BR;P3:F;P3:BR;
SUB Cnt_Get_PW(counter_no, frequency, dutycycle) 

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long

  DIM period as Long
  DIM pulse as Long
  DIM ref_edge as Long

#If MAKE_LIB = ON Then
  #error("CNT_Get_PW does NOT work in Libraries!")
#else

  pos3 = peek_P2(5C20FFA0h + (counter_no) * 256) '
  neg3 = peek_p2(5C20FFD0h + (counter_no) * 256) '

  ref_edge = shift_right(PWM_help_mode, counter_no - 1) AND 1

  IF (ref_edge = 1) then                                    'negative reference edge
    neg2 = peek_p2(5C20FFC0h + (counter_no) * 256) '
    period = neg2 - neg3
    pulse = neg2 - pos3
  ELSE                                                      'positive reference edge
    pos2 = peek_p2(5C20FF90h + (counter_no) * 256) '
    
    period = pos2 - pos3
    pulse = neg3 - pos3
  ENDIF

  if (period <> 0) then
    frequency = 250000000 / period                          'Frequenz [Hz] '100 MHz
    dutyCycle = pulse * 100 / (period)                      'PW Verhltnis
  else
    frequency = 0
    dutyCycle = 0
  endif
  
#endif
  
ENDSUB

'******************************************************************************
''' Reads registers and calculates PW hightime and lowtime.
'''+Use Cnt_PW_Latch before to get current values.
'''counter_no: Number (1..9) of the PW counter.
''' hightime: Pulse duration in units of 10 ns: PW high level time.
''' lowtime: Pulse period in units of 10 ns: PW low level time.
'''****************************************************************************
'''#C;P2:BR;P3:BR;
SUB Cnt_Get_PW_HL(counter_no, hightime, lowtime)

#If MAKE_LIB = ON Then
  #error("CNT_Get_PW_HL does NOT work in Libraries!")
#else

  DIM pos2 as Long
  DIM pos3 as Long
  DIM neg2 as Long
  DIM neg3 as Long
  DIM pulse as Long
  DIM pause as Long
  DIM ref_edge as Long


  pos3 = peek_P2(5C20FFA0h + (counter_no) * 256) '
  neg3 = peek_p2(5C20FFD0h + (counter_no) * 256) '
  
  
  
  ref_edge = shift_right(PWM_help_mode, counter_no - 1) AND 1

  IF (ref_edge = 1) then                                    'negative reference edge
    '  period=neg2-neg3
    neg2 = peek_p2(5C20FFC0h + (counter_no) * 256) '
    pulse = neg2 - pos3
    pause = pos3 - neg3
  ELSE                                                      'positive reference edge
    ' period=pos2-pos3
    pos2 = peek_p2(5C20FF90h + (counter_no) * 256) '
    pulse = neg3 - pos3
    pause = pos2 - neg3
  ENDIF
  hightime = pulse
  lowtime = pause
  
#endif
  
ENDSUB


'******************************************************************************
'''Set Input Receive Mode  
'''counter_no: Number (3..4) of the counter
'''mode: Counter input mode
'''+          0: Differential, High Threshold Logic (HTL)
'''+          1: RS 422 with termination on (default)
'''+          2: Single-ended, High Threshold Logic (HTL)
'''*************************************************************** 
SUB Cnt_Input_Receiver_Mode(counter_no,mode)
  
  dim old as long
  
  old=peek(5C210BF0h)
  old=old AND ( not(shift_left(3,((counter_no)-1)*2)))
  old=old or shift_left((mode) ,((counter_no)-1)*2)
  
  poke(5C210BF0h,old)
ENDSUB




'<ENDREGION>

'<REGION> SSI 
'******************************************************************************
''' Reads SSI encoder value 32 Bit.
'''+return value: Last counter value of the SSI counter, which stands for
'''+              the absolute position of the encoder.
''' dcdr_no: Number (1..4) of the SSI decoder.
'''****************************************************************************
FUNCTION SSI_Read(dcdr_no) AS long
  SSI_Read = Peek_P2 (5C210C50h + ((dcdr_no)-1) * 256)
ENDFUNCTION

'******************************************************************************
''' Sets the number of databits for the SSI Interface.
'''+The number of bits should be equal to the resolution of the encoder.
''' dcdr_no: Number (1..4) of the SSI decoder.
''' no_bits: Number of bits (1..32) which are read on the encoder.
'''****************************************************************************
SUB SSI_Set_Bits(dcdr_no, no_bits)
  POKE ((5C210C30h + ((dcdr_no)-1) * 256) , no_bits)
ENDSUB

'******************************************************************************
''' Sets the clock rate of the SSI clock.
''' dcdr_no: Number (1..4) of the SSI decoder.
''' prescale: Scale factor (10..255) for the clock rate:
'''+          Clock rate = 25 MHz / prescale.
'''****************************************************************************
SUB SSI_Set_Clock(dcdr_no,prescale)
  POKE ((5C210C20h+((dcdr_no)-1)*256) , prescale)
ENDSUB

'******************************************************************************
''' Starts reading from the selected SSI decoders.
'''+Useful only in SSI mode "single shot".
''' pattern: Bit pattern each bit corresponds to one ssi counter
'''+          bit=0: No action.
'''+          bit=1: Start reading from the SSI decoder.
'''+          Bit 0: SSI decoder 1
'''+          Bit 1: SSI decoder 2
'''+          Bit 2: SSI decoder 3
'''+          Bit 3: SSI decoder 4
'''****************************************************************************
SUB SSI_Start(pattern)
  POKE (5C210C00h, pattern)
ENDSUB

'******************************************************************************
''' Sets the SSI mode.
''' pattern: Bit pattern each bit corresponds to one counter
'''+          bit=0: "Single shot" mode, the encoder is read out once.
'''+          bit=1: "Continuous" mode, the encoder is read out continuously.
'''+          Bit 0: SSI decoder 1
'''+          Bit 1: SSI decoder 2
'''+          Bit 2: SSI decoder 3
'''+          Bit 3: SSI decoder 4
'''****************************************************************************
sub SSI_Mode(pattern)
  POKE (5C210C10h , pattern)
endsub

'******************************************************************************
''' Reads the SSI status.
'''+return value: Status of the SSI decoder
'''+          0: Complete SSI value was read.
'''+          1: Decoder is reading an encoder value.
'''+Useful only in SSI mode "single shot".
''' dcdr_no: Number (1..4) of the SSI decoder.
'''****************************************************************************
FUNCTION SSI_Status(dcdr_no) AS long
  dim value2 as long
  value2 =peek_p2(5C210C00h) ' Peek_P2 (5C210C00h+ ((dcdr_no)-1) * 256)
  ssi_status = shift_right(value2, ((dcdr_no) - 1)) AND 01H
ENDFUNCTION

*************************************************************
'''Sets the delay between reading two encoder values in continuous mode.
''' dcdr_no: Number (1..4) of the SSI decoder.
'''delay: Waiting time (1..65535) in units of 20 ns; the selectable range is 20 ns..1310.7 s
'''+      Default value after start-up is 1250 (25s).
'''************************************************************
SUB SSI_Set_Delay(dcdr_no, delay)
  POKE ((5C210CA0h + ((dcdr_no)-1) * 256) , delay)
ENDSUB




'<ENDREGION>

'<REGION> LS-BUS 

'******************************************************************************
'''Sets all digital outputs of the module 1 on the LS bus to defined levels
'''+and returns the status of all channels as bit pattern.
'''+This instruction works only with a single module on the LS bus with address 1.
'''+Also, no other instructions may be used afterwards.
'''+Return value: State of digital outputs and inputs
'''+          bit=0: Channel has level Low.
'''+          bit=1: Channel has level High.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 31: Channel 32
'''value: Bit pattern to set digital outputs.
'''+          bit=0: Set output to level Low.
'''+          bit=1: Set output to level High.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 31: Channel 32
'''****************************************************************************
Function LS_Dig_IO(value) As Long

  Dim cnt_i As Long
  dim invalue as long
  invalue=0
  For cnt_i = 0 To 24 step 8           
    invalue=invalue OR Shift_left( Peek_p2(SYSTEM_LSBUS_RX_FIFO_READ),cnt_i)          ' rx data read
  Next cnt_i
  LS_Dig_IO = invalue
                                               
  I_Send_BC8(44h, 1) ' WD trigger

  I_Send_NA32(1, 7Ch,value)                         ' channel 1..32
  LS_Read_Req(1, 7Ch, 4)                           ' request new in data
EndFunction

'******************************************************************************
'''Enables, disables and configures the watchdog counter.
'''+Return value: error status (0: o.k.)
'''ls_module: module address (1..15) on the LS bus.
'''enable: Set status of watchdog counter.
'''+          0: Disable watchdog counter.
'''+          1: Enable watchdog counter.
'''time: Release time (0..107374) of the counter in [ms].
'''****************************************************************************
Function LS_Watchdog_Init(ls_module, enable, time) As Long
  Dim ld[2] As Long
  Dim ret, t As Long

  ld[1] = 0ADh   'Watchdog disable
  ld[2] = 0
  ret = I_Send( ls_module, 45h, 2, ld)
  'Watchdog time
  t = time * 40000                                          't = time / 25e-6

  ret = ret Or (I_Send32( ls_module, 48h,t))
  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable And 1
  LS_Watchdog_Init = ret Or (I_Send(ls_module, 45h, 2, ld))
  LS_Watchdog_Init  = LS_Watchdog_Init  AND NOT(8)
EndFunction

'******************************************************************************
'''Resets the watchdog timer on all LS bus modules to theri starting values.
'''+If the watchdog is enabled, the user program has to call this function regularly.
'''+If the watchdog counter reaches 0, all output signals are reset.
'''****************************************************************************
Sub LS_Watchdog_Reset()
  I_Send_BC8(44h, 1)
EndSub

'******************************************************************************
'''Configures the digital channels 1..32 on a module HSM-24V as inputs or outputs
'''+in groups of 8.
'''+Return value: error status (0: o.k.)
'''ls_module: module address (1..15) on the LS bus.
'''pattern: Bit pattern to select channels as inputs or outputs.
'''+          bit=0: Set channels as inputs.
'''+          bit=1: Set channels as outputs.
'''+          Bit 0: Channels  1..8
'''+          Bit 1: Channels  9..16
'''+          Bit 2: Channels 17..24
'''+          Bit 3: Channels 25..32
'''****************************************************************************
Function LS_DigProg(ls_module, pattern) As Long
  Dim ld[2] As Long 
  Dim ret As Long

  ld[1] = (Shift_Left(pattern, 3) And 8h) OR (Shift_Left(pattern, 7) And 80h) OR 11H
  ld[2] = (Shift_Left(pattern, 2) And 8h) OR (Shift_Left(pattern, 6) And 80h) OR 11H
  ret = I_Send(ls_module, 16h, 2, ld)
  ld[1] = (Shift_Left(pattern, 1) And 8h) Or (Shift_Left(pattern, 5) And 80h) OR 11H
  ld[2] = (pattern And 8h) OR (Shift_Left(pattern, 4) And 80h) OR 11H
  LS_DigProg = ret Or (I_Send(ls_module, 20h + 16h, 2, ld))
EndFunction

'******************************************************************************
'''Sets or clears all digital outputs (channels 0..31).
'''ls_module: module address (1..15) on the LS bus.
'''value: Bit pattern to set digital outputs.
'''+          bit=0: Set output to level Low.
'''+          bit=1: Set output to level High.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 31: Channel 32
'''****************************************************************************
Sub LS_Digout_Long(ls_module, value)
  I_Send_NA32(ls_module, 7Ch, value)                 ' channels 1..32
EndSub

'******************************************************************************
'''Sets or clears all digital outputs (channel 0..31) and returns the bus error status.
'''ls_module: module address (1..15) on the LS bus.
'''value: Bit pattern to set digital outputs.
'''+          bit=0: Set output to level Low.
'''+          bit=1: Set output to level High.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 31: Channel 32
'''bus_stat: Error Code (0: O.K.)
'''****************************************************************************
Sub LS_Digout_Long_BS(ls_module, pattern, bus_stat)
  BUS_Stat=I_Send32(ls_module, 7Ch, pattern)                 ' channel 1..32
EndSub

'******************************************************************************
'''Reads the status of all channels (channel 0..31) as bit pattern.
'''+return value: state of digital outputs and inputs
'''+          bit=0: Channel has level Low.
'''+          bit=1: Channel has level High.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 31: Channel 32
'''ls_module: module address (1..15) on the LS bus.
'''****************************************************************************
Function LS_Digin_Long(ls_module) As Long
  Dim ret As Long
  ret = I_Receive32(ls_module, 7Ch,LS_Digin_Long )
EndFunction

'******************************************************************************
'''Reads the status of all channels (channel 0..31) as bit pattern and returns the bus error status.
'''+return value: state of digital outputs and inputs
'''+          bit=0: Channel has level Low.
'''+          bit=1: Channel has level High.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 31: Channel 32
'''ls_module: module address (1..15) on the LS bus.
'''bus_stat: Error Code (0: O.K.)
'''****************************************************************************
Function LS_Digin_Long_BS(ls_module,bus_stat) As Long
  BUS_Stat = I_Receive32(ls_module, 7Ch,LS_Digin_Long_BS)
EndFunction

'******************************************************************************
'''Reads the over-current status of digital outputs (channels 0..31).
'''+Return value: Bit pattern with over-current status.
'''+          bit=0: Channel is o.k.
'''+          bit=1: Over-current occurred, channel output is disabled.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 31: Channel 32
'''ls_module: module address (1..15) on the LS bus.
'''****************************************************************************
Function LS_Get_Output_Status(ls_module) As Long
  Dim t As Long
  t = I_Receive32(ls_module, 50h, LS_Get_Output_Status)
EndFunction

'******************************************************************************
'''Initializes an LS module of type HSM-24V.
'''+Return value: error status (0: o.k.)
'''ls_module: module address (1..15) on the LS bus.
'''****************************************************************************
Function LS_DIO_Init(ls_module) As Long
  Dim ld[4] As Long
  Dim ret As Long
  Dim addr As Long
  dim en as long
  
  en=System_GET_Option() AND 1000B
  
  if (en>0) then 
  
    Poke(5C510130h, 1)                    ' ' autoreset rx ON
    io_sleep(14)
    ld[1] = 3
    ret = I_Send(ls_module, 40h, 1, ld)              ' Reset JX 1, 2
    ld[1] = 1
    ret = ret Or (I_Send(ls_module, 5Ch, 1, ld))     ' timeout reset
    ld[1] = 4
    ret = ret Or (I_Send(ls_module, 4Ch, 1, ld))     ' Set default direction time
    ld[1] = 0
    ld[2] = 0
    ld[3] = 0
    ld[4] = 0
    LS_DIO_Init = ret Or (I_Send(ls_module, 50h, 4, ld))  ' overcurrent reset
    ld[1] = 30h
    LS_DIO_Init = ret Or (I_Send(ls_module, 43h, 1, ld))  ' overtemperature reset
  
    LS_DIO_Init =LS_DIO_Init AND NOT(8)
  
  else
    LS_DIO_Init=-2 'no LS Master on Gold III  available
  endif
    
    
EndFunction

'******************************************************************************
'''Resets the LS controller.
'''+The instruction should only be used in the section Init:.
'''****************************************************************************
SUB LS_Reset() 
  Poke(5C510110h, 11B)                    'clear rx und tx
  io_sleep(30)
  Poke(5C510130h, 1)                    ' ' autoreset rx ON
ENDSUB


'<ENDREGION>

'<REGION> PWM OUTPUT

'******************************************************************************
'''  Sets the default TTL levels for all PWM outputs.
'''+The default level is effective when the PWM output is disabled or has been stopped.
''' pattern: Bit pattern for selection of PWM outputs.
'''+          bit=0: TTL level low.
'''+          bit=1: TTL level high.
'''+          Bit 0: PWM output 1
'''+          ...
'''+          Bit 5: PWM output 6
'''****************************************************************************
SUB PWM_Standby_Value(pattern) 
  Poke (5c710100H,pattern)   
ENDSUB

'******************************************************************************
''' Enables an output of the PWM module.
''' pattern: Bit pattern for selection of PWM outputs.
'''+          bit=0: Disable PWM output.
'''+          bit=1: Enable PWM output.
'''+          Bit 0: PWM output 1
'''+          ...
'''+          Bit 5: PWM output 6
'''****************************************************************************
SUB PWM_Enable(pattern)
  Poke (5c710300H,pattern)   
ENDsub

'******************************************************************************
''' Stops the output of one or more PWM outputs immediately.
''' pattern: Bit pattern for selection of PWM outputs.
'''+          bit=0: No action.
'''+          bit=1: Stop PWM output immediately.
'''+          Bit 0: PWM output 1
'''+          ...
'''+          Bit 5: PWM output 6
'''****************************************************************************
SUB PWM_Reset(pattern)
  Poke (5c710200H,pattern)
ENDSUB

'******************************************************************************
''' Sets the defaults for one PWM output.
''' channel: Number (1..6) of PWM output.
''' startdelay: Start delay in units of 20 ns.
''' startvalue: Start level of PWM output:
'''+          0: TTL level low.
'''+          1: TTL level high.
'''+         With startvalue=0, PWM_Write_Latch uses the inverse duty cycle.
''' mode: Operating mode of PWM outputs as bit pattern (bits 0..2 only).
'''+          Bit 0: Moment to take over a new PW frequency:
'''+            bit=0: Take over at end of period.
'''+            bit=1: Take over immediately.
'''+          Bit 1: Number of pulses:
'''+            bit=0: infinite number of pulses.
'''+            bit=1: number of pulses is "count".
'''+          Bit 2: Moment to stop after stop instruction:
'''+            bit=0: Stop at end of period.
'''+            bit=1: Stop immediately.
'''count: Number of periods (1..32768), which are processed during an output cycle.
'''+          Only relevant, if "mode" bit 1 = 1.
'''****************************************************************************
SUB PWM_Init(channel, startdelay, startvalue, mode, count)
  DIM old as Long
  DIM maske as Long
  DIM maske2 as Long
  Poke (5c710DE0H+  (channel) * 32,startdelay)   '10E0
  Poke (5c710BE0H+  (channel) * 32,count)   '10C0
  Poke (5c7104E0H+  (channel) * 32,mode)   '1050
  
  
  maske = shift_left(1, channel - 1)
  maske2 = maske XOR 11111111B
  'startvalue
  old = peek_P2(5c710000H) AND maske2
  old = old or shift_left(startvalue AND 1, channel - 1)
  Poke (5c710000H,old)   
ENDSUB

'******************************************************************************
'''Writes dutycycle and frequency to the latch register.
'''channel: Number (1..6) of PWM output.
'''dutycycle: Duty cycle / inverse duty cycle in percent between 0.0 and 100.0.
'''+          Do not use the values 0.0 or 100.0.
'''+The inverse duty cycle (100% - dutycycle) is used with instruction PWM_Init, parameter startvalue=0.
'''+The highest output frequency where the duty cycle can be still defined in 1%-steps, is 500 kHz.
'''frequency: Frequency in Hertzs (0.01 Hz .. 50000 kHz).
'''****************************************************************************
SUB PWM_Write_Latch(channel, dutycycle, frequency)
  DIM max as Long
  DIM low as Long
  DIM per as float
  max = (50000000 / (frequency)) - 1                        'ref 50 MHz
  Poke (5c7109E0H+  (channel) * 32,max)   '10A0
  per = DutyCycle
  'IF (per>100) then per=100
  IF (per < 0) then per = 0
  low = (max * per * 0.01)

  if (max <= low) then low = max - 1
  Poke (5c7107E0H+  (channel) * 32,low)   '1080

ENDSUB

'******************************************************************************
''' Latches frequency and duty cyle of the selected PWM outputs to be output.
''' pattern: Bit pattern to select PWM outputs.
'''+          bit=0: No action.
'''+          bit=1: latch = enable for output.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 5: Channel 6
'''****************************************************************************
SUB PWM_Latch(pattern)
  Poke (5c710700H,pattern)  
ENDSUB

'******************************************************************************
''' Reads the operation status of all PWM outputs.
'''+return value: Bit pattern with status bits of all PWM outputs.
'''+          bit=0: PWM output has finished.
'''+          bit=1: PWM output is running.
'''+          Bit 0: Channel 1
'''+          ...
'''+          Bit 5: Channel 6
'''****************************************************************************
FUNCTION PWM_Get_Status() as Long
  PWM_Get_Status =  Peek_P2 (5c710300H)  ' peek(0c000300h)
ENDFUNCTION

'<ENDREGION>

'<REGION> ANYBUS M40
'''Writes array content into RAM
'''source_ar: source array (data type Long)
'''startindex: start index (1..n) in source_ar
'''startindex_ram: start index (0..n) in Anybus RAM
'''count: number (1..n) of words; word size is set with word_length
'''+   low priority  -> 1=slow (up to 16 x long), 2=middle (up to 128 x long), 3=fast (up to 1024 x long)
'''+   high priority -> 1,2,3 (up to 32768 x long)
'''word_length:
'''+   32   use 32 bit values in source_ar 
'''+   16   use 16 bit values in source_ar 
SUB M40_SET_RAM(source_ar[],startindex,startindex_ram,count,word_length) '<HIDE>
  dim i as long
  dim adr as long
  dim anzcount as Long
  DIM maxburst as Long
  dim icount as long
  DIM iindex as Long
  dim ready as long
  dim ram as long
  
  CHECK_TYPE_LONG (source_ar)
  System_Array_Debug_Check(source_ar,startindex,count)

  if (count > 0) then   
    maxburst=100
    iindex = startindex
    icount=count 
    ram=startindex_ram
   
    do 
      anzcount = min_long(icount, maxburst)          
   
      if (word_length=16) then       
        poke(5c670800h, ram)  '    Schreibadresse,  (32 Bit breit schreiben, deshalb 
      else
        poke(5c670800h, ram or shift_left(1,31)) 
      endif 
      
      for i=1 to anzcount
        'DB     Write_Fast_Bus_LB(source_ar[iindex], anzcount, 64070900h or shift_left(module, 20))
        poke(5c650000h,source_ar[iindex])
      
        inc iindex
      next  
      
      if (word_length=16) then    
        ram=ram+anzcount
      else
        ram=ram+anzcount+anzcount
      endif  
           
      icount = icount - anzcount
     
      do  'wait   
        ready=peek_p2(5c670800h)
      until ((ready=1) or (ready=12345678H))
    until (icount = 0)
    
  endif
    
      
ENDSUB

 
'''Reads RAM content into an array
'''destination_ar: destination array (data type Long)
'''startindex: start index (1..n) in destination_ar
'''startindex_ram: start index (0..n) in Anybus RAM
'''count: number (1..n) of words; word size is set with word_length
'''+   low priority  -> 1=slow (up to 16 x long), 2=middle (up to 128 x long), 3=fast (up to 1024 x long)
'''+   high priority -> 1,2,3 (up to 32768 x long)
'''word_length:
'''+   32   use 32 bit values in destination_ar 
'''+   16   use 16 bit values in destination_ar 
SUB M40_GET_RAM(destination_ar[],startindex,startindex_ram,count,word_length) '<HIDE>
  dim i as long
  dim anzcount as Long
  DIM maxburst as Long
  dim icount as long
  DIM iindex as Long
  
  dim ram as long
  dim i3 as long
  
   
  CHECK_TYPE_LONG (destination_ar)
  System_Array_Debug_Check(destination_ar,startindex,count)
  '
  
  if (count>0 )then
    maxburst=200
    icount=count  
    iindex=startindex
    ram=startindex_ram
    
    do
      anzcount = min_long(icount, maxburst)       
      poke(5c670810h, anzcount)
      
      if (word_length=32) then 
        poke(5c670850h,(ram) or shift_left(1,31))
        ram=ram+anzcount+anzcount   
      else   
        poke(5c670850h,(ram)) 
        ram=ram+anzcount
      endif
 
      for i=1 to anzcount     
        destination_ar[iindex]=peek_p2(5c650000h) 
        inc iindex
      next
      
        
      icount = icount - anzcount
    until (icount = 0)
  endif 

ENDSUB
   

SUB ABM40_Reset()     '<HIDE>'  
  poke(5c640000h, 1)  'Reset active '1  ms
  IO_sleep(100000)
  poke(5c640000h, 0) 'Reset inactive
  IO_sleep(150000000)  '1.5sec 
ENDSUB


'***************************************************************
'''Reads and writes process data from/to Anybus module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         4: Active
'''+     other: Error (configuration correct?)
'''in_pd_arr[]:    array for data from Anybus to ADwin
'''out_pd_arr[]:   array for data from ADwin to AnyBus
'''in_pd_arr_len:  number of elements (from Anybus to ADwin)
'''out_pd_arr_len: number of elements (from ADwin to Anybus)
'''work_arr[]:     array for communication ADwin processor <-> Anybus module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Run_ANYBUS_CC_M40(in_pd_arr[], out_pd_arr[], in_pd_arr_len, out_pd_arr_len, work_arr[]) AS LONG  ''<HIDE>
  DIM map_cnt_in, map_cnt_out, id_counter,i AS LONG
  Check_Type_Long (work_arr[1])
  System_Array_Debug_Check(work_arr, 1, AB_WORK_ARR_LEN)
  M40_GET_RAM(work_arr,ABP_STATUS_REGISTER_IDX,ABP_STATUS_REGISTER_ADR,1,16)
  M40_GET_RAM(work_arr,ABP_BUFFER_CONTROL_IDX,ABP_BUFFER_CONTROL_ADR,1,16)   
  IF ((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_RDMSG) = ABP_BIT_RDMSG) THEN       'There is a message available.
    M40_GET_RAM(work_arr,AB_START_MSG_HEADER_IN,ABP_MSG_DATA_READ_ADR,ABP_MSG_DATA_LENGH,16)   'Read Message
    work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT] = SHIFT_RIGHT(work_arr[AB_START_MSG_HEADER_IN + AB_MSG_SOURCE_ID_OBJ],8)
    work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_SOURCE_ID_OBJ] AND 0FFH
    work_arr[ABP_TEMP_IDX] = ABP_BIT_RDMSG + ABP_BIT_APPR
    M40_SET_RAM(work_arr,ABP_TEMP_IDX,ABP_BUFFER_CONTROL_ADR,1,16)                   'Message ACK
    M40_GET_RAM(work_arr,ABP_BUFFER_CONTROL_IDX,ABP_BUFFER_CONTROL_ADR,1,16)   
    IF ((work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_C_BIT) = ABP_MSG_HEADER_C_BIT) THEN 'Message is a command
      FOR i = 0 TO AB_HEADER_SIZE
        work_arr[AB_START_MSG_HEADER_OUT + i] = work_arr[AB_START_MSG_HEADER_IN + i]
      NEXT i
      work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT]
      work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
      work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] AND NOT(ABP_MSG_HEADER_C_BIT)
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
        CASE ABP_OBJ_NUM_APPD
          work_arr[ABS_DO_MSG] = AB_TRUE
          IF (ApplicationDataObject(work_arr) = AB_FALSE) THEN 
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
          ENDIF
        CASE ABP_OBJ_NUM_APP
          work_arr[ABS_DO_MSG] = AB_TRUE
          IF (ApplicationObject(work_arr) = AB_FALSE) THEN
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
          ENDIF
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_OBJECT
          work_arr[AB_ERROR_Extention1] = work_arr[AB_START_MSG_HEADER_IN + AB_OBJECT_OUT]
          work_arr[ABS_DO_MSG] = AB_TRUE
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_ERROR_BASE]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] OR (ABP_MSG_HEADER_E_BIT)
      ENDSELECT
    ELSE 'Message is a response to a command we have sent
      DEC work_arr[AB_OUTSTANDING_COMMANDS]
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT]
        CASE MSG_SETUP_COMPLETE
          IF ((work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_E_BIT) = ABP_MSG_HEADER_E_BIT) THEN
            work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_SETUP_FAILED
          ENDIF
      ENDSELECT
    ENDIF
  ENDIF  ' End of message availible
  
  IF ((((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_WRMSG) = 0) AND ((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_ANBR) = ABP_BIT_ANBR)) AND (work_arr[ABS_DO_MSG] = AB_FALSE)) THEN 'The Anybus-CC is ready to accept commands, and the WriteMsg buffer is free
    SELECTCASE work_arr[AB_CmdState]
      CASE MSG_INIT
        map_cnt_in = 0
        map_cnt_out = 0
        id_counter = 0
        work_arr[AB_OUTSTANDING_COMMANDS] = 0
        work_arr[ABS_DO_MSG] = AB_FALSE
        work_arr[AB_CmdState] = MSG_NODE_ADR
      CASE MSG_NODE_ADR
        IF (work_arr[AB_MAPPING_DEV_ADR] <> 0) THEN
          inc id_counter
          work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
          work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NC
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_SET_ATTR
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 5                        'Node ID
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_DEV_ADR]
          work_arr[ABS_DO_MSG] = AB_TRUE
        ENDIF
        work_arr[AB_CmdState] = MSG_MAP_IO_1
      CASE MSG_MAP_IO_1
        inc id_counter
        work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] =  id_counter and 0ffH
        work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NW
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_NW_CMD_MAP_ADI_WRITE_EXT_AREA
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 7
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1 + map_cnt_out
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = work_arr[AB_MAPPING_SIZE_OUT]
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 0100H OR work_arr[AB_MAPPING_SIZE_OUT] 
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = work_arr[AB_PROC_TYPE_OUT]
        work_arr[ABS_DO_MSG] = AB_TRUE
        INC  map_cnt_out
        IF (work_arr[AB_MAPPING_CNT_OUT] = map_cnt_out) THEN work_arr[AB_CmdState] = MSG_MAP_IO_3
      CASE MSG_MAP_IO_3
        inc id_counter
        work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
        work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_NW
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_NW_CMD_MAP_ADI_READ_EXT_AREA
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 7
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1 + map_cnt_out + map_cnt_in 
        IF(work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_PNIO) THEN work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 6 + map_cnt_in 'Profinet
        IF(work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_DPV1) THEN work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 6 + map_cnt_in 'Profibus
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = work_arr[AB_MAPPING_SIZE_IN]
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 0100H OR work_arr[AB_MAPPING_SIZE_IN] 
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = work_arr[AB_PROC_TYPE_IN]
        work_arr[ABS_DO_MSG] = AB_TRUE
        INC  map_cnt_in
        IF (work_arr[AB_MAPPING_CNT_IN] = map_cnt_in) THEN work_arr[AB_CmdState] = MSG_SETUP_COMPLETE
      CASE MSG_SETUP_COMPLETE
        'All the configuration commands have been processed by the Anybus - CC.
        'Go ahead and end the setup phase by sending SETUP_COMPLETE.
        inc id_counter
        work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = id_counter and 0ffH
        work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = ABP_OBJ_NUM_ANB
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = 1
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_SET_ATTR
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_BOOL_SIZEOF
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = ABP_ANB_IA_SETUP_COMPLETE
        work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = AB_TRUE
        work_arr[ABS_DO_MSG] = AB_TRUE
        work_arr[AB_CmdState] = MSG_DONE
      CASE MSG_DONE
        IF (work_arr[AB_INSTANCE_READ_REQUEST] = AB_TRUE) THEN
          work_arr[AB_INSTANCE_READ_REQUEST] = AB_FALSE
          work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT] = work_arr[AB_READ_SOURCE_ID]
          work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT] = work_arr[AB_READ_OBJ_NUM]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_INSTANCE] = work_arr[AB_READ_INST_NUM]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_COMMAND] = ABP_MSG_HEADER_C_BIT OR ABP_CMD_GET_ATTR
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 0
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = work_arr[AB_READ_ATTR_NUM]
          work_arr[ABS_DO_MSG] = AB_TRUE
        ENDIF 
    ENDSELECT
    IF (work_arr[ABS_DO_MSG] = AB_TRUE) THEN
      'A new command has been posted to the Anybus - CC.
      'Increment counter for outstanding commands.
      INC work_arr[AB_OUTSTANDING_COMMANDS]
    ENDIF
  ENDIF
  IF (work_arr[ABS_DO_MSG] = AB_TRUE) THEN
    IF (Write_Msg_To_Anybus(work_arr) = AB_TRUE) THEN
      work_arr[ABS_DO_MSG] = AB_FALSE
    endif
  ENDIF
  IF ((work_arr[ABP_STATUS_REGISTER_IDX] AND ABS_BIT_ANB_STAT_S) = ABP_ANB_STATE_PROCESS_ACTIVE) THEN
    '      'The "read process data" is only valid in the PROCESS_ACTIVE state.
    '      'Retrieve the new "read process data" from the Anybus - CC.
    IF((work_arr[ABP_BUFFER_CONTROL_IDX] AND ABP_BIT_RDPD) = ABP_BIT_RDPD) THEN
      M40_GET_RAM(in_pd_arr,1,ABP_PROCESS_DATA_READ_ADR,in_pd_arr_len,32)   
      work_arr[ABP_TEMP_IDX] = ABP_BIT_RDPD 
    ELSE
      work_arr[ABP_TEMP_IDX] = 0
    ENDIF
    
    M40_SET_RAM(out_pd_arr,1,ABP_PROCESS_DATA_WRITE_ADR,out_pd_arr_len,32)   
    work_arr[ABP_TEMP_IDX] =  work_arr[ABP_TEMP_IDX] + ABP_BIT_WRPD + ABP_BIT_APPR
    M40_SET_RAM(work_arr,ABP_TEMP_IDX,ABP_BUFFER_CONTROL_ADR,1,16)                   'Procedata refresh
    work_arr[ABS_SPI_CTRL] = work_arr[ABS_SPI_CTRL] OR ABS_BIT_SPI_CTRL_PD_VALID
  ENDIF
  
  Run_ANYBUS_CC_M40 = work_arr[ABP_STATUS_REGISTER_IDX] AND ABS_BIT_ANB_STAT_S

ENDFUNCTION


'***************************************************************
'''Reads and writes process data from/to EtherCat module and 
'''+handles mailbox communication to the module.
'''+return value: State of operation of the EtherCat module.
'''+         0: Initializing.
'''+         2: Slave waits for bus start by master.
'''+         3: Slave is idle.
'''+         4: Normal operation.
'''+     other: Error (configuration correct?)
'''in_pd_arr[]:    array for data from ADwin to EtherCAT
'''out_pd_arr[]:   array for data from EtherCAT to ADwin
'''in_pd_arr_len:  number (1..360) of elements (from ADwin to EtherCAT)
'''out_pd_arr_len: number (1..360) of elements (from EtherCAT to ADwin)
'''work_arr[]:     array[5000] as long for communication ADwin processor <-> EtherCat module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
FUNCTION Run_Ethercat(in_pd_arr[], out_pd_arr[], in_pd_arr_len,out_pd_arr_len, work_arr[]) AS LONG
  Run_ETHERCAT = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr, out_pd_arr_len, in_pd_arr_len, work_arr)
ENDFUNCTION


'***************************************************************
'''Reads and writes process data from/to ProfinetIO module and 
'''+handles mailbox communication to the module.
'''+return value: State of operation of the ProfinetIO module.
'''+         0: Initializing.
'''+         2: Slave waits for bus start by master.
'''+         3: Slave is idle.
'''+         4: Normal operation.
'''+     other: Error (configuration correct?)
'''in_pd_arr[]:    array for data from ADwin to Fieldbus
'''out_pd_arr[]:   array for data from Fieldbus to ADwin
'''in_pd_arr_len:  number of elements (1,2,4,8,16,32,64,128,196,256,320) in double words (from ADwin to Fieldbus)
'''+               The number must not be greater than given in in_mod_cnt with Init_ProfinetIO.
'''out_pd_arr_len: number of elements (1,2,4,8,16,32,64,128,196,256,320) in double words (from Fieldbus to ADwin)
'''+               The number must not be greater than given in out_mod_cnt with Init_ProfinetIO.
'''work_arr[]:     array[5000] as long for communication ADwin processor <-> ProfinetIO module, see Init_ProfinetIO.
'''***************************************************************
FUNCTION Run_ProfinetIO(in_pd_arr[], out_pd_arr[], in_pd_arr_len, out_pd_arr_len, work_arr[]) AS LONG
  Run_ProfinetIO = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr,  out_pd_arr_len, in_pd_arr_len, work_arr)
ENDFUNCTION


'***************************************************************
'''Reads and writes process data from/to EtherNetIP module and 
'''+handles mailbox communication to the module.
'''+return value:
'''+         0: Setup
'''+         2: Wait
'''+         4: Active
'''+     other: Error (configuration correct?)
'''out_pd_arr[]:   array for data from Ethernet to ADwin
'''out_pd_arr_len: number of elements (from Ethernet to ADwin)
'''in_pd_arr[]:    array for data from ADwin to Ethernet
'''in_pd_arr_len:  number of elements (from ADwin to Ethernet)
'''work_arr[]:     array[5000] as long  for communication T12 <-> ProfinetIO-Module 
'''+ min. size 4096 elements
'''***************************************************************
FUNCTION Run_EtherNetIP(out_pd_arr[], out_pd_arr_len, in_pd_arr[], in_pd_arr_len, work_arr[]) AS LONG 
  Run_EtherNetIP = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr,  out_pd_arr_len, in_pd_arr_len, work_arr)
ENDFUNCTION


'***************************************************************
'''Reads and writes process data from/to Profibus-40 module and 
'''+handles mailbox communication to the module.
'''+return value: State of operation of the Profibus slave.
'''+         0: Initializing.
'''+         2: Slave waits for bus start by master.
'''+         3: Slave is idle.
'''+         4: Normal operation.
'''+     other: Error (configuration correct?)
'''in_pd_arr[]:    array for data from ADwin to Profibus
'''out_pd_arr[]:   array for data from Profibus to ADwin
'''in_pd_arr_len:  number of elements (1,2,4,8,16,32,61) in double words (from ADwin to Profibus)
'''+               The number must not be greater than given in in_mod_cnt with Init_Profibus
'''out_pd_arr_len: number of elements (1,2,4,8,16,32,61) in double words (from Fieldbus to ADwin)
'''+               The number must not be greater than given in out_mod_cnt with Init_Profibus
'''work_arr[]:     array[5000] as long for communication ADwin processor <-> Profibus-40 module, see Init_Profibus
'''***************************************************************
FUNCTION Run_Profibus(in_pd_arr[], out_pd_arr[], in_pd_arr_len, out_pd_arr_len, work_arr[]) AS LONG
  Run_PROFIBUS = Run_ANYBUS_CC_M40(out_pd_arr, in_pd_arr, out_pd_arr_len, in_pd_arr_len, work_arr)
ENDFUNCTION

  
FUNCTION Write_Msg_To_Anybus(work_arr[]) AS LONG   ''<HIDE>
  dim i as long
  work_arr[ABS_SPI_MSG_SIZE] = AB_HEADER_SIZE + work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] 
  work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_SOURCE_ID_OBJ] = SHIFT_LEFT(work_arr[AB_START_MSG_HEADER_OUT + AB_OBJECT_OUT], 8) OR work_arr[AB_START_MSG_HEADER_OUT + AB_SOURCE_ID_OUT]
  M40_SET_RAM(work_arr,AB_START_MSG_HEADER_OUT,ABP_MSG_DATA_WRITE_ADR,work_arr[ABS_SPI_MSG_SIZE],16)                   'Message 
  work_arr[ABP_TEMP_IDX] = ABP_BIT_WRMSG + ABP_BIT_APPR
  M40_SET_RAM(work_arr,ABP_TEMP_IDX,ABP_BUFFER_CONTROL_ADR,1,16)                   'Message ACK
  Write_Msg_To_Anybus = AB_TRUE
ENDFUNCTION


FUNCTION ApplicationObject(work_arr[]) AS LONG      ''<HIDE>
  ApplicationObject = AB_TRUE
  SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE]
    CASE 1
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationObject = AB_FALSE
          ENDSELECT 
        CASE ABP_CMD_SET_ATTR
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 0
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_COMMAND
          ApplicationObject = AB_FALSE
      ENDSELECT
    CASEELSE
      work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_INSTANCE
      ApplicationObject = AB_FALSE
  ENDSELECT 
ENDFUNCTION 


FUNCTION ApplicationDataObject(work_arr[]) AS LONG      ''<HIDE>
  DIM i AS LONG
  ApplicationDataObject = AB_TRUE
  SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE]
    CASE ABP_INST_OBJ
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            CASE ABP_OA_NAME
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 65         '"Application data"
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = 112
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 112
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = 108
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 4] = 105
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 5] = 99
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 6] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 7] = 116
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 8] = 105
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 9] = 111
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 10] = 110
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 11] = 32
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 12] = 100
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 13] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 14] = 116
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 15] = 97
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 32
            CASE ABP_OA_REV
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 1
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_REV_DS
            CASE ABP_OA_NUM_INST
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] =  work_arr[AB_MAPPING_CNT_OUT] + work_arr[AB_MAPPING_CNT_IN]     
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_NUM_INST_DS
            CASE ABP_OA_HIGHEST_INST
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] =  work_arr[AB_MAPPING_CNT_OUT] + work_arr[AB_MAPPING_CNT_IN]      
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = ABP_OA_HIGHEST_INST_DS
            CASE 11          'No mappabel read data
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 0
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
            CASE 12          'No mappabel write data
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 0
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationDataObject = AB_FALSE
          ENDSELECT 
        CASE ABP_APPD_CMD_GET_INST_BY_ORDER
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_CMD_EXT] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT]
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] 
          work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 2
        CASE ABP_APPD_CMD_GET_INST_NUMBERS
          FOR i = 1 TO work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA + 1]
            work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + (i-1)] = i
          NEXT i
        CASEELSE
          work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_UNSUP_COMMAND
          ApplicationDataObject = AB_FALSE
      ENDSELECT
    CASEELSE
      SELECTCASE work_arr[AB_START_MSG_HEADER_IN + AB_MSG_COMMAND] AND ABP_MSG_HEADER_CMD_BITS
        CASE ABP_CMD_GET_ATTR
          SELECTCASE (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_CMD_EXT] AND 0FFH)
            case ABP_APPD_CMD_GET_ATTR_NAME
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 050H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 1] = 061H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 2] = 072H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 3] = 061H
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 4] = 06DH
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA + 5] = (030H + work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE])
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 6
            case ABP_APPD_CMD_GET_ATTR_DATA_TYPE
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_DATA_TYPE]
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            case ABP_APPD_CMD_GET_ATTR_NO_ELEMENTS
              IF (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE] <= work_arr[AB_MAPPING_CNT_IN]) THEN
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_SIZE_IN]
              ELSE
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = work_arr[AB_MAPPING_SIZE_OUT]
              ENDIF
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            case ABP_APPD_CMD_GET_ATTR_DISCRIPTOR
              IF (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_INSTANCE] <= work_arr[AB_MAPPING_CNT_IN]) THEN
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 09H             'Get access ; Mappable as write process data
              ELSE
                work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = 013H            'Get access; Set access; Mappable as read process data
              ENDIF
              work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA_SIZE] = 1
            CASEELSE
              work_arr[AB_ERROR_BASE] = AB_ERROR_CODE_ATTR_NOT_GETTABLE
              ApplicationDataObject = AB_FALSE
          ENDSELECT 
      ENDSELECT 
  ENDSELECT 
ENDFUNCTION 


FUNCTION Check_Range_ETHERCAT(count, data_type, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  DIM type_size AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  Check_Range_ETHERCAT = AB_FALSE
  work_arr[AB_MODUL_NUMBER] =1'module
  type_size = -1
  IF (data_type = AB_DATA_TYPE_UINT32) THEN type_size = 4
  IF (data_type = AB_DATA_TYPE_FLOAT) THEN type_size = 4
  IF (data_type = AB_DATA_TYPE_SINT32) THEN type_size = 4
  IF (((count * type_size) >= 0) AND ((count * type_size) <=1440))THEN
    Check_Range_ETHERCAT = AB_TRUE
    work_arr[AB_MAPPING_DATA_TYPE] = data_type
    work_arr[size_adr] = 001H
    work_arr[cnt_adr] = count
  ENDIF
ENDFUNCTION


FUNCTION Check_Range_PROFIBUS(dev_adr,count,  direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  DIM type_size AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_DPV1
  Check_Range_PROFIBUS = AB_FALSE
  work_arr[AB_MAPPING_DEV_ADR] = dev_adr
  work_arr[AB_MODUL_NUMBER] = 1 'module
  work_arr[cnt_adr] = 1
  IF (count = 001H) THEN
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 001H
  ENDIF
  IF (count = 002H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 002H
  ENDIF
  IF (count = 004H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 004H
  ENDIF
  IF (count = 008H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 008H
  ENDIF
  IF (count = 010H) THEN 
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 010H
  ENDIF
  IF (count = 020H) THEN
    Check_Range_PROFIBUS = AB_TRUE
    work_arr[size_adr] = 020H
  ENDIF
  IF (count = 03DH) THEN
    Check_Range_PROFIBUS = AB_TRUE
    'work_arr[cnt_adr] = 2
    work_arr[size_adr] = 03DH
  ENDIF
ENDFUNCTION


FUNCTION Check_Range_PROFINET(count, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_PNIO
  Check_Range_PROFINET = AB_FALSE
  work_arr[AB_MODUL_NUMBER] = 1'module
  work_arr[cnt_adr] = 1
  IF (count = 001H) THEN
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 001H
  ENDIF
  IF (count = 002H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 002H
  ENDIF
  IF (count = 004H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 004H
  ENDIF
  IF (count = 008H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 008H
  ENDIF
  IF (count = 010H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 010H
  ENDIF
  IF (count = 020H) THEN
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 020H
  ENDIF
  IF (count = 040H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 080H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 2
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0C0H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 3
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0100H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 4
    work_arr[size_adr] = 040H
  ENDIF
  IF (count = 0140H) THEN 
    Check_Range_PROFINET = AB_TRUE
    work_arr[cnt_adr] = 5
    work_arr[size_adr] = 040H
  ENDIF
ENDFUNCTION


FUNCTION Check_Range_EtherNetIP(count, direction, work_arr[]) AS LONG      ''<HIDE>
  DIM size_adr AS LONG
  DIM cnt_adr AS LONG
  IF (direction = AB_DIR_IN) THEN size_adr = AB_MAPPING_SIZE_IN
  IF (direction = AB_DIR_OUT) THEN size_adr = AB_MAPPING_SIZE_OUT
  IF (direction = AB_DIR_IN) THEN cnt_adr = AB_MAPPING_CNT_IN
  IF (direction = AB_DIR_OUT) THEN cnt_adr = AB_MAPPING_CNT_OUT
  work_arr[AB_MAPPING_DATA_TYPE] = AB_DATA_TYPE_UINT32
  work_arr[AB_USER_BUS_TYPE] = ABP_OBJ_NUM_EIP
  Check_Range_EtherNetIP = AB_FALSE
  work_arr[AB_MODUL_NUMBER] = 1'module
  work_arr[cnt_adr] = 1
  IF ((count >= 0) AND (count <= 125)) THEN
    Check_Range_EtherNetIP = AB_TRUE
    work_arr[size_adr] = count
  ENDIF
ENDFUNCTION


'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+ProfinetIO module.
'''+return value:
'''+          0: OK
'''+         -1: Wrong no of IO data elements
'''in_mod_cnt:  number of elements (1,2,4,8,16,32,64,128,196,256,320) in double words (from ADwin to Fieldbus)
'''out_mod_cnt: number of elements (1,2,4,8,16,32,64,128,196,256,320) in double words (from Fieldbus to ADwin)
'''work_arr[]:  array for communication ADwin processor <-> ProfinetIO module 
'''+ min. size AB_WORK_ARR_LEN 
'''***************************************************************
'''#C;LOW;
FUNCTION Init_ProfinetIO(in_mod_cnt, out_mod_cnt, work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_PROFINET(in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_PROFINET(out_mod_cnt,  AB_DIR_OUT, work_arr) 
  Init_ProfinetIO = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt,AB_DATA_TYPE_UINT32 , check_result, work_arr) 
ENDFUNCTION


'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+EtherCat module.
'''+return value:
'''+          0: OK
'''+         -1: Wrong IO size; the size of process data in and 
'''+             process data out must each be in the range of 0 .. 1440 byte
'''in_mod_cnt:  number (0..360) of elements in double words (from ADwin to EtherCAT)
'''out_mod_cnt: number (0..360) of elements in double words (from EtherCAT to ADwin)
'''data_type:   data type of process data in and process data out
'''+            [AB_DATA_TYPE_UINT32: unsigned integer, 32bit]
'''+            AB_DATA_TYPE_SINT32: signed integer, 32bit
'''+            AB_DATA_TYPE_FLOAT: floating point, 32bit
'''work_arr[]:  array for communication ADwin processor <-> EtherCAT module 
'''+            min. size AB_WORK_ARR_LEN 
'''***************************************************************
'''#C;LOW;
FUNCTION Init_EtherCat(in_mod_cnt, out_mod_cnt, data_type, work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_ETHERCAT(in_mod_cnt, data_type, AB_DIR_IN, work_arr) AND Check_Range_ETHERCAT(out_mod_cnt, data_type, AB_DIR_OUT, work_arr) 
  Init_ETHERCAT = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, data_type, check_result, work_arr) 
ENDFUNCTION


'***************************************************************
'''Initializes arrays and variables for the communication to the 
'''+Profibus-40 module.
'''+return value: Status of initialization:
'''+          0: Initialization successful.
'''+         -1: Error, size of data ranges is wrong.
'''dev_adr:     Slave node address / station address (1125) on the Profibus.
'''in_mod_cnt:  Size (1,2,4,8,16,32,61) of the area in the Profibus slave in double words (from ADwin to Profibus)
'''out_mod_cnt: Size (1,2,4,8,16,32,61) of the area in the Profibus slave in double words (from Fieldbus to ADwin)
'''work_arr[]:  array for communication ADwin processor <-> Profibus-40 module 
'''+            min. size AB_WORK_ARR_LEN
'''***************************************************************
'''#C;LOW;
FUNCTION Init_Profibus(dev_adr, in_mod_cnt, out_mod_cnt, work_arr[]) AS LONG
  DIM check_result AS LONG
  check_result =  Check_Range_PROFIBUS(dev_adr,in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_PROFIBUS(dev_adr,out_mod_cnt,  AB_DIR_OUT, work_arr) 
  Init_PROFIBUS = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, AB_DATA_TYPE_UINT32, check_result, work_arr) 
ENDFUNCTION


'***************************************************************
'''Resets the EtherNetIP module and initializes several variables.
'''+return value: Status of initialization:
'''+          0: Initialization successful.
'''+         -1: Error, size of data ranges is wrong.
'''in_mod_cnt:   number of elements (from ADwin to EtherNetIP)
'''in_mod_type:  data type (from ADwin to EtherNetIP)
'''+         1:  1 Byte
'''+         2:  2 Bytes
'''+         3:  4 Bytes
'''+        16:  8 Bytes
'''out_mod_cnt:  number of elements (from EtherNetIP to ADwin)
'''out_mod_type: data type (from EtherNetIP to ADwin)
'''+         1:  1 Byte
'''+         2:  2 Bytes
'''+         3:  4 Bytes
'''+        16:  8 Bytes
'''work_arr[]:   array for communication T12 <-> EtherNetIP-Module
'''+             min. size 4096 elements
'''***************************************************************
Function Init_EtherNetIP(in_mod_cnt, in_mod_type, out_mod_cnt, out_mod_type, work_arr[]) as long
  DIM check_result AS LONG
  check_result =  Check_Range_EtherNetIP(in_mod_cnt,  AB_DIR_IN, work_arr) AND Check_Range_EtherNetIP(out_mod_cnt,  AB_DIR_OUT, work_arr) 
  Init_EtherNetIP = Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, AB_DATA_TYPE_UINT32, check_result, work_arr) 
ENDFUNCTION


'***************************************************************
'''Initializes datas and variables for the communication to the 
'''+Anybus module.
'''+return value:
'''+         0: OK
'''+         -1: Wrong no of IO data elements
'''in_mod_cnt:   number of elements {1,2,4,8,16,32,64,128,196,256,320} (from ADwin to ANYBUS)
'''out_mod_cnt:  number of elements {1,2,4,8,16,32,64,128,196,256,320} (from ANYBUS to ADwin)
'''data_type:    ???
'''check_result: ???
'''work_arr[]:  array for communication ADwin processor <-> Anybus module 
'''+            min. size AB_WORK_ARR_LEN 
'''***************************************************************
'''#C;LOW;
FUNCTION Init_ANYBUS_CC_M40(in_mod_cnt, out_mod_cnt, data_type, check_result, work_arr[]) AS LONG     ''<HIDE>
  DIM i AS LONG
  Check_Type_Long (work_arr[1])
  System_Array_Debug_Check(work_arr,1,AB_WORK_ARR_LEN)

#if Prioritaet = low
  IF (check_result = AB_FALSE) THEN
    Init_ANYBUS_CC_M40 = -1
  ELSE
    Init_ANYBUS_CC_M40 = 0
  
    ABM40_Reset()
    FOR i = 1 TO AB_WORK_ARR_LEN
      IF ((i < AB_MAPPING_CNT_IN) OR (i > AB_USER_BUS_TYPE))THEN work_arr[i] = 0
    NEXT i

    work_arr[ABS_SPI_CTRL] = ABS_BIT_CMDCNT
    work_arr[AB_PROC_TYPE_IN] = data_type
    work_arr[AB_PROC_CNT_IN] = in_mod_cnt
    work_arr[AB_PROC_TYPE_OUT] = data_type 
    work_arr[AB_PROC_CNT_OUT] = out_mod_cnt
    work_arr[AB_CmdState] = MSG_INIT
    work_arr[AB_START_MSG_HEADER_OUT + AB_MSG_DATA] = AB_TRUE
    work_arr[ABS_SPI_STATE] = ABS_SPI_STATE_INIT
    work_arr[ABS_SPI_APP_STATE] = 0
    work_arr[ABS_SPI_INT_MASK] = 0
  ENDIF
#else
  Error_If_High("the command Init_ProfinetIO can only be used in low priority section ")
#endif
ENDFUNCTION

SUB Request_Attribute(Source_ID, Object, Instance, Attribute, work_arr[])      ''<HIDE>
  work_arr[AB_INSTANCE_READ_REQUEST] = AB_TRUE
  work_arr[AB_READ_SOURCE_ID] = Source_ID
  work_arr[AB_READ_OBJ_NUM] = Object
  work_arr[AB_READ_INST_NUM] = Instance
  work_arr[AB_READ_ATTR_NUM] = Attribute
ENDSUB
FUNCTION Read_Attribute(response_array[], work_arr[]) AS LONG      ''<HIDE>
  DIM i AS LONG
  Read_Attribute = AB_FALSE
  IF (work_arr[AB_START_MSG_HEADER_IN + AB_SOURCE_ID_OUT] = work_arr[AB_READ_SOURCE_ID]) THEN
    FOR i = 0 TO (work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA_SIZE]/2) 
      response_array[i + 1] = work_arr[AB_START_MSG_HEADER_IN + AB_MSG_DATA + i]
    NEXT i
    Read_Attribute = AB_TRUE
  ENDIF
ENDFUNCTION 


'<ENDREGION>

'<REGION> NET
  
'******************************************************************************
''' Set external NET LED  
''' led_no: Number (1..2) of LED.
''' value: State of the LED.
'''+          0: off
'''+          1: on, red ext LED, yellow LED in connector
'''+          2: on, green
'''+          3: on, orange 
'''****************************************************************************
SUB NET_Set_Ext_LED(led_no,value)
  if (led_no=1) then 
    poke(5c0018A0h, value) 
  else
    poke(5c001880h, value) 
  endif
ENDSUB
  
****************************************************************************
''' Set NET LED in connector
''' led_no: Number (1..2) of LED.
''' value: State of the LED.
'''+          0: off 
'''+          1: on, green
'''+          2: on, orange
'''****************************************************************************
SUB NET_Set_Connector_LED(led_no,value)
  if (led_no=1) then 
    poke(5c001800h,value) 
  else
    poke(5c001820h, value)   
  endif
ENDSUB
'<ENDREGION>

'<REGION> PLL
'------------------------------------------------------------
''' Reads if external clock is locked
'''+ Attention: This command is only for extern clock option
'''+ return value: Status of external clock
'''+          0: unlocked
'''+          1: locked
'''---------------------------------------------------------------
Function PLL_Get_Status() As Long 
  PLL_Get_Status= Peek_P2(5C00a000h)  AND 1
EndFunction

'------------------------------------------------------------
'''change function of DIO(42)
'''value: 
'''+    0 DIO (42) normal I/O (default)
'''+    1 DIO (42) 10 MHz output on
'''---------------------------------------------------------------
SUB PLL_10MHz_OUT(value)
  poke(5c00a800h, value) 
ENDSUB



'<ENDREGION>

'<REGION> eMMC
'*******************************************************************************
''' Initializes the flash memory (eMMC).
'''+ return value: Flash size or initialization error.
'''+          >0: Number of available sectors on eMMC flash.
'''+          <0: Error (-100) hardware not available
'''+ Sector size is EMMC_SECTOR_SIZE bytes (512).
'''+ Long value=4 bytes; 32bit Float value=4 bytes; 64bit float value=8 bytes.
'''*****************************************************************************
FUNCTION EMMC_Init() AS long
  EMMC_INIT=Int_EMMC_Init()
ENDFUNCTION

Function EMMC_Write_Internal(start_sector, sector_count, source_array[], array_idx) As Long '<HIDE>
  Dim ValuesPerSector, remaining_sectors, current_sector, current_sector_count, current_array_start_index As Long
  
  ValuesPerSector = EMMC_SECTOR_SIZE / SizeOfArrayElement(source_array)
  remaining_sectors = sector_count
  current_sector = start_sector
  current_array_start_index = array_idx
  EMMC_Write_Internal = 0
  
#IF DEBUG_MODE = ON THEN 
  If (start_sector < 0) then prozess_fehler = 200411
  System_Array_Debug_Check(source_array, array_idx, (sector_count * ValuesPerSector))
#endif
  
  Do
    ' write max 128 sectors in each run
    current_sector_count = Min_Long(remaining_sectors, EMMC_TRANSACTION_MAX_SECTORS)
    '  EMMC_Write_Internal = Int_Emmc_Write_Long(source_array[current_array_start_index], current_sector, current_sector_count)
   
   
    if (if_type_long (source_array) = 1) then
      EMMC_Write_Internal = Int_Emmc_Write_Long(source_array,current_array_start_index,current_sector,current_sector_count)  '<HIDE>
    endif
    
    if (if_type_float (source_array) = 1) then
      EMMC_Write_Internal = Int_Emmc_Write_Double(source_array,current_array_start_index,current_sector,current_sector_count)  '<HIDE>
    endif
    
    if (if_type_float32 (source_array) = 1) then
      EMMC_Write_Internal = Int_Emmc_Write_Float32(source_array,current_array_start_index,current_sector,current_sector_count)  '<HIDE>
    endif
   

#IF DEBUG_MODE = ON THEN 
    If (EMMC_Write_Internal = EMMC_RET_INVALID_SECTOR) then prozess_fehler = 200410
#endif

    ' update array pointer
    current_array_start_index = current_array_start_index + ValuesPerSector * current_sector_count
    ' update sector pointer
    current_sector = current_sector + current_sector_count
    remaining_sectors = remaining_sectors - current_sector_count
  Until ((remaining_sectors <= 0) or (EMMC_Write_Internal <> 0))
EndFunction


'*******************************************************************************
''' Writes values to the flash memory (eMMC).
'''+Before  use, please first call EEMC_INIT.
'''+ return value: 
'''+    EMMC_RET_OK              (0) - Access was OK
'''+    EMMC_RET_ACCESS_ERROR    (1) - Read or Write error
'''+    EMMC_RET_INVALID_SECTOR  (4) - Invalid sector
'''+    EMMC_RET_NOT_AVAILABLE (100) -  option not available on this hardware
''' start_sector: 0 to EMMC_SECTORS_MAX
''' sector_count: Number of sectors to be written. A sector contains EMMC_SECTOR_SIZE bytes.
''' source_array[]: Array from which data is read.
''' array_idx: Index (1..n) of the first array element to be transferred.
'''*****************************************************************************
Function EMMC_Write(start_sector, sector_count, source_array[], array_idx) As Long
#IF DEBUG_MODE = ON THEN 
  If (start_sector < 0) then prozess_fehler = 200411
#endif
  If (start_sector >= 0) Then
    EMMC_Write = EMMC_Write_Internal(start_sector, sector_count, source_array, array_idx)
  EndIf
EndFunction


'*******************************************************************************
''' Reads values from eMMC.
'''+ Before  use, please first call EEMC_INIT.
'''+ return value: 
'''+    EMMC_RET_OK              (0) - Access was OK
'''+    EMMC_RET_ACCESS_ERROR    (1) - Read or Write error
'''+    EMMC_RET_INVALID_SECTOR  (4) - Invalid sector
'''+    EMMC_RET_NOT_AVAILABLE (100) -  option not available on this hardware
''' start_sector: 0 to EMMC_SECTORS_MAX
''' sector_count: Number of sectors to be read. A sector contains EMMC_SECTOR_SIZE bytes.
''' dest_array[]: Array to which data is written.
''' array_idx: Index (1..n) of the first array element to be written.
'''*****************************************************************************
Function EMMC_Read(start_sector, sector_count, dest_array[], array_idx) As Long
  Dim ValuesPerSector, remaining_sectors, current_sector, current_sector_count, current_array_start_index As Long
  
  ValuesPerSector = EMMC_SECTOR_SIZE / SizeOfArrayElement(dest_array)
  remaining_sectors = sector_count
  current_sector = start_sector
  current_array_start_index = array_idx
  EMMC_Read = 0
  
#IF DEBUG_MODE = ON THEN 
  If (start_sector < 0) then prozess_fehler = 200401
  System_Array_Debug_Check(dest_array, array_idx, (sector_count * ValuesPerSector))
#endif
  
  Do
    ' read max 128 sectors in each run
    current_sector_count = Min_Long(remaining_sectors, EMMC_TRANSACTION_MAX_SECTORS)
    'EMMC_Read = Int_Emmc_Read_Long(dest_array[current_array_start_index], current_sector, current_sector_count)
    
    if (if_type_long (dest_array) = 1) then
      EMMC_Read=Int_Emmc_Read_Long(dest_array,current_array_start_index,current_sector,current_sector_count)  '<HIDE>
    endif
    
    if (if_type_float (dest_array) = 1) then
      EMMC_Read=Int_Emmc_Read_Double(dest_array,current_array_start_index,current_sector,current_sector_count)  '<HIDE>
    endif
    
    if (if_type_float32 (dest_array) = 1) then
      EMMC_Read=Int_Emmc_Read_float32(dest_array,current_array_start_index,current_sector,current_sector_count)  '<HIDE>
    endif
    

  
#IF DEBUG_MODE = ON THEN 
    If (EMMC_Read = EMMC_RET_INVALID_SECTOR) then prozess_fehler = 200400
#endif
    ' update array pointer
    current_array_start_index = current_array_start_index + ValuesPerSector * current_sector_count
    ' update sector pointer
    current_sector = current_sector + current_sector_count
    remaining_sectors = remaining_sectors - current_sector_count
  Until ((remaining_sectors <= 0) or (EMMC_Read <> 0))
EndFunction
'<ENDREGION>


