/*
 * (c) 2002 Jaeger Computergesteuerte Messtechnik GmbH, Lorsch
 *
 *  v2.0    Author: Daniel Franke <info@ADwin.de>
 *      Date:   06/30/2002
 *
 *  v1.0    Author: Marcus Galemann <info@ADwin.de>
 *
 * ChangeLog:
 *  v2.0
 */

#ifndef __ADWIN_H__
#define __ADWIN_H__

#include <netinet/in.h>
#include <sys/types.h>

/* Location of file that holds location of installation */
#define ADWINDIR_FILE     "/etc/adwin/ADWINDIR"

#define DC_UNKNOWN  0x00000
#define DC_LINK     0x10000
#define DC_PCMCIA   0x30000     /* PCMCIA == LINK */
#define DC_USB      0x40000
#define DC_ETHERNET 0x80000


#if (defined (__FreeBSD__) || defined(__APPLE__))
    #include <sys/types.h>
#else
    #include <linux/types.h>
#endif

#define DESCLEN 32
#define ETHERNET_DESCLEN 16
#define PWLEN   10

typedef struct {
    uid_t dev_uid;
    gid_t dev_gid;
    mode_t dev_mode;

    int dev_name;
    char dev_desc[DESCLEN];
    int dev_type;               /* connection type */

    int dev_link_base_addr;

    int dev_usb_serial;

    int dev_net_host_link;          /* device ID at IP */
    char  dev_net_host_password[PWLEN];
    int dev_net_package_count;      /* default: 5 */
    int dev_net_timeout;            /* default: 1000ms */

    struct sockaddr_in dev_net_server;

    int dev_processor;
} adwin_dev_t;


#endif /* __DEVICEADWIN_H__ */
