****************************************
*	 Prozenummer = 1
*	 Delay = 1953
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 2
*	 SAVECOMPIL = 0
****************************************
' file : FFT_scale_demo_opt.BAS			
' 990714 JK  created
' 020322 JK  IMPORT FFT.LI9
' 040130 JK  updated for T10 processor
' for all ADwin-systems with T9 or T10 processor
'--------------------------------------------------------------------------

' This program is an OPTimized version of the program FFT_scale_demo.bas.
'
' This program generates internally a frequency of 60 Hz with the amplitude
' of 0.7 (unitless). Upon this frequency a frequency of 30 Hz with 
' amplitude 1.0 and a constant offset of 1.5 is superposed. After the calls
' of the funktions FFT(), FFT_mag() and FFT_scale() we get a spectrum, 
' where the amplitudes of the showed frequencies match exactly to the 
' magnitudes of the signal components in the original waveform  : 
'			DATA_6[7]   = 1                        (60 Hz)
'			DATA_6[4]   = 0.7                      (30 Hz)
'			DATA_6[1]   = 1.5                      (constant offset)
'			DATA_6[all other elements]   = 0


#IF PROZESSOR = T10 THEN
IMPORT FFT.LIA
#ELSE
IMPORT FFT.LI9
#ENDIF

#DEFINE PI 		3.141592654 


DIM DATA_1[1024], DATA_3[4096], DATA_5[512] AS FLOAT AT DM_LOCAL
DIM DATA_2[1024], DATA_4[4096], DATA_6[512] AS FLOAT AT DM_LOCAL
DIM help_1[4096], help_2[4096]               AS FLOAT AT DM_LOCAL
'
'''DIM DATA_1[2048], DATA_3[8192], DATA_5[1024]  AS FLOAT AT DM_LOCAL
'''DIM DATA_2[2048], DATA_4[8192], DATA_6[1024]  AS FLOAT AT DM_LOCAL
'''DIM help_1[8192], help_2[8192]   AS FLOAT  ' (not enough space in DM_LOCAL)
'
'DIM DATA_1[16384], DATA_3[65536], DATA_5[8192]  AS FLOAT 
'DIM DATA_2[16384], DATA_4[65536], DATA_6[8192]  AS FLOAT 
'DIM help_1[65536], help_2[65536]               AS FLOAT 
'
'

DIM run, number                  AS LONG
DIM sim_freq1, sim_freq2, T_total, sample_freq AS FLOAT   
DIM const_offset   AS FLOAT ' (maybe a DC- offset)

LOWINIT:
'  number = 16384   ' number of points for FFT (must be a power of 2)
'  number = 8192   ' number of points for FFT (must be a power of 2)
'  number = 4096   ' number of points for FFT (must be a power of 2)
'  number = 2048   ' number of points for FFT (must be a power of 2)
'  number = 1024   ' number of points for FFT (must be a power of 2)
  number = 512    ' number of points for FFT (must be a power of 2)
'  number = 256    ' number of points for FFT (must be a power of 2)
  T_total = 0.1   ' [s]  total sampling time  
  sample_freq = number / T_total ' [Hz] ( = 10240 Hz)
  '	25 ns is the unit of ADSP system timer for a high priority process
  GLOBALDELAY = 1000000000 * T_total / number / 25

  sim_freq1 = 60     ' [Hz]     internal frequency generator 1
  sim_freq2 = 30     ' [Hz]     internal frequency generator 2
  const_offset = 1.5  ' [unitless]

  run = 1
EVENT:
  DATA_1[run] = 0.7 * sin(2*PI * sim_freq1 * T_total * run / number) 
  DATA_1[run] = DATA_1[run]+sin(2*PI * sim_freq2 * T_total * run/number) 
  DATA_1[run] = DATA_1[run] + const_offset
  DATA_2[run] = 0     '  clear the array with imaginary rate of data

  IF (run = number) THEN	END
  run = run + 1
	
FINISH:
	
    FFT_init(help_1, help_2, number)

PAR_13 = read_timer()

''''  FFT(DATA_1, DATA_2, DATA_3, DATA_4, help_1, help_2, number)

'    FFT_calc(DATA_1, DATA_2, DATA_3, DATA_4, help_1, help_2, number) ' measured with ADwin-CD version 4.01.0106
    FFT_calc_DM(DATA_1, DATA_2, DATA_3, DATA_4, help_1, help_2, number) ' specially optimized FFT-library (which is using :  AT DM_LOCAL , AT DRAM_EXTERN )
'    FFT_calc_DX(DATA_1, DATA_2, DATA_3, DATA_4, help_1, help_2, number) ' specially optimized FFT-library (which is using :  AT DM_LOCAL , AT DRAM_EXTERN )

PAR_14 = read_timer()
par_12 = par_14 - par_13

#IF PROZESSOR = T10 THEN
'fpar_12 displays the time needed for FFT in unit ms	
fpar_12 = par_12 / 20  ' GLOBALDELAY unit is  50 microseconds for T10
#ELSE
fpar_12 = par_12 / 10  ' GLOBALDELAY unit is 100 microseconds for T9
#ENDIF

'  FFT_mag(DATA_3, DATA_4, DATA_5, number / 2) ' magnitude into DATA_5
'  FFT_scale(DATA_5, DATA_6, number / 2) ' scaled magnitude into DATA_6

  FFT_mag_scale(DATA_3, DATA_4, DATA_6, number / 2) ' scaled magnitude into DATA_6

