****************************************
*	 Prozenummer = 1
*	 Delay = 1000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 4000001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'#######################################################################
'########################  Mesurement Process  #########################
'#########################   Version 1.00     ##########################
'#######################################################################

#INCLUDE ADWINPRO.INC
#INCLUDE ADWPDIO.INC
#INCLUDE ADWPAD.INC

#DEFINE pstom 1						'Pro-Storage module
#DEFINE painm 1						'Pro-AIn module
#DEFINE FB DATA_199				'global FIFO buffer (FB)
#DEFINE f_cmd DATA_198		'FCA (F_ile-C_ommand-A_rray)
DIM f_cmd[9] AS LONG AT DM_LOCAL	'FCA for control and status info
DIM dloss, led AS LONG

'#############################################
'### Required definition and dimensioning  ###

#DEFINE FB_size 100000		'FIFO buffer size
DIM FB[FB_size] AS LONG AS FIFO		'FIFO with data to write
'DIM FB[FB_size] AS FLOAT AS FIFO		'FIFO with data to write

'### Required definition and dimensioning  ###
'#############################################


INIT:
'#############################################
'### Required settings for storage process ###
' Do use these settings only if MP starts first !
' If not, turn these lines into comment lines.

	'-------- prepare FCA: -----------------------------------------------
	f_cmd[1]=1							'write to file #1
	f_cmd[2]=0							'file mode: NEW#
	f_cmd[3]=150000					'save every 15 seconds if any data in FIFO;
													'value 150000 valid for T9 processor.
													'(refers to timer of low priority process: 
													' T9:  150000 x 100s = 15s
													' T10: 300000 x  50s = 15s)
	'-------- initialize: ------------------------------------------------
	FIFO_CLEAR(199)					'initialize FB pointer
	START_PROCESS(9)				'start previously loaded storage process
'### Required settings for storage process ###
'#############################################

	SETLED(painm,AD,1)			'turn on LED on AIn module
	SETLED(pstom,DIO,0)			'turn off all LEDs on storage module
	dloss=0									'clear flag for data loss
	PAR_13=0								'clear flag for termination of storage process
	GLOBALDELAY=3628				'set sample rate to ~11.025 kHz
	
EVENT:
	'-------- measure analog input: --------------------------------------
	PAR_20=RTC_RD(pstom)		'get timestamp from RTC
	PAR_21=ADCF(painm,1)-32768		'measure ch-#1 and subtract offset
	'-------- check limits, if exceeded, save timestamp and value: -------
	IF (ABSI(PAR_21)>16384) THEN	'exceeding 5V limit?
'#############################################
'### required data input for storage proc. ###

		FB=PAR_20							'save timestamp in FB
		FB=PAR_21							'save value to FB

'### required data input for storage proc. ###
'#############################################
	ENDIF
	'-------- show all informations in FCA (if valid): -------------------
	IF (f_cmd[8]<>1) THEN
		PAR_1=f_cmd[1]				'current file-#
		PAR_2=f_cmd[2]				'file mode: 0 -> NEW, <>0 - APPEND
		PAR_3=f_cmd[3]				'time-out in 100s steps
		PAR_4=f_cmd[4]				'total file length (32 bit values)
		PAR_5=f_cmd[5]				'written data
		PAR_6=f_cmd[6]				'free elements in FB, if 0 => data loss !!!
		PAR_7=f_cmd[7]				'file-end and error status
		PAR_8=f_cmd[8]				'INIT status of storage process (if in INIT, =1)
		PAR_9=f_cmd[9]				'command to term. storage process (if no data in FB)
		PAR_10=PAR_4-PAR_5		'remaining data in current file
	ENDIF
	'-------- data loss detection: ---------------------------------------
	IF (f_cmd[6]=0) THEN	dloss=1	'data loss detected?
	IF (dloss<>0) THEN			'once a data loss detected?
		led=CHECKLED(pstom,DIO)	'get LED-status
		led=led OR 8h					'set bit for 2nd LED to light up red
		SETLED(pstom,DIO,led)	'let 2nd LED light up red
	ENDIF
	'-------- check for EOF and select next file if necessary: -----------
	IF (f_cmd[7]=64) THEN		'while writing data, EOF reached?
		IF (PROZESS9_RUNNING=0) THEN	'is storage process stopped?
			INC f_cmd[1]				'select next file
			START_PROCESS(9)		'start again storage process
			IF (f_cmd[1]>10) THEN END			'max. of 10 files written -> term.
		ENDIF
	ENDIF
	'-------- command to terminate storage process: ----------------------
	IF (PAR_13<>0) THEN			'terminate storage process?
		f_cmd[9]=1						'set FCA val. to term. storage process
	ENDIF
	
FINISH:
	SETLED(painm,AD,0)			'turn off LED on AIn module
	SETLED(pstom,DIO,0)			'turn off all LEDs on storage module