****************************************
*	 Prozenummer = 1
*	 Delay = 40000
*	 Eventsource = 0
*	 Number of Loops = 0
*	 Prioritt = 0
*	 Version = 1
*	 FastStop = 0
*	 AdbasicVersion = 3020001
*	 ATSRAM = 0
*	 OPT_LEVEL = 1
*	 SAVECOMPIL = 0
****************************************
'##########################################################################################
'#                                                                                        #
'# Example to measuring revolutions/minute with the ADwinPRO-System with a VR2/PW2-Module.#
'# At this programm a rotary encoder with line count of 2048 is used.                     #
'# The signal of rotary encoder must connect to counter 1(VR) and counter 3(PW).          #
'# The maximum frequency is about 600kHz.                                                 #
'# Last update 15.03.2002 ur/mh                                                           #
'#                                                                                        #
'# PAR_1 = First value counter 1 (VR-counter)                                             #
'# PAR_2 = First value counter 3 (PW-counter)                                             #
'# PAR_3 = Second value counter 1 (VR-counter)                                            #
'# PAR_4 = Second value counter 3 (PW-counter)                                            #
'# PAR_5 = Keep VR-countervalue in mind                                                   #
'# PAR_6 = Keep PW-countervalue in mind                                                   #
'# PAR_7 = rotary encoder with line count of 2048                                         #
'# FPAR_1= mean value of frequency                                                        #
'# FPAR_2= revolutions/minute                                                             #
'# FPAR_3= frequency                                                                      #
'#                                                                                        #
'##########################################################################################

#INCLUDE adwinpro.INC
#INCLUDE adwpdio.INC

DIM data_1[1000] AS FLOAT
DIM i AS LONG
DIM dauer, takte AS LONG
DIM cardadress AS LONG

INIT:
  i=1
  cardadress=1                       'Adress of VR2/PW2-Module
  SETLED(cardadress,DIO,1)           'LED VR2/PW2-Module ON
  PAR_7=2048                         'rotary encoder count

  GLOBALDELAY=40000                  'Globaldelay = 1ms
  CNT_SETMODE(cardadress,1)          'counter 1 to CLK/DIR
  CNT_CLEAR (cardadress,101B)        'counter 1 and 3 clear 
  CNT_ENABLE (cardadress,101B)       'counter 1 and 3 start

  PAR_5=0					
  PAR_6=0

EVENT:
  PAR_1=CNT_READ32(cardadress,1)        'VR-counter 1 (rising edge triggered) read first time
  PAR_2=CNT_READLATCH32(cardadress,7)   'PW-Latch counter 3 read (falling edge->3, rising edge->7) first time
	
  PAR_3=CNT_READ32(cardadress,1)        'VR-counter 1 (rising edge triggered) read second time
  PAR_4=CNT_READLATCH32(cardadress,7)   'PW-Latch counter 3 read (falling edge->3, rising edge->7) second time

  IF (PAR_1<>PAR_3) THEN    'Check of new countervalue between first and second read
    PAR_1=PAR_3
    PAR_2=PAR_4
  ENDIF

  takte=PAR_1-PAR_5         'count of edges between two EVENTS
  IF (takte<>0) THEN
    dauer=PAR_2-PAR_6       'calculate timebase
    FPAR_3=takte/dauer * 5000000      'frequency (5000000->frequency of VR2/PW2-Module)
    FPAR_1=FPAR_1*0.9 + FPAR_3*0.1    'mean value of frequency
    FPAR_2=(FPAR_1/PAR_7)*60          'rotations/minute
    PAR_5=PAR_1             'store VR-countervalue
    PAR_6=PAR_2             'store PW-countervalue
  ENDIF

  IF (i>1000) THEN i=1      'store Frequency so show with the PC
  DATA_1[i]=FPAR_1
  INC i

FINISH:
  CNT_ENABLE(cardadress,0)           'all counter stop
  SETLED(cardadress,DIO,0)           'LED VR2/PW2-Module OFF
