'<ADbasic Header, Headerversion 001.001>
' Foldings                       = 87,344,661,1206,2016,2120,2600,3724,4155,4456,4710,4980,5457,5674,6140,6330,6613,6864,6902,7101,7544,7615,8221,8288,8397,8568,8915,9265,9769,10278,10459,11577,11719
'<Header End>
'ADBASIC-SYSTEM-FILE--V1.00--0000--0000--Inc--PRO
'
'#################################################################
'#                        ADwinPRO2ARM.inc                       #
'#              INCLUDE-file for ADwin-Pro II-system             #
'#################################################################
'#                                                               #
'# Contents: Definition of functions and procedures              #
'#           to access ADwin PRO SYSTEM                          #
'#                                                               #
'#  21.06.2013  mf   creation  beta, beta, beta                  #
'#  06.08.2013  ap   sent set sensor type Konstante ergnzt      #
'#  07.08.2013  ap   P2_SENT_Get_Serial_Message_Array            #
'#  05.09.2013  ap   P2_SENT_INIT                                #
'#  18.11.2013  ap   P2_SENT_Request_Latch, etc.                 #
'#  04.12.2013  ap   sent                                        #
'#  10.12.2013  ap   SENT-4-OUT, SENT-6                          #
'#  13.12.2013  ap   Fix P2_SENT_Clear_Serial_Message_Array      #
'#  06.01.2014  mf   P2_Digin_Filter_Init(module, filter_value)  #
'#  16.01.2014  ap   Korrekturen bei 2 SENT Befehlen             #
'#  30.01.2014  ap   Doku Korrekturen PWM, CNT                   #
'#  04.02.2014  ap   Doku Korrekturen SENT, LS                   #
'#  07.08.2014  ap   Fix P2_SENT_Set_Serial_Message_Data         #
'#  07.01.2015  mf   T12 Ready                                   #
'#  27.02.2015  mf   bugfix P2_SPI_Master_Set_Clk_Wait           #
'#  08.05.2015  mf   debug code ding_fifo_read                   #
'#  11.05.2015  mf   bugfix Read_Fast_Bus_SB_unpacked1           #
'#  12.05.2015  mf   p2_seq_read debug                           #
'#  26.06.2015  mf   bugfix can                                  #
'#  26.08.2015  mf   many burst read_command support fifo array  #
'#  02.02.2016  mf   adcf_mode (0) seq_init lib                  #
'#  03.02.2016  mf   bugfix p2_dac_ramp_write                    #
'#  18.08.2016  mf   SG                                          #
'#  09.03.2016  mf   bugfix P2_Wait_mux, p2_adc, p2_adc24        #
'#                   p2_wait_mux                                 #
'#  12.04.2016  ur   LIN functions add                           #
'#  14.06.2016  mf   ECAT Master Beta                            #
'#  05.07.2016  mf   new Function for ADZL 0689                  #
'#  30.08.2016  mf   ECAT Bugfix Cast_tofloat32                  #
'#  20.09.2016  mf   P2_Transmit_Status removed hide             #
'#  12.10.2016  mf   LS Bus new sub ls_reset                     #
'#  26.10.2016  mf   LS BUS (LIB)                                #
'#  30.01.2016  mf/th flexray_timeout_value 100>1000             #
'#  19.09.2017  mf bugfix P2_SSI_Set_Delay                       #
'#  05.02.2018  mf   CAN-FD Beta                                 #
'#  27.04.2018  mf   removed at dm_local                         #
'#  23.08.2018  mf   P2_Digout_FIFO_Write_Flowrate               #
'#  28.11.2018  mf   anybus m40                                  #
'#  01.04.2020  ol   CANFD: alte Funktionen entfernt:            #
'#                   P2_CANFD_Req_Reg und P2_CANFD_Reed_Reg      #
'#                   P2_CANFD_Write_TMO_RAM modulcheck entfernt  #
'#                   P2_CANFD_Write_TMO_Header bergabe Parameter#
'#                   CANFD_datatable ergnzt                     #
'#  17.06.2020  ks   Funktionen mit bergbe von ByRef Parameter  #
'#                   (fr ADwin-C) in Beschreibung kenntlich     #
'#                   gemacht.                                    #
'#  01.04.2020  ol   P2_CANFD_Get_ESI umbenannt                  #
'#                   in P2_CANFD_Get_ESI_Flag                    #
'#  04.08.2020  ol   kommunikation --> communication             #
'#                   Rechtschreibfehler                          #
'#  14.09.2020  ks   Rckgabetyp in Beschreibung fr ADwinC      #
'#                   kenntlich gemacht.                          #
'#  26.10.2020  ur   P2_Comp_Init Hysteresis tresholds adjusted  #
'#  19.01.2021  mf   P2_Burst_init
'#  21.01.2021  mf   P2_PWM_Write_Latch debug_mode               #  
'#  24.09.2021  mf   P2_DRAM_Read,P2_DRAM_Write (internal sub)   #
'#  27.10.2021  mf   bugfix p2_burst_write                       #
'#  22.06.2022  mf   P2_CNT_Input_Receiver_Mode                  #
'#  06.10.2022  ap   P2_SENT_Get_Errorbits (fehlte bei T12)      #
'#  15.09.2023  mf   P2_Dig_FIFO_Mode>7                          #
'#  13.10.2023  mf   P2_canfd_get_ID bugfix                      #
'#  13.12.2023  JK   EndSub -> EndFunction                       #
'#  13.12.2023  gc   documentation update                        #
'#  23.01.2024  mf   new P2_CANFD_Set_Baudrate_Nominal_SP        #
'#  23.01.2024  mf   new P2_CANFD_Set_Baudrate_Data_SP           #
'#                                                               #
'# Attention:                                                    #
'#   - Do not copy the first source line (containing             #
'#     "'ADBASIC-SYSTEM-FILE...") to user files !                #
'#     Otherwise the Syntax color may be not correct.            #
'#   - This includefile requires ADbasic 5 or higher!            #
'#                                                               #
'#################################################################

#IF PROZESSOR = T12 THEN

'<REGION> Declaration


#const SYST_PRO 60000000H                                   '<HIDE> 
#define SYST_HW_NOP 600FFF00h                               '<HIDE> 

#define SYST_CPU 50000000H                                  '<HIDE> 



#define WATCHDOG   50004000h                                '<HIDE> 
#define WD_TIMER   50004000h                                '<HIDE>  
#define CPU_LED    50001100h                                '<HIDE> 
#define CPU_DIG_ADR 50002100H                               '<HIDE> 
#define CPU_DIG_ADR1 50002200H                              '<HIDE> 
#define CPU_DIG_CONFIG 50002000H                            '<HIDE> 


#define TTK_DAT_NR 16                                       '<HIDE>
#define TTK_D_STRUKT_LEN 20                                 '<HIDE>
#define TTK_INIT_IDX 2000                                   '<HIDE>
#define TTK_PAR_SZ_NR 71                                    '<HIDE>
#define TTK_PAR_LZ_NR 72                                    '<HIDE>
#define TTK_PAR_RQ_CH_NR 73                                 '<HIDE>
#define TTK_PAR_RQ_IDX_NR 74                                '<HIDE>
#define TTK_PAR_KS 75                                       '<HIDE>
#define TTK_PAR_RQW_CH_NR 76                                '<HIDE>
#define TTK_PAR_RQW_IDX_NR 77                               '<HIDE>
#define TTK_PAR_ABCC_STATE_NR 78                            '<HIDE>
#define TTK_PAR_VER 80                                      '<HIDE>
#define TTK_DK_IDX 100                                      '<HIDE>
#define TTK_CH_LEN 1600                                     '<HIDE>

'ECAT
#define ECAT_DSP_To_TiCo_1                    1             '<HIDE>
#define ECAT_DSP_To_TiCo_2                    2             '<HIDE>
#define ECAT_TiCo_To_DSP_1                    3             '<HIDE>
#define ECAT_TiCo_To_DSP_2                    4             '<HIDE>
#define ECAT_DSP_To_TiCo_11                   5             '<HIDE>
#define ECAT_DSP_To_TiCo_21                   6             '<HIDE>
#define ECAT_TiCo_To_DSP_11                   7             '<HIDE>
#define ECAT_TiCo_To_DSP_21                   8             '<HIDE>

' PARs used for interesting values and communication
' Note: The note about the Datas above does also apply here. Use
' Par[ECAT_Init_Result] on the TiCo, and P2_Get_Par(..., 
' ECAT_Init_Result) on the DSP.

' result of initialization function
#define ECAT_Init_Result                  1                 '<HIDE>
' version of driver software in TiCo
#define ECAT_Driver_Version               2                 '<HIDE>
' current state of the ECAT state machine
#define ECAT_Current_ECAT_State           3                 '<HIDE>
' result of last read operation
#define ECAT_Last_Read_Result             4                 '<HIDE>
' result of last write input operation
#define ECAT_Last_Write_Result            5                 '<HIDE>
' a magic flag, value must be ECAT_Magic_Flag_Value
#define ECAT_Magic_Flag_Par               6                 '<HIDE>
' current value of the distributed clock
#define ECAT_Current_DC_Time_Low          7                 '<HIDE>
#define ECAT_Current_DC_Time_High         8                 '<HIDE>
' State: 0-> Long values
'        1-> Float values
'        2-> Long and Float values
#define ECAT_Config_Value                 9                 '<HIDE>
' parameters to control double buffering of input and output datas
' the buffer the DSP is currently allowed to write to
' 1: DSP can write to buffer 1
' 2: DSP can write to buffer 2
' 0: DSP finished writing
' TiCo writes 1 or 2 to this variable, the DSP polls it, writes to the data
' and resets the value to 0
#define ECAT_Input_Buffer_DSP            11                 '<HIDE>
#define ECAT_Input_Buffer_TiCo           12                 '<HIDE>
#define ECAT_Input_Buffer_DSP_1          13                 '<HIDE>
#define ECAT_Input_Buffer_TiCo_1         14                 '<HIDE>
' basically the same, just for writing the reading values
#define ECAT_Output_Buffer_DSP           21                 '<HIDE>
#define ECAT_Output_Buffer_TiCo          22                 '<HIDE>
#define ECAT_Output_Buffer_DSP_1         23                 '<HIDE>
#define ECAT_Output_Buffer_TiCo_1        24                 '<HIDE>
' on ECAT cards, the ECAT_Magic_Flag_Par always holds this value
#define ECAT_Magic_Flag_Value         0AD0Eca1h             '<HIDE>
' maximum size of input and output datas
#define ECAT_RXPDO_COUNT_16L        16                      '<HIDE>
#define ECAT_TXPDO_COUNT_16L        16                      '<HIDE>
#define ECAT_RXPDO_COUNT_16F        16                      '<HIDE>
#define ECAT_TXPDO_COUNT_16F        16                      '<HIDE>
#define ECAT_STATE_INIT             0001h                   '<HIDE>
#define ECAT_STATE_PREOP            0002h                   '<HIDE>
#define ECAT_STATE_BOOT             0003h                   '<HIDE>
#define ECAT_STATE_SAFEOP           0004h                   '<HIDE>
#define ECAT_STATE_OP               0008h                   '<HIDE>

' return values of ADbasic EtherCAT functions
#define ECAT_NO_ERROR                    0                  '<HIDE>
#define ECAT_ERROR_INVALID_MODULE        1                  '<HIDE>
#define ECAT_ERROR_BUF_NOT_READY         2                  '<HIDE>

#If MAKE_LIB = OFF Then
DIM PWM_help_mode[15] as long                               '<HIDE>
Dim CAN_msg[9] As Long                                      ' array with 9 elements
#EndIf

' SENT
#DEFINE SENT_COMMAND_SET_DETECTION                    1     '<HIDE>
'#DEFINE SENT_COMMAND_SET_FREQUENCY                   3 '<HIDE> ' V1: channel number, V2: SENT clock frequency in Hz
#DEFINE SENT_COMMAND_SET_CLOCKTICK                    4     '<HIDE> ' V1: channel number, V2: SENT clock cycle period in ns
#DEFINE SENT_COMMAND_SET_CHECKSUMIMPLEMENTATION       6     '<HIDE> ' V1: channel number, V2: 0 legacy implementation, 1 recommended implementation
#DEFINE SENT_COMMAND_SET_SENSORTYPE                   7     '<HIDE> ' V1: channel number, V2: protocol specification subtype
#DEFINE SENT_COMMAND_CLEAR_SERIALDATA                 8     '<HIDE> ' Serial Message Data und Counter lschen
#DEFINE SENT_COMMAND_SET_PULSECOUNT                   9     '<HIDE> ' V1: channel number, V2: SENT pulse count (9/10)
#DEFINE SENT_COMMAND_REQUEST_LATCH                   12     '<HIDE> ' V1: channel pattern
#DEFINE SENT_COMMAND_SET_OUTPUT_MODE                101     '<HIDE> ' V1: channel number, V2: SENT output mode 0 continous, 1 fifo
#DEFINE SENT_COMMAND_CONFIG_OUTPUT                  102     '<HIDE> ' 
#DEFINE SENT_COMMAND_CONFIG_SERIAL_MESSAGES         103     '<HIDE> '
#DEFINE SENT_COMMAND_SET_ALL_SERIAL_MESSAGES        104     '<HIDE> '
#DEFINE SENT_COMMAND_SET_SINGLE_SERIAL_MESSAGE      105     '<HIDE> '
#DEFINE SENT_COMMAND_FIFO_CLEAR                     106     '<HIDE> '
#DEFINE SENT_COMMAND_SET_FIFO                       107     '<HIDE> '

' MIL 1553
#DEFINE MIL_CMDBUFF_BA                 5000h                '<HIDE>
#DEFINE MIL_CMDBUFF_LEN                0400h                '<HIDE>
#DEFINE MIL_DATBUFF_BA                 6000h                '<HIDE>
#DEFINE MIL_DATBUFF_LEN                2000h                '<HIDE>


'Address defines
#define CANFD_ADR_C1CON        00000h                       '<HIDE> 
#define CANFD_ADR_C1NBTCFG     00004h                       '<HIDE> 
#define CANFD_ADR_C1DBTCFG     00008h                       '<HIDE> 
#define CANFD_ADR_C1TDC        0000Ch                       '<HIDE> 
#define CANFD_ADR_C1TBC        00010h                       '<HIDE> 
#define CANFD_ADR_C1TSCON      00014h                       '<HIDE> 
#define CANFD_ADR_C1VEC        00018h                       '<HIDE> 
#define CANFD_ADR_C1INT        0001Ch                       '<HIDE> 
#define CANFD_ADR_C1RXIF       00020h                       '<HIDE> 
#define CANFD_ADR_C1TXIF       00024h                       '<HIDE> 
#define CANFD_ADR_C1RXOVIF     00028h                       '<HIDE> 
#define CANFD_ADR_C1TXATIF     0002Ch                       '<HIDE> 
#define CANFD_ADR_C1TXREQ      00030h                       '<HIDE> 
#define CANFD_ADR_C1TREC       00034h                       '<HIDE> 
#define CANFD_ADR_C1BDIAG0     00038h                       '<HIDE> 
#define CANFD_ADR_C1BDIAG1     0003Ch                       '<HIDE> 
#define CANFD_ADR_C1TEFCON     00040h                       '<HIDE> 
#define CANFD_ADR_C1TEFSTA     00044h                       '<HIDE> 
#define CANFD_ADR_C1TEFUA      00048h                       '<HIDE> 
#define CANFD_Reserved         0004Ch                       '<HIDE>
#define CANFD_ADR_C1TXQCON     00050h                       '<HIDE> 
#define CANFD_ADR_C1TXQSTA     00054h                       '<HIDE> 
#define CANFD_ADR_C1TXQUA      00058h                       '<HIDE> 
#define CANFD_ADR_C1FIFOCON1   0005Ch                       '<HIDE> 
#define CANFD_ADR_C1FIFOSTA1   00060h                       '<HIDE> 
#define CANFD_ADR_C1FIFOUA1    00064h                       '<HIDE> 
#define CANFD_ADR_C1FIFOCON2   00068h                       '<HIDE> 
#define CANFD_ADR_C1FIFOSTA2   0006Ch                       '<HIDE> 
#define CANFD_ADR_C1FIFOUA2    00070h                       '<HIDE> 
#define CANFD_FIFO_OFFSET      0000Ch                       '<HIDE> 

#define CANFD_ADR_C1FLTCON0    001D0h                       '<HIDE> 
#define CANFD_ADR_C1FLTOBJ0    001F0h                       '<HIDE> 
#define CANFD_ADR_C1MASK0      001F4h                       '<HIDE> 
#define CANFD_ADR_C1FLTOBJ1    001F8h                       '<HIDE> 
#define CANFD_ADR_C1MASK1      001FCh                       '<HIDE> 
#define CANFD_ADR_C1FLTOBJ2    00200h                       '<HIDE> 
#define CANFD_ADR_C1MASK2      00204h                       '<HIDE> 
#define CANFD_FILTER_OFFSET    00008h                       '<HIDE> 
#define CANFD_ADR_RAM_OFFSET   00400h                       '<HIDE> 
#define CANFD_ADR_TXQ0         00400h                       '<HIDE> 
#define CANFD_ADR_TXQ1         00404h                       '<HIDE> 
#define CANFD_ADR_TXQ2         00408h                       '<HIDE> 
#define CANFD_ADR_TXQ3         0040Ch                       '<HIDE> 
#define CANFD_ADR_TXQ4         00410h                       '<HIDE> 
#define CANFD_ADR_TXQ5         00414h                       '<HIDE> 
#define CANFD_ADR_TXQ6         00418h                       '<HIDE> 
#define CANFD_ADR_TXQ7         0041Ch                       '<HIDE> 
#define CANFD_ADR_TXQ8         00420h                       '<HIDE> 
#define CANFD_ADR_TXQ9         00424h                       '<HIDE> 
#define CANFD_ADR_TXQ10        00428h                       '<HIDE> 
#define CANFD_ADR_TXQ11        0042Ch                       '<HIDE> 
#define CANFD_ADR_TXQ12        00430h                       '<HIDE> 
#define CANFD_ADR_TXQ13        00434h                       '<HIDE> 
#define CANFD_ADR_TXQ14        00438h                       '<HIDE> 
#define CANFD_ADR_TXQ15        0043Ch                       '<HIDE> 
#define CANFD_ADR_TXQ16        00440h                       '<HIDE> 
#define CANFD_ADR_TXQ17        00444h                       '<HIDE> 
#define CANFD_ADR_TXQ18        00448h                       '<HIDE> 

#define CANFD_ADR_OSC          00E00h                       '<HIDE> 
#define CANFD_ADR_IOCON        00E04h                       '<HIDE> 
#define CANFD_ADR_CRC          00E08h                       '<HIDE> 
#define CANFD_ADR_ECCCON       00E0Ch                       '<HIDE> 
#define CANFD_ADR_ECCSTAT      00E10h                       '<HIDE> 

'Index defines
#define CANFD_IDX_MODUL        00001h                       '<HIDE> 
#define CANFD_IDX_CHANNEL      00002h                       '<HIDE> 
#define CANFD_LAST_Write_Pointer 00003h                     '<HIDE> 
#define CANFD_FREE_RAM         00004h                       '<HIDE> 
#define CANFD_BDIAG0           00005h                       '<HIDE> 
#define CANFD_BDIAG1           00006h                       '<HIDE> 
#define CANFD_TREC             00007h                       '<HIDE> 
#define CANFD_IDX_C1CON        00011h                       '<HIDE> 
#define CANFD_IDX_C1NBTCFG     00012h                       '<HIDE> 
#define CANFD_IDX_C1DBTCFG     00013h                       '<HIDE> 
#define CANFD_IDX_C1TDC        00014h                       '<HIDE> 
#define CANFD_IDX_C1TBC        00015h                       '<HIDE> 
#define CANFD_IDX_C1TSCON      00016h                       '<HIDE> 
#define CANFD_IDX_C1VEC        00017h                       '<HIDE> 
#define CANFD_IDX_C1INT        00018h                       '<HIDE> 
#define CANFD_IDX_C1RXIF       00019h                       '<HIDE> 
#define CANFD_IDX_C1TXIF       0001Ah                       '<HIDE> 
#define CANFD_IDX_C1RXOVIF     0001Bh                       '<HIDE> 
#define CANFD_IDX_C1TXATIF     0001Ch                       '<HIDE> 
#define CANFD_IDX_C1TXREQ      0001Dh                       '<HIDE> 
#define CANFD_IDX_C1TREC       0001Eh                       '<HIDE> 
#define CANFD_IDX_C1BDIAG0     0001Fh                       '<HIDE> 
#define CANFD_IDX_C1BDIAG1     00020h                       '<HIDE> 
#define CANFD_IDX_C1TEFCON     00021h                       '<HIDE> 
#define CANFD_IDX_C1TEFSTA     00022h                       '<HIDE> 
#define CANFD_IDX_C1TEFUA      00023h                       '<HIDE> 
#define Reserved_IDX           00024h                       '<HIDE>         
#define CANFD_IDX_C1TXQCON     00025h                       '<HIDE> 
#define CANFD_IDX_C1TXQSTA     00026h                       '<HIDE> 
#define CANFD_IDX_C1TXQUA      00027h                       '<HIDE> 
#define CANFD_IDX_C1FIFOCON1   00028h                       '<HIDE> 
#define CANFD_IDX_C1FIFOSTA1   00029h                       '<HIDE> 
#define CANFD_IDX_C1FIFOUA1    0002Ah                       '<HIDE> 
#define CANFD_IDX_C1FIFO_OFFSET  003h                       '<HIDE> 

#define CANFD_IDX_C1FLTCON0    00100h                       '<HIDE> 
#define CANFD_IDX_C1FLTOBJ0    00120h                       '<HIDE> 
#define CANFD_IDX_C1MASK0      00140h                       '<HIDE> 

#define CANFD_IDX_OSC          001F0h                       '<HIDE>
#define CANFD_IDX_IOCON        001F1h                       '<HIDE>
#define CANFD_IDX_CRC          001F2h                       '<HIDE>
#define CANFD_IDX_ECCCON       001F3h                       '<HIDE>
#define CANFD_IDX_ECCSTAT      001F4h                       '<HIDE>

'Mode defines
'''CAN controller mode: CANFD
#define CANFD_MODE_CANFD  0
#define CANFD_MODE_CONFIG 4                                 '<HIDE>
'''CAN controller mode: CAN 2.0
#define CANFD_MODE_CAN    6
'Bit defines
#define CANFD_BIT_RXOVIF        08H                         '<HIDE>
#define CANFD_INIT_OK 1                                     '<HIDE>
#define CANFD_INIT_NIO 0                                    '<HIDE>


'<ENDREGION>

'<REGION> System

'******************************************************************************
' If a low-priority process accesses a Pro-module it must not be
' interrupted by any other process !!!
'******************************************************************************
SUB SUB_BEGIN_CRITICAL_SECTION()                            '<HIDE>
#IF PRIORITAET = LOW
  BEGIN_CRITICAL_SECTION
#ENDIF
ENDSUB

SUB SUB_END_CRITICAL_SECTION()                              '<HIDE>
#IF PRIORITAET = LOW
  END_CRITICAL_SECTION
#ENDIF
ENDSUB


'******************************************************************************
' Function only for internal use.
' check if the pro2 address is legal
'******************************************************************************
SUB CHECK_CARD(module)                                      '<HIDE>
#IF DEBUG_MODE = ON THEN
  IF ((module < 1) OR (module > 15)) THEN
    PROZESS_FEHLER = 200001
    end_exit
  ENDIF
#ENDIF
ENDSUB

Sub System_Array_Debug_Check(array[], startindex, length)   '<HIDE>
#IF DEBUG_MODE = ON THEN

  if (if_type_fifo (array) = 1) then
  
  else
    if ((startindex) + (length) - 1 > Get_Array_Length(array)) then
      PROZESS_FEHLER = 0C1000000H or Get_Array_No (array)
      end_exit
    endif
    ''  
    if ((startindex) < 1) then 
      PROZESS_FEHLER = 0C2000000H or Get_Array_No (array)
      end_exit
    endif
    
  endif
  
#endif
ENDSUB

'******************************************************************************
'''Switches a LED on or off.
'''module: module address
'''+      0: CPU module
'''+  1..15: Module address
'''value: LED status
'''+      0: off
'''+      1: on
'''******************************************************************************
SUB P2_Set_LED(module, value)
  IF (module = 0) THEN
    POKE(CPU_LED, value)
  ELSE
    CHECK_CARD(module)
    POKE (68040000h OR shift_left(module, 20), value)
  ENDIF
ENDSUB

'******************************************************************************
'''Checks the LED on a module or CPU.
'''module: module address
'''+      0: CPU module
'''+  1..15: Module address
'''****************************************************************************
FUNCTION P2_Check_LED(module) As Long
  IF (module = 0) THEN
    P2_CHECK_LED = (PEEK(CPU_LED) and 1)
  ELSE
    CHECK_CARD(module)
    P2_Check_LED = Peek_P2 (68040000h OR shift_left(module, 20))
  ENDIF
ENDFUNCTION

'******************************************************************************
'''Configures the external Event input.
'''min_hold: Minimum time, which an edge must be held to be accepted.
'''+      0: 15 ns (default)
'''+      1: 50 ns
'''edge: Type of edge, which is accepted
'''+      1: rising edge (default)
'''+      2: falling edge
'''+      3: rising & falling edge
'''prescaler: Number (1..15) of edges, after which an event signal is triggered (Default: 1).
'''****************************************************************************
SUB CPU_Event_Config(min_hold, edge, prescaler)
  DIM old AS Long
  DIM new AS Long
  old = peek(50003000h) AND 7FFFFF00H
  new = shift_left((min_hold AND 1), 31) or (edge AND 3) or (shift_left(prescaler, 4)) or old
  poke(50003000h, new)
ENDSUB

'*******************************************************************************
'''Activates or deactivates the external Event input.
'''module: module address (1..15)
'''enable: 
'''+      0: disable external event signal (default).
'''+      1: enable external event signal.
'''*****************************************************************************
SUB P2_Event_Enable(module, enable)
  DIM old AS Long
  CHECK_CARD(module)  
  old = Peek_P2 (68048000h OR shift_left(module, 20))
  old = (old AND 0FFFFFFFEH) or enable
  POKE (68048000h OR shift_left(module, 20), old)
ENDSUB

'*******************************************************************************
'''Configures the external Event input.
'''module: module address (1..15)
'''min_hold: Minimum time, which an edge must be held to be accepted.
'''+      0: 15 ns (default)
'''+      1: 50 ns
'''edge: Type of edge, which is accepted
'''+      1: rising edge (default)
'''+      2: falling edge
'''+      3: rising & falling edge
'''prescaler: Number (1..255) of edges, after which an event signal is triggered (Default: 1).
'''*****************************************************************************
SUB P2_Event_Config(module, min_hold, edge, prescaler)
  DIM old AS Long
  DIM neu AS Long
  DIM value AS Long

  CHECK_CARD(module)
  old = Peek_P2 (68048000h OR shift_left(module, 20))
  neu = shift_left((min_hold AND 1), 4) or shift_left((edge AND 3), 2)
  old = (old AND 0FFFFFFE3H) or neu
  POKE (68048000h OR shift_left(module, 20), old)
  value = prescaler AND 0FFH
  POKE (68048100h OR shift_left(module, 20), value)
ENDSUB

'*******************************************************************************
'''Configures the pre-processing of event signals at the external Event input.
'''module: module address (1..15)
'''mode: Mode of event signal pre-processing:
'''+      0: No pre-processing (default).
'''+      1: Signal after clearance at the input ENABLE.
'''+      2: Signal from AB mode.
'''+      3: Signal from AB mode after clearance at the input ENABLE.
'''edge: Type of edge, that is accepted at the input ENABLE. For mode=1 or mode=3 only.
'''+      1: rising edge (default)
'''+      2: falling edge
'''+      3: rising & falling edge
'''*****************************************************************************
SUB P2_Event2_Config(module, mode, edge)
  DIM old AS Long

  CHECK_CARD(module)
  old = Peek_P2 (68048200h OR shift_left(module, 20))
  old = old AND 0FFFFFFE0H  
  POKE (68048200h OR shift_left(module, 20), old)
  old = old or (shift_left((edge AND 3), 3)) or (mode and 7)
  POKE (68048200h OR shift_left(module, 20), old)
  
ENDSUB

'******************************************************************************
'''Reads the TTL levels at the event inputs EVENT/A, ENABLE, B.
'''+return value: Bit pattern of current TTL levels.
'''+  bit=0: TTL level low.
'''+  bit=1: TTL level high.
'''+  bit no.        31..3    2      1       0
'''+  event input      -      B   ENABLE  EVENT/A
'''+The inputs EVENT/A, B and ENABLE are not present on any module.
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Event_Read(module) as Long
  check_card(module)
  P2_Event_Read = Peek_P2 (60070400h OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Checks whether an edge has been detected at the selected DIG I/O input of the CPU module.
'''+You set the type of edge with CPU_Dig_IO_Config.
'''+return value: Flag whether an edge has been detected at the DIG I/O input.
'''+      0: no edge detected
'''+      1: selected edge has been detected at least once
'''channel: Number of the DIG I/O input on the CPU module.
'''+      0: DIG I/O 0
'''+      1: DIG I/O 1
'''****************************************************************************
FUNCTION CPU_Digin(channel) AS Long 
  CPU_DIGIN = shift_right(peek(cpu_DIG_ADR + (256 * channel)), 1) AND 1
ENDFUNCTION

'******************************************************************************
'''Configures the DIG I/O channels of the CPU module.
'''pattern: Bit pattern to configure the DIG I/O channels.
'''+        2 bits each configure a channel, other bits have no function.
'''+   Bits in 'pattern'    31..6     5..4    3..2     1..0
'''+   Channel                -    DIG I/O 1    -   DIG I/O 1
'''+  2 bit combination:
'''+    00b: Input channel for falling edges
'''+    01b: Input channel for rising edges
'''+    10b: Output channel
'''+    11b: Output channel
'''****************************************************************************
SUB CPU_Dig_IO_Config(pattern)
  poke(cpu_DIG_CONFIG, pattern)  
ENDSUB

'******************************************************************************
'''Sets a digital output DIG I/O on the CPU module to the selected TTL level.
'''+The selected DIG I/O channel must be configured as output with CPU_Dig_IO_Config.
'''channel: Number of the DIG I/O output on the CPU module.
'''+      0: DIG I/O 0
'''+      1: DIG I/O 1
'''level: TTL level of the output.
'''+      0: TTL level low
'''+      1: TTL level high
'''****************************************************************************
SUB CPU_Digout(channel, level) 
  poke(CPU_DIG_ADR + channel * 256, level AND 1)
ENDSUB

'******************************************************************************
'''Starts a specified action synchronously on the selected modules.
'''+You can disable selected inputs/outputs or function groups with P2_Sync_Enable.
'''+  Module type     Action
'''+  Analog input    Start A/D single conversion on all enabled ADCs.
'''+  Analog output    Start D/A conversion on all enabled DACs with the value 
'''+                  of the DAC register.
'''+  Digital input    Transfer status of all inputs into the input latch register.
'''+  Digital output  Transfer values from the output latch register and transfer
'''+                  to all outputs.
'''+  Counter        Copy  counter values into counter latches.
'''+  Temperature    Transfer status of the inputs into the input latch register.
'''+  Multi I/O        The synchronizing signal refers to all enabled groups:
'''+                  analog inputs, analog outputs, digital channels, counters
'''module_pattern: bit pattern to set the module adresses
'''+ bit no.         31..15   14   13  ..  1   0 
'''+ module address    -      15   14  ..  2   1
'''****************************************************************************
SUB P2_Sync_All(module_pattern)
  POKE (68010000h, module_pattern)
ENDSUB

'******************************************************************************
'''Activates or deactivates the sync function of a module for selected
'''+channels or function groups.
'''module: module address (1..15)
'''enable: Bit pattern for selection of inputs, outputs or function groups
'''+       that are enabled or disabled.
'''+ Analog modules
'''+   Bits in 'enable'  31..8   7   6   5   4   3   2   1   0
'''+   Channel no.              8   7   6   5   4   3   2   1
'''+ Digital modules: Bit 0 stands for all digital channels.
'''+ Multi I/O modules
'''+   Bits in 'enable'  31..4   3    2     1      0
'''+   Function group        CNT  AIN  AOUT  DIG I/O
'''****************************************************************************
SUB P2_Sync_Enable(module, enable)
  check_card(module)
  POKE (68041100h OR shift_left(module, 20), enable)
ENDSUB

'******************************************************************************
'''Returns the settings of the synchronizing option of the specified module.
'''+You set the synchronizing option with P2_Sync_Enable.
'''+Return value: Bit pattern for synchronizing option of inputs, outputs or
'''+function groups that are enabled or disabled.
'''+ Analog modules
'''+   Bits in ret_val  31..8   7   6   5   4   3   2   1   0
'''+   Channel no.              8   7   6   5   4   3   2   1
'''+ Digital modules: Bit 0 stands for all digital channels.
'''+ Multi I/O modules
'''+   Bits in ret_val  31..4   3    2     1      0
'''+   Function group        CNT  AIN  AOUT  DIG I/O
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Sync_Stat(module) AS Long
  check_card(module)
  P2_Sync_Stat = Peek_P2 (68041100h OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Enables or disables the synchronization of ADC conversions with other modules
'''+as master or slave. A signal at the event input of the master module starts
'''+conversions on all slave modules.
'''+Only one master module is allowed.
'''module: module address (0..15); 0 = CPU module.
'''mode: Synchronization mode (0..2) of the module.
'''+      0: No synchronisation (default).
'''+      1: Synchronisation as master module.
'''+      2: Synchronisation as slave module.
'''****************************************************************************
SUB P2_Sync_Mode(module, mode)
  if ((module > 0) AND (module < 16)) then 
    POKE (68049000h OR shift_left(module, 20), mode)
  else
    poke(50003100H, mode) 
  endif
ENDSUB

'****************************************************************************
Function P2_System_Read_MC(module) as long                  '<HIDE>
  CHECK_CARD(module)
  P2_System_Read_MC = Peek_P2 (68000400h OR shift_left(module, 20))
endfunction 
  
'<ENDREGION>

'<REGION> System PRO BUS Burst


'anzcount 1 bis 32768 (long burst)
'****************************************************************************
sub Write_Fast_Bus_LB(array, anzcount, busadr)              '<HIDE>
  SUB_BEGIN_CRITICAL_SECTION
  if (if_type_long (array) = 1) then 
    write_Fast_Bus_LB_nocritL(array, anzcount, busadr)
  endif 
  
  if (if_type_int64 (array) = 1) then 
    write_Fast_Bus_LB_nocritI64(array, anzcount, busadr)
  endif 
  
  if (if_type_short (array) = 1) then 
    write_Fast_Bus_LB_nocritS(array, anzcount, busadr)
  endif 
  SUB_END_CRITICAL_SECTION
ENDSUB


'short burst anzcount 2,3,4
'****************************************************************************
sub Write_Fast_Bus_SB(array, anzcount, busadr)              '<HIDE>
 
  SUB_BEGIN_CRITICAL_SECTION
  if (if_type_fifo (array) = 1) then 
    Write_Fast_Bus_SB_nocritXF(Get_Array_No (array), anzcount, busadr)
  else
    selectcase anzcount
      case 2
        Write_Fast_Bus_SB_nocritL2(array, busadr)
      case 3
        Write_Fast_Bus_SB_nocritL3(array, busadr)
      case 4
        Write_Fast_Bus_SB_nocritL4(array, busadr)
    endselect 
  endif
    
  SUB_END_CRITICAL_SECTION
ENDSUB


'short burst anzcount 2,3,4
'****************************************************************************
sub Write_Fast_Bus_SB_Packed(array, anzcount, busadr)       '<HIDE>
  if (if_type_fifo (array) = 1) then 
    SUB_BEGIN_CRITICAL_SECTION
    Write_Fast_Bus_SB_nocritXF_packed(Get_Array_No (array), anzcount, busadr)
    SUB_END_CRITICAL_SECTION
  else 
    if (if_type_long (array) = 1) then 
      SUB_BEGIN_CRITICAL_SECTION
      selectcase anzcount
      
        case 2
          Write_Fast_Bus_SB_nocritL2_Packed(array, busadr)
        case 3
          Write_Fast_Bus_SB_nocritL3_packed(array, busadr)
        case 4
          Write_Fast_Bus_SB_nocritL4_packed(array, busadr)
      endselect 
      SUB_END_CRITICAL_SECTION
    endif
  
    if (if_type_short (array) = 1) then 
      SUB_BEGIN_CRITICAL_SECTION
      selectcase anzcount
      
        case 2
          Write_Fast_Bus_SB_nocritS2_Packed(array, busadr)
        case 3
          Write_Fast_Bus_SB_nocritS3_Packed(array, busadr)
        case 4
          Write_Fast_Bus_SB_nocritS4_Packed(array, busadr)
      endselect 
      SUB_END_CRITICAL_SECTION
    endif
  
    if (if_type_float (array) = 1) then 
      SUB_BEGIN_CRITICAL_SECTION
      selectcase anzcount
      
        case 2
          Write_Fast_Bus_SB_nocritD2_Packed(array, busadr)
        case 3
          Write_Fast_Bus_SB_nocritD3_Packed(array, busadr)
        case 4
          Write_Fast_Bus_SB_nocritD4_Packed(array, busadr)
      endselect 
      SUB_END_CRITICAL_SECTION
    endif
  
    
    if (if_type_int64 (array) = 1) then 
      SUB_BEGIN_CRITICAL_SECTION
      selectcase anzcount
      
        case 2
          Write_Fast_Bus_SB_nocriti642_Packed(array, busadr)
        case 3
          Write_Fast_Bus_SB_nocriti643_Packed(array, busadr)
        case 4
          Write_Fast_Bus_SB_nocriti644_Packed(array, busadr)
      endselect 
      SUB_END_CRITICAL_SECTION
    endif
    
    
    
    if (if_type_float32 (array) = 1) then 
      SUB_BEGIN_CRITICAL_SECTION
      selectcase anzcount
        case 2
          Write_Fast_Bus_SB_nocritF2_Packed(array, busadr)
        case 3
          Write_Fast_Bus_SB_nocritF3_Packed(array, busadr)
        case 4
          Write_Fast_Bus_SB_nocritF4_Packed(array, busadr)
      endselect 
      SUB_END_CRITICAL_SECTION
    endif
  endif
ENDSUB


'****************************************************************************
sub Write_Fast_Bus_Modul_Pattern(adr, modulpattern, value)  '<HIDE>
  SUB_BEGIN_CRITICAL_SECTION
  Write_Fast_Bus_SB_nocrit64(modulpattern, value, adr)      '<HIDE>
  SUB_END_CRITICAL_SECTION
endsub



'****************************************************************************
sub Read_Fast_Bus_LB(array, anzcount, busadr)               '<HIDE>
  SUB_BEGIN_CRITICAL_SECTION 
  if (if_type_fifo (array) = 1) then 
    Read_Fast_Bus_LB_nocritXF(Get_Array_No (array), anzcount, busadr)
  else 
    if (if_type_long (array) = 1) then 
      Read_Fast_Bus_LB_nocritL(array, anzcount, busadr)
    endif
  
    if (if_type_short (array) = 1) then 
      Read_Fast_Bus_LB_nocritS(array, anzcount, busadr)
    endif
  
    if (if_type_float (array) = 1) then
      Read_Fast_Bus_LB_nocritD(array, anzcount, busadr)
    endif
    
    if (if_type_int64 (array) = 1) then
      Read_Fast_Bus_LB_nocritI64(array, anzcount, busadr)
    endif
    
    
    if (if_type_float32 (array) = 1) then 
      Read_Fast_Bus_LB_nocritF(array, anzcount, busadr)
    endif
  endif

  
  SUB_END_CRITICAL_SECTION
ENDSUB


'anzcount = count value over bus (even)
'write values alternate to array 1 and 2 
'****************************************************************************
sub Read_Fast_Bus_LB2(array, array2, anzcount, busadr)      '<HIDE>
  SUB_BEGIN_CRITICAL_SECTION
 
  if (if_type_fifo (array) = 1) then 
    Read_Fast_Bus_LB2_nocritXF(Get_Array_No (array), Get_Array_No (array2), anzcount, busadr)
  else
    
    if (if_type_long (array) = 1) then 
      CHECK_TYPE_LONG (array2)
      Read_Fast_Bus_LB2_nocritL(array, array2, anzcount, busadr)
    endif
    
    if (if_type_int64 (array) = 1) then 
      CHECK_TYPE_int64 (array2)
      Read_Fast_Bus_LB2_nocritI64(array, array2, anzcount, busadr)
    endif
    
    
    if (if_type_short (array) = 1) then 
      CHECK_TYPE_SHORT (array2)
      Read_Fast_Bus_LB2_nocritS(array, array2, anzcount, busadr)
    endif
  
    if (if_type_float (array) = 1) then 
      CHECK_TYPE_FLOAT (array2)
      Read_Fast_Bus_LB2_nocritD(array, array2, anzcount, busadr)
    endif
    
    if (if_type_float32 (array) = 1) then 
      CHECK_TYPE_FLOAT32 (array2) 
      Read_Fast_Bus_LB2_nocritF(array, array2, anzcount, busadr)
    endif
  endif

  
  SUB_END_CRITICAL_SECTION
ENDSUB
   

'****************************************************************************
sub Read_Fast_Bus_SB(array, anzcount, busadr)               '<HIDE>
  SUB_BEGIN_CRITICAL_SECTION
  
  if (if_type_fifo (array) = 1) then 
    Read_Fast_Bus_SB_nocritXF(Get_Array_No (array), busadr, anzcount)
  else
      
    if (if_type_long (array) = 1) then 
      selectcase anzcount
        case 1 
          poke(global_adr_pointer (array), peek_p2 (busadr AND 0FFFFFFFBH))  
        case 2
          Read_Fast_Bus_SB_nocritL2(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritL3(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritL4(array, busadr)
      endselect 
    endif
  
    if (if_type_short (array) = 1) then 
      selectcase anzcount
        case 1
          poke_s (global_adr_pointer (array), peek_p2 (busadr AND 0FFFFFFFBH))
        case 2
          Read_Fast_Bus_SB_nocritS2(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritS3(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritS4(array, busadr)
      endselect 
    endif
  
    if (if_type_float32 (array) = 1) then 
      selectcase anzcount
        case 1
          poke_f32 (global_adr_pointer (array), peek_p2 (busadr AND 0FFFFFFFBH))
        case 2
          Read_Fast_Bus_SB_nocritf2(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritf3(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritf4(array, busadr)
      endselect 
    endif
  
    if (if_type_float (array) = 1) then 
      selectcase anzcount
        case 1
          poke_f64 (global_adr_pointer (array), peek_p2 (busadr AND 0FFFFFFFBH))
        case 2
          Read_Fast_Bus_SB_nocritD2(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritD3(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritD4(array, busadr)
      endselect 
    endif
  
    if (if_type_int64 (array) = 1) then 
      selectcase anzcount
        case 1
          poke_i64 (global_adr_pointer (array), peek_p2 (busadr AND 0FFFFFFFBH))
        case 2
          Read_Fast_Bus_SB_nocritI642(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritI643(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritI644(array, busadr)
      endselect 
    endif
    
  endif
    
  SUB_END_CRITICAL_SECTION
ENDSUB


'****************************************************************************
sub Read_Fast_Bus_SB_unpacked1(array, anzcount, busadr)     '<HIDE>
  
  dim one32, help as long
  SUB_BEGIN_CRITICAL_SECTION
  if (if_type_fifo (array) = 1) then 
    Read_Fast_Bus_SB_nocritX_unpacked1F(Get_Array_No (array), busadr, anzcount)
  else
    if (if_type_long (array) = 1) then 
      selectcase anzcount
        case 1  
          one32 = peek_p2 (busadr AND 0FFFFFFFBH)
          poke(global_adr_pointer (array), one32 AND 0FFFFH)
          poke(global_adr_pointer (array) + 4, shift_right(one32, 16))
       
        case 2
          Read_Fast_Bus_SB_nocritL2_unpacked1(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritL3_unpacked1(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritL4_unpacked1(array, busadr)
      endselect 
    endif
  
  
    if (if_type_short (array) = 1) then 
      selectcase anzcount
        case 1  
          one32 = peek_p2 (busadr AND 0FFFFFFFBH)
          poke_s (global_adr_pointer (array), one32 AND 0FFFFH)
          poke_s (global_adr_pointer (array) + 2, shift_right(one32, 16))
        case 2
          Read_Fast_Bus_SB_nocritS2_unpacked1(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritS3_unpacked1(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritS4_unpacked1(array, busadr)
      endselect 
    endif
  
    if (if_type_float (array) = 1) then 
      selectcase anzcount
        case 1  
          one32 = peek_p2 (busadr AND 0FFFFFFFBH)
          help = one32 AND 0FFFFH
          poke_f64 (global_adr_pointer (array), help)
          poke_f64 (global_adr_pointer (array) + 8, shift_right(one32, 16))
        case 2
          Read_Fast_Bus_SB_nocritD2_unpacked1(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritD3_unpacked1(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritD4_unpacked1(array, busadr)
      endselect 
    endif

    if (if_type_int64 (array) = 1) then 
      selectcase anzcount
        case 1  
          one32 = peek_p2 (busadr AND 0FFFFFFFBH)
          help = one32 AND 0FFFFH
          poke_i64 (global_adr_pointer (array), help)
          poke_i64 (global_adr_pointer (array) + 8, shift_right(one32, 16))
        case 2
          Read_Fast_Bus_SB_nocriti642_unpacked1(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocriti643_unpacked1(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocriti644_unpacked1(array, busadr)
      endselect 
    endif
  
    if (if_type_float32 (array) = 1) then 
      selectcase anzcount
        case 1  
          one32 = peek_p2 (busadr AND 0FFFFFFFBH)
          help = one32 AND 0FFFFH
          poke_f32 (global_adr_pointer (array), help)
          poke_f32 (global_adr_pointer (array) + 4, shift_right(one32, 16))
        case 2
          Read_Fast_Bus_SB_nocritF2_unpacked1(array, busadr)
        case 3
          Read_Fast_Bus_SB_nocritF3_unpacked1(array, busadr)
        case 4
          Read_Fast_Bus_SB_nocritF4_unpacked1(array, busadr)
      endselect 
    endif
    
  endif


  SUB_END_CRITICAL_SECTION
ENDSUB


'****************************************************************************
sub Read_Fast_Bus_LB_unpacked1(array, anzcount, busadr)     '<HIDE>
  SUB_BEGIN_CRITICAL_SECTION
  
  if (if_type_fifo (array) = 1) then 
    Read_Fast_Bus_LB_unpacked1_nocritXF(Get_Array_No (array), anzcount, busadr)
  else
    if (if_type_long (array) = 1) then 
      Read_Fast_Bus_LB_unpacked1_nocritL(array, anzcount, busadr)
    endif
  
    if (if_type_short (array) = 1) then 
      Read_Fast_Bus_LB_unpacked1_nocritS(array, anzcount, busadr)
    endif
  
    if (if_type_float32 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked1_nocritF(array, anzcount, busadr)
    endif
  
    if (if_type_float (array) = 1) then 
      Read_Fast_Bus_LB_unpacked1_nocritD(array, anzcount, busadr)
    endif
    
    if (if_type_int64 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked1_nocritI64(array, anzcount, busadr)
    endif
    
  endif
  
  SUB_END_CRITICAL_SECTION
ENDSUB


'****************************************************************************
sub Read_Fast_Bus_LB_unpacked2(array, array2, anzcount, busadr)  '<HIDE>
  
 
  SUB_BEGIN_CRITICAL_SECTION
 
  if (if_type_fifo (array) = 1) then 
    Dim fifonr[2] as short
    fifonr[1] = Get_Array_No (array)
    fifonr[2] = Get_Array_No (array2)
    Read_Fast_Bus_LB_unpacked2_nocritXF(fifonr, anzcount, busadr)
  else
    if (if_type_long (array) = 1) then 
      Read_Fast_Bus_LB_unpacked2_nocritL(array, array2, anzcount, busadr)
    endif
  
    if (if_type_short (array) = 1) then 
      Read_Fast_Bus_LB_unpacked2_nocritS(array, array2, anzcount, busadr)
    endif
  
    if (if_type_float32 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked2_nocritF(array, array2, anzcount, busadr)
    endif
  
    if (if_type_float (array) = 1) then 
      Read_Fast_Bus_LB_unpacked2_nocritD(array, array2, anzcount, busadr)
    endif
    
    if (if_type_int64 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked1_nocritI64(array, anzcount, busadr)
    endif
    
    
    
  endif
  
  SUB_END_CRITICAL_SECTION
ENDSUB


'****************************************************************************
sub Read_Fast_Bus_LB_unpacked4(array, array2, array3, array4, anzcount, busadr)  '<HIDE>
 
  SUB_BEGIN_CRITICAL_SECTION
  
  if (if_type_fifo (array) = 1) then 
    Dim fifonr[4] as short
    fifonr[1] = Get_Array_No (array)
    fifonr[2] = Get_Array_No (array2)
    fifonr[3] = Get_Array_No (array3)
    fifonr[4] = Get_Array_No (array4)
    Read_Fast_Bus_LB_unpacked4_nocritXF(fifonr, anzcount, busadr)
  else
    if (if_type_long (array) = 1) then 
      Read_Fast_Bus_LB_unpacked4_nocritL(array, array2, array3, array4, anzcount, busadr)
    endif
  
    if (if_type_short (array) = 1) then 
      Read_Fast_Bus_LB_unpacked4_nocritS(array, array2, array3, array4, anzcount, busadr)
    endif
  
    if (if_type_float32 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked4_nocritF(array, array2, array3, array4, anzcount, busadr)
    endif
  
    if (if_type_float (array) = 1) then 
      Read_Fast_Bus_LB_unpacked4_nocritD(array, array2, array3, array4, anzcount, busadr)
    endif
    
    if (if_type_int64 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked4_nocritI64(array, array2, array3, array4, anzcount, busadr)
    endif
    
  endif
  SUB_END_CRITICAL_SECTION
ENDSUB


'****************************************************************************
sub Read_Fast_Bus_LB_unpacked8(array, array2, array3, array4, array5, array6, array7, array8, anzcount, busadr)  '<HIDE>


  SUB_BEGIN_CRITICAL_SECTION
 
  if (if_type_fifo (array) = 1) then 
    Dim fifonr[8] as short
    fifonr[1] = Get_Array_No (array)
    fifonr[2] = Get_Array_No (array2)
    fifonr[3] = Get_Array_No (array3)
    fifonr[4] = Get_Array_No (array4)
    fifonr[5] = Get_Array_No (array5)
    fifonr[6] = Get_Array_No (array6)
    fifonr[7] = Get_Array_No (array7)
    fifonr[8] = Get_Array_No (array8)
    
    Read_Fast_Bus_LB_unpacked8_nocritXF(fifonr, anzcount, busadr)
  else 
    if (if_type_long (array) = 1) then 
      Read_Fast_Bus_LB_unpacked8_nocritL(array, array2, array3, array4, array5, array6, array7, array8, anzcount, busadr)
    endif
  
    if (if_type_short (array) = 1) then 
      Read_Fast_Bus_LB_unpacked8_nocritS(array, array2, array3, array4, array5, array6, array7, array8, anzcount, busadr)
    endif
  
    if (if_type_float32 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked8_nocritF(array, array2, array3, array4, array5, array6, array7, array8, anzcount, busadr)
    endif
  
    if (if_type_float (array) = 1) then 
      Read_Fast_Bus_LB_unpacked8_nocritD(array, array2, array3, array4, array5, array6, array7, array8, anzcount, busadr)
    endif
    
    if (if_type_int64 (array) = 1) then 
      Read_Fast_Bus_LB_unpacked8_nocritI64(array, array2, array3, array4, array5, array6, array7, array8, anzcount, busadr)
    endif
    
    
    
  endif
   
  SUB_END_CRITICAL_SECTION
ENDSUB


'<ENDREGION>

'<REGION> DIO

'******************************************************************************
'''Clears the Digin Fifo of the edge detection.
'''module: module address (1..15)
'''****************************************************************************
SUB P2_Digin_FIFO_Clear(module)
  CHECK_CARD(module)
  POKE (68048800h OR shift_left(module, 20), 0)             'FIFO clear
ENDSUB

'******************************************************************************
'''Stops the edge output and clears the edge output Fifo.
'''+Use only with P2_Dig_Fifo_Mode, mode < 8. Otherwise, use P2_Digout_FIFO_Clear2.
'''+The output Fifo must be cleared before first use.
'''+Edge output can be restarted with P2_Digout_Fifo_Start.
'''module: module address (1..15)
'''****************************************************************************
SUB P2_Digout_FIFO_Clear(module)
  CHECK_CARD(module)
  POKE (68048800h OR shift_left(module, 20), 0)
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
ENDSUB

'******************************************************************************
'''Stops the edge output and clears the edge output Fifo.
'''+Use only with module DIO32-TiCo Rev. F, and with P2_Dig_Fifo_Mode, mode > 7.
'''+Otherwise, use P2_Digout_FIFO_Clear.
'''+The output Fifo must be cleared before first use.
'''+Edge output can be restarted with P2_Digout_Fifo_Start.
'''module: module address (1..15)
'''****************************************************************************
SUB P2_Digout_FIFO_Clear2(module)
  CHECK_CARD(module)
  POKE (68048800h OR shift_left(module, 20), 1)
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
ENDSUB

'******************************************************************************
'''Reads timer value of the input Fifo.
'''+return value: Current value of the Fifo timer.
'''+The Fifo timer runs with 100 MHz clock rate; exceptions: DIO32-Tico2 and
'''+DIO8-D12 run with a clock rate 200MHz.
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Digin_FIFO_Read_Timer(module) as Long
  CHECK_CARD(module)
  P2_Digin_FIFO_Read_Timer = Peek_P2 (60003110h OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Reads the timer value of the output Fifo.
'''+Use only with P2_Dig_Fifo_Mode, mode=1 or 5 (absolute time values). With
'''+mode 9, use P2_Digout_FIFO_Clear2.
'''+The Fifo timer runs with 100 MHz clock rate; exceptions: DIO32-Tico2 and
'''+DIO8-D12 run with a clock rate 200MHz.
'''module: module address (1..15)
'''******************************************************************************
FUNCTION P2_Digout_FIFO_Read_Timer(module) as Long
  CHECK_CARD(module) 
  P2_Digout_FIFO_Read_Timer = Peek_P2 (60003110h OR shift_left(module, 20))
ENDFUNCTION


'******************************************************************************
'''Reads the 100 MHz timer of the output Fifo.
'''+Use only with module DIO32-TiCo Rev. F, and with P2_Dig_Fifo_Mode, mode=9.
'''+With mode=1 or 5, use P2_Digout_FIFO_Read_Timer.
'''+The counter is set to zero with P2_Digout_Fifo_Clear2, which also stops the
'''+edge output.
'''module: module address (1..15)
'''******************************************************************************
FUNCTION P2_Digout_FIFO_Read_Timer2(module) as Long
  CHECK_CARD(module) 
  P2_Digout_FIFO_Read_Timer2 = Peek_P2 (60003120h OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Sets the number of loops for the edge output on the specified module.
'''+Use only with module DIO32-TiCo Rev. F, and with P2_Dig_Fifo_Mode, mode=15.
'''+The number of loops is decremented after each loop. As soon as 0 is reached,
'''+the edge output stops. One loop covers the edge output of the complete list of
'''+value pairs in the output Fifo.
'''+With P2_Digout_Fifo_Get_Loop, you get the number of loops still to do.
'''module: module address (1..15)
'''loops: number of loops to process
'''+      0: endless
'''+     >0: number of loops to do
'''******************************************************************************
SUB P2_Digout_FiFo_Set_Loop(module, loops)
  CHECK_CARD(module) 
  POKE (68048710h OR shift_left(module, 20), loops) 
ENDSUB

'******************************************************************************
'''Returns the number of loops to be still processed with edge output.
'''+return value: number of loops still to be processed.
'''+      0: edge output has stopped.
'''+     >0: number of loops to do.
'''+Use only with module DIO32-TiCo Rev. F, and with P2_Dig_Fifo_Mode, mode=15.
'''+The return value is invalid if endless loops are set (P2_Digout_Fifo_Set_Loop, loops=0).
'''+The number of loops is decremented after each loop. As soon as 0 is reached,
'''+the edge output stops. One loop covers the edge output of the complete list of
'''+value pairs in the output Fifo.
'''module: module address (1..15)
'''******************************************************************************
Function P2_Digout_FiFo_Get_Loop(module) as long
  CHECK_CARD(module)  
  P2_Digout_FiFo_Get_Loop = Peek_P2 ((68048710h OR shift_left(module, 20)))
EndFunction

'******************************************************************************
'''Stops the loop for the Fifo edge output on the specified modules.
'''+Use only with module DIO32-TiCo Rev. F, and with P2_Dig_Fifo_Mode, mode=15.
'''+When stopping edge output, the loop counter is set to zero (0).
'''+Edge output can be restarted with P2_Digout_Fifo_Start.
'''module_pattern: bit pattern to select modules, see table
'''+  bit=0: ignore module
'''+  bit=1: stop edge output on the module
'''+   Bits in module_pattern   31..15   14   13   ..   1   0
'''+   Module address                   15   14   ..   2   1
'''stop_mode: how to stop the edge output:
'''+      1: stop edge output immediately
'''+      2: stop edge output after end of Loop
'''******************************************************************************
SUB P2_Digout_FiFo_Stop(module_pattern, stop_mode)
  if (stop_mode = 1) then 
    POKE (68048720h, module_pattern) 
  else
    POKE (68048730h, module_pattern) 
  endif
ENDSUB

''******************************************************************************
'''Sets the spike filter duration for all digital inputs.
'''module: module address (1..15)
'''filter_value: Filtering duration.
'''+           0: disable the filter
'''+    1..65535: duration in units of 20 ns length, 
'''+              with DIO-32-TiCo2 and DIO-8-D12: units of 10 ns
'''+The filtering duration should be a bit longer than the expected width of spikes.
''''****************************************************************************
SUB P2_Digin_Filter_Init(module, filter_value)
  CHECK_CARD(module)
  ' poke_fast_bus(32804876h or (shift_left(module, 16)), Filter_value) 
  POKE (68048760h OR shift_left(module, 20), Filter_value)
  p2_sleep(14)
ENDSUB

'******************************************************************************
'''Enables selected digital inputs to be monitored with the edge detection unit.
'''module: module address (1..15)
'''pattern: bit pattern to select digital inputs, see table
'''+  bit=0: ignore digital input
'''+  bit=1: monitor edges on this digital input
'''+   Bit no.            31   30   ..   1   0
'''+   Digital input      31   30   ..   1   0
'''******************************************************************************
SUB P2_Digin_FIFO_Enable(module, pattern)
  CHECK_CARD(module)  
  POKE (68048900h OR shift_left(module, 20), pattern)       'FIFO clear
ENDSUB

'******************************************************************************
'''Returns the number of saved value pairs in the Fifo of the edge detection unit.
'''+return value: Number of saved value pairs in the Fifo
'''+   DIO-32-TiCo Rev. F:      0..8191
'''+   DIO-32-TiCo2, DIO-8-D12: 0..2047
'''+   all other modules:       0..511
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Digin_FIFO_Full(module) as Long
  CHECK_CARD(module) 
  P2_Digin_FIFO_Full = Peek_P2 (68048800h OR shift_left(module, 20)) AND 0FFFFH
ENDFUNCTION

'******************************************************************************
'''Returns the number of free value pairs in the edge output FIFO.
'''+return value: number of free value pairs in the Fifo
'''+   DIO-32-TiCo Rev. F:      0..8191
'''+   DIO-32-TiCo2, DIO-8-D12: 0..2047
'''+   all other modules:       0..511
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Digout_FIFO_Empty(module) as Long
  CHECK_CARD(module)
  P2_Digout_FIFO_Empty = Peek_P2 (68048820h OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Sets the FIFO operating mode, input with edge detection and/or edge output.
'''module: module address  (1..15)
'''mode: FIFO operating mode
'''+      0: Input FIFO with edge detection. Default.
'''+      1: Output FIFO with edge output, time values with absolute reference, single output
'''+      3: Output FIFO with edge output, time values with relative reference, single output
'''+      5: Output FIFO with edge output, time values with absolute reference, continuous output (TiCo2 only)
'''+      7: Output FIFO with edge output, time values with relative reference, continuous output (TiCo2 only)
'''+      9: Input and output FIFO, time values with absolute reference, single output (DIO32-TiCo Rev. F only)
'''+     11: Input and output FIFO, time values with relative reference, single output (DIO32-TiCo Rev. F only)
'''+     15: Input and output FIFO, time values with relative reference, continuous output in a loop  (DIO32-TiCo Rev. F only)
'''+ On DIO-32-TiCo Rev. E, modes 1, 3 are available since revision E03.
'''****************************************************************************
SUB P2_Dig_FIFO_Mode(module, mode)
  CHECK_CARD(module)
  POKE (68048700h OR shift_left(module, 20), mode) 
ENDSUB

'******************************************************************************
'''Starts the edge output on the specified modules.
'''module_pattern: bit pattern to select modules, see table
'''+  bit=0: ignore module
'''+  bit=1: stop edge output on the module
'''+   Bits in module_pattern   31..15   14   13   ..   1   0
'''+   Module address                   15   14   ..   2   1
'''****************************************************************************
SUB P2_Digout_FIFO_Start(module_pattern)
  POKE (68048600h, module_pattern) 
ENDSUB

' ******************************************************************************
'''Enables or disables digital outputs for edge output.
'''+Use only with P2_Dig_Fifo_Mode, modes 1..7. Otherwise, use P2_Digout_FIFO_Enable2.
'''+The output Fifo must be cleared with P2_Digout_FIFO_Clear before first use.
'''+Edge output is started with P2_Digout_Fifo_Start.
'''module: module address (1..15)
'''pattern: bit pattern to select digital outputs, see table
'''+  bit=0: ignore digital input
'''+  bit=1: monitor edges on this digital input
'''+   Bit no.            31   30   ..   1   0
'''+   Digital output     31   30   ..   1   0
'''*****************************************************************************
SUB P2_Digout_FIFO_Enable(module, pattern)
  CHECK_CARD(module)
  POKE (68048900h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Enables or disables digital outputs for edge output.
'''+Use only with P2_Dig_Fifo_Mode, mode > 8. Otherwise, use P2_Digout_FIFO_Enable.
'''+Output channels must be first programmed as outputs using P2_DigProg.
'''module: module address (1..15)
'''pattern: bit pattern to select digital outputs, see table
'''+  bit=0: ignore digital input
'''+  bit=1: monitor edges on this digital input
'''+   Bit no.            31   30   ..   1   0
'''+   Digital output     31   30   ..   1   0
'''*****************************************************************************
SUB P2_Digout_FIFO_Enable2(module, pattern)
  CHECK_CARD(module)
  POKE (68048910h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Writes value pairs (output value, time stamp) into the edge output Fifo.
'''module: module address (1..15)
'''count: number of value pairs (check with P2_Digout_Fifo_Empty)
'''+   DIO-32-TiCo Rev. F:      1..32767
'''+   DIO-32-TiCo2, DIO-8-D12: 1..2047
'''+   all other modules:       1..511
'''array[]: array with value pairs (output value, time stamp)
'''+     array[1]:   output value 1
'''+     array[2]:   time stamp 1
'''+     array[3]:   output value 2 
'''+     array[4]:   time stamp 2
'''+       ..
'''+     array[n]:   value n
'''+     array[n+1]: time stamp n
'''+ The bits in an output value set the level of the digital outputs:
'''+  bit=0: Output level low
'''+  bit=1: Output level high
'''+   Bit no.            31   30   ..   1   0
'''+   Digital output     31   30   ..   1   0
'''+With module AOut-1/16, any array element contains 2 output values (analog,
'''+digital) and 2 status bits:
'''+   bits 15.. 0: DAC value in digits
'''+   bits 29..16: output levels (low/high) of channels 29..16
'''+      bit 30=1: enables output of the DAC value (bits 15:0)
'''+      bit 31=1: enables output of the TTL levels (bits 29:16)
'''+    bit30/31=0: disables output, previous value remains.
'''start_index: start index in array[] where the first value is read
'''****************************************************************************
SUB P2_Digout_FIFO_Write(module, count, array[], start_index)
  
  dim anzcount as Long

  CHECK_TYPE_LONG (array[1])
  CHECK_CARD(module)

  if (count > 0) then 
    anzcount = count * 2
    System_Array_Debug_Check(array, start_index, anzcount)
    Write_Fast_Bus_LB(array[start_index], anzcount, 64003100h or shift_left(module, 20))
  endif
ENDSUB

'******************************************************************************
'''Writes time stamps and output values into DIO FIFO.
'''module: module address (1..15)
'''count: number of value pairs (check with P2_Digout_Fifo_Empty)
'''array[]: array of values and time stamps
'''+     array[1]  = value 1
'''+     array[2]  = time stamp 1
'''+     array[3]  = value 2 
'''+     array[4]  = time stamp 2
'''+       ...
'''+     array[n]  = value n
'''+     array[n+1]= time stamp n
'''array_start_index: start index in target arrays for data storage
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''****************************************************************************
SUB P2_Digout_FIFO_Write_Flowrate(module, count, array[], array_start_index, flowrate)  '<HIDE>
  dim anzcount as Long
  DIM maxburst as Long
  dim icount as long
  DIM iindex as Long
  
  CHECK_TYPE_LONG (array[1])

#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 16
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF
 
 
 
  CHECK_CARD(module)

  if (count > 0) then 
    
    iindex = array_start_index
    icount = count * 2
    
    do
      anzcount = min_long(icount, maxburst)
    
      System_Array_Debug_Check(array, iindex, anzcount) 

      Write_Fast_Bus_LB(array[iindex], anzcount, 64003100h or shift_left(module, 20))

      icount = icount - anzcount
      iindex = iindex + anzcount
      
    until (icount = 0)
    
  endif
ENDSUB

'******************************************************************************
'''Reads value pairs (input value, time stamp) from the FIFO of the edge detection
'''+unit and writes them into an array[].
'''+This instruction runs faster than P2_Digin_FIFO_Read.
'''module: module address (1..15)
'''count: number of value pairs to read (check with P2_Digin_FIFO_Full)
'''+   DIO-32-TiCo Rev. F:      1..8191
'''+   DIO-32-TiCo2, DIO-8-D12: 1..2047
'''+   all other modules:       1..511
'''array[]: array of value pairs (input value, time stamp)
'''+     array[1]  = input value 1
'''+     array[2]  = time stamp 1
'''+     array[3]  = input value 2 
'''+     array[4]  = time stamp 2
'''+       ...
'''+     array[n]  = input value n
'''+     array[n+1]= time stamp n
'''+ The bits in an input value are the levels of the digital inputs:
'''+  bit=0: Input level low
'''+  bit=1: Input level high
'''+   Bit no.            31   30   ..   1   0
'''+   Digital input      31   30   ..   1   0
'''+With module AOut-1/16, the input value refers to digital inputs 0..15.
'''start_index: start index in array[] where the first value is written.
'''****************************************************************************
SUB P2_Digin_FIFO_Read_Fast(module, count, array[], start_index) 
  dim ilen as Long
  dim iindex as Long
  dim anzcount as Long

  
  CHECK_CARD(module)
  ilen = count * 2
  System_Array_Debug_Check(array, start_index, ilen)
  
  if (ilen > 0) then
 
#IF PRIORITAET = HIGH    
    if (if_type_fifo (array) = 1) then
      Read_Fast_Bus_LB(array, ilen, 64003104h OR shift_left(module, 20)) 
    else
      Read_Fast_Bus_LB(array[start_index], ilen, 64003104h OR shift_left(module, 20)) 
    endif

#else
    iindex = start_index
    
    do
      anzcount = min_long(ilen, 32)
      
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_LB(array, anzcount, 64003104h OR shift_left(module, 20))
      else
        Read_Fast_Bus_LB(array[iindex], anzcount, 64003104h OR shift_left(module, 20))
      endif
      
        
      ilen = ilen - anzcount
      iindex = iindex + anzcount
    until (ilen = 0)
#endif
  endif

ENDSUB

'******************************************************************************
'''Reads value pairs (input value, time stamp) from the FIFO of the edge detection
'''+unit and writes them into the arrays value[] and timestamp[].
'''module: module address (1..15)
'''count: number of value pairs to read (check with P2_Digin_FIFO_Full)
'''+   DIO-32-TiCo Rev. F:      1..8191
'''+   DIO-32-TiCo2, DIO-8-D12: 1..2047
'''+   all other modules:       1..511
'''array[]: array of input values
'''+ The bits in an input value are the levels of the digital inputs:
'''+  bit=0: Input level low
'''+  bit=1: Input level high
'''+   Bit no.            31   30   ..   1   0
'''+   Digital input      31   30   ..   1   0
'''+With module AOut-1/16, the input value refers to digital inputs 0..15.
'''timestamp[]: array of associated time stamp values
'''start_index: start index in array[] where the first value is written.
'''****************************************************************************
SUB P2_Digin_FIFO_Read(module, count, value[], timestamp[], start_index) 

  dim ilen as Long
  dim iindex as Long
  dim anzcount as Long
  dim i as Long

  CHECK_CARD(module)
  System_Array_Debug_Check(value, start_index, count)
  System_Array_Debug_Check(timestamp, start_index, count)
  
  if (count > 0) then
    ilen = count * 2
    iindex = start_index
      
    do
      
#IF PRIORITAET = LOW
      anzcount = min_long(ilen, 32)
#else
      anzcount = min_long(ilen, 32768)
#endif      
      

      if (if_type_fifo (timestamp) = 1) then
        Read_Fast_Bus_LB2(value, timestamp, anzcount, 64003104h OR shift_left(module, 20))
      else
        Read_Fast_Bus_LB2(value[iindex], timestamp[iindex], anzcount, 64003104h OR shift_left(module, 20))
      endif
         
      ilen = ilen - anzcount
      iindex = iindex + shift_right(anzcount, 1)

    until (ilen = 0)
  endif

ENDSUB

'******************************************************************************
'''Returns whether positive or negative edges have occurred on digital inputs.
'''+return value: Bit pattern of digital inputs. Each bit represents an edge
'''+ occurred at an input.
'''+  bit=0: No edge has occurred.
'''+  bit=1: The selected edge has occurred.
'''+   Bit no.            31   30   ..   1   0
'''+   Digital input      31   30   ..   1   0
'''+A query with P2_Digin_Edge resets all bits to zero.
'''module: module address (1..15)
'''edge: Kind of detected edge
'''+      0: Detect negative edge.
'''+      1: Detect positive edge.
'''****************************************************************************
Function P2_Digin_Edge(module, edge) as Long
  check_card(module)  
  P2_Digin_Edge = Peek_P2 ((60003010h - shift_left(edge, 4)) OR shift_left(module, 20))
EndFunction

'******************************************************************************
'''Programs the digital channels 0..31 as inputs or outputs in groups of 8.
'''module: module address (1..15)
'''pattern: each bit corresponds to 8 channels
'''+  bit=0: set group of channels as inputs
'''+  bit=1: set group of channels as outputs
'''+     Bit no. - Channels
'''+        0       00..07
'''+        1       08..15
'''+        2       16..23
'''+        3       24..31
'''****************************************************************************
SUB P2_DigProg(module, pattern)
  check_card(module)
  POKE (68041000h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Gets the voltage level of a digital channel group.
'''+return value (0..255): digits value referring to the voltage level
'''+      0: 1.6 V
'''+    100: 2.2 V
'''+    193: 3.3 V
'''+    240: 4.4 V
'''+    255: 4.7 V
'''module: module address (1..15)
'''group:
'''+      0: channels 0..7
'''+      1: channels 8..15
'''+      2: channels 16..23
'''+      3: channels 24..31
'''****************************************************************************
FUNCTION P2_DigProg_Get_IO_Level(module, group) as long     '<HIDE>
  dim bit, poti, i as long
  CHECK_CARD(module)
  poti = 0
  sub_begin_critical_section
  POKE (68015000h OR shift_left(module, 20), 77359400h)     'Poti ID
  for i = 0 to 31
    if ((i = 0) or (i = 16)) then
      bit = Peek_P2 (68015020h OR shift_left(module, 20))
      poke(syst_hw_nop, 4)                                  '80 ns bus sleep
    endif
    bit = Peek_P2 (68015020h OR shift_left(module, 20))
    poke(syst_hw_nop, 4)                                    '80 ns bus sleep
    poti = poti or (shift_left(bit and 1, 31 - i))
  next
  POKE (68015000h OR shift_left(module, 20), 0)             'Poti ID => Disable
  sub_end_critical_section
  P2_DIGPROG_GET_IO_LEVEL = 255 - (shift_right(poti, (group) * 8) AND 0FFH)
ENDFUNCTION 

'******************************************************************************
'''Sets the voltage level of the digital channels in groups of 8 to a defined value.
'''module: module address (1..15)
'''group: channel group (0..3)
'''+      0: channels 0..7
'''+      1: channels 8..15
'''+      2: channels 16..23
'''+      3: channels 24..31
'''level: value in digits (0..255) to set the voltage level
'''+      0: 1.6 V
'''+    100: 2.2 V
'''+    193: 3.3 V
'''+    240: 4.4 V
'''+    255: 4.7 V
'''****************************************************************************
SUB P2_DigProg_Set_IO_Level(module, group, level) 
  dim bit, poti, i as long
  CHECK_CARD(module)
  poti = 0
  sub_begin_critical_section 
  POKE (68015000h OR shift_left(module, 20), 77359400h)     'Poti ID
  for i = 0 to 31
    if ((i = 0) or (i = 16)) then                           'stack                  
      bit = Peek_P2 (68015020h OR shift_left(module, 20))   'stack bit
      poke(syst_hw_nop, 4)                                  '80 ns bus sleep
    endif 
    bit = Peek_P2 (68015020h OR shift_left(module, 20))
    poke(syst_hw_nop, 4)                                    '80 ns bus sleep
    poti = poti or (shift_left(bit and 1, 31 - i))
  next
  poti = (poti AND not(shift_left(0FFH, (group) * 8))) or shift_left(255 - (level AND 0FFH), (group) * 8)  
  for i = 0 to 31
    if ((i = 0) or (i = 16)) then                           'stack bit
      POKE (68015020h OR shift_left(module, 20), 0)         'Poti 2 Stack Bit
      poke(syst_hw_nop, 4)                                  '80 ns bus sleep
    endif
    
    POKE (68015020h OR shift_left(module, 20), shift_right(poti, 31 - i) and 1)
    poke(syst_hw_nop, 4)                                    '80 ns bus sleep
  next i
  POKE (68015000h OR shift_left(module, 20), 0)             'Poti ID => Disable
  sub_end_critical_section
ENDSUB

'******************************************************************************
'''Sets the digital outputs (channels 0..31).
'''module: module address (1..15)
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB P2_Digout_Long(module, pattern)
  check_card(module)
  POKE (60000000h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Reads the digital inputs (channels 0..31).
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Digin_Long(module) AS Long
  check_card(module)
  P2_Digin_Long = Peek_P2 ((60001000h OR shift_left(module, 20)))
ENDFUNCTION

'******************************************************************************
'''Reads back the output value of the digital outputs (channels 0..31).
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Get_Digout_Long(module) AS Long
  check_card(module) 
  P2_Get_Digout_Long = Peek_P2 ((60000000h OR shift_left(module, 20)))
ENDFUNCTION

'******************************************************************************
'''Sets and resets selected digital outputs.
'''module: module address (1..15)
'''set: Bit pattern indicating the outputs which should be set
'''clear: Bit pattern indicating the outputs which should be reset
'''****************************************************************************
SUB P2_Digout_Bits(module, set, clear) 
  check_card(module)
  SUB_BEGIN_CRITICAL_SECTION 
  POKE (60000210h OR shift_left(module, 20), clear) 
  POKE (60000200h OR shift_left(module, 20), set)
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
'''Sets selected digital outputs.
'''module: module address (1..15)
'''set: Bit pattern indicating the outputs which should be set
'''****************************************************************************
SUB P2_Digout_Set(module, set)
  check_card(module)
  POKE (60000200h OR shift_left(module, 20), set) 
ENDSUB

'******************************************************************************
'''Sets selected digital outputs.
'''module: module address (1..15)
'''clear: Bit pattern indicating the outputs which should be reset
'''******************************************************************************
SUB P2_Digout_Reset(module, clear)
  check_card(module)
  POKE (60000210h OR shift_left(module, 20), clear) 
ENDSUB

'******************************************************************************
'''Sets or resets one channel of a digital outputs.
'''module: module address (1..15)
'''channel: channel (0..31)
'''value:
'''+     0: reset channel
'''+     1: set channel
'''****************************************************************************
SUB P2_Digout(module, channel, value)
  check_card(module)
  POKE ((60000210h - shift_left(value, 4)) OR shift_left(module, 20), shift_left(1, (channel))) 
ENDSUB

'******************************************************************************
'''Sets output register (channel 0..31).
'''module: module address (1..15)
'''pattern: each bit corresponds to a channel
'''*****************************************************************************
SUB P2_Dig_Write_Latch(module, pattern)
  check_card(module)
  POKE (60000100h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Reads the input latch register (channel 0..31).
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Dig_Read_Latch(module) AS Long
  check_card(module) 
  P2_Dig_Read_Latch = Peek_P2 ((60001100h OR shift_left(module, 20)))
ENDFUNCTION

'******************************************************************************
'''Latches the digital I/O module.
'''+ Inputs are latched in the input registers
'''+ Outputs are set according to the output register.
'''module: module address (1..15)
'''******************************************************************************
SUB P2_Dig_Latch(module)
  check_card(module)
  POKE (60002000h OR shift_left(module, 20), 0) 
ENDSUB

'******************************************************************************
'''Reads the digital inputs (channel 0..31).
'''+ result
'''+            Bit 0...7 -> DIO 1 ... DIO 8
'''+Option ET1      
'''+            Bit 16..19 -> OPT 1 ... OPT 4 
'''+MIO D12
'''+            Bit 0...11 OPT 1....OPT 12
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_MIO_Digin_Long(module) AS Long
  check_card(module)  
  P2_MIO_Digin_Long = Peek_P2 ((60065200h OR shift_left(module, 20)))
ENDFUNCTION

'******************************************************************************
'''Reads the input latch register (channel 0..31).
'''+ result 
'''+                Bit 0...7 -> DIO 1 ... DIO 8
'''+Option ET1      
'''+                Bit 16-19 -> OPT 1 ... OPT 4 
'''+MIO D12
'''+            Bit 0...11 OPT 1....OPT 12
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_MIO_Dig_Read_Latch(module) AS Long
  check_card(module)  
  P2_MIO_Dig_Read_Latch = Peek_P2 ((60065250h OR shift_left(module, 20)))
ENDFUNCTION

'******************************************************************************
'''Sets the digital outputs (channel 0..31).
'''module: module address (1..15)
'''pattern: each bit corresponds to a channel
'''+          Bit 0...7   ->  DIO 1 ... DIO 8
'''+Option ET1
'''+          Bit 24...27 -> TRA 1 ... TRA 4 
'''+MIO D12
'''+          Bit 16...27 TRA 1....TRA 12
'''******************************************************************************
SUB P2_MIO_Digout_Long(module, pattern)
  check_card(module)
  POKE (60065000h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Sets output register (channel 0..31).
'''module: module address (1..15)
'''pattern: each bit corresponds to a channel
'''+          Bit 0...7    DIO 1 ... DIO 8
'''+Option ET1
'''+          Bit 24...27  TRA 1 ... TRA 4 
'''+MIO D12
'''+          Bit 16...27 TRA 1....TRA 12
'''****************************************************************************
SUB P2_MIO_Dig_Write_Latch(module, pattern)
  check_card(module)
  POKE (60065050h OR shift_left(module, 20), pattern)
ENDSUB

'******************************************************************************
'''Latches the digital I/O module.
'''+ Inputs are latched in the input registers
'''+ Outputs are set according to the output register.
'''module: module address (1..15)
'''******************************************************************************
SUB P2_MIO_Dig_Latch(module)
  check_card(module)
  POKE (60065150h OR shift_left(module, 20), 0)
ENDSUB

'******************************************************************************
'''Sets or resets one channel of a digital output.
'''module: module address (1..15)
'''channel: channel (0..31)
'''+           0...7    DIO 1 ... DIO 8
'''+Option ET1
'''+           24...27  TRA 1 ... TRA 4 
'''+MIO D12
'''+          Bit 16...27 TRA 1....TRA 12
'''value: 
'''+       0->reset channel
'''+       1->set channel
'''****************************************************************************
SUB P2_MIO_Digout(module, channel, value)
  check_card(module)
  POKE ((60065110h - shift_left(value, 4)) OR shift_left(module, 20), shift_left(1, (channel)))   
ENDSUB

'******************************************************************************
'''Initializes the a digital I/O module (channel 0..31).
'''module: module address (1..15)
'''pattern: each bit corresponds to 4 channel
'''+     0->input
'''+     1->output
'''******************************************************************************
SUB P2_MIO_DigProg(module, pattern)
  check_card(module)
  POKE (68041000h OR shift_left(module, 20), pattern)
ENDSUB

'******************************************************************************
'''Reads back of the output value of the digital outputs (channel 0..31).
'''module: module address (1..15)
'''******************************************************************************
FUNCTION P2_MIO_Get_Digout_Long(module) AS Long
  check_card(module)  
  P2_MIO_Get_Digout_Long = Peek_P2 (60065000h OR shift_left(module, 20))
ENDFUNCTION




'<ENDREGION>

'<REGION> DIO_Base

'******************************************************************************
'''Programs all digital channels 0..31 of a digital I/O module
'''+as inputs or outputs.
'''module: module address (1..15)
'''pattern: each bit corresponds to an I/O channel (bit no. = channel no.)
'''+     bit=0: set channel as input
'''+     bit=1: set channel as output
'''****************************************************************************
SUB P2_DigProg_Bits(module, pattern)             
  check_card(module)
  POKE (68041010h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Programs the digital channels 32..58 of a digital I/O module
'''+as inputs or outputs.
'''module: module address (1..15)
'''pattern: each bit corresponds to an I/O channel. Channel no. = bit no. + 32
'''+     bit=0: set channel as input
'''+     bit=1: set channel as output
'''****************************************************************************
SUB P2_DigProg_Bits_High(module, pattern)                   '<HIDE>
  check_card(module)
  POKE (68041020h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Sets the digital outputs (channel 32 - 58).
'''module: module address (1..15)
'''pattern: each bit corresponds to a channel (only first 26 bits will be
'''+         used, the other bits will be ignored)
'''****************************************************************************
SUB P2_Digout_Long_High(module, pattern)                    '<HIDE>
  check_card(module)
  POKE (60000010h OR shift_left(module, 20), pattern) 
ENDSUB

'******************************************************************************
'''Reads the digital inputs (channel 32 - 58).
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Digin_Long_High(module) AS Long                 '<HIDE>
  check_card(module)  
  P2_Digin_Long_High = Peek_P2 (60001010h OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Reads back of the output value of the digital outputs (channel 32 - 58).
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_Get_Digout_Long_High(module) AS Long            '<HIDE>
  check_card(module)
  P2_Get_Digout_Long_High = Peek_P2 (60000010h OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Sets and resets selected digital outputs (channel 32 - 58).
'''module: module address (1..15)
'''set: Bit pattern indicating the outputs which should be set
'''clear: Bit pattern indicating the outputs which should be reset
'''****************************************************************************
SUB P2_Digout_Bits_High(module, set, clear)                 '<HIDE>
  check_card(module)
  SUB_BEGIN_CRITICAL_SECTION 
  POKE((61010010h OR shift_left(module, 20)), clear)
  POKE((61010010h OR shift_left(module, 20)), set)
  SUB_END_CRITICAL_SECTION
ENDSUB

'******************************************************************************
'''Sets or resets one channel of a digital output. 
'''module: module address (1..15)
'''channel: channel (32 - 58)
'''value: 0 = reset channel
'''+       1 = set channel
'''****************************************************************************
SUB P2_Digout_High(module, channel, value)                  '<HIDE>
  check_card(module)
  POKE ((60000230h - (value) * 16) OR shift_left(module, 20), shift_left(1, (channel))) 
ENDSUB

'******************************************************************************
'''Sets output register (channel 32 - 58).
'''module: module address (1..15)
'''pattern: each bit corresponds to a channel
'''****************************************************************************
SUB P2_Dig_Write_Latch_High(module, pattern)                '<HIDE>
  check_card(module)
  POKE (60000110h OR shift_left(module, 20), pattern) 
ENDSUB
  
'******************************************************************************
'''Reads the input latch register (channel 32 - 58).
'''module: module address (1..15)
'******************************************************************************
FUNCTION P2_Dig_Read_Latch_High(module) AS Long             '<HIDE>
  check_card(module)  
  P2_Dig_Read_Latch_High = Peek_P2 ((60001110h OR shift_left(module, 20)))
ENDFUNCTION

'<ENDREGION>

'<REGION> ADC_FAST

'******************************************************************************
'''Samples, converts and reads out the digital 16 bit ADC-value
'''+ of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
'''+ Attention:                                                                
'''+ This instruction is not prepared to handle an access from                 
'''+ a low AND high priority process to the same module.                       
'''+ result: 16 bit Long
'''module: module address (1..15)
'''input_no: channel number of analog input
'''******************************************************************************
FUNCTION P2_ADCF(module, input_no) AS Long
  DIM adc_n1, reminder AS Long

  check_card(module)

  adc_n1 = SHIFT_LEFT(1, (input_no - 1))
  '............ start conversion ............
  POKE (60070000h OR shift_left(module, 20), adc_n1) 
  '............ wait EOC ............
  do
    reminder = Peek_P2 ((60070100h OR shift_left(module, 20)))
  until (((reminder AND adc_n1) = 0) or reminder = 12345678H)
  ' 12345678H = timeout from bus because no module is present
  '............ read out result ............
  p2_ADCF = Peek_P2 ((60001FF0h + ((input_no) * 16)) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Samples, converts and reads out the digital 24 bit ADC-value
'''+ of an analog input of an AIN-Fx/yy-module ("fast"-ADC-module).
'''+  Attention:                                                               
'''+  This instruction is not prepared to handle an access from                
'''+  a low AND high priority process to the same module.
'''+ result: 24 bit Long        
'''module:  module address (1..15)
'''input_no: channel number of analog input
'''******************************************************************************
FUNCTION P2_ADCF24(module, input_no) AS Long
  DIM adc_n1, reminder AS Long

  check_card(module)

  adc_n1 = SHIFT_LEFT(1, (input_no - 1))
  '............ start conversion ............
  POKE (60070000h OR shift_left(module, 20), adc_n1) 
  '............ wait EOC ............
  do
    reminder = Peek_P2 ((60070100h OR shift_left(module, 20)))
  until (((reminder AND adc_n1) = 0) or reminder = 12345678H)
  ' 12345678H = timeout from bus because no module is present
  '............ read out result ............
  P2_ADCF24 = Peek_P2 (60000000h or shift_left(module, 20) + ((input_no) - 1) * 16)  
ENDFUNCTION

'*****************************************************************************
'''Starts a conversion on selected ADC on AIN-Fx/yy-modules.
'''module: module address (1..15)
'''ADC_pattern: example 0101=adc 1 u. 3
'''*****************************************************************************
SUB P2_Start_ConvF(module, ADC_pattern)
  check_card(module)
  POKE (60070000h OR shift_left(module, 20), ADC_pattern) 
ENDSUB

'*****************************************************************************
'''Waits until EOC-signals of all selected ADCs are active.
'''+ (for AIN-Fx/yy-modules only)
'''module: module address (1..15)
'''ADC_pattern: ADC-#1 -> bit 0, ..., ADC-#8 -> bit 7
'''*****************************************************************************
SUB P2_Wait_EOCF(module, ADC_pattern)
  DIM reminder AS Long
  check_card(module)
  do
    reminder = Peek_P2 (60070100h OR shift_left(module, 20))
  until (((reminder AND ADC_pattern) = 0) or reminder = 12345678H)
  ' 12345678H = timeout from bus because no module is present
ENDSUB

'*****************************************************************************
'''Returns conversion result of ADC of AIN-Fx/yy-module.
'''+Result: 16 bit Long
'''module: module address (1..15)
'''adc_no: channel number of analog input
'''*****************************************************************************
FUNCTION P2_Read_ADCF(module, adc_no) AS Long
  check_card(module)
  P2_Read_ADCF = Peek_P2 ((60001FF0h + (adc_no) * 16) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Returns conversion result of ADC of AIN-Fx/yy-module.
'''+Result: 24 bit Long
'''module: module address (1..15)
'''adc_no: channel number of analog input
'''*****************************************************************************
FUNCTION P2_Read_ADCF24(module, adc_no) AS Long
  check_card(module)
  P2_Read_ADCF24 = Peek_P2 ((60000000h or ((adc_no) - 1) * 16) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Returns conversion result of two ADCs simultaneously from
'''+ an AIN-Fx/yy-module.
'''+Result: 32 bit Long
'''+         low-word -> adc_no, high-word -> adc_no + 1
''' module: module address (1..15)
''' adc_no: 
'''+         1->channel no. 1 low  + 2 high word
'''+         2->channel no. 3 + 4
'''+         3->channel no. 5 + 6
'''+         4->channel no. 7 + 8
'''*****************************************************************************
FUNCTION P2_Read_ADCF32(module, adc_no) AS Long
  check_card(module)
  P2_READ_ADCF32 = Peek_P2 ((60003FF0h + (adc_no) * 16) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Returns conversion result of two ADCs simultaneously and
'''+immediately starts the conversion of both ADC again.
'''+Result: 32 bit Long
'''+        low-word -> adc_no, high-word -> adc_no + 1
'''module: module address (1..15)
'''adc_no: 
'''+         1->channel no. 1 + 2
'''+         2->channel no. 3 + 4
'''+         3->channel no. 5 + 6
'''+         4->channel no. 7 + 8
'''*****************************************************************************
FUNCTION P2_Read_ADCF_SConv32(module, adc_no) AS Long
  check_card(module)
  P2_Read_ADCF_SConv32 = Peek_P2 ((60004FF0h + (adc_no) * 16) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
''' Returns conversion result of ADC and starts immediately
'''+a new conversion (for AIN-Fx/yy-modules only).
'''+Result: 16 bit Long
'''module: module address  (1..15)
'''adc_no: channel number of analog input
'''*****************************************************************************
FUNCTION P2_Read_ADCF_SConv(module, adc_no) AS Long
  check_card(module)
  P2_Read_ADCF_SConv = Peek_P2 ((60002FF0h + (adc_no) * 16) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Returns conversion result of ADC and starts immediately
'''+ a new conversion (for AIN-Fx/yy-modules only).
'''+Result: 24 bit Long
'''module: module address (1..15)
'''adc_no: channel number of analog input
'''*****************************************************************************
FUNCTION P2_Read_ADCF_SConv24(module, adc_no) AS Long
  check_card(module)
  P2_Read_ADCF_SConv24 = Peek_P2 ((60000FF0h + (adc_no) * 16) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Transfers the input data from channel 1..4 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Read_ADCF4_Packed(module, array[], index) 
  CHECK_TYPE_LONG (array[1])
  check_card(module)
  System_Array_Debug_Check(array, index, 2)  
  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_SB(array, 2, 61004004H OR shift_left(module, 20))
  else
    Read_Fast_Bus_SB(array[index], 2, 61004004H OR shift_left(module, 20))
  endif

ENDSUB

'*****************************************************************************
'''Transfer the input data from channel 1..8 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Read_ADCF8_Packed(module, array[], index)
  CHECK_TYPE_LONG (array[1])
  System_Array_Debug_Check(array, index, 4)
  check_card(module)
  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_SB(array, 4, 63004004H OR shift_left(module, 20))
  else
    Read_Fast_Bus_SB(array[index], 4, 63004004H OR shift_left(module, 20))
  endif
  
ENDSUB

'*****************************************************************************
'''Transfers the input data from channel 1..8 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Read_ADCF8(module, array[], index) 
  'CHECK_TYPE_LONG_OR_SHORT(array[1])
  check_card(module)
  System_Array_Debug_Check(array, index, 8)
  if (if_type_fifo (array) = 1) then 
    Read_Fast_Bus_SB_unpacked1(array, 4, 63004004H OR shift_left(module, 20))
  else
    Read_Fast_Bus_SB_unpacked1(array[index], 4, 63004004H OR shift_left(module, 20))
  endif

ENDSUB

'****************************************************************************
'''Transfers the input data from channel 1..4 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''****************************************************************************
SUB P2_Read_ADCF4(module, array[], index)
  check_card(module)
  System_Array_Debug_Check(array, index, 4)

  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_SB_unpacked1(array, 2, 61004004H OR shift_left(module, 20))
  else
    Read_Fast_Bus_SB_unpacked1(array[index], 2, 61004004H OR shift_left(module, 20))
  endif
ENDSUB

'****************************************************************************
'''Transfers the input data from channel 1..8 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''****************************************************************************
SUB P2_Read_ADCF8_24B(module, array[], index)
  CHECK_TYPE_LONG (array[1])
  check_card(module)
  System_Array_Debug_Check(array, index, 8)    

  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB(array, 8, 64000004h OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB(array[index], 8, 64000004h OR shift_left(module, 20))
  endif 
ENDSUB

'****************************************************************************
'''Transfers the input data from channel 1..4 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''****************************************************************************
SUB P2_Read_ADCF4_24B(module, array[], index))
  check_card(module)
  System_Array_Debug_Check(array, index, 4)  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_SB(array, 4, 63000004H OR shift_left(module, 20))
  else
    Read_Fast_Bus_SB(array[index], 4, 63000004H OR shift_left(module, 20))
  endif
  
ENDSUB

'****************************************************************************
'''Sets the input range.
'''module: module address (1..15)
'''channel: 1..8
'''mode: 
'''+      0->range -10 V -> +10 V
'''+      1->range - 5 V -> + 5 V
'''+      2->range -2.5V -> + 2.5V
'''+      3->range -1.25V-> + 1.25V
'''**************************************************************************
SUB P2_Set_Gain(module, channel, mode)
  check_card(module)
  POKE ((68051FF0h + (channel) * 16) OR shift_left(module, 20), mode) 
ENDSUB

'****************************************************************************
'''Sets the input mode.
'''module_pattern: bit pattern to set the module adresses
'''mode:
'''+bit 0->auto mode ON
'''+bit 1->channel multiplex
'''+bit 2->start_convf by extern event
'''**************************************************************************
SUB P2_ADCF_Mode(module_pattern, mode)
  DIM startdelay AS Long
  DIM delaymod AS Long
  DIM old AS Long
  dim module as Long
  dim time as Long
  dim gc as long
  
  if (mode <> 0) then 
    gc = globaldelay                                        'globaldelay does not exits in lib
  endif

  Write_Fast_Bus_Modul_Pattern(69020000h, module_pattern, 0)  '   Autosample off


  for module = 1 to 15
    if (module_pattern AND shift_left(1, module - 1) > 0) then 
      time = Peek_P2 (68000550h OR shift_left(module, 20)) 
      
      'time=time / 1 'delay in ns

       
      startdelay = gc - time                                '100 conversion time F8/18
     
      
      startdelay = startdelay / 20
 
      
      if (startdelay < 0) then startdelay = 0
      if (mode AND 2 > 0) then                              'channel multiplex on/off
    

        delaymod = gc / 2
        POKE (68050450h OR shift_left(module, 20), 1)
   
      else
        

        delaymod = gc

        POKE (68050450h OR shift_left(module, 20), 0)
      endif

       
      old = Peek_P2 (68048000h OR shift_left(module, 20))

      

      if (mode AND 4 > 0) then                              'start_convf by event
        old = (old AND 0FFFEFFFFH) or 65536
      else
        old = (old AND 0FFFEFFFFH)
      endif


      POKE (68048000h OR shift_left(module, 20), old)
      POKE (68050300h OR shift_left(module, 20), 20)        'prescale
      POKE (68050350h OR shift_left(module, 20), startdelay)  'delay in ns
      POKE (68050400h OR shift_left(module, 20), delaymod)  'prescale =20 > ns
      
     
      old = Peek_P2 (68040000h OR shift_left(module, 20))   'sync clear!!!
 
    endif
  next

  Write_Fast_Bus_Modul_Pattern(69020000h, module_pattern, (mode AND 1))  '
  IF (mode AND 1 > 0) then cpu_sleep(40)
ENDSUB


'****************************************************************************
' ADCF
'****************************************************************************
'''Sets limit.
'''module: module adress (1..15)
'''channel: channel (1..8)
'''valuehigh: switch point to set limit overflow bit to 1
'''valuelow: switch point to set limit underflow bit to 1
''' *************************************************************************
SUB P2_ADCF_Set_Limit(module, channel, valuehigh, valuelow)
  check_card(module)  
  POKE (68055FF0h + ((channel) * 16) OR shift_left(module, 20), valuehigh)
  POKE (68054FF0h + ((channel) * 16) OR shift_left(module, 20), valuelow)
ENDSUB

'****************************************************************************
'''Reads the limit-overrun and -underrun flags of all FADC.
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_ADCF_Read_Limit(module) AS Long
  check_card(module)
  P2_ADCF_Read_Limit = Peek_P2 (60070300h OR shift_left(module, 20)) 
ENDFUNCTION

'******************************************************************************
'''Transfers the min_max value to an array. 
'''module: module address (1..15)
'''array[]: destination array
'''array_index: start index at the destination array
'''+             array_index+ 0 = channel 1 min.
'''+             array_index+ 1 = channel 1 max.
'''+             array_index+ 2 = channel 2 min.
'''+             array_index+ 3 = channel 2 max.
'''+             array_index+ 4 = channel 3 min.
'''+             array_index+ 5 = channel 3 max.
'''+             array_index+ 6 = channel 4 min.
'''+             array_index+ 7 = channel 4 max.
'''+             array_index+ 8 = channel 5 min.
'''+             array_index+ 9 = channel 5 max.
'''+             array_index+ 10 = channel 6 min.
'''+             array_index+ 11 = channel 6 max.
'''+             array_index+ 12 = channel 7 min.
'''+             array_index+ 13 = channel 7 max.
'''+             array_index+ 14 = channel 8 min.
'''+             array_index+ 15 = channel 8 max.
'''******************************************************************************
SUB P2_ADCF_Read_Min_Max8(module, array[], array_index) 
  check_card(module)
  System_Array_Debug_Check(array, array_index, 16)

  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB_unpacked1(array, 8, 64006004H OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB_unpacked1(array[array_index], 8, 64006004H OR shift_left(module, 20))
  endif
  
ENDSUB
 
'******************************************************************************
'''Transfers the min_max value  to an array).
'''module: module address (1..15)
'''array[]: destination array
'''array_index: start index at the destination array
'''+             array_index+ 0 = channel 1 min.
'''+             array_index+ 1 = channel 1 max.
'''+             array_index+ 2 = channel 2 min.
'''+             array_index+ 3 = channel 2 max.
'''+             array_index+ 4 = channel 3 min.
'''+             array_index+ 5 = channel 3 max.
'''+             array_index+ 6 = channel 4 min.
'''+             array_index+ 7 = channel 4 max.
'''******************************************************************************
SUB P2_ADCF_Read_Min_Max4(module, array[], array_index) 
  check_card(module)
  System_Array_Debug_Check(array, array_index, 8)
 
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_SB_unpacked1(array, 4, 63006004H OR shift_left(module, 20))  
  else
    Read_Fast_Bus_SB_unpacked1(array[array_index], 4, 63006004H OR shift_left(module, 20))  
  endif
  
ENDSUB

'******************************************************************************
'''Sets max Value =0 ; Set min Value=0FFFFH.
'''module: module address (1..15)
'''channel_pattern: select channel
'''****************************************************************************
SUB P2_ADCF_Reset_Min_Max(module, channel_pattern)
  check_card(module)
  POKE (68050700h OR shift_left(module, 20), channel_pattern)
ENDSUB 
  
'****************************************************************************
'''Sets average filter.
'''module: modul address (1..15)
'''mode: 
'''+      0->Filter off
'''+      1->2
'''+      2->4
'''+      3->8
'''+      4->16
'''+      5->32
'''****************************************************************************
SUB P2_Set_Average_Filter(module, mode)
  check_card(module)
  if (mode = 0) then
    POKE (68050000h OR shift_left(module, 20), 1)           ' stop
  else
    POKE (68050000h OR shift_left(module, 20), 2)           ' start
    POKE (68050050h OR shift_left(module, 20), mode - 1)    'filter
  endif
ENDSUB

'<ENDREGION>

'<REGION> BURST
'******************************************************************************
''' Sets the parameters of the burst mode
''' module: modul address (1..15) 
'''channels: 
'''+          1->Sample Channel 1
'''+          3->Sample Channel 1+2
'''+         15->Sample Channel 1+2+3+4
'''+        255->Sample Channel 1+2+3+4+5+6+7+8
'''buffer_start: startadr ram
'''buffer_count: length per channel
'''pulses:  
'''+ Fx/14  sampleperiode (n*20 ns)   1 to 4 channels value 1 ... 65 535
'''+                                  8 channels value 2 ... 65 535
'''+ Fx/16  sampleperiode (n*10 ns)  value 25 ... 65 535
'''trigger_mode:
'''+              Bit 0 x
'''+              Bit 1 0 Single 1 Continiuous
'''+              Bit 2 0 Sync 1 Event
'''******************************************************************************
SUB P2_Burst_Init(module, channels, buffer_start, buffer_count, pulses, trigger_mode)
  dim ch_count as Float
  dim ramend as Long
  dim i as Long
  dim len as Long
  dim mc, sp as long
  check_card(module)
  
  mc = P2_System_Read_MC(module)
  p2_System_PROII_Bus_Set_Timeout()
  sp = 0
  if ((mc = 4102) or (mc = 4103)) then sp = 1
  
  ch_count = 0
  for i = 0 to 7
    if (channels AND (Shift_left(1, i)) > 0) then inc ch_count
  next
  if (channels = 131) then ch_count = 2
  if (channels = 143) then ch_count = 4
  if (channels = 127) then ch_count = 8
  

#IF DEBUG_MODE = ON THEN
  if (ch_count = 1) then
    if (buffer_count AND 7 > 0) then PROZESS_FEHLER = 200102  ':8
  else
    if (buffer_count AND 3 > 0) then PROZESS_FEHLER = 200101  ':4
  endif
  if (buffer_start AND 3 > 0) then PROZESS_FEHLER = 200100
  if (sp = 1) then PROZESS_FEHLER = 200105
#ENDIF
  if (sp = 1) then ch_count = 0

  ch_count = ch_count * 0.5 * buffer_count
  ramend = buffer_start + ch_count
     
  POKE(68050600h OR shift_left(module, 20), 32896)
  p2_sleep(14)  
  POKE(68050610h OR shift_left(module, 20), buffer_start)
  POKE(68050620h OR shift_left(module, 20), ramend - 1)
  POKE(68050640h OR shift_left(module, 20), channels)
  POKE(68050650h OR shift_left(module, 20), pulses)
  POKE(68050600h OR shift_left(module, 20), trigger_mode or 1)  ' +star
  poke(syst_hw_nop, 2)                                      '20 ns bus sleep
  
ENDSUB

'******************************************************************************
''' Starts the burst measurement
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************************
SUB P2_Burst_Start(module_pattern)  
  Write_Fast_Bus_Modul_Pattern(69021000h, module_pattern, 1)  '   Autosample on
  poke(syst_hw_nop, 2)                                      '20 ns bus sleep
ENDSUB

'******************************************************************************
''' Stops the burst measure
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************************
SUB P2_Burst_Stop(module_pattern)
  Write_Fast_Bus_Modul_Pattern(69021000h, module_pattern, 0)  '   Autosample off 
  poke(syst_hw_nop, 2)                                      '20 ns bus sleep
ENDSUB

'******************************************************************************
''' Resets burst mode
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************************
SUB P2_Burst_Reset(module_pattern)  
  Write_Fast_Bus_Modul_Pattern(69021000h, module_pattern, 2)  '   Autosample off
  poke(syst_hw_nop, 2)                                      '20 ns bus sleep
ENDSUB


'******************************************************************************
''' Returns the sample position
''' module: module address (1..15)
'''****************************************************************************
Function P2_Burst_Read_Index(module) AS Long
  dim status[4] as Long
  check_card(module)
  '1 status, 2 start, 3 end, 4 aktuell
  
  READ_FAST_BUS_SB(status[1], 4, 6B050604H OR shift_left(module, 20))
  
  P2_BURST_READ_INDEX = status[4]
ENDFUNCTION


'******************************************************************************
''' Returns the sample position if the 
'''+limit-overrun or -underrun flags is changed
'''+since the last read of the index register
''' module: module address (1..15)
'''****************************************************************************
Function P2_Burst_Read_Index_Limit(module) AS Long          '<HIDE>
  CHECK_CARD(module)  
  P2_Burst_Read_Index_Limit = Peek_P2 (60070350h OR shift_left(module, 20))
ENDFUNCTION



'******************************************************************************
''' Reads the progress of the burst measure
'''+return value: number of conversions to do
''' module: module address  (1..15)
'''****************************************************************************
Function P2_Burst_Status(module) AS Long

  dim status[5] as Long


  dim ch_count as Long
  dim i as Long
  dim channels as long

  check_card(module)
  '1 status, 2 start, 3 end, 4 aktuell 5 select  
  ch_count = 0
  read_fast_bus_sb(status[1], 4, 6B050604H or shift_left(module, 20))
  status[5] = Peek_P2 (shift_left(module, 20) or 68050640h)

 
  
  channels = status[5]
  
  for i = 0 to 7
    if (channels AND (Shift_left(1, i)) > 0) then inc ch_count
  next
  if (channels = 131) then ch_count = 2
  if (channels = 143) then ch_count = 4
  if (channels = 127) then ch_count = 8
     
  P2_BURST_STATUS = (status[3] - status[4] + 1) * 2 / ch_count
ENDFUNCTION


'******************************************************************************
''' Transfers data to Modul
''' module: module address (1..15)
''' count: number of values
''' startadr: startadr. ram
''' array[]: source array
''' array_start_index: startindex at the source array
''' flowrate:
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_Write(module, count, startadr, array[], array_start_index, flowrate)  '<HIDE>
  dim ilen as Long
  dim iindex as Long
  dim pointer as Long
  dim maxburst as Long
  dim anzcount as Long
  CHECK_TYPE_LONG (array[1])


#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 8
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)
  
  poke(syst_hw_nop, 12)                                     '80 ns bus sleep  'todo: fehlt bei T11!
  POKE (60070800h OR shift_left(module, 20), startadr AND 0FFFFFFFCH)

  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
  ilen = count AND 0FFFFFFFCH
  iindex = array_start_index

#IF DEBUG_MODE = ON THEN
  if (count AND 3 > 0) then PROZESS_FEHLER = 200141         ':4
  if (startadr AND 3 > 0) then PROZESS_FEHLER = 200140
#ENDIF

  if (ilen > 0) then
    do 
      anzcount = min_long(ilen, maxburst)
      System_Array_Debug_Check(array, iindex, anzcount)  
      Write_Fast_Bus_LB(array[iindex], anzcount, 64070900h or shift_left(module, 20))
      ilen = ilen - anzcount
      iindex = iindex + anzcount
    until (ilen = 0)
    
    if (count < 9) then 
      p2_sleep(40) 
    else
      p2_Sleep(100)                                         'Time to write buffer 24 long to dram 
    endif
    
  endif
ENDSUB


'******************************************************************************
''' Transfers the input data to an array
''' module: module address (1..15)
''' count: number of values
''' startadr: startadr. ram
''' array[]: destination array
''' array_start_index: startindex at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_Read(module, count, startadr, array[], array_start_index, flowrate)
  dim ilen as Long
  dim iindex as Long
  dim maxburst as Long
  dim anzcount as Long

#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 8
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)
  POKE (60070850h OR shift_left(module, 20), startadr AND 0FFFFFFFCH)

  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
  ilen = count AND 0FFFFFFFCH

#IF DEBUG_MODE = ON THEN
  if (count AND 3 > 0) then PROZESS_FEHLER = 200121         ':4
  if (startadr AND 3 > 0) then PROZESS_FEHLER = 200120
#ENDIF

  iindex = array_start_index
  if (ilen > 0) then
    do
      anzcount = min_long(ilen, maxburst)
      System_Array_Debug_Check(array, iindex, anzcount)
          
      
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_LB(array, anzcount, 64070904h OR shift_left(module, 20))
      else
        Read_Fast_Bus_LB(array[iindex], anzcount, 64070904h OR shift_left(module, 20))
      endif
      
      
      ilen = ilen - anzcount
        
      iindex = iindex + anzcount
    until (ilen = 0)
  endif
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' count: number of values
''' startadr: startadr. ram
''' array[]: destination array
''' array_start_index: startindex at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_Read_Unpacked1(module, count, startadr, array[], array_start_index, flowrate)
  dim ilen as Long
  dim iindex as Long
  dim maxburst as Long
  dim anzcount as Long
  
#IF DEBUG_MODE = ON THEN
  if (P2_Burst_Get_Channel_Count(module) <> 1) then PROZESS_FEHLER = 200110
#ENDIF

#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 8
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)
  POKE (60070850h OR shift_left(module, 20), startadr)
          
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep ' wait until FIFO empty

  ilen = count AND 0FFFFFFF8H                               'Number of values is divisible by 8 ?
  ilen = ilen * 0.5
  iindex = array_start_index

#IF DEBUG_MODE = ON THEN
  if (count AND 7 > 0) then PROZESS_FEHLER = 200123         ':8
  if (startadr AND 3 > 0) then PROZESS_FEHLER = 200120
#ENDIF

  if (ilen > 0) then
    do
      anzcount = min_long(ilen, maxburst)
      
      System_Array_Debug_Check(array, iindex, anzcount * 2)
            
      ilen = ilen - anzcount 
      if (if_type_fifo (array) = 1) then
        read_Fast_Bus_LB_unpacked1(array, anzcount, 64070904h or shift_left(module, 20))
      else
        Read_Fast_Bus_LB_unpacked1(array[iindex], anzcount, 64070904h or shift_left(module, 20))
      endif
      iindex = iindex + anzcount * 2
    until (ilen = 0)
  endif
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' count: number of values per channel
''' startadr: startadr. ram
''' array1[]: destination array low channel
''' array2[]: destination array high channel
''' array_start_index: startindex at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_Read_Unpacked2(module, count, startadr, array1[], array2[], array_start_index, flowrate)
  dim ilen as Long
  dim iindex as Long
  dim maxburst as Long
  dim anzcount as Long
  
  
  if (if_type_long (array1) = 1) then 
    CHECK_TYPE_LONG (array2[1])
  endif
  
  if (If_type_short (array1) = 1) then 
    CHECK_TYPE_SHORT (array2[1])    
  endif
  '  
  if (If_type_float32 (array1) = 1) then 
    CHECK_TYPE_FLOAT32 (array2[1])    
  endif
    
  if (If_type_float (array1) = 1) then 
    CHECK_TYPE_FLOAT (array2[1])    
  endif


#IF DEBUG_MODE = ON THEN
  if (P2_Burst_Get_Channel_Count(module) <> 2) then PROZESS_FEHLER = 200110
#ENDIF

#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 16
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)

  POKE (60070850h OR shift_left(module, 20), startadr)

  poke(syst_hw_nop, 4h)                                     ' wait until FIFO empty
 
  ilen = count AND 0FFFFFFFCH                               '/4

#IF DEBUG_MODE = ON THEN
  if (count AND 3 > 0) then PROZESS_FEHLER = 200124         ':8
  if (startadr AND 3 > 0) then PROZESS_FEHLER = 200120
#ENDIF
  iindex = array_start_index
  if (ilen > 0) then
    do
     
      anzcount = min_long(ilen, maxburst)
      
      
         
      ilen = ilen - anzcount 
      if (if_type_fifo (array1) = 1) then
        read_Fast_Bus_LB_unpacked2(array1, array2, anzcount, 64070904h or shift_left(module, 20))
      else
        System_Array_Debug_Check(array1, iindex, anzcount)
        System_Array_Debug_Check(array2, iindex, anzcount)
        Read_Fast_Bus_LB_unpacked2(array1[iindex], array2[iindex], anzcount, 64070904h or shift_left(module, 20))
      endif
      
        
      iindex = iindex + anzcount
    until (ilen = 0)
  endif
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
'''module: module address (1..15)
'''count: number of values per channel
'''startadr: startadr. ram
'''array1[]: destination array channel 1
'''array2[]: destination array channel 2
'''array3[]: destination array channel 3
'''array4[]: destination array channel 4
'''array_start_index: start index at the destination array
'''flowrate: 
'''+         1->slow
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_Read_Unpacked4(module, count, startadr, array1[], array2[], array3[], array4[], array_start_index, flowrate)
  dim ilen as Long
  dim iindex as Long
  dim maxburst as Long
  dim anzcount as Long



  if (if_type_long (array1) = 1) then 
    CHECK_TYPE_LONG (array2[1])
    CHECK_TYPE_LONG (array3[1])
    CHECK_TYPE_LONG (array4[1])
  endif
  
  if (if_type_short (array1) = 1) then 
    CHECK_TYPE_SHORT (array2[1]) 
    CHECK_TYPE_SHORT (array3[1])
    CHECK_TYPE_SHORT (array4[1])
  endif

  if (if_type_float (array1) = 1) then 
    CHECK_TYPE_FLOAT (array2[1]) 
    CHECK_TYPE_FLOAT (array3[1])
    CHECK_TYPE_FLOAT (array4[1])
  endif

  if (if_type_float32 (array1) = 1) then 
    CHECK_TYPE_FLOAT32 (array2[1]) 
    CHECK_TYPE_FLOAT32 (array3[1])
    CHECK_TYPE_FLOAT32 (array4[1])
  endif
  
  
#IF DEBUG_MODE = ON THEN
  if (P2_Burst_Get_Channel_Count(module) <> 4) then PROZESS_FEHLER = 200110
#ENDIF


#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 16
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)

  POKE (60070850h OR shift_left(module, 20), startadr)           
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep' wait until FIFO empty
  
  ilen = (count AND 0FFFFFFFEH) * 2                         '/2
 
#IF DEBUG_MODE = ON THEN
  if (count AND 1 > 0) then PROZESS_FEHLER = 200125         ':2
  if (startadr AND 3 > 0) then PROZESS_FEHLER = 200120
#ENDIF
  iindex = array_start_index
  if (ilen > 0) then
    do
      
      anzcount = min_long(maxburst, ilen)
           
      ilen = ilen - anzcount 
      
      if (if_type_fifo (array1) = 1) then
        read_Fast_Bus_LB_unpacked4(array1, array2, array3, array4, anzcount, 64070904h or shift_left(module, 20))
      else
        System_Array_Debug_Check(array1, iindex, anzcount / 2)
        System_Array_Debug_Check(array2, iindex, anzcount / 2)
        System_Array_Debug_Check(array3, iindex, anzcount / 2)
        System_Array_Debug_Check(array4, iindex, anzcount / 2)
        Read_Fast_Bus_LB_unpacked4(array1[iindex], array2[iindex], array3[iindex], array4[iindex], anzcount, 64070904h or shift_left(module, 20))
      endif
      
      
      iindex = iindex + anzcount * 0.5
      
      
    until (ilen = 0)
  endif
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
'''count: number of values per channel
'''startadr: startadr. ram
'''ar1[]: destination array channel 1
'''ar2[]: destination array channel 2
'''ar3[]: destination array channel 3
'''ar4[]: destination array channel 4
'''ar5[]: destination array channel 5
'''ar6[]: destination array channel 6
'''ar7[]: destination array channel 7
'''ar8[]: destination array channel 8
'''array_start_index: start index at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_Read_Unpacked8(module, count, startadr, ar1[], ar2[], ar3[], ar4[], ar5[], ar6[], ar7[], ar8[], array_start_index, flowrate)
  dim ilen as Long
  dim iindex as Long
  dim maxburst as Long
  dim anzcount as Long



  if (if_type_long (ar1) = 1) then 
    CHECK_TYPE_LONG (ar2[1])
    CHECK_TYPE_LONG (ar3[1])
    CHECK_TYPE_LONG (ar4[1])
    CHECK_TYPE_LONG (ar5[1])
    CHECK_TYPE_LONG (ar6[1])
    CHECK_TYPE_LONG (ar7[1])
    CHECK_TYPE_LONG (ar8[1])
  endif
  
  if (if_type_short (ar1) = 1) then 
    CHECK_TYPE_SHORT (ar2[1])
    CHECK_TYPE_SHORT (ar3[1])
    CHECK_TYPE_SHORT (ar4[1]) 
    CHECK_TYPE_SHORT (ar5[1])
    CHECK_TYPE_SHORT (ar6[1])
    CHECK_TYPE_SHORT (ar7[1]) 
    CHECK_TYPE_SHORT (ar8[1])
  endif

  if (if_type_float (ar1) = 1) then 
    CHECK_TYPE_float (ar2[1])
    CHECK_TYPE_float (ar3[1])
    CHECK_TYPE_float (ar4[1]) 
    CHECK_TYPE_float (ar5[1])
    CHECK_TYPE_float (ar6[1])
    CHECK_TYPE_float (ar7[1]) 
    CHECK_TYPE_float (ar8[1])
  endif

  if (if_type_float32 (ar1) = 1) then 
    CHECK_TYPE_float32 (ar2[1])
    CHECK_TYPE_float32 (ar3[1])
    CHECK_TYPE_float32 (ar4[1]) 
    CHECK_TYPE_float32 (ar5[1])
    CHECK_TYPE_float32 (ar6[1])
    CHECK_TYPE_float32 (ar7[1]) 
    CHECK_TYPE_float32 (ar8[1])
  endif


#IF DEBUG_MODE = ON THEN
  if (P2_Burst_Get_Channel_Count(module) <> 8) then PROZESS_FEHLER = 200110
#ENDIF

#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 16
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)

  POKE (60070850h OR shift_left(module, 20), startadr)

            
  poke(syst_hw_nop, 4)                                      ' wait until FIFO empty
  ilen = count * 4
  iindex = array_start_index
#IF DEBUG_MODE = ON THEN
  if (startadr AND 3 > 0) then PROZESS_FEHLER = 200120
#ENDIF
  if (ilen > 0) then
    do
     
      anzcount = min_long(ilen, maxburst)
    
      
      ilen = ilen - anzcount                                '
      if (if_type_fifo (ar1) = 1) then
        read_Fast_Bus_LB_unpacked8(ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8, anzcount, 64070904h or shift_left(module, 20))
      else
        
        System_Array_Debug_Check(ar1, iindex, anzcount / 4)
        System_Array_Debug_Check(ar2, iindex, anzcount / 4)
        System_Array_Debug_Check(ar3, iindex, anzcount / 4)
        System_Array_Debug_Check(ar4, iindex, anzcount / 4)
        System_Array_Debug_Check(ar5, iindex, anzcount / 4)
        System_Array_Debug_Check(ar6, iindex, anzcount / 4)
        System_Array_Debug_Check(ar7, iindex, anzcount / 4)
        System_Array_Debug_Check(ar8, iindex, anzcount / 4)
        
        read_Fast_Bus_LB_unpacked8(ar1[iindex], ar2[iindex], ar3[iindex], ar4[iindex], ar5[iindex], ar6[iindex], ar7[iindex], ar8[iindex], anzcount, 64070904h or shift_left(module, 20))

      endif
      
      
      iindex = iindex + anzcount * 0.25
      
    until (ilen = 0)
  endif
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' count: number of values per channel
''' array[]: destination array
''' array_start_index: start index at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_CRead_Unpacked1(module, count, array[], array_start_index, flowrate)

  dim le as Long
  dim diff as Long

  dim startb[2] as Long 
  dim indexb[2] as Long
  dim status[4] as Long                                     '1 status, 2 start, 3 end, 4 aktuell
  dim leb[2] as Long
   
  
  dim intern_count as Long
  dim i as Long

  check_card(module)

  
  Read_Fast_Bus_SB(status[1], 4, 6B050604H OR shift_left(module, 20))
  
  
  le = count / 2                                            'Long word
  status[4] = status[4] - 4
  if (status[4] < status[2]) then status[4] = status[3] - 3
  diff = status[4] - le                                     'write pointer - count32
  if (diff >= status[2]) then                               'diff> start => no overflow
    intern_count = 1
    startb[1] = diff
    indexb[1] = array_start_index
    leb[1] = le
  else                                                      'overflow
    intern_count = 2
    leb[1] = status[2] - diff
    startb[1] = status[3] - leb[1] + 1
    indexb[1] = array_start_index

    leb[2] = le - leb[1]
    startb[2] = status[2]
    indexb[2] = array_start_index + leb[1] * 2
  endif
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED1(module, (leb[i] * 2), startb[i], array, indexb[i], flowrate)
  next
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' count: number of values per channel
''' array1[]: destination array low channel
''' array2[]: destination array high channel
''' array_start_index: start index at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_CRead_Unpacked2(module, count, array1[], array2[], array_start_index, flowrate)
  
  dim le as Long
  dim diff as Long
  dim intern_count as Long
  dim i as Long
  

  dim status[4] as Long                                     '1 status, 2 start, 3 end, 4 aktuell
  dim leb[2] as Long
  dim startb[2] as Long
  dim indexb[2] as Long

  
  check_card(module)
  
  Read_Fast_Bus_SB(status[1], 4, 6B050604H OR shift_left(module, 20))
  
  le = count                                                'Long word
  status[4] = status[4] - 4
  if (status[4] < status[2]) then status[4] = status[3] - 3
  diff = status[4] - le                                     'write pointer - count32
  if (diff >= status[2]) then                               'diff> start => no overflow
    intern_count = 1
    startb[1] = diff
    indexb[1] = array_start_index
    leb[1] = le
  else                                                      'overflow
    intern_count = 2
    leb[1] = status[2] - diff
    startb[1] = status[3] - leb[1] + 1
    indexb[1] = array_start_index
    leb[2] = le - leb[1]
    startb[2] = status[2]
    indexb[2] = array_start_index + leb[1]                  '*2
  endif
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED2(module, leb[i], startb[i], array1, array2, indexb[i], flowrate)
  next
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' count: number of values per channel
''' array1[]: destination array channel 1
''' array2[]: destination array channel 2
''' array3[]: destination array channel 3
''' array4[]: destination array channel 4
''' array_start_index: start index in the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_CRead_Unpacked4(module, count, array1[], array2[], array3[], array4[], array_start_index, flowrate)
  dim le as Long
  dim diff as Long

  dim intern_count as Long
  dim i as Long


  dim status[4] as Long                                     '1 status, 2 start, 3 end, 4 aktuell
  dim leb[2] as Long
  dim startb[2] as Long
  dim indexb[2] as Long


      
  check_card(module)
  
  Read_Fast_Bus_SB(status[1], 4, 6B050604H OR shift_left(module, 20))

  
  le = count                                                'Long word
  le = le * 2
  status[4] = status[4] - 4
  if (status[4] < status[2]) then status[4] = status[3] - 3
  diff = status[4] - le                                     'write pointer - count32
  if (diff >= status[2]) then                               'diff> start => no overflow
    intern_count = 1
    startb[1] = diff
    indexb[1] = array_start_index
    leb[1] = le
  else                                                      'overflow
    intern_count = 2
    leb[1] = status[2] - diff
    startb[1] = status[3] - leb[1] + 1
    indexb[1] = array_start_index
    leb[2] = le - leb[1]
    startb[2] = status[2]
    indexb[2] = array_start_index + leb[1] * 0.5
  endif
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED4(module, (leb[i] / 2), startb[i], array1, array2, array3, array4, indexb[i], flowrate)
  next
ENDSUB


'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' count: number of values per channel
''' ar1[]: destination array channel 1
''' ar2[]: destination array channel 2
''' ar3[]: destination array channel 3
''' ar4[]: destination array channel 4
''' ar5[]: destination array channel 5
''' ar6[]: destination array channel 6
''' ar7[]: destination array channel 7
''' ar8[]: destination array channel 8
''' array_start_index: start index in the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_Burst_CRead_Unpacked8(module, count, ar1[], ar2[], ar3[], ar4[], ar5[], ar6[], ar7[], ar8[], array_start_index, flowrate)

  dim le as Long
  dim diff as Long
  dim intern_count as Long
  dim i as Long
  

  dim status[4] as Long                                     '1 status, 2 start, 3 end, 4 aktuell
  dim leb[2] as Long
  dim startb[2] as Long
  dim indexb[2] as Long

  
  check_card(module)

  Read_Fast_Bus_SB(status[1], 4, 6B050604H OR shift_left(module, 20))
 
  le = count                                                'Long word
  le = le * 4
  status[4] = status[4] - 4
  if (status[4] < status[2]) then status[4] = status[3] - 3
  diff = status[4] - le                                     'write pointer - count32
  if (diff >= status[2]) then                               'diff> start => no overflow
    intern_count = 1
    startb[1] = diff
    indexb[1] = array_start_index
    leb[1] = le
  else                                                      'overflow
    intern_count = 2
    leb[1] = status[2] - diff
    startb[1] = status[3] - leb[1] + 1
    indexb[1] = array_start_index
    leb[2] = le - leb[1]
    startb[2] = status[2]
    indexb[2] = array_start_index + leb[1] * 0.25
  endif
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED8(module, (leb[i] / 4), startb[i], ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8, indexb[i], flowrate)
  next
ENDSUB

'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' buffer_start: startadr ram
''' buffer_count: length per channel
''' count: number of values
''' startadr: startadr. ram
''' array[]: destination array
''' array_start_index: start index at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
sub P2_Burst_CRead_Pos_Unpacked1(module, buffer_start, buffer_count, count, startadr, array[], array_start_index, flowrate)
  dim le as Long
  dim diff as Long
  dim intern_count as Long
  dim i as Long
  dim endadr as long

  dim lel[2] as Long 
  dim startb[2] as Long 
  dim indexb[2] as Long 


  le = count / 2                                            '4,2,1,0.5  'lnge in long
  endadr = buffer_start + buffer_count / 2                  '4,2,1,0.5    
  diff = endadr - (startadr + le)                           '
  
  if (diff >= 0) then                                       'kein berlauf
    intern_count = 1
    startb[1] = startadr
    indexb[1] = array_start_index
    lel[1] = le
  else                                                      'overflow
    intern_count = 2
    lel[1] = endadr - startadr
    startb[1] = startadr
    indexb[1] = array_start_index
    lel[2] = le - lel[1]
    startb[2] = buffer_start
    indexb[2] = array_start_index + lel[1] * 2              '  
  endif
  
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED1(module, (lel[i] * 2), startb[i], array, indexb[i], flowrate)
  next
  
endsub

'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address  (1..15)
''' buffer_start: startadr ram
''' buffer_count: length per channel
''' count: number of values per channel
''' startadr: startadr. ram
''' array1[]: destination array low channel
''' array2[]: destination array high channel
''' ar_start: start index at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
sub P2_Burst_CRead_Pos_Unpacked2(module, buffer_start, buffer_count, count, startadr, array1[], array2[], ar_start, flowrate)
  dim le as Long
  dim diff as Long
  

  dim lel[2] as Long 
  dim startb[2] as Long 
  dim indexb[2] as Long 

  
  dim intern_count as Long
  dim i as Long
  dim endadr as long
  
  check_card(module)    
  le = count                                                '4,2,1,0.5  'lnge in long
  endadr = buffer_start + buffer_count                      '4,2,1,0.5

  diff = endadr - (startadr + le)                           '
  
  if (diff >= 0) then                                       'kein berlauf
    intern_count = 1
    startb[1] = startadr
    indexb[1] = ar_start
    lel[1] = le
  else                                                      'overflow
    intern_count = 2
    lel[1] = endadr - startadr
    startb[1] = startadr
    indexb[1] = ar_start
    
    lel[2] = le - lel[1]
    startb[2] = buffer_start
    indexb[2] = ar_start + lel[1]                           '  
  endif
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED2(module, (lel[i]), startb[i], array1, array2, indexb[i], flowrate)
  next
  
endsub

'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' buffer_start: startadr ram
''' buffer_count: length per channel
''' count: number of values per channel
''' startadr: startadr. ram
''' array1[]: destination array channel 1
''' array2[]: destination array channel 2
''' array3[]: destination array channel 3
''' array4[]: destination array channel 4
''' ar_start: start index at the destination array
'''flowrate: 
'''+         1->slow
'''+         2->medium
'''+         3->fast
'''******************************************************************************
sub P2_Burst_CRead_pos_Unpacked4(module, buffer_start, buffer_count, count, startadr, array1[], array2[], array3[], array4[], ar_start, flowrate)
  dim le as Long
  dim diff as Long
  
  

  dim lel[2] as Long 
  dim startb[2] as Long 
  dim indexb[2] as Long 

  
  dim intern_count as Long
  dim i as Long
  dim endadr as long

  le = count * 2                                            '4,2,1,0.5  'lnge in long  
  endadr = buffer_start + buffer_count * 2                  '4,2,1,0.5
  diff = endadr - (startadr + le)                           '
  
  if (diff >= 0) then                                       'kein berlauf
    intern_count = 1
    startb[1] = startadr
    indexb[1] = ar_start
    lel[1] = le
  else                                                      'overflow
    intern_count = 2
    lel[1] = endadr - startadr
    startb[1] = startadr
    indexb[1] = ar_start
    
    lel[2] = le - lel[1]
    startb[2] = buffer_start
    indexb[2] = ar_start + lel[1] / 2                       '  
  endif
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED4(module, (lel[i] / 2), startb[i], array1, array2, array3, array4, indexb[i], flowrate)
  next
endsub

'******************************************************************************
''' Transfers the input data to an array and unpacked
''' module: module address (1..15)
''' buffer_start: startadr ram
''' buffer_count: length per channel
''' count: number of values per channel
''' startadr: startadr. ram
''' ar1[]: destination array channel 1
''' ar2[]: destination array channel 2
''' ar3[]: destination array channel 3
''' ar4[]: destination array channel 4
''' ar5[]: destination array channel 5
''' ar6[]: destination array channel 6
''' ar7[]: destination array channel 7
''' ar8[]: destination array channel 8
''' ar_start: start index at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
sub P2_Burst_CRead_Pos_Unpacked8(module, buffer_start, buffer_count, count, startadr, ar1[], ar2[], ar3[], ar4[], ar5[], ar6[], ar7[], ar8[], ar_start, flowrate)
  dim le as Long
  dim diff as Long
  

  dim lel[2] as Long 
  dim startb[2] as Long 
  dim indexb[2] as Long 


  
  
  dim intern_count as Long
  dim i as Long
  dim endadr as long
  
  le = count * 4                                            '4,2,1,0.5 
  endadr = buffer_start + buffer_count * 4                  '4,2,1,0.5
  diff = endadr - (startadr + le)                           ' 
  
  if (diff >= 0) then                                       '
    intern_count = 1
    startb[1] = startadr
    indexb[1] = ar_start
    lel[1] = le
  else                                                      'overflow
    intern_count = 2
    lel[1] = endadr - startadr
    startb[1] = startadr
    indexb[1] = ar_start
    
    lel[2] = le - lel[1]
    startb[2] = buffer_start
    indexb[2] = ar_start + lel[1] / 4                       ' 
  endif
  
  for i = 1 to intern_count
    P2_BURST_READ_UNPACKED8(module, (lel[i] / 4), startb[i], ar1, ar2, ar3, ar4, ar5, ar6, ar7, ar8, indexb[i], flowrate)
  next

endsub


'return: count of select channel
Function P2_Burst_Get_Channel_Count(module) as long         '<HIDE>
  dim ch_count, i, channels as long 
  check_card(module)
 
  channels = Peek_P2 (68050640h OR shift_left(module, 20))
 
  ch_count = 0
  for i = 0 to 7
    if (channels AND (Shift_left(1, i)) > 0) then inc ch_count
  next
  if (channels = 131) then ch_count = 2
  if (channels = 143) then ch_count = 4
  if (channels = 127) then ch_count = 8
  P2_Burst_Get_Channel_Count = ch_count
ENDFunction


'<ENDREGION>

'<REGION> ADC MUX

'******************************************************************************
''' Starts conversion of ADC.
''' module: module address (1..15)
'''******************************************************************************
SUB P2_Start_Conv(module)
  check_card(module)
  POKE (60070000h OR shift_left(module, 20), 1) 
ENDSUB


'******************************************************************************
''' Waits until EOC-signal goes active (End Of Conversion).
''' module: module address (1..15)
'''******************************************************************************
SUB P2_Wait_EOC(module)
  DIM reminder AS Long
  
  check_card(module)
  DO 
    reminder = Peek_P2 (60070100h OR shift_left(module, 20))
  UNTIL ((reminder AND 1) = 0)
ENDSUB


'******************************************************************************
''' Selects single-ended (s.e.) or differential (diff.) inputs.
'''+ for the AIN-32/18-module only.
''' module: module address (1..15)
''' mode: s.e. -> 0, diff. -> 1 (default)
'''****************************************************************************
SUB P2_SE_Diff(module, mode)
  check_card(module)
  POKE (68050120h OR shift_left(module, 20), mode) 
ENDSUB


'******************************************************************************
''' Sets mux to desired input channel.
''' module: module address (1..15)
''' pattern: bit 9 & 8 -> gain, bit 4...0 -> channel 1..32
'''******************************************************************************
SUB P2_Set_Mux(module, pattern)
  check_card(module)
  POKE (68050100h OR shift_left(module, 20), pattern) 
ENDSUB

'********************************************************************************
''' Waits the difference time between the last change of multiplexer and required time of the multiplexer.
'''+The required time can be set with P2_Seq_Init.
'''module: module address (1..15)
'''******************************************************************************
SUB P2_Wait_Mux(module)
  DIM muxtime AS Long

  check_card(module)
  '............ wait multiplexer settling time ........
  muxtime = Peek_P2 (68050220h OR shift_left(module, 20))   ' step 20 ns
  
  if ((muxtime > 6) AND (muxtime < 12345678H)) then
    P2_SLEEP(shift_left(muxtime, 1))
  endif

ENDSUB


'******************************************************************************
''' Returns conversion result of ADC.
'''+ result: 16 bit Long
''' module: module address (1..15)
'''******************************************************************************
FUNCTION P2_Read_ADC(module) AS Long
  check_card(module)  
  P2_READ_ADC = Peek_P2 (60002000h OR shift_left(module, 20))
ENDFUNCTION


'******************************************************************************
''' Returns conversion result of ADC.
'''+ result: 24 bit Long
''' module: module address (1..15)
'''******************************************************************************
FUNCTION P2_Read_ADC24(module) AS Long
  check_card(module)
  P2_READ_ADC24 = Peek_P2 (60000000h OR shift_left(module, 20))
ENDFUNCTION


'******************************************************************************
''' Samples, converts and reads out the digital ADC-value of an
'''+ analog input.
'''+  Attention:                                                                
'''+  This instruction is not prepared to handle an access from                 
'''+  a low AND high priority process to the same module.       
'''+ result: 16 bit Long         
''' module: module address (1..15)
''' adc_no: channel number of analog input
'''******************************************************************************
FUNCTION P2_ADC(module, adc_no) AS Long
  DIM reminder AS Long
  DIM muxtime AS Long

  '............ set MUX ............
  check_card(module)
  POKE (68050100h OR shift_left(module, 20), adc_no - 1) 

  '............ wait multiplexer settling time ........
  muxtime = Peek_P2 (68050220h OR shift_left(module, 20))   ' step 20 ns

  if ((muxtime > 6) AND (muxtime < 12345678H)) then
    P2_SLEEP(shift_left(muxtime, 1))
  endif

  '............ start conversion ............
  POKE (60070000h OR shift_left(module, 20), 1) 
  
  '............ wait EOC ............
  do
    reminder = Peek_P2 (60070100h OR shift_left(module, 20))
  until ((reminder AND 1) = 0)

  '............ read out result ............
  p2_ADC = Peek_P2 (60002000h OR shift_left(module, 20))
  
ENDFUNCTION


'******************************************************************************
''' Samples, converts and reads out the digital ADC-value of an
'''+ analog input.
'''+ result: 24 bit Long
'''+ Attention:                                                                
'''+ This instruction is not prepared to handle an access from                 
'''+ a low AND high priority process to the same module.                       
''' module: module address (1..15)
''' adc_no: channel number of analog input
'''******************************************************************************
FUNCTION P2_ADC24(module, adc_no) AS Long
  DIM reminder AS Long
  DIM muxtime AS Long

  '............ set MUX ............
  check_card(module)
  POKE (68050100h OR shift_left(module, 20), adc_no - 1) 

  '............ wait multiplexer settling time ........
  muxtime = Peek_P2 (68050220h OR shift_left(module, 20))   'wait depending on hardware

  if ((muxtime > 6) AND (muxtime < 12345678H)) then
    P2_SLEEP(shift_left(muxtime, 1))
  endif

  '............ start conversion ............
  POKE (60070000h OR shift_left(module, 20), 1) 

  '............ wait EOC ............
  do
    reminder = Peek_P2 (60070100h OR shift_left(module, 20))
  until ((reminder AND 1) = 0)

  '............ read out result ............
  P2_ADC24 = Peek_P2 (60000000h OR shift_left(module, 20))
ENDFUNCTION


'******************************************************************************
''' Returns conversion result of ADC and immediately starts a new conversion.
'''+ result: 16 bit Long
''' module: module address (1..15)
'''******************************************************************************
FUNCTION P2_Read_ADC_SConv(module) AS Long
  check_card(module)
  P2_Read_ADC_SConv = Peek_P2 (60003000h OR shift_left(module, 20))
ENDFUNCTION


'******************************************************************************
''' Returns conversion result of ADC and immediately starts a new conversion.
'''+ result: 24 bit Long
''' module: module address (1..15) 
'''******************************************************************************
FUNCTION P2_Read_ADC_SConv24(module) AS Long
  check_card(module)
  P2_Read_ADC_SConv24 = Peek_P2 (60001000h OR shift_left(module, 20))
ENDFUNCTION


'******************************************************************************
''' Transfers the input data to an array (16 Bit Long)
''' module: module address (1..15)
''' length: number of values (only even-numbered)
''' array[]: destination array
''' index: start index at the destination array
'''******************************************************************************
SUB P2_Seq_Read(module, length, array[], index)

  check_card(module)
  
#IF DEBUG_MODE = ON THEN
  if ((length AND 1) > 0) then 
    PROZESS_FEHLER = 201000
  endif
#endif
  
  IF (length > 1) then

    System_Array_Debug_Check(array, index, length)
    IF (length > 9) THEN
    
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_LB_unpacked1(array, shift_right(length, 1), 64004004H OR shift_left(module, 20))
      else
        Read_Fast_Bus_LB_unpacked1(array[index], shift_right(length, 1), 64004004H OR shift_left(module, 20))
      endif
      
        
    ELSE                                                    '
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_SB_unpacked1(array, shift_right(length, 1), 60004004H OR shift_left(module, 20) or shift_Left((length) - 2, 23))
      else
        Read_Fast_Bus_SB_unpacked1(array[index], shift_right(length, 1), 60004004H OR shift_left(module, 20) or shift_Left((length) - 2, 23))
      endif
      
    ENDIF 

  ENDIF
ENDSUB


'******************************************************************************
''' Transfers the input data to an array (32 Bit Long).
''' module: module address (1..15)
''' length: number of values / 2
''' array[]: destination array
''' index: start index at the destination array
'''******************************************************************************
SUB P2_Seq_Read_Packed(module, length, array[], index)
  CHECK_TYPE_LONG (array[1])
  check_card(module)
  System_Array_Debug_Check(array, index, length)
  IF (length > 0) then
    IF (length > 4) THEN
    
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_LB(array, length, 64004004H OR shift_left(module, 20))
      else
        Read_Fast_Bus_LB(array[index], length, 64004004H OR shift_left(module, 20))
      endif
      
    ELSE                                                    '
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_SB(array, length, 60004004H OR shift_left(module, 20) or shift_Left(length - 1, 24))
      else
        Read_Fast_Bus_SB(array[index], length, 60004004H OR shift_left(module, 20) or shift_Left(length - 1, 24))
      endif
      
    ENDIF
  ENDIF
ENDSUB


'******************************************************************************
''' Transfers the input data to an array (24 Bit Long).
''' module: module address (1..15)
''' length: number of values
''' array[]: destination array
''' index: start index at the destination array
'''******************************************************************************
SUB P2_Seq_Read24(module, length, array[], index)
  CHECK_TYPE_LONG (array[1])
  check_card(module)
  IF (length > 0) then
    System_Array_Debug_Check(array, index, length)
    IF (length > 4) THEN
    
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_LB(array, length, 64000004H OR shift_left(module, 20))
      else
        Read_Fast_Bus_LB(array[index], length, 64000004H OR shift_left(module, 20))
      endif
      
    ELSE
     
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_SB(array, length, shift_Left(length - 1, 24) OR shift_left(module, 20) or 60000004H)
      else 
        Read_Fast_Bus_SB(array[index], length, shift_Left(length - 1, 24) OR shift_left(module, 20) or 60000004H)
      endif
    ENDIF
  ENDIF
ENDSUB


'******************************************************************************
''' Initializes the sequential control.
''' module: module address (1..15)
''' mode:
'''+     0->normal mode
'''+     1->single shot mode
'''+     2->continuous mode event delay
'''+     3->continuous mode max speed
''' gain:
'''+     0->range -10 V -> +10 V
'''+     1->range -5V   -> + 5 V
'''+     2->range -2.5V -> + 2.5 V
'''+     3->range -1.25 -> + 1.25 V
''' channel: selected channels in binary
''' mux_time: Number of time units, which sets the settling time of the sequential control:
'''+     0: Standard waiting time (125 = 2.5 s)
'''+     1252^31: Waiting time in units of 20 ns.
'''******************************************************************************
SUB P2_Seq_Init(module, mode, gain, channel, mux_time)
  dim i as Long
  dim anz as Long
  dim delay as Long
  dim imux as Long
  dim startdelay as Long

  dim modulcode as long


  check_card(module)
  anz = 0
  for i = 0 to 31
    if (shift_left(1, i) AND channel > 0) then inc anz
  next

  POKE (60070200h OR shift_left(module, 20), 0)             'stop
  P2_SET_MUX(module, shift_left(gain, 8))                   'gain  
  POKE (68050450h OR shift_left(module, 20), channel)       'channel
  POKE (68050300h OR shift_left(module, 20), 20) 

  if (mux_time <> 0) then
   
    imux = mux_time
  else
    modulcode = Peek_P2 (68000400h OR shift_left(module, 20))

    if ((modulcode = 10240) or (modulcode = 10241)) then    'mio-4
      imux = 250                                            '5   s
    else
      imux = 125                                            '2, 5 s
    endif
       
  endif
  
  POKE (68050200h OR shift_left(module, 20), imux)
  
  if (mode = 2) then 
    startdelay = globaldelay - ((anz * imux * 20) + 2310)   'globaldelay does not work in lib
    if (startdelay < 0) then startdelay = 0
  else
    startdelay = 0
  endif
  
  p2_sleep(70)


  if (mode = 3) then
    POKE (68050350h OR shift_left(module, 20), 0)
    POKE (68050400h OR shift_left(module, 20), 0)
    POKE (60070200h OR shift_left(module, 20), 3)           'continous
  else
    POKE (68050350h OR shift_left(module, 20), startdelay / 20) 
    POKE (68050400h OR shift_left(module, 20), processdelay)
    
    
    if (mode = 2) then
      POKE (60070200h OR shift_left(module, 20), 3)         'mode
      i = Peek_P2 (68040000h OR shift_left(module, 20))
    else
      POKE (60070200h OR shift_left(module, 20), mode)      'mode
    endif
  endif

ENDSUB


'******************************************************************************
''' Starts SEQ-Mode.
''' module_pattern: bit pattern to set the module adresses
'''******************************************************************************
SUB P2_Seq_Start(module_pattern))    
  POKE (68010100h, module_pattern)
ENDSUB


'******************************************************************************
''' Waits until the sequence control has converted and stored all channels of the channel group on the specified module.
''' module: module address (1..15)
'''******************************************************************************
SUB P2_Seq_Wait(module)
  DIM reminder AS Long

  check_card(module)
  poke(syst_hw_nop, 0) 
  DO
    reminder = Peek_P2 (60070100h OR shift_left(module, 20))
  UNTIL ((reminder AND 1) = 0)
ENDSUB


'******************************************************************************
''' Gets ADC_Read_Limit.
''' module: module address (1..15)
''' nr: 
'''+     1->READ LIMIT channel 1..16
'''+     2->READ LIMIT channel 17..32
'''******************************************************************************
FUNCTION P2_ADC_Read_Limit(module, nr) AS Long
  check_card(module)
  P2_ADC_READ_LIMIT = Peek_P2 ((600702E0h + (nr) * 32) OR shift_left(module, 20))
ENDFUNCTION


'******************************************************************************
''' Sets the upper and lower limit for one F-ADC of the specified module.
''' module: module address (1..15)
''' channel: channel (1..32)
''' valuehigh: switch point to set limit overflow bit to 1
''' valuelow: switch point to set limit underflow bit to 1
'''******************************************************************************
SUB P2_ADC_Set_Limit(module, channel, valuehigh, valuelow)
  check_card(module)
  POKE (68055FF0h + ((channel) * 16) OR shift_left(module, 20), valueHigh)
  POKE (68054FF0h + ((channel) * 16) OR shift_left(module, 20), valueLow)
ENDSUB

'<ENDREGION>

'<REGION> DAC

'********************************** DAC ***************************************
''' Converts the digitial value to an analog output.
''' module: module address (1..15)
''' dac_no: channel number of analog output (1..8)
''' value:  output value (0..65535)
'''******************************************************************************
SUB P2_DAC(module, dac_no, value)
  check_card(module)
  POKE ((60022FF0h + (dac_no) * 16) OR shift_left(module, 20), value) 
ENDSUB

'********************************** DAC ***************************************
''' Converts the digitial value to an analog output 1 and dioout  Bit (16..31).
''' module: module address (1..15)
''' value:  
'''+ Bit (0..15) output value (0..65535)
'''+ Bit (16..31) dio value (channel 16..31)
'''******************************************************************************
SUB P2_DAC1_DIO(module, value)
  check_card(module)
  POKE (60026100h OR shift_left(module, 20), value) 
ENDSUB


'******************************************************************************
''' Transfers the output data from array to DAC 1..4
''' module: module address (1..15)
''' array[]: source array
''' index: start index in the source array
'''******************************************************************************
SUB P2_DAC4(module, array[], index)
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB_packed(array, 2, 61025000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 4)
    Write_Fast_Bus_SB_packed(array[index], 2, 61025000h OR shift_left(module, 20))
  endif
ENDSUB


'******************************************************************************
''' Transfers the output data from array to DAC 1..8
''' module: module address (1..15)
''' array[]: source array
''' index: start index in the source array
'''******************************************************************************
SUB P2_DAC8(module, array[], index)
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB_packed(array, 4, 63025000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 8)
    Write_Fast_Bus_SB_packed(array[index], 4, 63025000h OR shift_left(module, 20))
  endif
ENDSUB


'******************************************************************************
''' Sets DAC-register to desired value.
''' module: module address (1..15)
''' dac_no: channel number of analog output (1..8)
''' value:  output value (0..65535)
'''******************************************************************************
SUB P2_Write_DAC(module, dac_no, value)
  check_card(module)
  POKE ((60021FF0h + (dac_no) * 16) OR shift_left(module, 20), value) 
ENDSUB


' *****************************************************************************
''' Sets DAC-register to desired value.
''' module: module address (1..15)
''' dac_no: 
'''+         0->Channel 1 and 2
'''+         1->Channel 3 and 4
'''+         2->Channel 5 and 6
'''+         3->Channel 7 and 8
''' value: output value 32Bit
'''******************************************************************************
SUB P2_Write_DAC32(module, dac_no, value)
  check_card(module)
  POKE ((60024000h + (dac_no) * 16) OR shift_left(module, 20), value) 
ENDSUB


'******************************************************************************
''' Transfers the output data from array 16 Bit to DAC-register 1..4
''' module: module address (1..15)
''' array:  source array
''' index:  start index at the source array
'''******************************************************************************
SUB P2_Write_DAC4(module, array[], index)
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB_packed(array, 2, 61024000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 4)
    Write_Fast_Bus_SB_packed(array[index], 2, 61024000h OR shift_left(module, 20))
  endif
ENDSUB


'******************************************************************************
''' Transfers the output data from array 16 Bit to DAC-register 1..8
''' module: module address (1..15)
''' array[]: source array long or short
''' index: start index at the source array
'''******************************************************************************
SUB P2_Write_DAC8(module, array[], index)
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB_packed(array, 4, 63024000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 8)  
    Write_Fast_Bus_SB_packed(array[index], 4, 63024000h OR shift_left(module, 20))
  endif
  
ENDSUB


'******************************************************************************
''' Transfers the output data from array 32 Bit to DAC-register 1..4
''' module: module address (1..15)
''' array[]: source array long
''' index: start index at the source array
'''******************************************************************************
SUB P2_Write_DAC4_Packed(module, array[], index)
  CHECK_TYPE_LONG (array[1])
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB(array, 2, 61024000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 2) 
    Write_Fast_Bus_SB(array[index], 2, 61024000h OR shift_left(module, 20))
  endif
ENDSUB


'******************************************************************************
''' Transfers the output data from array 32 Bit to DAC-register 1..8
''' module: module address (1..15)
''' array[]: source array long
''' index: start index at the source array
'''******************************************************************************
SUB P2_Write_DAC8_Packed(module, array[], index)
  CHECK_TYPE_LONG (array[1])
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB(array, 4, 63024000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 4)
    Write_Fast_Bus_SB(array[index], 4, 63024000h OR shift_left(module, 20))
  endif
ENDSUB


'******************************************************************************
''' Transfers the output data from array 32 Bit to DAC-register 1..4
''' module: module address (1..15)
''' array[]: source array [long]
''' index: start index at the source array
'''******************************************************************************
SUB P2_DAC4_Packed(module, array[], index)
  CHECK_TYPE_LONG (array[1]) 
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB(array, 2, 61025000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 2)  
    Write_Fast_Bus_SB(array[index], 2, 61025000h OR shift_left(module, 20))
  endif
ENDSUB


'******************************************************************************
''' Transfers the output data from array 32 Bit to DAC-register 1..8
''' module: module address (1..15)
''' array[]: source array [long]
''' index: start index at the source array
'''******************************************************************************
SUB P2_DAC8_Packed(module, array[], index)
  CHECK_TYPE_LONG (array[1])
  check_card(module)
  if (if_type_fifo (array) = 1) then
    Write_Fast_Bus_SB(array, 4, 63025000h OR shift_left(module, 20))
  else
    System_Array_Debug_Check(array, index, 4)  
    Write_Fast_Bus_SB(array[index], 4, 63025000h OR shift_left(module, 20))
  endif
ENDSUB


'********************************************************************************
''' Simultaneously starts conversion of all DACs on this module.
''' module: module address (1..15)
'''******************************************************************************
SUB P2_Start_DAC(module)
  check_card(module)
  POKE (60070020h OR shift_left(module, 20), 0)
ENDSUB


* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
''' Transfers the output data and starts ramp mode.
'''+before use: use P2_DAC_Ramp_BufferFree to check if buffer is free
'''+ramp stops automatically at the end if no new data is given
''' module: module address (1..15)
''' channel: 1
''' start_dac: start value 0..65535 of DAC ramp
''' end_dac: end value 0..65535 of DAC ramp
''' dio_start: 0000 xxxx H .. FFFFxxxx H; bits 16..31 represent dig. channel 16..31
''' dio_end:   0000 xxxx H .. FFFFxxxx H; bits 16..31 represent dig. channel 16..31
''' time: DAC ramp length in ns (20, 40, .. 65520)
''' flags: bit pattern to select output mode
'''+ bit 1 output DAC ramp
'''+ bit 2 output digital value dio_start
'''+ bit 3 output digital value dio_end
'''******************************************************************************
SUB P2_DAC_Ramp_Write(module, channel, start_dac, end_dac, dio_start, dio_end, time, flags)


  dim int[4] as long 

 
  dim ts as long 
  dim ti as long
  dim ds, de as long
  check_card(module)
  
  ti = ((time) / 20)
  if (ti < 1) then ti = 1
  
  ds = start_Dac AND 0FFFFH
  de = end_DAC AND 0FFFFH
  
  int[1] = ds or (dio_start And 0FFFF0000H)
  int[2] = de or (dio_end And 0FFFF0000H)
  
  
  if (ds = de) then                                         '=
    int[3] = ti
  else
    if (ds < de) then                                       '+
      ts = (((de - ds) * 16384.0)) / ti  
      if (ts < 1) then ts = 1 
      int[3] = ts
    else                                                    '-
      ts = (((ds - de) * 16384.0)) / ti
      if (ts < 1) then ts = 1 
      int[3] = -ts
    endif 
  endif
  
  
  int[4] = flags
      
  Write_Fast_Bus_SB(int[1], 4, (6B021FF0h + shift_left(channel, 4)) or (shift_left(module, 20)))
  
  poke(syst_hw_nop, 1)                                      '20 ns bus sleep
ENDSUB


* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
''' Gets ramp status.
'''+ <>0 running 
'''+ 0 stop
''' module: module address (1..15)
''' channel: 1 
'''******************************************************************************
Function P2_DAC_Ramp_Status(module, channel) as long 
  P2_DAC_Ramp_STATUS = Peek_P2 ((60025FF0h + (channel) * 16) OR shift_left(module, 20))
  P2_DAC_Ramp_STATUS = P2_DAC_Ramp_STATUS AND 111B
ENDFUNCTION


'********************************************************************************
''' Checks if buffer free.
'''+ >=0 free
'''+ <0 not free
''' module: module address (1..15)
''' channel: 1
'''******************************************************************************
Function P2_DAC_Ramp_Buffer_Free(module, channel) as long
  P2_DAC_Ramp_Buffer_Free = Peek_P2 ((60025FF0h + (channel) * 16) OR shift_left(module, 20))
ENDFUNCTION


'********************************************************************************
''' Stops Ramp mode.
''' module: module address (1..15)
''' channel: 1
'''******************************************************************************
SUB P2_DAC_Ramp_Stop(module, channel)
  POKE ((60025FF0h + (channel) * 16) OR shift_left(module, 20), 1)
endsub

'<ENDREGION>

'<REGION> Serial Interface

'***********************************************
''' Sets a register of the serial controller.
''' module: module address (1..15)
''' register_no: register on the serial controller
''' value: value for the selected register
'''***********************************************
sub P2_Set_RS(module, register_no, value)
  CHECK_CARD(module)
  POKE (60000000h OR (shift_left((register_no) + 200H, 4)) OR shift_left(module, 20), value) 
  poke(syst_hw_nop, 8)                                      '80 ns bus sleep
endsub


'***********************************************
''' Reads the value of a register of the serial controller.
''' module: module address (1..15)
''' register_no: register on the serial controller
'''**********************************************
FUNCTION P2_Get_RS(module, register_no) AS Long
  CHECK_CARD(module)

  SUB_BEGIN_CRITICAL_SECTION
  POKE (60000000h OR shift_left(module, 20), register_no)
  poke(syst_hw_nop, 8)                                      '80 ns bus sleep
  P2_GET_RS = Peek_P2 (60000100h OR shift_left(module, 20))
  SUB_END_CRITICAL_SECTION
ENDFUNCTION


'******************************************************************
'''Initializes a serial interface.
'''module: module address (1..15)
'''channel: number of the serial interface
'''Baud_rate: Baudrate for the serial comunication
'''+ 2304000
'''+ 1152000
'''+  460800
'''+  230400
'''+  115200
'''+   57600
'''+   38400
'''+   19200
'''+    9600
'''+    4800
'''+    2400
'''+    1200
'''+     600
'''+     300
'''parity:     
'''+             0->no parity
'''+             1->even
'''+             2->odd
'''word_length: Number of databits for the serial comunication (5..8)
'''stop_bits:   
'''+             0->1 Stopbit
'''+             1->1, 5 Stopbits by using 5 Databits
'''+             1->2 Stopbits by using 6.7 or 8 Databits
'''handshake:   
'''+             0->RS-232 no handshake
'''+             1->RS-232 Hardware handshake (RTS/CTS)
'''+             2->RS-232 Software handshake (Xon/Xoff)
'''+             3->RS-485 no handshake
'''+             4->RS-422 no handshake (for RS 422 Modul only)
'''+             6->RS-422 Software handshake (Xon/Xoff) (for RS 422 Modul only)
'''******************************************************************
sub P2_RS_Init(module, channel, Baud_rate, parity, word_length, stop_bits, handshake)
  dim offset as Long                                        ' offset for the selected serial interface
  dim divisor as Long                                       ' value by which the external clock has to be divided to get the selected baudrate
  dim DLL_value as Long                                     ' value for the DLL register
  dim DLH_value as Long                                     ' value for the DLH register
  dim LCR_value as Long                                     ' value for the LCR register

  CHECK_CARD(module)
  offset = (channel - 1) * 8

  if (Handshake > 2) then                                   'rs485
    POKE (60000000h OR ((channel + 21H) * 16) OR shift_left(module, 20), 1)  'rs 485 
  else                                                      'rs232
    POKE (60000000h OR ((channel + 21H) * 16) OR shift_left(module, 20), 0)  'rs 232 
  endif

  divisor = (36864000) / (Baud_rate * 16)                   ' calculates the the divider for the external clock
  DLL_value = divisor and 0ffh                              ' value for the DLL register
  DLH_value = shift_right((divisor and 0ff00h), 8)          ' value for the DLH register

  LCR_value = word_length - 5
  LCR_value = LCR_value or shift_left(stop_bits, 2)
  if (parity = 1) then LCR_value = LCR_value or 011000b
  if (parity = 2) then LCR_value = LCR_value or 001000b     'value for the LCR register

  P2_set_rs(module, offset + 3, 080h)                       ' LCR-bit7=1    Divisor latch enable
  p2_set_rs(module, offset + 0, DLL_value)                  ' DLL-reg               setting baudrate
  p2_set_rs(module, offset + 1, DLH_value)                  ' DLH-reg               setting baudrate
  p2_set_rs(module, offset + 3, (0bfh))                     ' LCR-reg               Enhanced feature reg enable
  p2_set_rs(module, offset + 4, 011h)                       ' setting character for softwarehandshake Xon1
  p2_set_rs(module, offset + 5, 012h)                       ' setting character for softwarehandshake Xon2
  p2_set_rs(module, offset + 6, 013h)                       ' setting character for softwarehandshake Xoff1
  p2_set_rs(module, offset + 7, 014h)                       ' setting character for softwarehandshake Xoff2
  if (handshake = 0) then
    p2_set_rs(module, offset + 2, 010h)                     ' EFR-reg no handshake(RS232) + enhanced functions enabled
  endif
  if (handshake = 1) then
    p2_set_rs(module, offset + 2, 0d0h)                     ' EFR-reg hardwarehandshake(RS232) + enhanced functions enabled
  endif
  if (handshake = 2) then
    p2_set_rs(module, offset + 2, 01ah)                     ' EFR-reg softwarehandshake(RS232) (Xon1/Xoff1) + enhanced functions enabled
  endif
  if (handshake = 3) then
    p2_set_rs(module, offset + 2, 010h)                     ' EFR-reg               no handshake (RS485) + enhanced functions enabled
  endif
  
  if (handshake = 4) then
    p2_set_rs(module, offset + 2, 010h)                     ' EFR-reg no handshake(RS232) + enhanced functions enabled
    POKE (60000000h OR ((channel + 25H) * 16) OR shift_left(module, 20), 2)  '
  endif
  
  if (handshake = 6) then
    p2_set_rs(module, offset + 2, 01ah)                     ' EFR-reg softwarehandshake(RS232) (Xon1/Xoff1) + enhanced functions enabled
    POKE (60000000h OR ((channel + 25H) * 16) OR shift_left(module, 20), 2) 
  endif

    
  p2_set_rs(module, offset + 3, LCR_value)                  ' LCR-reg               Divisor latch disable; 8 Databits
  p2_set_rs(module, offset + 4, 040h)                       ' MCR reg               enable access to TCR and TLR register
  p2_set_rs(module, offset + 6, 087h)                       ' TCR reg               FIFO trigger level
  p2_set_rs(module, offset + 4, 04h)                        ' MCR reg               FIFOrdy reg enable; is necessary to get status information of the FIFO
  p2_set_rs(module, offset + 2, 00fh)                       ' FCR-reg               FIFOs enable, FIFOs clear, DMA Mode1
endsub


'***************************************************************
''' Resets the serial interface module.
''' module: module address (1..15)
'''***************************************************************
sub P2_RS_Reset(module)
  CHECK_CARD(module)
  POKE (60000210h OR shift_left(module, 20), 0)             'reset 200 ns !!
  POKE (60000220h OR shift_left(module, 20), 1)             'RS 485 CH1 485
  POKE (60000230h OR shift_left(module, 20), 1)             'RS 485 CH2 485
  POKE (60000240h OR shift_left(module, 20), 1)             'RS 485 CH3 485
  POKE (60000250h OR shift_left(module, 20), 1)             'RS 485 CH4 485

  POKE (60000260h OR shift_left(module, 20), 0)             'RS 485 CH1 receive
  POKE (60000270h OR shift_left(module, 20), 0)             'RS 485 CH2 receive
  POKE (60000280h OR shift_left(module, 20), 0)             'RS 485 CH3 receive
  POKE (60000290h OR shift_left(module, 20), 0))            'RS 485 CH4 receive
  p2_sleep(16)
endsub


'***************************************************************
''' Writes a byte to the transmit FIFO if the FIFO is not full.
'''+return value:
'''+write_fifo : 
'''+             0->byte is written
'''+             1->FIFO full
''' module: module address (1..15)
'''channel: number of the serial interface
'''value: value which should be written to the FIFO
'''***************************************************************
function P2_Write_FIFO(module, channel, value) as Long
  if (P2_get_rs(module, 7 + ((channel - 1) * 8)) and shift_left(1, channel - 1) <> 0) then
    P2_set_rs(module, ((channel - 1) * 8), value)           ' Writing byte to transmit FIFO
    P2_write_fifo = 0                                       ' return value: byte is written successful to the transmit FIFO
  else
    p2_write_fifo = 1                                       ' return value: Fifo full; byte is not written
  endif
endfunction

'***************************************************************
''' Checks if write fifo is full.
'''+ return value:
'''+             0->one or more byte in write FIFO is free
'''+             1->FIFO full
'''module: module address (1..15)
'''channel: number of the serial interface
'''***************************************************************
function P2_Write_FIFO_Full(module, channel) as Long
  if (P2_get_rs(module, 7 + ((channel - 1) * 8)) and shift_left(1, channel - 1) = 0) then
    P2_write_fifo_full = 1                
  else
    p2_write_fifo_full = 0               
  endif
endfunction

'***************************************************************
''' Checks if there is any more data to transmit.
'''+return value:
'''+check_shift_reg : 
'''+                  0->Shift register and transmit hold are empty
'''+                  1->Shift register and transmit hold are not empty
''' module: module address (1..15)
'''channel: number of the serial interface
'''***************************************************************
function P2_Check_Shift_Reg(module, channel) as Long
  if (P2_get_rs(module, ((channel - 1) * 8) + 5) and 64 = 64) then  ' reading the status byte
    P2_check_shift_reg = 0
  else
    p2_check_shift_reg = 1
  endif
endfunction


'***************************************************************
''' Reads byte from the receive FIFO.
'''+return value: 
'''+                   0..255->value of the received byte
'''+                  -1->no bytes in the receive FIFO
''' module: module address (1..15)
'''channel: number of the serial interface
'''***************************************************************
function P2_Read_FIFO(module, channel) as Long
  if (P2_get_rs(module, ((channel - 1) * 8) + 5) and 1 <> 0) then  'read byte, if there is a byte in the receive FIFO        '
    P2_read_fifo = P2_get_rs(module, ((channel - 1) * 8))   ' read byte from receive FIFO (return value = value of the received byte)
  else
    P2_read_fifo = -1                                       ' no new byte in the receive FIFO (return value = -1)
  endif
endfunction


'***************************************************************
'''Only for RS485.
'''+Selects whether the interface is sending data or is listening on the bus.  
''' module: module address (1..15)
'''channel: number of the serial interface
'''value: 
'''+               0->Listening
'''+               1->Sending Data
'''+               2->Sending Data + Listening
'''***************************************************************
sub P2_RS485_Send(module, channel, value)
  CHECK_CARD(module)
  POKE (60000250h + ((channel) * 16) OR shift_left(module, 20), value)
endsub

'******************************************************************************
''' Sets RS LEDs on/off for the RS Channel.
'''module: module address (1..15)
'''channel: number of the RS interface on the RS module
'''led_col: 
'''+          0->LED off
'''+          1->LED red
'''+          2->LED green
'''+          3->LED orange
'''******************************************************************************
sub P2_RS_Set_LED(module, channel, led_col)
  CHECK_CARD(module)
  POKE (60002FF0h + ((channel) * 16) OR shift_left(module, 20), led_col)
endsub

'<ENDREGION>

'<REGION> LIN

'******************************************************************************
'''Sets LIN LEDs on/off for the LIN Channel.
'''module: module address (1..15)
'''channel: number of the LIN interface on the LIN module
'''led_col: 
'''+          0->LED off
'''+          1->LED red
'''+          2->LED green
'''+          3->LED orange
'''****************************************************************************
sub P2_LIN_Set_LED(module, channel, led_col)
  CHECK_CARD(module)
  POKE (60002FF0h + ((channel) * 16) OR shift_left(module, 20), led_col)
endsub

'***************************************************************
'''Initializes communication between TiCo and T12.
'''+return value: -1->no LIN-Module
'''+               0->OK
'''+               1->no Modul at this adress
'''+               2->no tico
'''module: module address (1..15)
'''lin_datatable[]: array with 150 elements of type Long, used to store communication details 
'''*************************************************************
Function P2_LIN_Init(module, lin_datatable[]) as long
  dim cnt as long
  dim ret as long
  dim l_modulcode as long

  CHECK_TYPE_LONG (lin_datatable[1])
  CHECK_CARD(module)
  ret = -1

  cnt = Peek_P2 (6800E000h OR shift_left(module, 20))

  
  if (cnt = 12345678H) then ret = 1
  if (cnt = 0) then ret = 2
  if (ret = -1) then 
    l_modulcode = Peek_P2 (68000400h OR shift_left(module, 20))
    
    if ((l_modulcode = 0E00h) or (l_modulcode = 0E01h)) then
      P2_TDRV_Init(module, 1, lin_datatable)
      ret = 0
    endif
  endif
  P2_LIN_INIT = ret
endfunction

'***************************************************************
'''Writes Init at each channel.
'''lin_datatable[]: see P2_LIN_INIT
'''channel: 1..2
'''baudrate: 2400, 9600, 19200 (recommended)
'''mode:  
'''+       0->slave
'''+       1->master
'''chs_enh: 
'''+         0->classic
'''+         1->enhanced
'''*************************************************************
sub P2_LIN_Init_Write(lin_datatable[], channel, baudrate, mode, chs_enh)
  dim l_arr[TTK_D_STRUKT_LEN] as long
  dim l_f as float
  dim i as long

  CHECK_TYPE_LONG (lin_datatable[1])

  for i = 7 to TTK_D_STRUKT_LEN
    l_arr[i] = 0
  next i
  l_arr[1] = channel
  l_arr[2] = 71
  l_arr[3] = baudrate
  l_f = baudrate / 1.55                                     '(min:13/9; besser ist 14/9)
  'l_f = baudrate / 1.44  '(min:13/9; besser ist 14/9)
  l_arr[4] = l_f
  l_arr[5] = mode
  l_arr[6] = chs_enh
  P2_LIN_write_dat(lin_datatable, l_arr)
endsub

'***************************************************************
'''Applies Init.
'''lin_datatable[]: see P2_LIN_INIT
'''***************************************************************
sub P2_LIN_Init_Apply(lin_datatable[])
  CHECK_TYPE_LONG (lin_datatable[1])
  P2_LIN_Proz_SpSt(lin_datatable)
endsub

'***************************************************************
'''Resets LIN.
'''lin_datatable[]: see P2_LIN_INIT
'''reset_mode:  =1->all (like System ON/OFF)
'''+            <>1->Counter reset
'''*************************************************************
sub P2_LIN_Reset(lin_datatable[], reset_mode)
  dim l_temp as long
  CHECK_TYPE_LONG (lin_datatable[1])

  if (reset_mode = 1) then
    p2_set_par(lin_datatable[85], 1, TTK_PAR_KS, 0)         'KS
  endif
  P2_LIN_Proz_SpSt(lin_datatable)
endsub

'***************************************************************
'''Reads LIN verion.
'''lin_datatable[]: see P2_LIN_INIT
'''***************************************************************
function P2_LIN_Get_Version(lin_datatable[]) as long
  CHECK_TYPE_LONG (lin_datatable[1])
  P2_LIN_Get_Version = p2_get_par(lin_datatable[85], 1, TTK_PAR_VER)
endfunction

'***************************************************************
'''LIN Process Stop and Start.
'''lin_datatable[]: see P2_LIN_INIT
'''***************************************************************
sub P2_LIN_Proz_SpSt(lin_datatable[])                       '<HIDE>
  dim l_temp as long
  CHECK_TYPE_LONG (lin_datatable[1])

  p2_sleep(7000)                                            'Processdelay LIN-Modul
  P2_TiCo_Stop_Process(lin_datatable, 1)
  'wait for stop
  do
    l_temp = p2_process_status(lin_datatable[85], 1, 1)
  until ((l_temp = 0) or (l_temp = 12345678H))
  P2_TiCo_Start_Process(lin_datatable, 1)
  'wait for running
  do
    l_temp = p2_process_status(lin_datatable[85], 1, 1)
  until ((l_temp = 1) or (l_temp = 12345678H))
endsub

'***************************************************************
'''Writes Data to TiCo.
'''lin_datatable[]: see P2_LIN_INIT
'''tx_dat[]: values to write (TTK_D_STRUKT_LEN)
'''***************************************************************
sub P2_LIN_Write_Dat(lin_datatable[], tx_dat[])             '<HIDE>
  dim l_t11_sz as long
  CHECK_TYPE_LONG (lin_datatable[1])
  CHECK_TYPE_LONG (tx_dat[1])
  do
    l_t11_sz = p2_get_par(lin_datatable[85], 1, TTK_PAR_SZ_NR)  'writepointer
  until (l_t11_sz <> 0)
  p2_setdata_long(lin_datatable, TTK_DAT_NR, l_t11_sz, TTK_D_STRUKT_LEN, tx_dat, 1, 1)
  p2_set_par(lin_datatable[85], 1, TTK_PAR_SZ_NR, 0)        'writepointer
endsub

'***************************************************************
'''Reads Data from TiCo.
'''lin_datatable[]: see P2_LIN_INIT
'''channel: 1..2
'''membox: 1..64
'''rd_dat[]: values to write (TTK_D_STRUKT_LEN)
'''***************************************************************
sub P2_LIN_Read_Dat(lin_datatable[], channel, membox, rd_dat[])
  dim l_t11_lz as long
  dim l_t11_req_ch as long
  CHECK_TYPE_LONG (lin_datatable[1])
  CHECK_TYPE_LONG (rd_dat[1])

  l_t11_req_ch = channel
  p2_set_par(lin_datatable[85], 1, TTK_PAR_RQ_IDX_NR, membox)  'Anforderung
  p2_set_par(lin_datatable[85], 1, TTK_PAR_RQ_CH_NR, l_t11_req_ch)  'Anforderung start
  do
    l_t11_req_ch = p2_get_par(lin_datatable[85], 1, TTK_PAR_RQ_CH_NR)
  until (l_t11_req_ch = 0)
  l_t11_lz = p2_get_par(lin_datatable[85], 1, TTK_PAR_LZ_NR)  'leseindex
  p2_getdata_long(lin_datatable, TTK_DAT_NR, l_t11_lz, TTK_D_STRUKT_LEN, rd_dat, 1, 1)
endsub

'***************************************************************
'''Writes Data to MSG-Box.
'''lin_datatable[]:  see P2_LIN_INIT
'''channel: 1..2
'''membox: 1..64
'''msg_id: 0..63
'''msg_dat[]: data[8] to write
'''msg_len: 1..8
'''msg_send: 0->msg receive
'''+          1->msg send
'''***************************************************************
sub P2_LIN_Msg_Write(lin_datatable[], channel, membox, msg_id, msg_dat[], msg_len, msg_send)
  dim l_arr[TTK_D_STRUKT_LEN] as long
  dim l_i as long
  dim i as long
  CHECK_TYPE_LONG (lin_datatable[1])
  CHECK_TYPE_LONG (msg_dat[1])

  for i = 1 to TTK_D_STRUKT_LEN
    l_arr[i] = 0
  next i
  for l_i = 1 to msg_len
    l_arr[l_i + 3] = msg_dat[l_i] and 0FFh
  next l_i
  l_arr[1] = channel
  l_arr[2] = membox
  l_arr[3] = msg_id
  l_arr[13] = msg_len
  l_arr[14] = msg_send
  P2_LIN_write_dat(lin_datatable, l_arr)
endsub

'***************************************************************
'''Sends message.
'''lin_datatable[]: see P2_LIN_INIT
'''channel: 1..2
'''membox: 1..64
'''***************************************************************
sub P2_LIN_Msg_Transmit(lin_datatable[], channel, membox)
  dim l_arr[TTK_D_STRUKT_LEN] as long
  dim i as long
  CHECK_TYPE_LONG (lin_datatable[1])

  for i = 1 to TTK_D_STRUKT_LEN
    l_arr[i] = 0
  next i
  'Werte schreiben
  l_arr[1] = channel
  l_arr[2] = 72
  l_arr[3] = membox
  p2_LIN_write_dat(lin_datatable, l_arr)
endsub

'***************************************************************
'''Reads Data from TiCo.
'''+return value: -4->Checksum error
'''+              -3->Timeout error
'''+              -2->receive now
'''+              -1->no new Message
'''+               1->new Message
'''lin_datatable[]: see P2_LIN_INIT
'''channel: 1..2
'''membox: 1..64
'''***************************************************************
function P2_LIN_Msg_Read_Status(lin_datatable[], channel, membox) as long
  dim _arr[1] as long
  dim _td_idx as long

  CHECK_TYPE_LONG (lin_datatable[1])
  _td_idx = ((((membox - 1) * TTK_D_STRUKT_LEN) + TTK_DK_IDX) + ((channel - 1) * TTK_CH_LEN) + 20)
  p2_getdata_long(lin_datatable, TTK_DAT_NR, _td_idx, 1, _arr, 1, 1)
  P2_LIN_Msg_Read_status = _arr[1]
endfunction

'***************************************************************
'''Reads Data from TiCo.
'''+return value: n->Quantity of Messages
'''lin_datatable[]: see P2_LIN_INIT
'''channel: 1..2
'''***************************************************************
function P2_LIN_Ch_Read_Cnt(lin_datatable[], channel) as long
  dim _arr[1] as long
  dim _td_idx as long

  CHECK_TYPE_LONG (lin_datatable[1])
  _td_idx = (((64 * TTK_D_STRUKT_LEN) + TTK_DK_IDX) + ((channel - 1) * TTK_CH_LEN) + 4)
  p2_getdata_long(lin_datatable, TTK_DAT_NR, _td_idx, 1, _arr, 1, 1)
  P2_LIN_Ch_Read_cnt = _arr[1]
endfunction

'<ENDREGION>

'<REGION> CAN

'---------------------------------------------------------------
''' Sets CAN interface speed and bus termination.
''' module: module address (1..15)
''' channel: CAN channel (1..2)
''' mode: 
'''+ 0 CAN interface OFF, bus termination OFF
'''+ 1 CAN interface OFF, bus termination 120 Ohm
'''+ 2 High speed CAN, bus termination OFF
'''+ 3 High speed CAN, bus termination 120 Ohm
'''+ 4 Low speed CAN, bus termination OFF
'''---------------------------------------------------------------
Sub P2_CAN_Set_Mode(module, channel, mode)
  dim md as long
  dim rb as long
  dim old as long
  dim mcode as long
  
  CHECK_CARD(module)
  
  mcode = Peek_P2 (68000400h OR shift_left(module, 20))
  
  if (mcode = 3638) then 
  
    rb = 0
    if ((mode = 1) or (mode = 3)) then rb = 1
    
    md = rb                                                 'off
    if ((mode = 2) or (mode = 3)) then md = md or 2         'high speed
    if (mode = 4) then md = md or 4                         'low speed
  
    old = Peek_P2 (60001400h OR (10000h * (channel)) OR shift_left(module, 20))
    
    
    if (old <> md) then 
      'set new
      POKE (60001400h OR (10000h * (channel)) or shift_left(module, 20), rb)
      CPU_Sleep(1000000)                                    '10 ms relais settling time
      POKE (60001400h OR (10000h * (channel)) or shift_left(module, 20), md)      
      CPU_Sleep(1000000)                                    '10 ms relais settling time
    endif
  
  endif
      
ENDSUB


'---------------------------------------------------------------
''' Enables a message object for receiving messages.
'''+ Disables all interrups of the message object.
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' msg_no:  Number of the message object
''' identifier: incomming frames are accepted by this message object, if the identifier matches the frame identifier
''' extended: Determines whether the identifier is 11 or 29 Bit
'''+             0->11 Bit identifier
'''+             1->29 Bit identifier
'''---------------------------------------------------------------
Sub P2_En_Receive(module, channel, msg_no, identifier, extended)
  P2_Set_CAN_Reg(module, channel, (msg_no) * 16, 149)       'enable message object
  If (extended = 0) Then
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, 128)  'read; DLC = 8 ; 11 Bit identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))  'Set identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, 132)  'read; DLC = 8 ; 29 Bit identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255))  'Set identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'---------------------------------------------------------------
''' Enables a message object for transmitting messages.
'''+ Disables all interrups of the message object.
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' msg_no:  Number of the message object
''' identifier: identifier for the frames which will be transmitted
''' extended: Determines whether the identifier is 11 or 29 Bit
'''+             0 = 11 Bit identifier
'''+             1 = 29 Bit identifier
'''---------------------------------------------------------------
Sub P2_En_Transmit(module, channel, msg_no, identifier, extended)
  Dim bit As Long
  P2_Set_CAN_Reg(module, channel, (msg_no) * 16, 149)       'enable message object
  If ((extended And 2) = 0) Then
    bit = 0
  Else
    bit = 8
  EndIf
  If ((extended And 1) = 0) Then
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, (136 - bit))  'write; DLC = 8 ; 11 bit identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 3) And 255))  'Set identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Left(identifier, 5) And 255))
  Else
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, (140 - bit))  'write; DLC = 8 ; 29 bit identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 2, (Shift_Right(identifier, 21) And 255))  'Set identifier
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 3, (Shift_Right(identifier, 13) And 255))
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 4, (Shift_Right(identifier, 5) And 255))
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 5, (Shift_Left(identifier, 3) And 255))
  EndIf
EndSub


'---------------------------------------------------------------
''' Initialises the CAN controller.
'''+ All message objects will be disabled.
'''+ Bitrate: 1MBit/s
'''+ Acceptance filter : Must match
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
'''---------------------------------------------------------------
Sub P2_Init_CAN(module, channel)
  Dim counter As Long
  Dim addr As Long

  CHECK_CARD(module)
  'reset
  POKE (60000000h OR (10000h * (channel)) or 1200H or shift_left(module, 20), 1)
  P2_Sleep(120000)                                          ' Reset pin must be low for at least 1 ms
  P2_Set_CAN_Reg(module, channel, 0, 65)                    ' Access to the registers of the controller only for CPU
  P2_Set_CAN_Reg(module, channel, 2, 65)                    ' CPU interface register
 
  for counter = 6 to 15
    P2_Set_CAN_Reg(module, channel, counter, 0FFh)          ' Setting all masks to "must match"
  next 
   
  P2_Set_CAN_Reg(module, channel, 01Fh, 0)                  ' Clock Out Register
  P2_Set_CAN_Reg(module, channel, 02Fh, 0)                  ' Bus configuration register
  P2_Set_CAN_Reg(module, channel, 03Fh, 0)
 
  P2_Set_CAN_Reg(module, channel, 04Fh, 032h)               ' Bit Timing register 1

  For counter = 1 To 15                                     ' Disable all message objects
    P2_Set_CAN_Reg(module, channel, counter * 16, 85)
    P2_Set_CAN_Reg(module, channel, counter * 16 + 1, 85)
  Next counter
  P2_Set_CAN_Reg(module, channel, 0, 0)                     ' Access to the registers of the controller only for Application
EndSub


'---------------------------------------------------------------
' Aid sub for Read_Msg_Con and Read_Msg.
'---------------------------------------------------------------
'''#C;P4:BR;P5:BR;P6:BR;P7:BR;P8:BR;
Sub P2_Read_Controller_Registers(module, channel, msg_no, id0, id1, id2, id3, id_length)  '<HIDE>
  Dim counter As Long
  Dim buffer As Long

  buffer = (P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 6))
  CAN_msg[9] = Shift_Right((buffer And 0F0h), 4)            ' Number of databytes
  id_length = buffer And 4
  id0 = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 2)  ' identifier registers
  id1 = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 3)
  If (id_length = 4) Then
    id2 = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 4)
    id3 = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 5)
  EndIf
  For counter = 1 To CAN_msg[9]                             ' reading databytes
    CAN_msg[counter] = P2_Get_CAN_Reg(module, channel, ((msg_no) * 16) + counter + 6)
  Next counter
EndSub


'---------------------------------------------------------------
''' Checks if there is a new frame in the selected
'''+ message object. if there is a new frame all databytes are read
'''+ and then written to the array "CAN_msg".
'''+ The number of dadabytes is written to the element 9 of the array "CAN_msg".
'''+ The return value of the function is the identifier of the frame.
'''+ If there is no new frame in the message box the return value is -1.
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' msg_no: number of the message object
'''---------------------------------------------------------------
Function P2_Read_Msg(module, channel, msg_no) As Long
  Dim new As Long                                           ' new message in the message object
  Dim id0, id1, id2, id3 As Long                            ' identifier Byte 0 and 1
  Dim id_length As Long                                     ' buffer to distinguish 11 and 29 bit identifier

  new = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3  ' Check, if a new frame in arrived
  If (new = 2) Then                                         ' New frame is arrived
    P2_read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_length)
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)    ' reset interrupt
    P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 85)  ' reset the new data flag
    If (id_length = 0) Then
      P2_Read_Msg = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      P2_Read_Msg = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))  ' return value = 29 bit identifier
    EndIf
  Else
    P2_Read_Msg = -1                                        ' return value = -1
  EndIf
EndFunction


'---------------------------------------------------------------
''' Checks if there is a new frame in the selected
'''+ message object. If there is a new frame all databytes are read
'''+ and then written to the array "CAN_msg".
'''+ The number of databytes is written to the element 9 of the array "CAN_msg".
'''+ The return value of the function is the identifier of the frame.
'''+ If there is no new frame in the message box the return value is -1.
'''+ Checks the consistens of the data and if they ars not consistent
'''+ the datas will be reread.
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' msg_no: number of the message object
'''---------------------------------------------------------------
Function P2_Read_Msg_Con(module, channel, msg_no) As Long
  Dim new As Long                                           ' new message in the message object
  Dim id_length As Long                                     ' buffer to distinguish 11 and 29 bit identifier
  Dim id0, id1, id2, id3 As Long                            ' identifier Byte 0 and 1

  new = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3  ' Check, if a new frame in arrived
  If (new = 2) Then                                         ' New frame is arrived
    
    If (msg_no = 15) then
      P2_read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_length)
      P2_Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)  ' reset interrupt
      P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 85)  ' reset the new data flag
      new = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3  ' Check, if a new frame in arrived
      If (new = 2) Then                                     ' New frame is arrived
        P2_read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_length)
        P2_Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)  ' reset interrupt
        P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 85)  ' reset the new data flag
      endif
    else
      P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 85)  ' reset the new data flag
      P2_read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_length)
      new = P2_Get_CAN_Reg(module, channel, (msg_no) * 16 + 1) And 3  ' Check, if a new frame in arrived
      If (new = 2) Then                                     ' New frame is arrived
        P2_read_controller_registers(module, channel, msg_no, id0, id1, id2, id3, id_length)
        P2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 85)  ' reset the new data flag
      endif
      P2_Set_CAN_Reg(module, channel, (msg_no) * 16, 0FDh)  ' reset interrupt
    endif 
    If (id_length = 0) Then
      P2_Read_Msg_Con = (Shift_Right(id1, 5)) Or (Shift_Left(id0, 3))  ' return value = 11 bit identifier
    Else
      P2_Read_Msg_Con = (Shift_Right(id3, 3)) Or (Shift_Left(id2, 5)) Or (Shift_Left(id1, 13)) Or (Shift_Left(id0, 21))  ' return value = 29 bit identifier
    EndIf
  Else
    p2_Read_Msg_Con = -1                                    ' return value = 0
  EndIf
EndFunction


'---------------------------------------------------------------
''' Transmits a frame.
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' msg_no: number of the message object
'''+ The databytes and the number of databytes have to be written in the
'''+ array "CAN_msg" before this Subroutine is activated.
'''+ After this Subroutine the frame is transmitted As soon As the
'''+ CAN-bus allows it.
'''---------------------------------------------------------------
Sub P2_Transmit(module, channel, msg_no)
  Dim buffer As Long
  Dim counter As Long

  For counter = 1 To CAN_msg[9]
    p2_Set_CAN_Reg(module, channel, ((msg_no) * 10h) + counter + 6, CAN_msg[counter])  ' copy datas
  Next counter

  buffer = (P2_Get_CAN_Reg(module, channel, ((msg_no) * 10h) + 6) AND 0FH) Or Shift_Left(CAN_msg[9], 4)  ' read register
  ''buffer = buffer And 0Fh               ' change DLC Bits
  'buffer = buffer
  p2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 6, buffer)  ' write register
  p2_Set_CAN_Reg(module, channel, (msg_no) * 16 + 1, 102)   ' Control register (setting bit to transmit data)
EndSub


'---------------------------------------------------------------
''' Checks if a Messagebox is ready to send. (The last message is
'''+ already sent)
'''+ return value: 
'''+        Bit 0 = ready to send
'''+        Bit 1 = not ready to send
''' module:  module address  (1..15)
''' channel: number of the CAN interface on the CAN module
''' msg_no: number of the message object
'''---------------------------------------------------------------
Function P2_Transmit_Status(module, channel, msg_no) as long 
  P2_Transmit_Status = shift_right(P2_Get_CAN_Reg(module, channel, ((msg_no) * 10h) + 1), 5) and 1  ' Control 1register
EndFunction


'---------------------------------------------------------------
''' Enables the interrupt of a message object.
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' msg_no: number of the message object
'''---------------------------------------------------------------
Sub P2_En_Interrupt(module, channel, msg_no)
  P2_Set_CAN_Reg(module, channel, (msg_no) * 16, 0EBh)      ' Enable interrupt of the message object.
  P2_Set_CAN_Reg(module, channel, 0, 02h)                   ' Enable global interrupt.
  p2_event_config(module, 0, 2, 1)
EndSub

 
'******************************************************************
''' Reads the Interruptsource clear by read.
'''+return: 
'''+        Bit 0 =1 Interrupt from CAN Channel 1
'''+        Bit 1 =1 Interrupt from CAN Channel 2
''' module: module address (1..15)
'''****************************************************************** 
Function P2_CAN_Interrupt_Source(module) As Long 
  dim h as long
  Check_Card(module)
  h = Peek_P2 (60030000h OR shift_left(module, 20))
  P2_CAN_Interrupt_Source = h
EndFunction


'---------------------------------------------------------------
''' Sets a register of the CAN controller.
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' regno: register which should be set
''' value: value which should be written to the register.
'''---------------------------------------------------------------
Sub P2_Set_CAN_Reg(module, channel, regno, value)
  CHECK_CARD(module)
  Sub_Begin_Critical_Section  
  POKE (60000000h OR (10000h * (channel)) or (((regno) and 0ffh) * 16) or shift_left(module, 20), value)
  p2_sleep(80)
  Sub_End_Critical_Section
EndSub


'---------------------------------------------------------------
''' Reads a register of the CAN controller.
'''+ return value: value of the register
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' regno: register to read
'''---------------------------------------------------------------
Function P2_Get_CAN_Reg(module, channel, regno) As Long
  dim old as long

  CHECK_CARD(module)
  SUB_BEGIN_CRITICAL_SECTION
  old = PEEK_P2 ((60000000h OR (10000h * (channel)) or (((regno) and 0ffh) * 16) or shift_left(module, 20))) 
  old = old + 1                                             ' don't remove ! reguired if optimize>0
  p2_sleep(78)
  
  P2_Get_CAN_Reg = Peek_P2 ((60000000h OR (10000h * (channel)) or (1000H) or shift_left(module, 20)))
  SUB_END_CRITICAL_SECTION
EndFunction


'---------------------------------------------------------------
''' Reads the register where the bus error pin of the tranceiver
'''+ is stored.
'''+ The register is set when the a bus error occurs and is reset by
'''+ reading the register.
'''+ Attention: This command is only for low-speed CAN
'''+ return value : 0->no error
'''+                1->error
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
'''---------------------------------------------------------------
Function P2_Get_Line_Status(module, channel) As Long        '<HIDE>
  dim old as long

  Check_Card(module)
  old = Peek_P2 ((60001200h or (10000h * (channel)) or shift_left(module, 20)))
  P2_Get_Line_Status = shift_right(old, 1) AND 1
EndFunction


'---------------------------------------------------------------
'Function only For internal use.
'---------------------------------------------------------------
'''#C;P1:F;
Function System_Round(value) As Long                        '<HIDE>
  Dim buffer As Float

  buffer = value + 0.5
  System_Round = buffer
EndFunction


'---------------------------------------------------------------
'Function only For internal use.
'---------------------------------------------------------------
'''#C;P1:F;
Function Int_Check(fl_value, int_value) As Long             '<HIDE>
  Dim fbuffer As Float

  fbuffer = fl_value - int_value
  If ((fbuffer >= 0.00001) Or (fbuffer <= -0.00001)) Then
    Int_Check = 1                                           ' not equal
  Else
    Int_Check = 0                                           ' equal
  EndIf
EndFunction


'---------------------------------------------------------------
''' Sets the baudrate of the CAN-Bus.
'''+ return value: 
'''+                0->baudrate is set
'''+                1->the selected baudrate is not set
''' module: module address (1..15)
''' channel: number of the CAN interface on the CAN module
''' baud: CAN-Bus baudrate
'''---------------------------------------------------------------
Function P2_Set_CAN_Baudrate(module, channel, baud) As Long
  Dim scale As Long
  Dim fbuffer As Float
  Dim lbuffer As Long
  Dim back As Long
  Dim tseg1 As Long
  Dim tseg2 As Long
  Dim brp As Long
  Dim btr0 As Long
  Dim btr1 As Long

  P2_Set_CAN_Baudrate = 0                                   ' Initialisation
  fbuffer = 8000000 / baud
  scale = system_Round(fbuffer)                             ' total scale to achive the baudrate
  P2_Set_CAN_Baudrate = Int_Check(fbuffer, scale)           ' 1 if baudrate not possible
  If (P2_Set_CAN_Baudrate = 0) Then                         ' If baudrate possible then find settings
    brp = (scale - 1) / 25                                  ' Prescaler
    Do                                                      ' find the right brp
      fbuffer = (scale / (brp + 1) - 3)
      lbuffer = system_Round(fbuffer)
      back = Int_Check(fbuffer, lbuffer)                    ' Inc prescaler Until tseg1 + tseg 2 is an Long
      Inc(brp)
    Until ((back = 0) Or (fbuffer < 5))
    Dec(brp)
    If (back <> 0) Then P2_Set_CAN_Baudrate = 1
  EndIf

  If (P2_Set_CAN_Baudrate = 0) Then                         ' If there is a correct prescaler
    tseg2 = lbuffer * 0.4
    tseg1 = lbuffer - tseg2
    If (tseg2 > 7) Then
      Do
        Dec(tseg2)
        Inc(tseg1)
      Until (tseg2 = 7)
    EndIf
    btr0 = brp                                              ' Synchronization jump width = 1 (bits = 0)
    btr1 = tseg1 + Shift_Left(tseg2, 4)                     ' one sampling each Bit
    P2_Set_CAN_Reg(module, channel, 0, 65)                  ' enable access to btr regisers
    P2_Set_CAN_Reg(module, channel, 3Fh, btr0)              ' set btr0 regisers
    P2_Set_CAN_Reg(module, channel, 4Fh, btr1)              ' set btr1 regisers
    P2_Set_CAN_Reg(module, channel, 0, 0)                   ' disable access to btr regisers
  EndIf
EndFunction

'******************************************************************************
''' Sets CAN LEDs on/off for the CAN channel.
''' module: module address (1..15)
'''channel: number of the CAN interface on the CAN module
'''led_col: 
'''+          0->LED off
'''+          1->LED red
'''+          2->LED green
'''+          3->LED orange
'''******************************************************************************
sub P2_CAN_Set_LED(module, channel, led_col)
  CHECK_CARD(module)
  POKE (60001500h + ((channel) * 10000h) OR shift_left(module, 20), led_col)
endsub

'<ENDREGION>

'<REGION> FlexRay

' an ENUM of allowed functions
#define FlexRay_Instruction_Idle                       0    '<HIDE>
#define FlexRay_Instruction_Read                       1    '<HIDE>
#define FlexRay_Instruction_Write                      2    '<HIDE>
#define FlexRay_Instruction_SetLed                     3    '<HIDE>
#define FlexRay_Instruction_Reset                      4    '<HIDE>
#define FlexRay_Instruction_Get_Version                5    '<HIDE>
#define FlexRay_Instruction_Get_Number_Of_Controllers  6    '<HIDE>

' Parameter mapping on TiCo
#define FlexRay_Par_Instruction        2                    '<HIDE>
#define FlexRay_Par_Controller         3                    '<HIDE>
#define FlexRay_Par_Address            4                    '<HIDE>
#define FlexRay_Par_Value              5                    '<HIDE>

#Define FlexRay_Channel_A              0                    '<HIDE>
#Define FlexRay_Channel_B              1                    '<HIDE>

' Possible return values for P2_FlexRay_* - functions:
''' The last command has been completed successfully
#Define FlexRay_Success  0
''' The last command was issued while the FlexRay module was still working on another request
#Define FlexRay_Busy 1
''' The FlexRay module did not finish the command in time
#Define FlexRay_Timeout  2

' maximum time to wait for a command on FlexRay card to complete
#Define FlexRay_Timeout_value 1000                          '<HIDE>

'******************************************************************************
' generic function to read information from FlexRay card
' should not be used by the end user
'******************************************************************************
'''#C;P5:BR;
Function FlexRay_Read_Instruction(data_table[], controller, address, instruction, status) As Long  '<HIDE>
  Dim Timeout_Counter As Long
  
  CHECK_TYPE_LONG (data_table[1])
  If (P2_Get_Par(data_table[85], 1, FlexRay_Par_Instruction) = FlexRay_Instruction_Idle) Then
    P2_Set_Par(data_table[85], 1, FlexRay_Par_controller, controller)
    P2_Set_Par(data_table[85], 1, FlexRay_Par_address, address)
    P2_Set_Par(data_table[85], 1, FlexRay_Par_Instruction, instruction)
    Do 
      Inc Timeout_Counter 
    Until ((P2_Get_Par(data_table[85], 1, FlexRay_Par_Instruction) = FlexRay_Instruction_Idle) Or (Timeout_Counter = FlexRay_Timeout_value))
    If (Timeout_Counter = FlexRay_Timeout_value) Then
      FlexRay_Read_Instruction = -1
      status = FlexRay_Timeout
    Else
      FlexRay_Read_Instruction = P2_Get_Par(data_table[85], 1, FlexRay_Par_value)
      status = FlexRay_Success
    EndIf
  Else
    FlexRay_Read_Instruction = -1
    status = FlexRay_Busy
  EndIf
EndFunction

'******************************************************************************
' generic function to write information to FlexRay card
' should not be used by the end user
'******************************************************************************
'''#C;P6:BR;
Sub FlexRay_Write_Instruction(data_table[], controller, address, value, instruction, status)  '<HIDE>
  Dim Timeout_Counter As Long
  
  CHECK_TYPE_LONG (data_table[1])
  If (P2_Get_Par(data_table[85], 1, FlexRay_Par_Instruction) = FlexRay_Instruction_Idle) Then
    P2_Set_Par(data_table[85], 1, FlexRay_Par_controller, controller)
    P2_Set_Par(data_table[85], 1, FlexRay_Par_address, address)
    P2_Set_Par(data_table[85], 1, FlexRay_Par_Instruction, instruction)
    P2_Set_Par(data_table[85], 1, FlexRay_Par_value, value)
    Do 
      Inc Timeout_Counter 
    Until ((P2_Get_Par(data_table[85], 1, FlexRay_Par_Instruction) = FlexRay_Instruction_Idle) Or (Timeout_Counter = FlexRay_Timeout_value))
    If (Timeout_Counter = FlexRay_Timeout_value) Then
      status = FlexRay_Timeout
    Else
      status = FlexRay_Success
    EndIf
  Else
    status = FlexRay_Busy
  EndIf
EndSub

'******************************************************************************
'''Initializes communication between DSP and FlexRay card. 
'''module: module address (1..15)
'''data_table[]: array with 150 elements of type Long
'''status:          0-> OK
'''+                1-> no module at this adress
'''+                2-> not a FlexRay module
'''****************************************************************************
'''#C;P3:BR;
Sub P2_FlexRay_Init(module, data_table[], status)
  dim cnt as long
  dim ret as long
  dim module_code as long

  CHECK_TYPE_LONG (data_table[1])
  CHECK_CARD(module)
  status = -1
  'determine number of TiCos
  cnt = Peek_P2 (6800E000h OR shift_left(module, 20))
  
  if (cnt = 12345678H) then status = 1
  if (cnt = 0) then status = 2
  if (status = -1) then 
    module_code = Peek_P2 (68000400h OR shift_left(module, 20))
    
    if (module_code = 0E18h) then
      P2_TDRV_Init(module, 1, data_table)
      status = 0
    else
      status = 2
    endif
  endif
EndSub
  
'******************************************************************************
'''Reads a 16-bit word from a given address from the specified FlexRay controller.
'''data_table[]: array with 150 elements of type Long
'''controller: select controller 1 or 2
'''address: address to read from (0-01ffeh, 2-byte alignment)
'''status: returns
'''+        0 if everything was ok (FlexRay_Success)
'''+        1 if the module was busy (FlexRay_Busy)
'''+        2 if the module did not respond in time (FlexRay_Timeout)
'''****************************************************************************
'''#C;P4:BR;
Function P2_FlexRay_Read_Word(data_table[], controller, address, status) As Long
  CHECK_TYPE_LONG (data_table[1])
  P2_FlexRay_Read_Word = FlexRay_Read_Instruction(data_table, controller, address, FlexRay_Instruction_Read, status)
EndFunction

'******************************************************************************
'''Writes a 16-bit word to given address on the specified FlexRay controller.
'''data_table[]: array with 150 elements of type Long
'''controller: select controller 1 or 2
'''address: address to write to (0-01ffeh, 2-byte alignment)
'''value: 16-bit word to write
'''status: returns
'''+        0 if everything was ok (FlexRay_Success)
'''+        1 if the module was busy (FlexRay_Busy)
'''+        2 if the module did not respond in time (FlexRay_Timeout)
'''****************************************************************************
'''#C;P5:BR;
Sub P2_FlexRay_Write_Word(data_table[], controller, address, value, status)
  CHECK_TYPE_LONG (data_table[1])
  FlexRay_Write_Instruction(data_table, controller, address, value, FlexRay_Instruction_Write, status)
EndSub

'******************************************************************************
'''Sets channel LED on specified FlexRay controller.
'''data_table[]: array with 150 elements of type Long
'''controller: select controller 1 or 2
'''channel: 0 for channel A, 1 for channel B
'''value: 0 = LED OFF, 1 = LED ON
'''status: returns
'''+        0 if everything was ok (FlexRay_Success)
'''+        1 if the module was busy (FlexRay_Busy)
'''+        2 if the module did not respond in time (FlexRay_Timeout)
'''****************************************************************************
'''#C;P5:BR;
Sub P2_FlexRay_Set_LED(data_table[], controller, channel, value, status) 
  CHECK_TYPE_LONG (data_table[1])
  FlexRay_Write_Instruction(data_table, controller, channel, value, FlexRay_Instruction_SetLed, status)
EndSub

'******************************************************************************
'''Hard-Resets specified controller.
'''data_table[]: array with 150 elements of type Long
'''controller: select controller 1 or 2
'''status: returns
'''+        0 if everything was ok (FlexRay_Success)
'''+        1 if the module was busy (FlexRay_Busy)
'''+        2 if the module did not respond in time (FlexRay_Timeout)
'''****************************************************************************
'''#C;P3:BR;
Sub P2_FlexRay_Reset(data_table[], controller, status)
  CHECK_TYPE_LONG (data_table[1])
  FlexRay_Write_Instruction(data_table, controller, 0, 0, FlexRay_Instruction_Reset, status)
EndSub

'******************************************************************************
'''Gets Firmware version of FlexRay module.
'''+ e.g. 001030205h for high level driver version 1.3, low level driver version 2.5
'''data_table[]: array with 150 elements of type Long
'''status: returns
'''+        0 if everything was ok (FlexRay_Success)
'''+        1 if the module was busy (FlexRay_Busy)
'''+        2 if the module did not respond in time (FlexRay_Timeout)
'''****************************************************************************
'''#C;P2:BR;
Function P2_FlexRay_Get_Version(data_table[], status) As Long
  CHECK_TYPE_LONG (data_table[1])
  P2_FlexRay_Get_Version = FlexRay_Read_Instruction(data_table, 1, 0, FlexRay_Instruction_Get_Version, status)
EndFunction

'******************************************************************************
'''Gets number of installed FlexRay controllers.
'''data_table[]: array with 150 elements of type Long
'''status: returns
'''+        0 if everything was ok (FlexRay_Success)
'''+        1 if the module was busy (FlexRay_Busy)
'''+        2 if the module did not respond in time (FlexRay_Timeout)
'''****************************************************************************
'''#C;P2:BR;
Function P2_FlexRay_Get_Number_Of_Controllers(data_table[], status) As Long
  CHECK_TYPE_LONG (data_table[1])
  P2_FlexRay_Get_Number_Of_controllers = FlexRay_Read_Instruction(data_table, 1, 0, FlexRay_Instruction_Get_Number_Of_controllers, status)
EndFunction

'<ENDREGION>

'<REGION> CNT

'***************************************************************
'''Sets mode for counter.
'''module: module address (1..15)
'''channel: number of the counter (1..4)
'''mode:
'''+   Bit 0 CNT MODE
'''+           0->clock/direction
'''+           1->AB
'''+   Bit 1 CLEAR MODE
'''+           0->normal mode
'''+           1->clear IF A=1 B=1 C=1
'''+   Bit 2 INV CLK
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 3 INV DIR
'''+           0->not inverse
'''+           1->inverse
'''+   Bit 4 CLEAR or LATCH
'''+           0->C use for clear
'''+           1->C use for latch
'''+   Bit 5 Ext Clear/Latch Enable
'''+           0->disable
'''+           1->enable
'''+   Bit 6 PWM Reference edge
'''+           0->positive
'''+           1->negative
'''+   Bit 7, 8 PWM INPUT_SELECT
'''+           00->A
'''+           01->B
'''+           10->C
'''***************************************************************
SUB P2_Cnt_Mode(module, channel, mode)
#If MAKE_LIB = ON Then
  #error("P2_CNT_Mode does NOT work in Libraries!")
#else
  DIM modei as Long
  CHECK_CARD(module)
  POKE ((600109F0h + (channel) * 16) OR shift_left(module, 20), mode)
  modei = shift_right(mode, 6) AND 1
  PWM_help_mode[module] = ((NOT(shift_left(1, channel - 1))) AND PWM_help_mode[module]) OR shift_left(modei, channel - 1)
#endif
ENDSUB

'***************************************************************
'''Activates or deactivates counter.
'''module: module address (1..15)
'''pattern: Bit 0..3 VR counter enable
'''+           0=disable
'''+           1=enable
'''***************************************************************
SUB P2_Cnt_Enable(module, pattern)
  CHECK_CARD(module)
  POKE (60010B50h OR shift_left(module, 20), pattern)
ENDSUB

'***************************************************************
'''Activates or deactivates PW counter.
'''module: module address (1..15)
'''pattern: 
'''+         0..3 PW counter enable
'''+         0=disable
'''+         1=enable
'''*************************************************************
SUB P2_Cnt_PW_Enable(module, pattern)
  CHECK_CARD(module)
  POKE (60010B60h OR shift_left(module, 20), pattern)
ENDSUB

'***************************************************************
'''Latches vr-counter to vr-latch.
'''module: module address (1..15)
'''pattern: each bit corresponds to a counter
'''***************************************************************
SUB P2_Cnt_Latch(module, pattern)
  CHECK_CARD(module)
  POKE (60010B00h OR shift_left(module, 20), pattern)
ENDSUB

'***************************************************************
'''Reads vr-latch register.
'''module: module address (1..15)
'''channel: number of the counter (1..x)
'''***************************************************************
FUNCTION P2_Cnt_Read_Latch(module, channel) as Long
  CHECK_CARD(module) 
  P2_CNT_Read_Latch = Peek_P2 ((6000FF60h + (channel) * 256) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Transfers the counter data from channel 1..4 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Cnt_Read_Latch4(module, array[], index)
  check_card(module)
  CHECK_TYPE_LONG (array[1])
  System_Array_Debug_Check(array, index, 4)  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB(array, 4, 64010404H OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB(array[index], 4, 64010404H OR shift_left(module, 20))
  endif
  
ENDSUB

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'''Transfers the counter data from channel 1..8 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Cnt_Read_Latch8(module, array[], index)
  check_card(module)
  CHECK_TYPE_LONG (array[1])
  System_Array_Debug_Check(array, index, 8)  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB(array, 8, 64010404H OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB(array[index], 8, 64010404H OR shift_left(module, 20))
  endif
  
ENDSUB


'**************************************************************
'''Latches vr-counter to vr-latch and read vr-latch register (counter value).
'''module: module address (1..15)
'''channel: number of the counter (1..x)
'''**************************************************************
FUNCTION P2_Cnt_Read(module, channel) as Long
  CHECK_CARD(module)  
  POKE (60010B00h OR shift_left(module, 20), shift_left(1, channel - 1))
  P2_CNT_Read = Peek_P2 ((6000FF60h + (channel) * 256) OR shift_left(module, 20))
ENDFUNCTION

'*****************************************************************************
'''Transfers the counter data from channel 1..4 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Cnt_Read4(module, array[], index)
  check_card(module)
  CHECK_TYPE_LONG (array[1])
  System_Array_Debug_Check(array, index, 4)
  POKE (60010B00h OR shift_left(module, 20), 0FH)  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB(array, 4, 64010404H OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB(array[index], 4, 64010404H OR shift_left(module, 20))
  endif
 
ENDSUB

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'''Transfers the counter data from channel 1..8 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_Cnt_Read8(module, array[], index)
  check_card(module)
  CHECK_TYPE_LONG (array[1])
  System_Array_Debug_Check(array, index, 8)
  POKE (60010B00h OR shift_left(module, 20), 0FFH)  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB(array, 8, 64010404H OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB(array[index], 8, 64010404H OR shift_left(module, 20))
  endif
 
ENDSUB





'***************************************************************
'''Clears counter.
'''module: module address (1..15)
'''pattern: each bit corresponds to a counter
'''+           0=nothing
'''+           1=cnt clear
'''*************************************************************
SUB P2_Cnt_Clear(module, pattern)
  CHECK_CARD(module)
  POKE (60010B10h OR shift_left(module, 20), pattern)
ENDSUB

'**************************************************************
'''Reads the status of a counter input.
'''+ return: 
'''+          Bit 0: A/CLK Input
'''+          Bit 1: B Input
'''+          Bit 2: Clear/Latch Input
'''+          Bit 3: Cable error
'''+          Bit 4: Phase error
''' module: module address (1..15)
''' channel: number of the counter (1..4)
'''**************************************************************
FUNCTION P2_Cnt_Get_Status(module, channel) as Long
  CHECK_CARD(module)  
  P2_CNT_Get_Status = Peek_P2 ((6000FFF0h + (channel) * 256) OR shift_left(module, 20))
ENDFUNCTIOn

'**************************************************************
'''FUNCTION read register
'''module: module address (1..15)
'''channel: channel to be set 
'''regno: 
'''+        0 pos_pwm_latch 1
'''+        1 pos_pwm_latch 2
'''+        2 pos_pwm_latch 3
'''+        3 neg_pwm_latch 1
'''+        4 neg_pwm_latch 2
'''+        5 neg_pwm_latch 3
'''+        6 vr latch
'''+        7 pwm latch shadow
'''+        8 pos_pwm_latch 1 shadow
'''+        9 pos_pwm_latch 2 shadow
'''+       10 pos_pwm_latch 3 shadow
'''+       11 neg_pwm_latch 1 shadow
'''+       12 neg_pwm_latch 2 shadow
'''+       13 neg_pwm_latch 3 shadow
'''+       14 vr_latch shadow
'''+       15 status
'''**************************************************************
FUNCTION P2_Cnt_Read_Int_Register(module, channel, regno) as Long
  CHECK_CARD(module)  
  P2_CNT_Read_INT_Register = Peek_P2 ((6000FF00h + (channel) * 256 + (regno) * 16) OR shift_left(module, 20))
ENDFUNCTION

'***************************************************************
'''Copies pw-latches and vr-latches to shadow register.
'''module: module address (1..15)
'''pattern: each bit corresponds to a counter
'''***************************************************************
SUB P2_Cnt_PW_Latch(module, pattern)
  CHECK_CARD(module)
  POKE (60010B20h OR shift_left(module, 20), pattern)
ENDSUB


'***************************************************************
'''Does two steps at one timestep:
'''+ 1. latch vr-counter to vr-latch
'''+ 2. copy pw-latches and vr-latches to shadow registers
'''module: module address (1..15)
'''pattern: each bit corresponds to a counter
'''***************************************************************
SUB P2_Cnt_Sync_Latch(module, pattern)
  CHECK_CARD(module)
  POKE (60010CF0h OR shift_left(module, 20), pattern)
ENDSUB


'**************************************************************
'''Reads registers and calculates pw frequency and dutycycle.
'''+ Remark: use P2_cnt_pw_latch before (to get actual values)
'''module: module address (1..15)
'''channel: number of the counter (1..4)
'''frequency: by ref  as float
'''dutycycle: by ref  as float
'''+Definition: dutycycle means "high time" refered to "period time" of signal
'''**************************************************************
'''#C;P3:F;P4:F;P3:BR;P4:BR;
SUB P2_Cnt_Get_PW(module, channel, frequency, dutycycle)
#If MAKE_LIB = ON Then
  #error("P2_CNT_Get_PW does NOT work in Libraries!")
#else
  DIM period as Long
  DIM puls as Long
  DIM ref_edge as Long

  DIM AR[5] as long 
  'AR[1]=pos2
  'AR[2]=pos3
  'AR[3]=neg1
  'AR[4]=neg2
  'AR[5]=neg3
  CHECK_CARD(module)
  
  Read_Fast_Bus_LB(ar[1], 5, (6400FF94h + (channel) * 256) OR shift_left(module, 20))

  ref_edge = shift_right(PWM_help_mode[module], channel - 1) AND 1
  IF (ref_edge = 1) then                                    'negative reference edge
    period = AR[4] - AR[5]                                  'neg2-neg3
    puls = AR[4] - AR[2]                                    'neg2-pos3
  ELSE                                                      'positive reference edge
    period = AR[1] - AR[2]                                  'pos2-pos3
    puls = AR[5] - AR[2]                                    'neg3-pos3
  ENDIF

  if (period <> 0) then
    frequency = 100000000 / period                          'Frequenz [Hz] '100 MHz
    dutyCycle = puls * 100 / (period)                       'PWM Verhltnis
  else 
    frequency = 0
    dutyCycle = 0
  endif
  
#endif
  
ENDSUB

'**************************************************************
'''Reads registers and calculates PW high time and low time.
'''+ Remark: use P2_Cnt_PW_Latch before (to get current values)
'''module: module address (1..15)
'''channel: number of the counter (1..4)
'''hightime: PW high time as return value (Long)
'''lowtime: PW low time as return value (Long)
'''**************************************************************
'''#C;P3:BR;P4:BR;
SUB P2_Cnt_Get_PW_HL(module, channel, hightime, lowtime)
#If MAKE_LIB = ON Then
  #error("P2_CNT_Get_PW_H does NOT work in Libraries!")
#else
  DIM ref_edge as Long
  DIM AR[5] as long 

  'AR[1]=pos2
  'AR[2]=pos3
  'AR[3]=neg1
  'AR[4]=neg2
  'AR[5]=neg3

  CHECK_CARD(module)
 
  Read_Fast_Bus_LB(ar[1], 5, (6400FF94h + (channel) * 256) OR shift_left(module, 20))


  ref_edge = shift_right(PWM_help_mode[module], channel - 1) AND 1
  IF (ref_edge = 1) then                                    'negative referenz edge
    '  period=neg2-neg3
    hightime = AR[4] - AR[2]                                'neg2-pos3
    lowtime = AR[2] - AR[5]                                 'pos3-neg3
  ELSE                                                      'positive referenz edge
    ' period=pos2-pos3
    hightime = AR[5] - AR[2]                                'neg3-pos3
    lowtime = AR[1] - AR[5]                                 'pos2-neg3
  ENDIF
#endif
ENDSUB

'**************************************************************
'''Reads SSI encoder value 32 Bit.
'''module: module address (1..15)
'''dcdr_no: number of the ssi decoder (1..2)
'''**************************************************************
FUNCTION P2_SSI_Read(module, dcdr_no) AS long
  CHECK_CARD(module)

  P2_SSI_Read = Peek_P2 ((60010C40h + (dcdr_no) * 16) OR shift_left(module, 20))

ENDFUNCTION

'*****************************************************************************
'''Transfers the ssi data from dcdr_no 1..2 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_SSI_Read2(module, array[], index)
  check_card(module)
  CHECK_TYPE_LONG (array[1])
  System_Array_Debug_Check(array, index, 2)    
  
  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB(array, 2, 64010444H OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB(array[index], 2, 64010444H OR shift_left(module, 20))
  endif
  
ENDSUB

'**************************************************************
'''Sets the number of databits for the SSI Interface.
'''module: module address (1..15)
'''dcdr_no: number of the ssi decoder (1..2)
'''bit_no: number of bits
'''**************************************************************
SUB P2_SSI_Set_Bits(module, dcdr_no, bit_no)
  CHECK_CARD(module)
  POKE ((60010C20h + (dcdr_no) * 16) OR shift_left(module, 20), bit_no)
ENDSUB

'**************************************************************
'''Sets frequency of the SSI clock.
'''module: module address (1..15)
'''prescale: frequency = 25MHZ / prescale
'''**************************************************************
SUB P2_SSI_Set_Clock(module, prescale)
  CHECK_CARD(module)
  POKE (60010C20h OR shift_left(module, 20), prescale)
ENDSUB

'**************************************************************
'''Starts the SSI interface.
'''module: module address (1..15)
'''pattern: Bit pattern each bit corresponds to one counter
'''**************************************************************
SUB P2_SSI_Start(module, pattern)
  CHECK_CARD(module)
  POKE (60010C00h OR shift_left(module, 20), pattern)
ENDSUB

'*************************************************************
'''Sets the SSI mode.
'''module: module address (1..15)
'''pattern: each bit corresponds to one counter
'''+          0 = single start mode
'''+          1 = continuous start mode
'''*************************************************************
sub P2_SSI_Mode(module, pattern)
  CHECK_CARD(module)
  POKE (60010C10h OR shift_left(module, 20), pattern)
endsub

'*************************************************************
'''Reads the SSI status.
'''+return value: 
'''+        0 = SSI value compleated
'''+        1 = SSI transfer running
'''module: module address (1..15)
'''dcdr_no: number of the ssi decoder (1..2)
'''*************************************************************
FUNCTION P2_SSI_Status(module, dcdr_no) AS long
  dim value2 as long

  CHECK_CARD(module)  
  value2 = Peek_P2 (60010C00h OR shift_left(module, 20))
  P2_SSI_Status = shift_right(value2, dcdr_no - 1) AND 01H  'shift_right(value2, ((dcdr_no)-1)) AND 01H
ENDFUNCTION

'*************************************************************
'''Sets the delay in continuous mode.
'''module: module address (1..15)
'''dcdr_no: number of the ssi decoder (1..2)
'''delay: 16 Bit / 20 ns  [default 25s / 1250]
'''************************************************************
SUB P2_SSI_Set_Delay(module, dcdr_no, delay)
  CHECK_CARD(module)
  POKE ((60010C90h + (dcdr_no) * 16) OR shift_left(module, 20), delay)
ENDSUB


'''Set Input Reveiver Mode  
'''module: module address (1..15)
'''channel: number of the counter (1..x)
'''mode: 
'''+0 = D-HTL
'''+1 = SE-HTL
'''+2 = RS 422 with termination on (default value) 
'''*************************************************************** 
SUB P2_CNT_Input_Receiver_Mode(module, channel, mode)
  CHECK_CARD(module)
  POKE ((60010A70h + (channel) * 16) OR shift_left(module, 20), mode)
ENDSUB


'<ENDREGION>

'<REGION> PWM OUTPUT

'***************************************************************
'Setzt den Ausgang auf Low oder High wenn der PWM Modus fr den Kanal nicht aktiv ist
'Gleichzeitig ist dies der Zustand der gesetzt wird nach dem die PWM Ausgabe sich stoppt oder gestoppt wird.
'''Sets the default TTL levels for all PWM outputs.
'''module: module address (1..15)
'''pattern: each bit corresponds to a counter 0: low 1: high
'''***************************************************************
SUB P2_PWM_Standby_Value(module, pattern)
  CHECK_CARD(module)
  POKE (60010020h OR shift_left(module, 20), pattern)
ENDSUB

'***************************************************************
'''Enables an output of the PWM module.
'''module: module address (1..15)
'''pattern: each bit corresponds to a counter 0: disable 1: enable
'''*************************************************************
SUB P2_PWM_Enable(module, pattern)
  CHECK_CARD(module)
  POKE (60010000h OR shift_left(module, 20), pattern)
ENDsub

'***************************************************************
'stoppt PWM Ausgabe unabhngig von Modus sofort !!!
'Ausgang geht auf Standby Wert
'''Stops the output of one or more PWM outputs immediately.
'''module: module address (1..15)
'''pattern:
'''+ 0: No influence
'''+ 1: Stop output immediately
'''***************************************************************
SUB P2_PWM_Reset(module, pattern)
  CHECK_CARD(module)
  POKE (60010030h OR shift_left(module, 20), pattern)
ENDSUB

'***************************************************************
'''Sets the defaults for one PWM output.
'''module: module address (1..15)
'''channel: Number (1..16) of PWM output
'''startdelay: Start delay in units of 10 ns
'''startvalue:
'''+0: low.
'''+1: high
'''mode:
'''+Bit 0: Moment to take over a new PW frequency:
'''+       Bit = 0: Take over at end of period.
'''+       Bit = 1: Take over immediately.
'''+Bit 1: Number of pulses:
'''+       Bit = 0: infinite number of pulses.
'''+       Bit = 1: number of pulses is count.
'''+Bit 2: Moment to stop after stop instruction:
'''+       Bit = 0: Stop at end of period.
'''+       Bit = 1: Stop immediately.
'''count:  Number of periods (1..32768), which are processed during an output cycle.
'''**************************************************************
SUB P2_PWM_Init(module, channel, startdelay, startvalue, mode, count)
  DIM old as Long
  DIM maske as Long
  DIM maske2 as Long

  CHECK_CARD(module)

  POKE ((600104F0h + (channel) * 16) OR shift_left(module, 20), startdelay)
  POKE ((600103F0h + (channel) * 16) OR shift_left(module, 20), count)
  POKE ((600100F0h + (channel) * 16) OR shift_left(module, 20), mode)
  
  maske = shift_left(1, channel - 1)
  maske2 = maske XOR 0FFFFFFFFH
  'startvalue
  old = Peek_P2 (60010010h OR shift_left(module, 20))
  old = (old AND maske2) or shift_left(startvalue AND 1, channel - 1) 
  POKE (60010010h OR shift_left(module, 20), old)

  
ENDSUB

'**************************************************************
'''Writes frequency and duty cycle into the latch register.
'''module: module address (1..15)
'''channel: Number (1..16) of PWM output.
'''DutyCycle:    0 .. 100 %
'''frequency: 0.05 .. 25000000 Hz
'''************************************************************
'''#C;P3:F;P4:F;
SUB P2_PWM_Write_Latch(module, channel, DutyCycle, frequency)
  DIM max as Long
  DIM low as Long
  DIM per as float
  dim fri as float

  fri = frequency
  if (fri < 0.01) then fri = 0.01
  
  CHECK_CARD(module)
  max = (100000000 / (fri)) - 1                             'ref 100 MHz
  
#IF DEBUG_MODE = ON THEN
  if (max < 2) then
    max = 2
    PROZESS_FEHLER = 202000
  endif
#endif
  
  
  
  POKE ((600101F0h + (channel) * 32) OR shift_left(module, 20), max)

  per = DutyCycle
  IF (per < 0) then per = 0
  low = (max * per * 0.01)
  if (max <= low) then low = max - 1
  POKE ((600101E0h + (channel) * 32) OR shift_left(module, 20), low)
ENDSUB

'**************************************************************
'''Writes frequency and duty cycle for several PWM outputs into the latch registers.
'''module: module address (1..15)
'''DutyCycle[]: Duty cycle / inverse duty cycle in percent between 0.0 and 100.0 (do not use 0.0 or 100.0).
'''frequency[]: 0.05 ... 25000000 Hz
'''channel_count: 1 to 16
'''************************************************************
'''#C;P2:F;P3:F;
SUB P2_PWM_Write_Latch_Block(module, DutyCycle[], frequency[], channel_count)
  DIM max as Long
  DIM low as Long
  DIM per as float

  DIM outbuffer[32] as long

  
  
  dim i as long
  dim p as long
  dim fri as float

  CHECK_CARD(module)
    
  
  p = 1
  for i = 1 to channel_count
    fri = frequency[i]
    if (fri < 0.01) then fri = 0.01
    max = (100000000 / (fri)) - 1                           'max ref 100 MHz
  
#IF DEBUG_MODE = ON THEN
    if (max < 2) then
      max = 2
      PROZESS_FEHLER = 202010
    endif
#endif
  
    per = DutyCycle[i]
    IF (per < 0) then per = 0
    low = (max * per * 0.01)
    if (max <= low) then low = max - 1
    outbuffer[p] = low
    inc p
    outbuffer[p] = max
    inc p
  next
  Write_Fast_Bus_LB(outbuffer[1], p - 1, 64010200h or shift_left(module, 20))
ENDSUB

'**************************************************************
'''Latches frequency and dutycyle register to pwm state machine.
'''module: module address (1..15)
'''pattern: each bit corresponds to a channel
'''************************************************************
SUB P2_PWM_Latch(module, pattern)
  CHECK_CARD(module)
  POKE (60010040h OR shift_left(module, 20), pattern)
ENDSUB

'**************************************************************
'''Reads the status of the pwm state machine.
'''+ return value: 
'''+ 0: stop
'''+ 1: run   (each channel one bit)
'''module: module address (1..15)
'''************************************************************
FUNCTION P2_PWM_Get_Status(module) as Long
  CHECK_CARD(module) 
  P2_PWM_Get_Status = Peek_P2 (60010000h OR shift_left(module, 20))
ENDFUNCTION

'<ENDREGION>

'<REGION> Fieldbus

'---------------------------------------------------------------
' Gets a byte from the DPRAM of a profibus-DP master or slave.
' module: module address (1..15)
' byteno: number of the byte on the DPRAM
'---------------------------------------------------------------
Function P2_Get_Pro_Byte(module, byteno) As Long            '<HIDE>
  dim in_data as long
  CHECK_CARD(module)  
  in_data = Peek_P2 (60000000h or ((byteno) * 16) OR shift_left(module, 20))
  P2_Get_Pro_Byte = (in_data and 0FFh)
EndFunction

'---------------------------------------------------------------
' Sets a byte in the DPRAM of a profibus-DP master or slave.
' byteno: number of the byte on the DPRAM
' value:  value for the selected byte
'---------------------------------------------------------------
Sub P2_Set_Pro_Byte(module, byteno, value)                  '<HIDE>
  CHECK_CARD(module)
  POKE (60000000h or ((byteno) * 16) OR shift_left(module, 20), (value and 0FFh))    
  poke(syst_hw_nop, 2)                                      '
EndSub

'---------------------------------------------------------------
' Resets Hardware on the HMS Module.
' module: module address (1..15)
'---------------------------------------------------------------
Sub P2_ABCC_Reset(module)                                   '<HIDE>
 
  dim abretry as long
  dim state as long
 
  CHECK_CARD(module)
  
  abretry = 3

  do 
    POKE (60040000h OR shift_left(module, 20), 1)           'reset active                          

    p2_sleep(100000)
    POKE (60040000h OR shift_left(module, 20), 0)           'reset inactive
    
    
    P2_sleep(150000000)                                     '1.5sec (in 10 nsec)
    p2_set_pro_byte(module, 3801H, 15)
    p2_set_pro_byte(module, 3802H, 0)
    
    state = p2_get_pro_byte(module, 3801h)
    dec abretry
  until ((state = 15) or (abretry = 0))
    
  p2_set_pro_byte(module, 3801H, 0)

EndSub

'***************************************************************
''' Reads and writes processdata from/to Profibus module.
'''+return value:
'''+         0-> Setup
'''+         2-> Wait
'''+         4-> Active
'''+     other-> Error (configuration correct?)
''' module: module address (1..15)
'''out_pd_arr[]: array with output data
'''out_pd_arr_len: number of output elements
'''in_pd_arr[]: array for input data
'''in_pd_arr_len: number of input elements
'''work_arr[]: array for communication T12 <-> Profibus-Module 
'''+ the same as at Init function
'''***************************************************************
function P2_Run_Profibus(module, out_pd_arr[], out_pd_arr_len, in_pd_arr[], in_pd_arr_len, work_arr[]) as long
  dim l_t11_lz as long
  dim l_t11_sz as long
  dim l_t11_req_cnt as long
  
  CHECK_TYPE_LONG (work_arr[1])
  CHECK_TYPE_LONG (in_pd_arr[1])
  CHECK_TYPE_LONG (out_pd_arr[1])
  CHECK_CARD(module)

  l_t11_req_cnt = in_pd_arr_len
  p2_set_par(work_arr[85], 1, TTK_PAR_RQ_IDX_NR, 0)         'Anforderung
  p2_set_par(work_arr[85], 1, TTK_PAR_RQ_CH_NR, l_t11_req_cnt)  'Anforderung start
  p2_set_par(work_arr[85], 1, TTK_PAR_RQW_IDX_NR, 0)        'offset
  p2_set_par(work_arr[85], 1, TTK_PAR_RQW_CH_NR, out_pd_arr_len)  'Anzahl
  do
    l_t11_sz = p2_get_par(work_arr[85], 1, TTK_PAR_SZ_NR)   'writepointer
    l_t11_req_cnt = p2_get_par(work_arr[85], 1, TTK_PAR_RQ_CH_NR)
  until ((l_t11_sz <> 0) and (l_t11_req_cnt = 0))
  l_t11_lz = p2_get_par(work_arr[85], 1, TTK_PAR_LZ_NR)     'leseindex
  p2_setdata_long(work_arr, TTK_DAT_NR, l_t11_sz, out_pd_arr_len, out_pd_arr, 1, 1)
  p2_set_par(work_arr[85], 1, TTK_PAR_SZ_NR, 0)             'writepointer
  p2_getdata_long(work_arr, TTK_DAT_NR, l_t11_lz, in_pd_arr_len, in_pd_arr, 1, 1)
  P2_Run_Profibus = p2_get_par(work_arr[85], 1, TTK_PAR_ABCC_STATE_NR)
endfunction

'***************************************************************
'''Initializes communication at Profibus-Module.
'''+return value: 
'''+         0-> OK
'''+     other-> Error
''' module: module address (1..15)
'''dev_adr: node ID
'''in_mod_cnt: number of input elements
'''in_mod_type: input datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''out_mod_cnt: number of output elements
'''out_mod_type: output datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''work_arr[]: array for communication T11 <-> DeviceNet-Module
'''+  min size 200 elements
'''info[]: info array for bustype
'''+  min size 10 elements
'''+ these returnvalues are correct:
'''+         [1]-> 1
'''+         [2]-> 4
'''***************************************************************
function P2_Init_Profibus(module, dev_adr, in_mod_cnt, in_mod_type, out_mod_cnt, out_mod_type, work_arr[], info[]) as long
  dim cnt as long
  dim ret as long
  dim l_modulcode as long
  dim l_arr[10] as long

  'TiCo-communication initialisieren
  CHECK_TYPE_LONG (work_arr[1])
  CHECK_CARD(module)
  ret = -1

  cnt = Peek_P2 (6800E000h OR shift_left(module, 20))

  
  if (cnt = 12345678H) then ret = 1
  if (cnt = 0) then ret = 2
  if (ret = -1) then
  
    l_modulcode = Peek_P2 (68000400h OR shift_left(module, 20))
    if (l_modulcode = 0E40h) then
      P2_TDRV_Init(module, 1, work_arr)
      ret = 0
    endif
  endif
  'return value: -1->no LIN-Module
  '               0->OK
  '               1->no Modul at this adress
  '               2->no tico
  if (ret = 0) then
    l_arr[1] = dev_adr
    l_arr[2] = in_mod_cnt
    l_arr[3] = in_mod_type
    l_arr[4] = out_mod_cnt
    l_arr[5] = out_mod_type
    p2_setdata_long(work_arr, TTK_DAT_NR, TTK_INIT_IDX + 1, 5, l_arr, 1, 1)
    P2_LIN_Init_Apply(work_arr)
    p2_getdata_long(work_arr, TTK_DAT_NR, TTK_INIT_IDX + 11, 10, info, 1, 1)
  endif
  P2_Init_Profibus = ret
endfunction 


'***************************************************************
'''Reads and writes processdata from/to DeviceNet module.
'''+return value: 
'''+         0-> Setup
'''+         2-> Wait
'''+         4-> Active
'''+     other-> Error (configuration correct?)
'''module: module address (1..15)
'''in_pd_arr[]: array for input data
'''in_pd_arr_len: number of input elements
'''out_pd_arr[]: array with output data
'''out_pd_arr_len: number of output elements
'''work_arr[]: array for communication T12 <-> DeviceNet-Module 
'''+ the same as at Init function
'''***************************************************************
function P2_Run_DeviceNet(module, in_pd_arr[], in_pd_arr_len, out_pd_arr[], out_pd_arr_len, work_arr[]) as long
  dim l_t11_lz as long
  dim l_t11_sz as long
  dim l_t11_req_cnt as long
  
  CHECK_TYPE_LONG (work_arr[1])
  CHECK_TYPE_LONG (in_pd_arr[1])
  CHECK_TYPE_LONG (out_pd_arr[1])
  CHECK_CARD(module)

  l_t11_req_cnt = in_pd_arr_len
  p2_set_par(work_arr[85], 1, TTK_PAR_RQ_IDX_NR, 0)         'Anforderung
  p2_set_par(work_arr[85], 1, TTK_PAR_RQ_CH_NR, l_t11_req_cnt)  'Anforderung start
  p2_set_par(work_arr[85], 1, TTK_PAR_RQW_IDX_NR, 0)        'offset
  p2_set_par(work_arr[85], 1, TTK_PAR_RQW_CH_NR, out_pd_arr_len)  'Anzahl
  do
    l_t11_sz = p2_get_par(work_arr[85], 1, TTK_PAR_SZ_NR)   'writepointer
    l_t11_req_cnt = p2_get_par(work_arr[85], 1, TTK_PAR_RQ_CH_NR)
  until ((l_t11_sz <> 0) and (l_t11_req_cnt = 0))
  l_t11_lz = p2_get_par(work_arr[85], 1, TTK_PAR_LZ_NR)     'leseindex
  p2_setdata_long(work_arr, TTK_DAT_NR, l_t11_sz, out_pd_arr_len, out_pd_arr, 1, 1)
  p2_set_par(work_arr[85], 1, TTK_PAR_SZ_NR, 0)             'writepointer
  p2_getdata_long(work_arr, TTK_DAT_NR, l_t11_lz, in_pd_arr_len, in_pd_arr, 1, 1)
  P2_Run_DeviceNet = p2_get_par(work_arr[85], 1, TTK_PAR_ABCC_STATE_NR)
endfunction

'***************************************************************
'''Initializes communication at DeviceNet-Module.
'''+return value: 
'''+         0-> OK
'''+     other-> Error
''' module: module address (1..15)
'''dev_adr: node ID
'''baudrate: 
'''+         0-> 125kbit
'''+         1-> 250kbit
'''+         2-> 250kbit
'''+         3-> Autobaud
'''in_mod_cnt: number of input elements
'''in_mod_type: input datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''out_mod_cnt: number of output elements
'''out_mod_type: output datatype
'''+         1-> 1 Byte
'''+         2-> 2 Byte
'''+         3-> 4 Byte
'''+        16-> 8 Byte
'''work_arr[]: array for communication T11 <-> DeviceNet-Module
'''+  min size 200 elements
'''info[]: info array for bustype
'''+  min size 10 elements
'''+ these returnvalues are correct:
'''+         [1]-> 1
'''+         [2]-> 4
'''***************************************************************
function P2_Init_DeviceNet(module, dev_adr, baudrate, in_mod_cnt, in_mod_type, out_mod_cnt, out_mod_type, work_arr[], info[]) as long
  dim cnt as long
  dim ret as long
  dim l_modulcode as long
  dim l_arr[10] as long

  'TiCo-communication initialisieren
  CHECK_TYPE_LONG (work_arr[1])
  CHECK_CARD(module)
  ret = -1

  cnt = Peek_P2 (6800E000h OR shift_left(module, 20))

  if (cnt = 12345678H) then ret = 1
  if (cnt = 0) then ret = 2
  if (ret = -1) then
    l_modulcode = Peek_P2 (68000400h OR shift_left(module, 20))

    if (l_modulcode = 0E40h) then
      P2_TDRV_Init(module, 1, work_arr)
      ret = 0
    endif
  endif
  'return value: -1->no LIN-Module
  '               0->OK
  '               1->no Modul at this adress
  '               2->no tico
  if (ret = 0) then
    l_arr[1] = dev_adr
    l_arr[2] = in_mod_cnt
    l_arr[3] = in_mod_type
    l_arr[4] = out_mod_cnt
    l_arr[5] = out_mod_type
    l_arr[6] = baudrate
    p2_setdata_long(work_arr, TTK_DAT_NR, TTK_INIT_IDX + 1, 6, l_arr, 1, 1)
    P2_LIN_Init_Apply(work_arr)
    p2_getdata_long(work_arr, TTK_DAT_NR, TTK_INIT_IDX + 11, 10, info, 1, 1)
  endif
  P2_Init_DeviceNet = ret
endfunction 

'<ENDREGION>

'<REGION> RTD 

'******************************************************************************
'''Starts RTD mode measure.
'''module_pattern: bit pattern to set the module adresses
'''****************************************************************************
sub P2_RTD_Start(module_pattern)     
  POKE (68010000h, module_pattern)                          'start auto-measure mode
endsub

'******************************************************************************
'''Initializes the RTD mode measure.
'''module: module address (1..15)
'''mode: 
'''+    0=single shot
'''+    1=continous measurement   
'''muxtime: Number of time units, which sets the settling time of the sequential control
'''+    0= standard waiting time (5000 = 100 s)
'''****************************************************************************
sub P2_RTD_Config(module, mode, muxtime)
  
  dim tvalue as long
  
  tvalue = muxtime
  if (tvalue > 65535) then tvalue = 65535
  if (tvalue < 0) then tvalue = 0
  
  if (muxtime = 0) then
    POKE (6805a260h OR shift_left(module, 20), 5000)        'settling time (*20ns)                          
  else
    POKE (6805a260h OR shift_left(module, 20), tvalue)      'settling time (*20ns)                           
  endif

  if (mode = 0) then
    POKE (6805a250h OR shift_left(module, 20), 1)                            

  else
    POKE (6805a250h OR shift_left(module, 20), 3)      
    POKE (6805a270h OR shift_left(module, 20), 1)           'start auto-measure mode    
  endif


endsub

'*******************************************************************************
'''Initializes the RTD mode.
'''module: module address (1..15)
'''channel: no. 1..8 of measurement channel
'''active: activation of measurement channel
'''+       0=Channel is disabled
'''+       1=Channel is enabled
'''type: measuring method
'''+     0=2 wire
'''+     1=4 wire
'''+     2=3 wire
'''element: Type (02) of thermo couple
'''+        0=PT 100 
'''+        1=PT 500
'''+        2=PT 1000
'''+        3=Ni 100
'''filter: Filter quality (07)
'''+ in order to filter periodic disturbances, a number
'''+ of measurements is averaged to a measuring value
'''+               0=1 measurment (filter off)
'''+               1=2 measurements (=2^1)
'''+               2=4 measurements (=2^2)
'''+               3=8 measurements (=2^3)
'''+               4=16 measurements (=2^4)
'''+               5=32 measurements (=2^5)
'''+               6=64 measurements (=2^6)
'''+               7=128 measurements (=2^7)
'''sample_period: Sampling interval in microseconds (365535) between
'''+ each 2 measurements for a measurement value (which is not the
'''+ interval between 2 measurement values).
'''+     50 Hz filter: filter=128, sample_period=156
'''+     60 Hz filter: filter=128, sample_period=130
'''+     16.3Hz filter: filter=128, sample_period=478
'''******************************************************************************
SUB P2_RTD_Channel_Config(module, channel, active, type, element, filter, sample_period)
  dim mo as long
  dim e as long
  
  e = element
  if (e = 3) then e = 0
  mo = filter AND 111B
  
  mo = mo or shift_left(e AND 11B, 5)
  mo = mo or shift_left(type AND 11B, 7) 
  ' mo = mo or shift_left(11 AND 00B, 9) 'offset 0 mV
  mo = mo or shift_left(11 AND 10B, 11)                     'gain 4
  mo = mo or shift_left(active AND 1B, 14) 
  mo = mo or shift_left(sample_period AND 0FFFFH, 16) 
   
  POKE ((68059FF0h + (channel) * 16) OR shift_left(module, 20), mo)    
  
endsub

'****************************************************************************
'''Reads the RTD status.
'''+return value: 
'''+        0 = measure compleated
'''+        1 = measure running
'''module: module address (1..15)
'''****************************************************************************
function P2_RTD_Status(module) as long
  P2_RTD_Status = Peek_P2 (6805A270h OR shift_left(module, 20))
endfunction

'******************************************************************************
'''Reads RTD.
'''+return: 24 Bit value
'''module: module address (1..15)
'''channel: no. 1...8
Function P2_RTD_Read(module, channel) as long 
  P2_RTD_Read = Peek_P2 ((60009FF0h + (channel) * 16) OR shift_left(module, 20))
endFunction 

'******************************************************************************
'''Transfers the rtd input data from channel 1..8 to an array.
'''module: module address (1..15)
'''array[]: destination array
'''index: start index at the destination array
'''*****************************************************************************
SUB P2_RTD_Read8(module, array[], index)
  check_card(module)
  System_Array_Debug_Check(array, index, 8)  

  if (if_type_fifo (array) = 1) then
    Read_Fast_Bus_LB(array, 8, 6400A004h OR shift_left(module, 20))
  else
    Read_Fast_Bus_LB(array[index], 8, 6400A004h OR shift_left(module, 20))
  endif
ENDSUB

'******************************************************************************
'''Converts 24 bit value to ohm, C or F.
'''dig_val: 24 bit value from RTD module
'''element:
'''+        0=PT 100  (-200C ... 700 C)
'''+        1=PT 500  (-200C ... 700 C)
'''+        2=PT 1000 (-200C ... 700 C)
'''+        3=NI 100  (-60C ... 250 C)
'''ret_type: 
'''+       0 = Ohm
'''+       1 = C
'''+       2 = F
'''*****************************************************************************
'''#C;R:F;
Function P2_RTD_Convert(dig_val, element, ret_type) As Float
  '>UE 4V PGA=4, OFFSET 0 mV
  
  dim value as float
  
  '
  'ulsb = 4/ 2^24 =238.e -9
  'R=U/I 
  
  'R=Ulsb *digit /i      i=0.001 => *1000
  'R=Ulsb *digit /i      1000/PGA => 250
  
  
  
 
  if (element = 0) then 
    '    value = (238.418579102e-9 * (dig_val - 2 ^ 23)) * 250 '   / 0.008   '0, 8 offset 800 mV    
    value = 0.000059604644775390625 * (dig_val - 2 ^ 23)
    if (ret_type <> 0) then value = R100_to_T(value)
  endif
      
  
      
  if (element = 1) then 
    
    '  value = (238.418579102e-9 * (dig_val - 2 ^ 23)) * 1250 ' / 0.0016  '0, 8 offset 800 mV
    value = 0.000298023223876953125 * (dig_val - 2 ^ 23)
    if (ret_type <> 0) then value = R500_to_T(value)
      
  endif
      
  if (element = 2) then 
    'value = (238.418579102e-9 * (dig_val - 2 ^ 23)) * 2500' / 0.0008   '0, 8 offset 800 mV
    value = 0.00059604644775390625 * (dig_val - 2 ^ 23)
    if (ret_type <> 0) then value = R1000_to_T(value)
  endif
    
      
  if (element = 3) then
    value = 0.000059604644775390625 * (dig_val - 2 ^ 23)
    if (ret_type <> 0) then value = Ni100_to_T(value)
  endif
  
  
  
  If (ret_type = 2) Then                                    'C -> F
    value = (value * 1.8) + 32
  EndIf
  
  P2_RTD_Convert = value
  
EndFunction

'******************************************************************************
'R: Resistance [Ohm]
'Returnvalue: Temperature [Gradcelsius]
'''#C;R:F;P1:F;
function R1000_to_T(R) as float                             '<HIDE>
  if (R <= 1000) then
    R1000_to_T = (-241.96101911923662 + (R * (0.221625771283274 + (R * (0.000028538728879 + (R * (-0.000000009909455 + (0.000000000001704 * R))))))))
  else
    R1000_to_T = (-245.79502517703554 + (R * (0.235987001741932 + (R * (0.000009961415960 + (R * (-0.000000000310489 + (0.000000000000176 * R))))))))
  endif
endfunction

'******************************************************************************
'R: Resistance [Ohm]
'Returnvalue: Temperature [Gradcelsius]
'''#C;R:F;P1:F;
function R500_to_T(R) as float                              '<HIDE> 
  if (R <= 500) then
    R500_to_T = (-241.96101911923662 + (R * (0.443251542566549 + (R * (0.000114154915517 + (R * (-0.00000007927564 + (0.000000000027264 * R))))))))
  else
    R500_to_T = (-245.78726436591276 + (R * (0.471946956899156 + (R * (0.000039879222289 + (R * (-0.000000002501607 + (0.000000000002817 * R))))))))
  endif
endfunction

'******************************************************************************
'R: Resistance [Ohm]
'Returnvalue: Temperature [Gradcelsius]
'''#C;R:F;P1:F;
function R100_to_T(R) as float                              '<HIDE>
  if (R <= 100) then
    R100_to_T = (-241.96101911923827 + (R * (2.216257712832873 + (R * (0.002853872887926 + (R * (-0.000009909454958 + (0.000000017040295 * R))))))))
  else
    R100_to_T = (-245.78726436592083 + (R * (2.359734784495932 + (R * (0.000996980557234 + (R * (-0.000000312700936 + (0.000000001760837 * R))))))))
  endif
endfunction

'******************************************************************************
'R: Resistance [Ohm]
'Returnvalue: Temperature [Gradcelsius]
'''#C;R:F;P1:F;
function Ni100_to_T(R) as float                             '<HIDE>
  if (r <= 150) then                                        '-60 bis 83 
    Ni100_to_T = (-266.8220768496540 + (R * (4.3056334917106 + (R * (-0.0287156598318 + (R * (0.0001768268092 + (R * (-0.0000006262517 + (r * 0.0000000009214))))))))))
  else
    Ni100_to_T = (-224.4670322165270000 + (R * (2.798664948531 + (R * (-0.006907088245210479 + (R * (0.00001665633668389378 + (R * (-0.0000000306710536276955 + (r * 0.0000000000267027233658013))))))))))      
  endif
endfunction

'<ENDREGION>

'<REGION> EtherCAT MIO

sub P2_MIO_ECAT_Set_Reg(module, adr, value)                 '<HIDE>
  dim status as long
  check_card(module) 
  POKE (600DF000h OR shift_left(module, 20), adr)
  POKE (600DF020h OR shift_left(module, 20), value)
  
  do 
    status = Peek_P2 (600DF100h OR shift_left(module, 20))
  until (status >= 0)
endsub


function P2_MIO_ECAT_Get_Reg(module, adr) as long           '<HIDE>
  dim status as long
  check_card(module)

  POKE (600DF100h OR shift_left(module, 20), adr)
  
  do
    P2_MIO_ECAT_Get_Reg = Peek_P2 (600DF100H OR shift_left(module, 20))
  until (P2_MIO_ECAT_Get_Reg >= 0)
endfunction

'Bit     0  : 0=ERROR-LED aus, 1=ERROR_LED an
'Bit  3..1  : -
'Bit  4..7  : pulsbreite pb x50[ms]
'Bit 15..8  : pause pa x50[ms]
'Bit 19..16 : pulszahl n, ! 0fH = blinken ohne Unterbrechung !
'Bit 31..17 : -
SUB P2_MIO_ECAT_ErrLED(module, pattern)                     '<HIDE>
  check_card(module)
  POKE (600DF1A0h OR shift_left(module, 20), pattern)                            
ENDSUB

'<ENDREGION>

'<REGION> EtherCAT PRO II Module

'---------------------------------------------------------------
'''Initializes the EtherCAT module.
'''+return value: 
'''+   ECAT_NO_ERROR                    0
'''+   ECAT_ERROR_INVALID_MODULE        1
'''module: module address (1..15)
'''ecat_datatable[]: array with 150 elements of type Long, used to store communication details 
'''---------------------------------------------------------------
Function P2_ECAT_Init(module, ecat_datatable[]) As Long
  P2_ECAT_Init = ECAT_NO_ERROR
  
  ' initialise data transfer T11 <-> TiCo
  P2_TDRV_Init(module, 1, ecat_datatable)

  If (P2_Get_Par(module, 1, ECAT_Magic_Flag_Par) <> ECAT_Magic_Flag_Value) Then
    P2_ECAT_Init = ECAT_ERROR_INVALID_MODULE
  EndIf
EndFunction

' Writes Values[DSP_Index] .. Values[DSP_Index + Count] to ECAT_Outputs[ECAT_Index] .. ECAT_Outputs[ECAT_Index + Count]
Function P2_ECAT_Write(ecat_datatable[], Values[], DSP_Index, Count, ECAT_Index) As Long  '<HIDE>
  Dim tmp as Long
  Dim Buffer[16] as Long
  Dim I as Long
  P2_ECAT_Write = ECAT_NO_ERROR

  if (if_type_long (values) = 1) then
    ' we use 2 buffer mode, so first determine which buffer to write to
    tmp = P2_Get_Par(ecat_datatable[85], 1, ECAT_Output_Buffer_DSP)  ' 21
  
    If (tmp = 0) Then
      P2_ECAT_Write = ECAT_ERROR_BUF_NOT_READY
    Else
      If (tmp = 1) Then
        P2_SetData_Long(ecat_datatable, ECAT_DSP_To_TiCo_1, ECAT_Index, Count, Values, DSP_Index, 3)  ' 1
      Else
        P2_SetData_Long(ecat_datatable, ECAT_DSP_To_TiCo_2, ECAT_Index, Count, Values, DSP_Index, 3)  ' 2
      Endif

      P2_Set_Par(ecat_datatable[85], 1, ECAT_Output_Buffer_DSP, 0)  ' 21
    EndIf
  else
    ' we use 2 buffer mode, so first determine which buffer to write to
    tmp = P2_Get_Par(ecat_datatable[85], 1, ECAT_Output_Buffer_DSP_1)
  
    If (tmp = 0) Then
      P2_ECAT_Write = ECAT_ERROR_BUF_NOT_READY
    Else
      For I = 1 To 16
        Buffer[I] = Cast_Float32ToLong(Values[I])
      Next
      If (tmp = 1) Then
        P2_SetData_Long(ecat_datatable, ECAT_DSP_To_TiCo_11, ECAT_Index, Count, Buffer, DSP_Index, 3)  ' 5
      Else
        P2_SetData_Long(ecat_datatable, ECAT_DSP_To_TiCo_21, ECAT_Index, Count, Buffer, DSP_Index, 3)  ' 6
      Endif

      P2_Set_Par(ecat_datatable[85], 1, ECAT_Output_Buffer_DSP_1, 0)
    EndIf
  endif
    
EndFunction

'---------------------------------------------------------------
'''Writes 16 longs to EtherCAT module.
'''+return value: 
'''+   ECAT_NO_ERROR                    0
'''+   ECAT_ERROR_BUF_NOT_READY         2
''' ecat_datatable[]: see P2_ECAT_Init
''' ecat_outputs[]: data with at least 16 long elements being sent to EtherCAT
'''---------------------------------------------------------------
Function P2_ECAT_Write_Data_16L(ecat_datatable[], ecat_outputs[]) As Long
  P2_ECAT_Write_Data_16L = P2_ECAT_Write(ecat_datatable, ecat_outputs, 1, ECAT_TXPDO_COUNT_16L, 1)
EndFunction

'---------------------------------------------------------------
'''Writes 16 floats to EtherCAT module.
'''+Available since EtherCAT firmware version 2.0.
'''+return value: 
'''+   ECAT_NO_ERROR                    0
'''+   ECAT_ERROR_BUF_NOT_READY         2
''' ecat_datatable[]: see P2_ECAT_Init
''' ecat_outputs_f[]: data with at least 16 float elements being sent to EtherCAT
'''---------------------------------------------------------------
'''#C;P2:F32;
Function P2_ECAT_Write_Data_16F(ecat_datatable[], ecat_outputs_f[]) As Long
  P2_ECAT_Write_Data_16F = P2_ECAT_Write(ecat_datatable, ecat_outputs_F, 1, ECAT_TXPDO_COUNT_16F, 1)
EndFunction

' Reads ECAT_Inputs[ECAT_Index] .. ECAT_Outputs[ECAT_Index + Count] into Values[DSP_Index] .. Values[DSP_Index + Count]
Function P2_ECAT_Read(ecat_datatable[], Values[], DSP_Index, Count, ECAT_Index) As Long  '<HIDE>
  Dim tmp as Long
  Dim Buffer[16] as Long
  Dim I as Long

  P2_ECAT_Read = ECAT_NO_ERROR

  if (if_type_long (values) = 1) then
    ' we use 2 buffer mode, so first determine which buffer to read from to
    tmp = P2_Get_Par(ecat_datatable[85], 1, ECAT_Input_Buffer_DSP)  ' 11
    If (tmp = 0) Then
      P2_ECAT_Read = ECAT_ERROR_BUF_NOT_READY
    Else
      If (tmp = 1) Then
        P2_GetData_Long(ecat_datatable, ECAT_TiCo_To_DSP_1, ECAT_Index, Count, Values, DSP_Index, 3)  ' 3
      Else
        P2_GetData_Long(ecat_datatable, ECAT_TiCo_To_DSP_2, ECAT_Index, Count, Values, DSP_Index, 3)  ' 4
      Endif
      P2_Set_Par(ecat_datatable[85], 1, ECAT_Input_Buffer_DSP, 0)  ' 11
    EndIf
  else
    ' we use 2 buffer mode, so first determine which buffer to read from to
    tmp = P2_Get_Par(ecat_datatable[85], 1, ECAT_Input_Buffer_DSP_1)
    If (tmp = 0) Then
      P2_ECAT_Read = ECAT_ERROR_BUF_NOT_READY
    Else
      If (tmp = 1) Then
        P2_GetData_Long(ecat_datatable, ECAT_TiCo_To_DSP_11, ECAT_Index, Count, Buffer, DSP_Index, 3)
      Else
        P2_GetData_Long(ecat_datatable, ECAT_TiCo_To_DSP_21, ECAT_Index, Count, Buffer, DSP_Index, 3)
      Endif

      P2_Set_Par(ecat_datatable[85], 1, ECAT_Input_Buffer_DSP_1, 0)
      For I = 1 To 16
        Values[I] = Cast_LongToFloat32(Buffer[I])
      Next
    EndIf
  endif
    
EndFunction

'---------------------------------------------------------------
'''Reads 16 longs from EtherCAT module.
'''+return value: 
'''+   ECAT_NO_ERROR                    0
'''+   ECAT_ERROR_BUF_NOT_READY         2
'''ecat_datatable[]: see P2_ECAT_Init
'''ecat_inputs[]: data with at least 16 elements being read from EtherCAT
'''---------------------------------------------------------------
Function P2_ECAT_Read_Data_16L(ecat_datatable[], ecat_inputs[]) As Long
  P2_ECAT_Read_Data_16L = P2_ECAT_Read(ecat_datatable, ecat_inputs, 1, ECAT_RXPDO_COUNT_16L, 1)
EndFunction

'---------------------------------------------------------------
'''Reads 16 floats from EtherCAT module.
'''+Available since EtherCAT firmware version 2.0.
'''+return value: 
'''+   ECAT_NO_ERROR                    0
'''+   ECAT_ERROR_BUF_NOT_READY         2
'''ecat_datatable[]: see P2_ECAT_Init
'''ecat_inputs_f[]: data with at least 16 elements being read from EtherCAT
'''---------------------------------------------------------------
'''#C;P2:F32;
Function P2_ECAT_Read_Data_16F(ecat_datatable[], ecat_inputs_f[]) As Long
  P2_ECAT_Read_Data_16F = P2_ECAT_Read(ecat_datatable, ecat_inputs_F, 1, ECAT_RXPDO_COUNT_16F, 1)
EndFunction

'---------------------------------------------------------------
'''Returns the current EtherCAT state.
'''+return value: 
'''+   ECAT_STATE_INIT             0001h
'''+   ECAT_STATE_PREOP            0002h
'''+   ECAT_STATE_BOOT             0003h
'''+   ECAT_STATE_SAFEOP           0004h
'''+   ECAT_STATE_OP               0008h
'''ecat_datatable[]: see P2_ECAT_Init
'''---------------------------------------------------------------
Function P2_ECAT_Get_State(ecat_datatable[]) As Long
  P2_ECAT_Get_State = P2_Get_Par(ecat_datatable[85], 1, ECAT_Current_ECAT_State)
EndFunction

'---------------------------------------------------------------
'''Returns the version of the EtherCAT firmware.
'''+return value: EtherCAT firmware version, where the high word
'''+              represents the major version, and the low word 
'''+              represents the minor version. 
'''+              Example: 00010003h -> version 1.3
'''ecat_datatable[]: see P2_ECAT_Init
'''---------------------------------------------------------------
Function P2_ECAT_Get_Version(ecat_datatable[]) As Long
  P2_ECAT_Get_Version = P2_Get_Par(ecat_datatable[85], 1, ECAT_Driver_Version)
EndFunction

'---------------------------------------------------------------
'''Sets the transfer mode of the EtherCAT module.
'''+Available since EtherCAT firmware version 2.0.
'''ecat_datatable[]: see P2_ECAT_Init
'''mode: 0: data type Long
'''+     1: data type Float
'''+     2: data types Long & Float
'''---------------------------------------------------------------
sub P2_ECAT_Set_Mode(ecat_datatable[], mode)
  P2_Set_Par(ecat_datatable[85], 1, ECAT_Config_Value, mode)
EndSub

'<ENDREGION>

'<REGION> TC-8 ISO

Import tc.lic

'******************************************************************************
'''Sets the samplerate of tc iso module.
'''module: module address (1..15)
'''rate:
'''+      1: sample rate = 3520 Hz
'''+      2: sample rate = 1760 Hz
'''+      3: sample rate = 880 Hz
'''+      4: sample rate = 440 Hz
'''+      5: sample rate = 220 Hz
'''+      6: sample rate = 110 Hz
'''+      7: sample rate = 55 Hz
'''+      8: sample rate = 27.5 Hz
'''+      9: sample rate = 13.75 Hz
'''+     15: sample rate = 6.875 Hz (default)
'''****************************************************************************
Sub P2_TC_Set_Rate(module, rate)
  CHECK_CARD(module)
  POKE (6805A000h OR shift_left(module, 20), rate)
EndSub


'******************************************************************************
'''Copies all channel values to latches.
'''module: module address (1..15)
'''****************************************************************************
SUB P2_TC_Latch(module)                                     'or syncall
  CHECK_CARD(module)   
  POKE (68010000h, shift_left(1, module - 1))               'sync_all
ENDSUB


'---------------------------------------------------------------
''' read channel latches 1..8 and convert values.
'''+remark: use P2_TC_Latch or P2_Sync_All first to latch current values
''' module: module address (1..15)
''' tc_element: type of thermo couple to be converted; use a constant if possible, a variable requires a lot of program memory.
'''+-1 thermo voltage only (without cold junction correction)
'''+ 0 thermo couple type J, -210C .. 1200C
'''+ 1 thermo couple type K, -200C .. 1372C
'''+ 2 thermo couple type N, -200C .. 1300C
'''+ 3 thermo couple type S,  -50C .. 1768C
'''+ 4 thermo couple type T, -200C ..  400C
'''+ 5 thermo couple type R,  -50C .. 1768C
'''+ 6 thermo couple type E, -200C .. 1000C
'''+ 7 thermo couple type B,  250C .. 1820C
''' ret_type:
'''+       0: thermovoltage in V;
'''+          with tc_element=-1, value is without cold junction correction and voltage range is +-80000 V.
'''+       1: temperature in C
'''+       2: temperature in F
'''array[]: destination array for data storage  [data type float]
'''array_start_index: start index in destination array for data storage
'''-------------------------------------------------------------
'''#C;P4:F;
SUB P2_TC_Read_Latch8(module, tc_element, ret_type, array[], array_start_index) 
 
  Dim volt2, korSpg as float
  dim volt, coldjunction, i as long
 
 
  dim buffer[10] as long

  
  check_card(module)
  CHECK_TYPE_FLOAT (array[1])
    

  Read_Fast_Bus_LB_unpacked1(buffer[1], 5, 6400A204H OR shift_left(module, 20))
   
  
  
  coldjunction = buffer[1] And 1FFFh                        '
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  if (tc_element = -1) then korspg = 0 
  if (tc_element = 0) then korspg = TC_Convert_Typ_J_Inv((coldjunction / 16))
    
  if (tc_element = 1) then                                  'type 'K
    If (coldjunction <= 400) Then                           '<25 C
      korspg = (2.5055 * coldjunction)
    Else
      korspg = (2.56 * (coldjunction - 9.76))
    EndIf
  endif

  if (tc_element = 2) then korspg = TC_Convert_Typ_N_Inv((coldjunction / 16))
  if (tc_element = 3) then korspg = TC_Convert_Typ_S_Inv((coldjunction / 16))
  if (tc_element = 4) then korspg = TC_Convert_Typ_T_Inv((coldjunction / 16))
  if (tc_element = 5) then korspg = TC_Convert_Typ_R_Inv((coldjunction / 16))
  if (tc_element = 6) then korspg = TC_Convert_Typ_E_Inv((coldjunction / 16))
  if (tc_element = 7) then korspg = 0

  for i = 0 to 7
    volt = buffer[i + 3] And 0FFFFh                         'thermovoltage 409.6 digit /mV 'brauche ich wahrscheinlich nicht 
    If (volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
    volt2 = volt * 2.44140625                               'thermovoltage = > V
    volt2 = volt2 + korspg 
  
    If (ret_type > 0) Then                                  'convert
      if (tc_element = 0) then array[i + array_start_index] = TC_Convert_Typ_J(volt2) 
      if (tc_element = 1) then array[i + array_start_index] = TC_Convert_Typ_K(volt2) 
      if (tc_element = 2) then array[i + array_start_index] = TC_Convert_Typ_N(volt2)
      if (tc_element = 3) then array[i + array_start_index] = TC_Convert_Typ_S(volt2)
      if (tc_element = 4) then array[i + array_start_index] = TC_Convert_Typ_T(volt2)
      if (tc_element = 5) then array[i + array_start_index] = TC_Convert_Typ_R(volt2)
      if (tc_element = 6) then array[i + array_start_index] = TC_Convert_Typ_E(volt2)
      if (tc_element = 7) then array[i + array_start_index] = TC_Convert_Typ_B(volt2)
    Else
      array[i + array_start_index] = volt2
    EndIf

    If (ret_type = 2) Then array[i + array_start_index] = (array[i + array_start_index] * 1.8) + 32  'C -> F
  next
  
ENDSUB


'---------------------------------------------------------------
''' Read schannel latches 1..6 and convert values.
'''+remark: use P2_TC_Latch or P2_Sync_All first to latch current values
''' module: module address (1..15)
''' tc_element: type of thermo couple to be converted; use a constant if possible, a variable requires a lot of program memory.
'''+-1 thermo voltage only (without cold junction correction)
'''+ 0 thermo couple type J, -210C .. 1200C
'''+ 1 thermo couple type K, -200C .. 1372C
'''+ 2 thermo couple type N, -200C .. 1300C
'''+ 3 thermo couple type S,  -50C .. 1768C
'''+ 4 thermo couple type T, -200C ..  400C
'''+ 5 thermo couple type R,  -50C .. 1768C
'''+ 6 thermo couple type E, -200C .. 1000C
'''+ 7 thermo couple type B,  250C .. 1820C
''' ret_type:
'''+       0: thermovoltage in V;
'''+          with tc_element=-1, value is without cold junction correction and voltage range is +-80000 V.
'''+       1: temperature in C
'''+       2: temperature in F
'''array[]: destination array for data storage  [data type float]
'''array_start_index: start index in destination array for data storage
'''-------------------------------------------------------------
'''#C;P4:F;
SUB P2_TC_Read_Latch6(module, tc_element, ret_type, array[], array_start_index)  '<HIDE>

  Dim volt2, korSpg As float
  Dim volt, coldjunction, i as long

  dim buffer[8] as long



  check_card(module)
  CHECK_TYPE_FLOAT (array[1])
 
  Read_Fast_Bus_SB_unpacked1(buffer[1], 4, 6300A204H OR shift_left(module, 20))

  
 
  coldjunction = buffer[1] And 1FFFh 
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  if (tc_element = -1) then korspg = 0
  If (tc_element = 0) Then korspg = TC_Convert_Typ_J_Inv((coldjunction / 16))
    
  If (tc_element = 1) Then                                  'type 'K
    If (coldjunction <= 400) Then                           '<25 C
      korspg = (2.5055 * coldjunction)
    Else
      korspg = (2.56 * (coldjunction - 9.76))
    EndIf
  endif

  If (tc_element = 2) Then korspg = TC_Convert_Typ_N_Inv((coldjunction / 16))
  If (tc_element = 3) Then korspg = TC_Convert_Typ_S_Inv((coldjunction / 16))
  If (tc_element = 4) Then korspg = TC_Convert_Typ_T_Inv((coldjunction / 16))
  If (tc_element = 5) Then korspg = TC_Convert_Typ_R_Inv((coldjunction / 16))
  If (tc_element = 6) Then korspg = TC_Convert_Typ_E_Inv((coldjunction / 16))
  If (tc_element = 7) Then korspg = 0

  for i = 0 to 5
    volt = buffer[i + 3] And 0FFFFh                         'thermovoltage 409.6 digit /mV 'brauche ich wahrscheinlich nicht 
    If (volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
    volt2 = volt * 2.44140625                               'thermovoltage = > V
    volt2 = volt2 + korspg
     
    If (ret_type > 0) Then                                  'convert
      if (tc_element = 0) Then array[i + array_start_index] = TC_Convert_Typ_J(volt2) 
      if (tc_element = 1) Then array[i + array_start_index] = TC_Convert_Typ_K(volt2) 
      if (tc_element = 2) Then array[i + array_start_index] = TC_Convert_Typ_N(volt2)
      if (tc_element = 3) Then array[i + array_start_index] = TC_Convert_Typ_S(volt2)
      if (tc_element = 4) Then array[i + array_start_index] = TC_Convert_Typ_T(volt2)
      if (tc_element = 5) Then array[i + array_start_index] = TC_Convert_Typ_R(volt2)
      if (tc_element = 6) Then array[i + array_start_index] = TC_Convert_Typ_E(volt2)
      if (tc_element = 7) Then array[i + array_start_index] = TC_Convert_Typ_B(volt2)
    Else
      array[i + array_start_index] = volt2
    EndIf
    If (ret_type = 2) Then array[i + array_start_index] = (array[i + array_start_index] * 1.8) + 32  'C -> F
  next
  
ENDSUB

'---------------------------------------------------------------
''' Reads channel latches 1..4 and convert values.
'''+remark: use P2_TC_Latch or P2_Sync_All first to latch current values
''' module: module address (1..15)
''' tc_element: type of thermo couple to be converted; use a constant if possible, a variable requires a lot of program memory.
'''+-1 thermo voltage only (without cold junction correction)
'''+ 0 thermo couple type J, -210C .. 1200C
'''+ 1 thermo couple type K, -200C .. 1372C
'''+ 2 thermo couple type N, -200C .. 1300C
'''+ 3 thermo couple type S,  -50C .. 1768C
'''+ 4 thermo couple type T, -200C ..  400C
'''+ 5 thermo couple type R,  -50C .. 1768C
'''+ 6 thermo couple type E, -200C .. 1000C
'''+ 7 thermo couple type B,  250C .. 1820C
''' ret_type:
'''+       0: thermovoltage in V;
'''+          with tc_element=-1, value is without cold junction correction and voltage range is +-80000 V.
'''+       1: temperature in C
'''+       2: temperature in F
'''array[]: destination array for data storage  [data type float]
'''array_start_index: start index in destination array for data storage
'''-------------------------------------------------------------
'''#C;P4:F;
SUB P2_TC_Read_Latch4(module, tc_element, ret_type, array[], array_start_index) 

  Dim volt2, korSpg As float
  Dim volt, coldjunction, i as long
  

  dim buffer[6] as long



  check_card(module)
  CHECK_TYPE_FLOAT (array[1])
  
  Read_Fast_Bus_SB_unpacked1(buffer[1], 3, 6200A204H OR shift_left(module, 20))  '3 longs vom Bus auf 6 verteilen

 
  coldjunction = buffer[1] And 1FFFh 
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  if (tc_element = -1) then korspg = 0
  If (tc_element = 0) Then korspg = TC_Convert_Typ_J_Inv((coldjunction / 16))
    
  If (tc_element = 1) Then                                  'type 'K
    If (coldjunction <= 400) Then                           '<25 C
      korspg = (2.5055 * coldjunction)
    Else
      korspg = (2.56 * (coldjunction - 9.76))
    EndIf
  endif

  If (tc_element = 2) Then korspg = TC_Convert_Typ_N_Inv((coldjunction / 16))
  If (tc_element = 3) Then korspg = TC_Convert_Typ_S_Inv((coldjunction / 16))
  If (tc_element = 4) Then korspg = TC_Convert_Typ_T_Inv((coldjunction / 16))
  If (tc_element = 5) Then korspg = TC_Convert_Typ_R_Inv((coldjunction / 16))
  If (tc_element = 6) Then korspg = TC_Convert_Typ_E_Inv((coldjunction / 16))
  If (tc_element = 7) Then korspg = 0

  for i = 0 to 3
    volt = buffer[i + 3] And 0FFFFh                         'thermovoltage 409.6 digit /mV 'brauche ich wahrscheinlich nicht 
    If (volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
    volt2 = volt * 2.44140625                               'thermovoltage = > V
    volt2 = volt2 + korspg
     
    If (ret_type > 0) Then                                  'convert
      if (tc_element = 0) Then array[i + array_start_index] = TC_Convert_Typ_J(volt2) 
      if (tc_element = 1) Then array[i + array_start_index] = TC_Convert_Typ_K(volt2) 
      if (tc_element = 2) Then array[i + array_start_index] = TC_Convert_Typ_N(volt2)
      if (tc_element = 3) Then array[i + array_start_index] = TC_Convert_Typ_S(volt2)
      if (tc_element = 4) Then array[i + array_start_index] = TC_Convert_Typ_T(volt2)
      if (tc_element = 5) Then array[i + array_start_index] = TC_Convert_Typ_R(volt2)
      if (tc_element = 6) Then array[i + array_start_index] = TC_Convert_Typ_E(volt2)
      if (tc_element = 7) Then array[i + array_start_index] = TC_Convert_Typ_B(volt2)
    Else
      array[i + array_start_index] = volt2
    EndIf
    If (ret_type = 2) Then array[i + array_start_index] = (array[i + array_start_index] * 1.8) + 32  'C -> F
  next
  
ENDSUB

'---------------------------------------------------------------
''' Reads channel latches 1..2 and convert values.
'''+remark: use P2_TC_Latch or P2_Sync_All first to latch current values
''' module: module address (1..15)
''' tc_element: type of thermo couple to be converted; use a constant if possible, a variable requires a lot of program memory.
'''+-1 thermo voltage only (without cold junction correction)
'''+ 0 thermo couple type J, -210C .. 1200C
'''+ 1 thermo couple type K, -200C .. 1372C
'''+ 2 thermo couple type N, -200C .. 1300C
'''+ 3 thermo couple type S,  -50C .. 1768C
'''+ 4 thermo couple type T, -200C ..  400C
'''+ 5 thermo couple type R,  -50C .. 1768C
'''+ 6 thermo couple type E, -200C .. 1000C
'''+ 7 thermo couple type B,  250C .. 1820C
''' ret_type:
'''+       0: thermovoltage in V;
'''+          with tc_element=-1, value is without cold junction correction and voltage range is +-80000 V.
'''+       1: temperature in C
'''+       2: temperature in F
'''array[]: destination array for data storage  [data type float]
'''array_start_index: start index in destination array for data storage
'''-------------------------------------------------------------
'''#C;P4:F;
SUB P2_TC_Read_Latch2(module, tc_element, ret_type, array[], array_start_index)  '<HIDE>

  Dim volt2, korSpg As float
  Dim volt, coldjunction, i as long

  dim buffer[4] as long
  


  check_card(module)
  CHECK_TYPE_FLOAT (array[1]) 
  Read_Fast_Bus_SB_unpacked1(buffer[1], 2, 6100A204H OR shift_left(module, 20))  '2 longs vom Bus auf 4 verteilen

  coldjunction = buffer[1] And 1FFFh 
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h

  if (tc_element = -1) then korspg = 0
  If (tc_element = 0) Then korspg = TC_Convert_Typ_J_Inv((coldjunction / 16))
    
  If (tc_element = 1) Then                                  'type 'K
    If (coldjunction <= 400) Then                           '<25 C
      korspg = (2.5055 * coldjunction)
    Else
      korspg = (2.56 * (coldjunction - 9.76))
    EndIf
  endif

  If (tc_element = 2) Then korspg = TC_Convert_Typ_N_Inv((coldjunction / 16))
  If (tc_element = 3) Then korspg = TC_Convert_Typ_S_Inv((coldjunction / 16))
  If (tc_element = 4) Then korspg = TC_Convert_Typ_T_Inv((coldjunction / 16))
  If (tc_element = 5) Then korspg = TC_Convert_Typ_R_Inv((coldjunction / 16))
  If (tc_element = 6) Then korspg = TC_Convert_Typ_E_Inv((coldjunction / 16))
  If (tc_element = 7) Then korspg = 0

  for i = 0 to 1
    volt = buffer[i + 3] And 0FFFFh                         'thermovoltage 409.6 digit /mV 'brauche ich wahrscheinlich nicht 
    If (volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
    volt2 = volt * 2.44140625                               'thermovoltage = > V
    volt2 = volt2 + korspg
     
    If (ret_type > 0) Then                                  'convert
      if (tc_element = 0) Then array[i + array_start_index] = TC_Convert_Typ_J(volt2) 
      if (tc_element = 1) Then array[i + array_start_index] = TC_Convert_Typ_K(volt2) 
      if (tc_element = 2) Then array[i + array_start_index] = TC_Convert_Typ_N(volt2)
      if (tc_element = 3) Then array[i + array_start_index] = TC_Convert_Typ_S(volt2)
      if (tc_element = 4) Then array[i + array_start_index] = TC_Convert_Typ_T(volt2)
      if (tc_element = 5) Then array[i + array_start_index] = TC_Convert_Typ_R(volt2)
      if (tc_element = 6) Then array[i + array_start_index] = TC_Convert_Typ_E(volt2)
      if (tc_element = 7) Then array[i + array_start_index] = TC_Convert_Typ_B(volt2)
    Else
      array[i + array_start_index] = volt2
    EndIf
    If (ret_type = 2) Then array[i + array_start_index] = (array[i + array_start_index] * 1.8) + 32  'C -> F
  next
  
ENDSUB

'---------------------------------------------------------------
''' Reads channel and return converted value.
'''+remark: use P2_TC_Latch or P2_Sync_All first to latch current values
''' module: module address (1..15)
''' channel: (1-8)
''' tc_element: type of thermo couple to be converted; use a constant if possible, a variable requires a lot of program memory.
'''+-1 thermo voltage only (without cold junction correction)
'''+ 0 thermo couple type J, -210C .. 1200C
'''+ 1 thermo couple type K, -200C .. 1372C
'''+ 2 thermo couple type N, -200C .. 1300C
'''+ 3 thermo couple type S,  -50C .. 1768C
'''+ 4 thermo couple type T, -200C ..  400C
'''+ 5 thermo couple type R,  -50C .. 1768C
'''+ 6 thermo couple type E, -200C .. 1000C
'''+ 7 thermo couple type B,  250C .. 1820C
''' ret_type:
'''+       0: thermovoltage in V;
'''+          with tc_element=-1, value is without cold junction correction and voltage range is +-80000 V.
'''+       1: temperature in C
'''+       2: temperature in F
'''-------------------------------------------------------------
'''#C;R:F;
Function P2_TC_Read_Latch(module, channel, tc_element, ret_type) as float

  Dim value, volt, coldjunction as long
  Dim volt2 as float

  check_card(module)
  value = Peek_P2 ((6000A2F0h + (channel) * 16) OR shift_left(module, 20))

  coldjunction = (Shift_Right(value, 16)) And 1FFFh
  If (coldjunction And 1000h = 1000h) Then coldjunction = coldjunction Or 0FFFFE000h



  volt = value And 0FFFFh                                   'thermovoltage 409.6 digit /mV
  If (volt And 32768 = 32768) Then volt = volt Or 0FFFF0000h
  volt2 = volt * 2.44140625                                 'thermovoltage = > V
  
  If (tc_element = 0) Then volt2 = volt2 + TC_Convert_Typ_J_Inv((coldjunction / 16))
  
  If (tc_element = 1) Then                                  'type 'K
    If (coldjunction <= 400) Then                           '<25 C
      volt2 = volt2 + (2.5055 * coldjunction)
    Else
      volt2 = volt2 + (2.56 * (coldjunction - 9.76))
    EndIf
  endif
  
  If (tc_element = 2) Then volt2 = volt2 + TC_Convert_Typ_N_Inv((coldjunction / 16))
  If (tc_element = 3) Then volt2 = volt2 + TC_Convert_Typ_S_Inv((coldjunction / 16))
  If (tc_element = 4) Then volt2 = volt2 + TC_Convert_Typ_T_Inv((coldjunction / 16))
  If (tc_element = 5) Then volt2 = volt2 + TC_Convert_Typ_R_Inv((coldjunction / 16))
  If (tc_element = 6) Then volt2 = volt2 + TC_Convert_Typ_E_Inv((coldjunction / 16))
  'If (tc_element = 7) Then volt2 = volt2 + 0
  
  If (ret_type > 0) Then                                    'convert
    If (tc_element = 0) Then P2_TC_Read_Latch = TC_Convert_Typ_J(volt2) 
    If (tc_element = 1) Then P2_TC_Read_Latch = TC_Convert_Typ_K(volt2) 
    If (tc_element = 2) Then P2_TC_Read_Latch = TC_Convert_Typ_N(volt2)
    If (tc_element = 3) Then P2_TC_Read_Latch = TC_Convert_Typ_S(volt2)
    If (tc_element = 4) Then P2_TC_Read_Latch = TC_Convert_Typ_T(volt2)
    If (tc_element = 5) Then P2_TC_Read_Latch = TC_Convert_Typ_R(volt2)
    If (tc_element = 6) Then P2_TC_Read_Latch = TC_Convert_Typ_E(volt2)
    If (tc_element = 7) Then P2_TC_Read_Latch = TC_Convert_Typ_B(volt2)
  Else
    P2_TC_Read_Latch = volt2
  EndIf

  If (ret_type = 2) Then P2_TC_Read_Latch = (P2_TC_Read_Latch * 1.8) + 32  'C -> F  
  If (ret_type = 5) Then P2_TC_Read_Latch = coldjunction / 16 
  If (ret_type = 6) Then P2_TC_Read_Latch = volt            'for debug 
endfunction

'''<ENDREGION>

'<REGION> COMP 16

'********************************** CMP 16 ***************************************
'''Sets hysteresis switch points for a channel group
'''+Read comparator bits with instructions for digital inputs e.g. P2_Digin_Long.
'''+With hold/standard hysteresis, bits refer to channels as follows:
'''+       Bit no.       15, 14, .. 1, 0
'''+       Channel no.   15, 14, .. 1, 0
'''+With 2 channel hysteresis (P2_Comp_Set_Voltage), bits refer to channels as follows:
'''+       Bit no.         23,   22,   .. 17,  16
'''+       Channel pair  15/14, 13/12, .. 3/2, 1/0
'''module: module address (1..15)
'''ch_group: channel group (1..4)
'''+      1: Channels 0,2,4,6
'''+      2: Channels 1,3,5,7
'''+      3: Channels 8,10,12,14
'''+      4: Channels 9,11,13,15 
'''value: output value in digits (31675..65535), refers to voltage -1V..30V
'''+       digits = volts *(65536/60)+32768
'''+       volts  = (digits - 32768)*60/65536
'''******************************************************************************
SUB P2_Comp_Set(module, ch_group, value) 
  check_card(module)
  POKE ((60022FF0h + (ch_group) * 16) OR shift_left(module, 20), value)
ENDSUB

'********************************** CMP 16 ***************************************
'''Sets operation mode (hysteresis/hold) for comparators of a channel group
'''module: module address (1..15)
'''ch_group: channel group (1..4)
'''+      1: Channels 0,1,2,3
'''+      2: Channels 4,5,6,7
'''+      3: Channels 8,9,10,11
'''+      4: Channels 12,13,14,15
'''mode: operation mode (0..7)
'''+      0: no hysteresis / no hold
'''+      1: Hold 1 s.
'''+      2: Hold 10 s.
'''+      3: Hold 100 s.
'''+      4: Hysteresis +-34 mV around threshold  (until Rev. E02: +-17mV)
'''+      5: Hysteresis +-66 mV around threshold  (until Rev. E02: +-33mV)
'''+      6: Hysteresis +-110 mV around threshold (until Rev. E02: +-55mV)
'''+      7: Hysteresis +-200 mV around threshold (until Rev. E02: +-100mV)
'''******************************************************************************
SUB P2_Comp_Init(module, ch_group, mode) 
  check_card(module)
  POKE ((680509E0h + (ch_group) * 32) OR shift_left(module, 20), mode)
ENDSUB

SUB P2_Comp_Init_old(module, ch_pair, mode)                 '<HIDE>
  check_card(module)
  POKE ((680509F0h + (ch_pair) * 16) OR shift_left(module, 20), mode)
ENDSUB

''******************************************************************************
'''Sets spike filter duration for all comparators.
'''+Not suitable for combination with comparator mode Hold (P2_Comp_Init, mode=1..3).
'''+The number of spikes should be small, compared to the pulse width of the signal.
'''module: module address (1..15)
'''filter_value: Filtering duration, given in cycles (1..65535) of 20 ns length.
'''+ The value 0 disables the filter.
'''+ The filtering duration should be a bit longer than the expected width of spikes.
''''****************************************************************************
SUB P2_Comp_Filter_Init(module, filter_value)
  CHECK_CARD(module)
  POKE (68048760h OR shift_left(module, 20), Filter_value)
  p2_sleep(14)
ENDSUB

'<ENDREGION>

'<REGION> SENT

'***************************************************************
'''Initializes communication between SENT module TiCo and T12.
'''module: module address (1..15)
'''sent_datatable[]: array with 150 elements of type Long, used to store communication details 
'''***************************************************************
SUB P2_SENT_Init(module, sent_datatable[])
  P2_TDRV_INIT(module, 1, sent_datatable)
ENDSUB

'******************************************************************************
'''Gets the version of the SENT interface.
'''+Result: version number of the SENT interface
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_SENT_Get_Version(module) As Long
  P2_SENT_Get_Version = P2_Get_Par(module, 1, 80)
ENDFUNCTION

'--------------------------------------------------------------------------------

'******************************************************************************
'''Gets the status of the SENT channels.
'''+Result: bit pattern representing the operation status of the SENT channels
'''+bit = 0: detection mode, bit = 1: read mode
'''+bit 0 = status of channel 1
'''+bit 1 = status of channel 2
'''+bit 2 = status of channel 3
'''+bit 3 = status of channel 4
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_SENT_Get_ChannelState(module) As Long
  P2_SENT_Get_ChannelState = P2_Get_Par(module, 1, 3)
ENDFUNCTION

'--------------------------------------------------------------------------------
' Daten
'--------------------------------------------------------------------------------

'******************************************************************************
'''Gets the clock tick time of a SENT input channel in nanoseconds.
'''+Result: clock tick time (1500..6000) in ns.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_ClockTick(module, sent_channel) As Long
  P2_SENT_Get_ClockTick = P2_Get_Par(module, 1, (10 + (sent_channel) * 10))
ENDFUNCTION

' old name, changed for FW 17
FUNCTION P2_SENT_Get_Period(module, sent_channel) As Long   '<HIDE>
  P2_SENT_Get_Period = P2_SENT_Get_ClockTick(module, sent_channel)
ENDFUNCTION

'******************************************************************************
'''Gets the pulse count of a SENT channel. The pulse count indicates the
'''+existence of a pulse pause.
'''+Result: 9 = SENT signal without pulse pause
'''+       10 = SENT signal with pulse pause
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_PulseCount(module, sent_channel) As Long
  P2_SENT_Get_PulseCount = P2_Get_Par(module, 1, (11 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the errorbits of a SENT channel
'''+Result: Errorbits
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Errorbits(module, sent_channel) AS LONG
  P2_SENT_Get_Errorbits = P2_Get_Par(module, 1, (12 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the result of a CRC check of a SENT fast channel message.
'''+Result:0 = CRC check ok, transfer successful
'''+       1 = CRC error
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Fast_Channel_CRC_OK(module, sent_channel) As Long
  P2_SENT_Get_Fast_Channel_CRC_OK = P2_Get_Par(module, 1, (13 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the first 12 bit value (fast channel) of a SENT channel
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Fast_Channel1(module, sent_channel) As Long
  P2_SENT_Get_Fast_Channel1 = P2_Get_Par(module, 1, (14 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the second 12 bit value (fast channel) of a SENT channel
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Fast_Channel2(module, sent_channel) As Long
  P2_SENT_Get_Fast_Channel2 = P2_Get_Par(module, 1, (15 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the result of a CRC check of a SENT serial message.
'''+Result:0 = CRC check ok, transfer successful
'''+       1 = CRC error
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Serial_Message_CRC_OK(module, sent_channel) As Long
  P2_SENT_Get_Serial_Message_CRC_OK = P2_Get_Par(module, 1, (16 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the Id number of a SENT serial message.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Serial_Message_Id(module, sent_channel) As Long
  P2_SENT_Get_Serial_Message_Id = P2_Get_Par(module, 1, (17 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the data value of a SENT serial message.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Serial_Message_Data(module, sent_channel) As Long
  P2_SENT_Get_Serial_Message_Data = P2_Get_Par(module, 1, (18 + (sent_channel) * 10))
ENDFUNCTION

'******************************************************************************
'''Gets the message counter of a SENT channel. The counter is increased by 1
'''+with each arriving SENT message.
'''+A continuously increasing counter value serves as timeout monitor for the
'''+SENT sensor.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Get_Msg_Counter(module, sent_channel) As Long
  P2_SENT_Get_Msg_Counter = P2_Get_Par(module, 1, (19 + (sent_channel) * 10))
ENDFUNCTION

'--------------------------------------------------------------------------------
' Commands to SENT module
'--------------------------------------------------------------------------------

'******************************************************************************
'''Checks if the SENT module is ready to process a command.
'''+Result:   0 = ready for next command.
'''+        <>0 = still busy
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_SENT_Command_Ready(module) As Long
  P2_SENT_Command_Ready = P2_Get_Par(module, 1, 4)   
ENDFUNCTION
  
'******************************************************************************
'''Command: Sets a SENT channel to detection mode.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Set_Detection(module, sent_channel) As Long
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_DETECTION)    
    ready = 0    
  EndIf
  P2_SENT_Set_Detection = ready
  
ENDFUNCTION

'******************************************************************************
'''Command: Sets a SENT channel to read mode with a specified clock tick time.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''clocktick: SENT clock tick time in ns (1500..6000)
'''****************************************************************************
FUNCTION P2_SENT_Set_ClockTick(module, sent_channel, clocktick) As Long
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then
    P2_Set_Par(module, 1, 6, clocktick)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_CLOCKTICK)
    ready = 0    
  EndIf
  P2_SENT_Set_ClockTick = ready

ENDFUNCTION

' old name, changed for FW 17
FUNCTION P2_SENT_Set_Period(module, sent_channel, period) As Long  '<HIDE>
  P2_SENT_Set_Period = P2_SENT_Set_ClockTick(module, sent_channel, period)
ENDFUNCTION

'******************************************************************************
'''Command: Sets the pulse count for a SENT channel.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''pulsecount: SENT pulse count (9 without pause pulse, 10 with pause pulse)
'''****************************************************************************
FUNCTION P2_SENT_Set_PulseCount(module, sent_channel, pulsecount) As Long
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then
    P2_Set_Par(module, 1, 6, pulsecount)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_PULSECOUNT)
    ready = 0    
  EndIf
  P2_SENT_Set_PulseCount = ready

ENDFUNCTION

'******************************************************************************
'''Command: Sets the checksum implementation type for a SENT channel (sent version >=11).
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''crc_implement: 0 legacy implementation, 1 recommended implementation
'''****************************************************************************
FUNCTION P2_SENT_Set_CRC_Implementation(module, sent_channel, crc_implement) As Long
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then
    P2_Set_Par(module, 1, 6, crc_implement)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_CHECKSUMIMPLEMENTATION)
    ready = 0    
  EndIf
  P2_SENT_Set_CRC_Implementation = ready

ENDFUNCTION

'******************************************************************************
'''Command: Sets the sensor type for a SENT channel (sent version >=11).
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''sensor_type: 
'''****************************************************************************
FUNCTION P2_SENT_Set_Sensor_Type(module, sent_channel, sensor_type) As Long
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then
    P2_Set_Par(module, 1, 6, sensor_type)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_SENSORTYPE)
    ready = 0    
  EndIf
  P2_SENT_Set_Sensor_Type = ready

ENDFUNCTION

'******************************************************************************
'''Command: Clears the serial message data array for a SENT channel (sent version >=14).
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Clear_Serial_Message_Array(module, sent_channel) As Long
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_CLEAR_SERIALDATA)
    ready = 0    
  EndIf
  P2_SENT_Clear_Serial_Message_Array = ready
ENDFUNCTION

'--------------------------------------------------------------------------------

'******************************************************************************
'''Gets the serial message data and count (sent version >=14).
'''tdrv[]: Tico driver array
'''sent_channel: SENT channel (1..4)
'''serial_array[]: Array for target data. Needs to have space for 512 elements. 1..256 message value, 257..512 message counter
'''serial_array_idx: Start index in target array. Usually 1.
'''****************************************************************************
SUB P2_SENT_Get_Serial_Message_Array(tdrv[], sent_channel, serial_array[], serial_array_idx)
  Dim startidx AS LONG
  
  startidx = (sent_channel - 1) * 512 + 1
  P2_GETDATA_LONG(tdrv, 8, startidx, 512, serial_array, serial_array_idx, 3) 

ENDSUB

'******************************************************************************
'''Command: Sets pattern of SENT channels to be latched for data read-out.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''pattern: bitwise SENT channel pattern
'''****************************************************************************
FUNCTION P2_SENT_Request_Latch(module, pattern) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_Set_Par(module, 1, 5, pattern)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_REQUEST_LATCH)    
    ready = 0    
  EndIf
  P2_SENT_Request_Latch = ready
  
ENDFUNCTION

'******************************************************************************
'''Sets pattern of SENT channels to be latched for data read-out.
'''+result: bitwise channel pattern. 
'''+        0 channel has data for read-out
'''+        1 channel still needs to be updated by SENT module 
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_SENT_Check_Latch(module) AS LONG
  P2_SENT_Check_Latch = P2_Get_Par(module, 1, 13)
ENDFUNCTION

'******************************************************************************
'''Gets the latched SENT channel data. 
'''sent_datatable[]: communication array as initialised with P2_SENT_INIT
'''sent_channel: SENT channel (1..4)
'''data_array[]: target data array
'''data_array_idx: target data index
'''****************************************************************************
SUB P2_SENT_Get_Latch_Data(sent_datatable[], sent_channel, data_array[], data_array_idx)
  DIM idx AS LONG
  DIM len AS LONG
  len = 32
  idx = (sent_channel - 1) * len + 1 
  P2_GetData_Long(sent_datatable, 2, idx, len, data_array, data_array_idx, 3)    
ENDSUB

'******************************************************************************
'''Gets the output mode of the SENT channels.
'''+Result: bit pattern representing the operation status of the SENT channels
'''+bit = 0: continous mode, bit = 1: Fifo mode
'''+bit 0 = status of channel 1
'''+bit 1 = status of channel 2
'''+bit 2 = status of channel 3
'''+bit 3 = status of channel 4
'''module: module address (1..15)
'''****************************************************************************
FUNCTION P2_SENT_Get_Output_Mode(module) AS LONG
  P2_SENT_Get_Output_Mode = P2_Get_Par(module, 1, 3)
ENDFUNCTION


'******************************************************************************
'''Enables or disables output on a SENT channel. Before enabling, the channel must be configured.
'''module: module address (1..15)
'''enable_pattern: bitwise channel enable pattern
'''****************************************************************************
SUB P2_SENT_Enable_Channel(module, enable_pattern)
  P2_Set_Par(module, 1, 10, enable_pattern)
ENDSUB


'******************************************************************************
'''Inverts SENT channels output.
'''module: module address (1..15)
'''inverse_pattern: bitwise channel inverse pattern
'''****************************************************************************
SUB P2_SENT_Invert_Channel(module, inverse_pattern)
  P2_Set_Par(module, 1, 11, inverse_pattern)
ENDSUB

'******************************************************************************
'''Command: Sets the output channel operation mode.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''mode: 0 continous mode, 1 FIFO SENT mode, 2 FIFO PWM mode 
'''+ 0: use commands for continous mode. 
'''+ 1: 4 Bit Status / 12 Bit Fast Ch1 / 12 Bit Fast Ch2 / 4 Bit CRC
'''+ 2: 32 Bit * 10 ns resolution time to next edge change.
'''****************************************************************************
FUNCTION P2_SENT_Set_Output_Mode(module, sent_channel, mode) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_Set_Par(module, 1, 6, mode)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_OUTPUT_MODE)    
    ready = 0    
  EndIf
  P2_SENT_Set_Output_Mode = ready
  
ENDFUNCTION


'******************************************************************************
'''Command: Continous Mode - Configures an output channel.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''clocktick: clock tick time in ns, this means 3000 for 3 s. At least 1500 for 1.5 s.
'''pause: signal length in clock ticks.
'''+      0 no pause pulse
'''+      >0 signal length gets filled up to that value by a pause pulse 
'''lowticks: number of low ticks. Usually 4. At least 1.
'''crc_implementation: type of CRC generation algorithm: 0 legacy CRC, 1 recommended CRC
'''****************************************************************************
FUNCTION P2_SENT_Config_Output(module, sent_channel, clocktick, pause, lowticks, crc_implementation) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_Set_Par(module, 1, 9, crc_implementation)
    P2_Set_Par(module, 1, 8, lowticks)
    P2_Set_Par(module, 1, 7, pause)
    P2_Set_Par(module, 1, 6, clocktick)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_CONFIG_OUTPUT)    
    ready = 0    
  EndIf
  P2_SENT_Config_Output = ready
  
ENDFUNCTION

  
'******************************************************************************
'''Continous Mode - Sets the 2 reserved bits in the status nibble.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''value: 2 bit value
'''****************************************************************************
SUB P2_SENT_Set_Reserved_Bits(module, sent_channel, value)
  P2_Set_Par(module, 1, (11 + (sent_channel) * 10), value)
ENDSUB


'******************************************************************************
'''Continous Mode - Sets the first 12 bit value (fast channel) of a SENT channel.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''value: 12 bit channel value
'''****************************************************************************
SUB P2_SENT_Set_Fast_Channel1(module, sent_channel, value)
  P2_Set_Par(module, 1, (12 + (sent_channel) * 10), value)
ENDSUB


'******************************************************************************
'''Continous Mode - Sets the second 12 bit value (fast channel) of a SENT channel.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''value: 12 bit channel value
'''****************************************************************************
SUB P2_SENT_Set_Fast_Channel2(module, sent_channel, value)
  P2_Set_Par(module, 1, (13 + (sent_channel) * 10), value)
ENDSUB


'******************************************************************************
'''Command: Continous Mode - Configures the serial messages of a channel.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''serial_messagetype: select which type of serial messages will be used
'''+                    0 no serial messages
'''+                    1 standard serial message format
'''+                    2 enhanced serial message format, 8 bit Id, 12 bit Data
'''+                    3 enhanced serial message format, 4 bit Id, 16 bit Data
'''****************************************************************************
FUNCTION P2_SENT_Config_Serial_Messages(module, sent_channel, serial_messagetype) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_Set_Par(module, 1, 6, serial_messagetype)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_CONFIG_SERIAL_MESSAGES)    
    ready = 0    
  EndIf
  P2_SENT_Config_Serial_Messages = ready
  
ENDFUNCTION


'******************************************************************************
'''Command: Continous Mode - Sets the serial message id pattern.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_datatable[]: array with 150 elements of type Long, used to store communication details 
'''sent_channel: SENT channel (1..4)
'''sm_id_array[]: array of maximally 32 serial message ids.
'''sm_value_array[]: array of serial message values
'''sm_len: number of used serial messages. Maximum 32.
'''****************************************************************************
FUNCTION P2_SENT_Set_Serial_Message_Pattern(module, sent_datatable[], sent_channel, sm_id_array[], sm_value_array[], sm_len) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_SetData_Long(sent_datatable, 10, (sent_channel - 1) * 32 + 1, sm_len, sm_id_array, 1, 3)
    P2_SetData_Long(sent_datatable, 11, (sent_channel - 1) * 32 + 1, sm_len, sm_value_array, 1, 3)

    P2_Set_Par(module, 1, 6, sm_len)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_ALL_SERIAL_MESSAGES)    
    ready = 0    
  EndIf
  P2_SENT_Set_Serial_Message_Pattern = ready
 
ENDFUNCTION


'******************************************************************************
'''Command: Continous Mode - Sets a serial message.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''sm_id_idx: serial message array index. (not serial message id!)
'''sm_value: serial message value
'''****************************************************************************
FUNCTION P2_SENT_Set_Serial_Message_Data(module, sent_channel, sm_id_idx, sm_value) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_Set_Par(module, 1, 7, sm_value)
    P2_Set_Par(module, 1, 6, sm_id_idx)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_SINGLE_SERIAL_MESSAGE)  
    ready = 0    
  EndIf
  P2_SENT_Set_Serial_Message_Data = ready
  
ENDFUNCTION


'******************************************************************************
'''Fifo Mode - Gets Fifo filling level information.
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Fifo_Empty(module, sent_channel) AS LONG
  P2_SENT_Fifo_Empty = P2_Get_Par(module, 1, (18 + (sent_channel) * 10))
ENDFUNCTION


'******************************************************************************
'''Command: Fifo Mode - Clears Fifo.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_channel: SENT channel (1..4)
'''****************************************************************************
FUNCTION P2_SENT_Fifo_Clear(module, sent_channel) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_FIFO_CLEAR)    
    ready = 0    
  EndIf
  P2_SENT_Fifo_Clear = ready
  
ENDFUNCTION


'******************************************************************************
'''Command: Fifo Mode - Sets values to Fifo. Format according as set in Fifo mode.
'''+Result: 0 = command processed sucessfully
'''module: module address (1..15)
'''sent_datatable[]: array with 150 elements of type Long, used to store communication details 
'''sent_channel: SENT channel (1..4)
'''data[]: 1 - 100 values for the Fifo
'''len: length of the data.
'''****************************************************************************
FUNCTION P2_SENT_Set_Fifo(module, sent_datatable[], sent_channel, data[], len) AS LONG
  Dim ready As Long
  
  ready = P2_Get_Par(module, 1, 4)
  If (ready = 0) Then 
    P2_SETDATA_LONG(sent_datatable, 2, 1, len, data, 1, 3)
 
    P2_Set_Par(module, 1, 6, len)
    P2_Set_Par(module, 1, 5, sent_channel)
    P2_Set_Par(module, 1, 4, SENT_COMMAND_SET_FIFO)    
    ready = 0    
  EndIf
  P2_SENT_Set_Fifo = ready
 
ENDFUNCTION

'<ENDREGION>

'<REGION> SPI common

'*******************************************************************************
'''Sets the module operation mode.
'''module: module address (1..15)
'''mode: key number to set the operation mode
'''+  1: digital inputs/outputs only, refers to module Pro II-DIO-32-TiCo
'''+  2: SPI interface, both channels SPI slaves
'''+  3: SPI interface, channel 1 SPI master, channel 2 SPI slave
'''+  4: SPI interface, both channels SPI master
'''+  5: SPI interface, both channels SPI slaves with one clock input (clk1) for both slaves
'''*****************************************************************************
SUB P2_SPI_Mode(module, mode)
  dim imode as long
  CHECK_CARD(module)
  if (mode = 1) then imode = 1 
  if (mode = 2) then imode = 6
  if (mode = 3) then imode = 12
  if (mode = 4) then imode = 24
  if (mode = 5) then imode = 6 + 64
  if (mode = 6) then imode = 6 + 64 + 32                    'ADZL 0507  
  POKE (6805A000h OR shift_left(module, 20), imode)

ENDSUB

'******************************************************************************
'''Configures an SPI channel, either SPI master and SPI slave.
'''module: module address (1..15)
'''channel: SPI channel (1..2)  
'''mode: SPI master mode for CPOL (clock polarity) und CPHA (clock phase)
'''+  0: CPOL=0 CPHA=0 
'''+  1: CPOL=0 CPHA=1
'''+  2: CPOL=1 CPHA=0
'''+  3: CPOL=1 CPHA=1
'''bitlength: number (1..64) of transferred bits in an SPI message.
'''data_order: sequence of bits in an SPI message.
'''+    0: MSB first
'''+    1: LSB first
'''ss_select: Level to set a slave-select line active
'''+    0: active low
'''+    1: active high
'''******************************************************************************
SUB P2_SPI_Config(module, channel, mode, bitlength, data_order, ss_select)
  CHECK_CARD(module)
  dim imode as long
  
  if (mode = 0) then imode = 3 
  if (mode = 1) then imode = 0
  if (mode = 2) then imode = 11  
  if (mode = 3) then imode = 8
  
  imode = imode or shift_left(data_order AND 1, 4)
  imode = imode or shift_left(ss_select AND 1, 2)
  
  POKE ((60039F70h + (channel) * 16) OR shift_left(module, 20), 0)  'slave fifo disable
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
  POKE ((60038400h + (channel - 1) * 16) OR shift_left(module, 20), imode)
  POKE ((60038200h + (channel - 1) * 16) OR shift_left(module, 20), bitlength - 1)
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
  
  POKE ((60039F70h + (channel) * 16) OR shift_left(module, 20), 1)  'slave fifo enable
  
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
ENDSUB

'<ENDREGION>

'<REGION> SPI Slave

'******************************************************************************
'''Configures the settings of an SPI Slave; works supplemental to P2_SPI_Config.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''mode: Set mode "store number of received bits"
'''+     0: store SPI message only in slave infifo
'''+     1: store both number of received bits and SPI message in slave infifo
'''****************************************************************************
SUB P2_SPI_Slave_Config(module, channel, mode)
  CHECK_CARD(module)
  POKE (((6805A040h + (channel - 1) * 16) OR shift_left(module, 20)), mode)
ENDSUB

'******************************************************************************
'''Writes values into output FIFO of an SPI slave.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''count:   number of 32 bit values to be written
'''+Check first with P2_SPI_Slave_OutFIFO_Empty, if the Fifo has enough space.
'''array[]: array holding 32 bit values to be written
'''+ The output Fifo can hold 18 values of 32 bit. If SPI bit length exceeds
'''+ 32 bit, store values in pairs: lower word first (=smaller array index),
'''+  then higher word.
'''array_idx: start index in array[] pointing to the first 32 bit value
'''****************************************************************************
SUB P2_SPI_Slave_OutFifo_Write(module, channel, count, array[], array_idx) 
  CHECK_TYPE_LONG (array[1])
  CHECK_CARD(module)
  if (count > 0) then 
    System_Array_Debug_Check(array, array_idx, count)
    Write_Fast_Bus_LB(array[array_idx], count, (64038FF0h + shift_left(channel, 4)) or (shift_left(module, 20)))
    poke(syst_hw_nop, 4)                                    '80 ns bus sleep
  endif
ENDSUB

'******************************************************************************
'''Returns the number of free places in the output Fifo of an SPI slave.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''****************************************************************************
FUNCTION P2_SPI_Slave_OutFifo_Empty(module, channel) as Long
  dim tmp as long
  CHECK_CARD(module)

  tmp = Peek_P2 ((6805A070h + (channel) * 16) OR shift_left(module, 20))

  P2_SPI_Slave_OUTFIFO_Empty = ((Shift_Right(tmp, 16)) and 0000001Fh)
ENDFUNCTION

'******************************************************************************
'''Returns the number of used places (= received 32 bit values) in the input
'''+ Fifo of an SPI slave.
'''module:  module address (1..15)
'''channel: SPI channel (1..2) 
'''****************************************************************************
FUNCTION P2_SPI_Slave_InFifo_Full(module, channel) as Long
  dim tmp as long
  CHECK_CARD(module)
  tmp = Peek_P2 ((6805A070h + (channel) * 16) OR shift_left(module, 20))
  P2_SPI_Slave_INFIFO_Full = tmp and 0000001Fh
ENDFUNCTION

'******************************************************************************
'''Clears the input Fifo and/or output Fifo of an SPI slave.
'''module: module address  (1..15)
'''channel: SPI channel (1..2) 
'''pattern: bit pattern to define the Fifos being cleared
'''+ Bit 0: Input Fifo (MOSI)
'''+      Bit=0: leave Fifo unchanged; bit=1: clear Fifo
'''+ Bit 1: Output Fifo (MISO)
'''+      Bit=0: leave Fifo unchanged; bit=1: clear Fifo
'''****************************************************************************
SUB P2_SPI_Slave_Clear_Fifo(module, channel, pattern)
  POKE (((6805A7F0h + (channel) * 16) OR shift_left(module, 20)), pattern)
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
ENDSUB

'******************************************************************************
'''Reads 32 bit values from input Fifo of an SPI slave.
'''module: module address (1..15)
'''channel: SPI channel (1..2)
'''count:   number of 32 bit values to be read.
'''+Check first with P2_SPI_Slave_InFifo_Full, if the Fifo contains any data.
'''array[]: array to store the read of 32 bit values.
'''+ The input Fifo can hold 18 values of 32 bit. Each SPI message consists of 1..3
'''+ 32 bit values, depending on SPI bit length and whether the number of received bits
'''+ is stored. The order of values is:
'''+ - number of received bits (if set with SPI_Config)
'''+ - lower word of SPI message
'''+ - upper word of SPI message (if SPI bit length exceeds 32 bit.
'''array_idx: start index in array[] pointing to the first 32 bit value
'''****************************************************************************
SUB P2_SPI_Slave_InFifo_Read(module, channel, count, array[], array_idx)
  dim ilen as Long
  dim iindex as Long

  CHECK_TYPE_LONG (array[1])
  CHECK_CARD(module)
  System_Array_Debug_Check(array, array_idx, count)
  
  if (count > 0) then 
    Read_Fast_Bus_LB(array[array_idx], count, (64038FF4h + shift_left(channel, 4)) OR shift_left(module, 20))
  endif
ENDSUB

'<ENDREGION>

'<REGION> SPI Master
 
'******************************************************************************
'''Starts data transfer of an SPI master. If configured, also activates
'''+the slave-select line of the SPI master.
'''+Data transfer runs in both directions: Master sends an SPI message and also
'''+receives the slave's answer.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''****************************************************************************
SUB P2_SPI_Master_Start(module, channel)
  dim CLK_Delay as long
  CHECK_CARD(module)  
  POKE (((60038000h + (channel - 1) * 16) OR shift_left(module, 20)), 111B)
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep 'Warten damit die evtl. folgende Status Abfrage funktioniert
ENDSUB

'**************************************************************************
'see also P2_SPI_Config and P2_SPI_Mode
'''Configures the settings of an SPI master; works supplemental to P2_SPI_Config.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''clk_factor: Factor (2..2500) to determine the clock frequency f_SPI:
'''+            f_SPI = 25 MHz / clk_factor
'''+            Example: clk_factor=250 -> f_SPI = 25 MHz / 250 = 100 kHz
'''miso_delay: delay time for reading an SPI message in units (0..255) of 20 ns.
'''+            Delay time range is 0..5.1 s
'''ss_manual: activation mode (0, 1) for slave-select line of the SPI master.
'''+           0: SPI master activates slave-select line automatically.
'''+           1: slave-select lines are activated manually.
'''ss_time: Only with automatic slave-select activation: 
'''+ Additional time interval of slave-select signal in units (0..255) of 20 ns. Default is 25 (=0.5 s).
'''+ The slave-select signal starts a defined time interval before the clock signal
'''+ and ends by the same time interval after the end of the clock signal.
'''+ The time interval is a half period (of SPI frequency) plus the additional
'''+ time resulting from ss_time.
'''+ The total time interval is dT = 0.5 / f_SPI + ss_time * 20ns.
'''****************************************************************************
Sub P2_SPI_Master_Config(module, channel, clk_factor, miso_delay, ss_manual, ss_time)
  CHECK_CARD(module)
  dim help_clk_factor as long
  help_clk_factor = clk_factor
  if (help_clk_factor < 2) then help_clk_factor = 2         'not faster than 12.5MHZ (2*2*20ns=80ns->12.5MHz)
  POKE (((60038100h + (channel - 1) * 16) OR shift_left(module, 20)), help_clk_factor)
  POKE (((60038DF0h + (channel) * 16) OR shift_left(module, 20)), miso_delay)
  POKE (((60038300h + (channel - 1) * 16) OR shift_left(module, 20)), shift_left(ss_manual, 1))

  if (ss_manual = 1) then 
    POKE (((60038E70h + (channel) * 16) OR shift_left(module, 20)), 0)
  else 
    POKE (((60038E70h + (channel) * 16) OR shift_left(module, 20)), ss_time)
  endif
  
endsub

'******************************************************************************
'''Reads a received SPI message (MISO) of up to 64 bit length from SPI master input register.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''miso_high: Upper 32 bit of received SPI message. Must be a variable of data type Long.
'''miso_low:  Lower 32 bit of received SPI message. Must be a variable of data type Long.
'''****************************************************************************
'''#C;P3:BR;P4:BR;
SUB P2_SPI_Master_Get_Value64(module, channel, miso_high, miso_low)
  CHECK_CARD(module)
  miso_low = Peek_P2 ((60038900h + (channel - 1) * 16) OR shift_left(module, 20))
  miso_high = Peek_P2 ((60038A00h + (channel - 1) * 16) OR shift_left(module, 20))
ENDSUB

'******************************************************************************
'''Reads a received SPI message (MISO) of up to 32 bit length from SPI master input register.
'''+ Do use only if SPI bit length is no more than 32 bit.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''****************************************************************************
Function P2_SPI_Master_Get_Value32(module, channel) as long
  CHECK_CARD(module)
  P2_SPI_Master_Get_Value32 = Peek_P2 ((60038900h + (channel - 1) * 16) OR shift_left(module, 20))
ENDFunction

'******************************************************************************
'''Prepares an SPI message of up to 64 bit as MOSI output of an SPI master.
'''+The SPI message is not yet sent.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''mosi_high: Upper 32 bit of SPI message to be sent. Must be a variable of data type Long.
'''mosi_low: Lower 32 bit of SPI message to be sent. Must be a variable of data type Long.
'''****************************************************************************
SUB P2_SPI_Master_Set_Value64(module, channel, mosi_high, mosi_low)
  CHECK_CARD(module)
  POKE (((60038700h + (channel - 1) * 16) OR shift_left(module, 20)), mosi_low)
  POKE (((60038800h + (channel - 1) * 16) OR shift_left(module, 20)), mosi_high)
ENDSUB

'******************************************************************************
'''Prepares an SPI message of up to 32 bit as MOSI output of an SPI master.
'''+The SPI message is not yet sent.
'''+ Do use only if SPI bit length is no more than 32 bit.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''value: 32 bit value to be sent as SPI message. Must be a variable of data type Long.
'''****************************************************************************
SUB P2_SPI_Master_Set_Value32(module, channel, value)
  CHECK_CARD(module)
  POKE (((60038700h + (channel - 1) * 16) OR shift_left(module, 20)), value)
ENDSUB

'******************************************************************************
'''Inserts several wait times after a number of cycles into the clock signal of an SPI master.
'''+Time units are based on the clock signal frequency f_SPI.
'''module:  module address (1..15)
'''channel: SPI channel (1..2) 
'''clocks: Number (1..16) of cycles after which a wait time is inserted.
'''+        4 means to insert a wait time every 4 cycles.
'''+        0 deactivates the waiting times.
'''half_clk_wait[]: Array holding 5 wait times, the number (1..16) of which is given in half periods.
'''+A wait time t_wait results to: t_wait = 0.5 * half_clk_wait[n] / f_SPI.
'''+If SPI bit length and the clocks parameter result to 6 or more wait times, the value
'''+of half_clk_wait[5] will be repeated.
'''+ Example: clocks=8, half_clk_wait[1]=4
'''+          0.5*4 -> 2 wait periods: _-_-_-_-_-_-_-_-_____-_-_-_-_...
'''****************************************************************************
SUB P2_SPI_Master_Set_Clk_Wait(module, channel, clocks, half_clk_wait[])
  CHECK_CARD(module)
  CHECK_TYPE_LONG (half_clk_wait[1])
 
  POKE(((60038500h + (channel - 1) * 16) OR shift_left(module, 20)), clocks - 1)
  if (channel < 3) then 
    POKE(((60038600h + (channel - 1) * 16) OR shift_left(module, 20)), half_clk_wait[1] - 1)
    POKE(((60038620h + (channel - 1) * 16) OR shift_left(module, 20)), half_clk_wait[2] - 1)
    POKE(((60038640h + (channel - 1) * 16) OR shift_left(module, 20)), half_clk_wait[3] - 1)
    POKE(((60038660h + (channel - 1) * 16) OR shift_left(module, 20)), half_clk_wait[4] - 1)
    POKE(((60038680h + (channel - 1) * 16) OR shift_left(module, 20)), half_clk_wait[5] - 1)
  else
    POKE(((60039600h + (channel - 3) * 16) OR shift_left(module, 20)), half_clk_wait[1] - 1)
    POKE(((60039620h + (channel - 3) * 16) OR shift_left(module, 20)), half_clk_wait[2] - 1)
    POKE(((60039640h + (channel - 3) * 16) OR shift_left(module, 20)), half_clk_wait[3] - 1)
    POKE(((60039660h + (channel - 3) * 16) OR shift_left(module, 20)), half_clk_wait[4] - 1)
    POKE(((60039680h + (channel - 3) * 16) OR shift_left(module, 20)), half_clk_wait[5] - 1)
  endif 
ENDSUB

'******************************************************************************
'''Returns whether the data transfer of the SPI master is finished. With automatic
'''+ slave-select activation, the slave select line is active during data transfer
'''+ and inactive otherwise.
'''+ ret_val = 0: data transfer is complete (slave select line is inactive).
'''+ ret_val = 1: data transfer is running (slave select line is active).
'''+As long as data transfer is running, no SPI command must be sent to the SPI master.
'''module:  module address (1..15)
'''channel: SPI channel (1..2) 
'''****************************************************************************
FUNCTION P2_SPI_Master_Status(module, channel) AS LONG
  CHECK_CARD(module)
  P2_SPI_Master_Status = Peek_P2 ((60038000h + (channel - 1) * 16) OR shift_left(module, 20))
ENDFUNCTION

'******************************************************************************
'''Reads static input channel.
'''+ ret_val = 0: data channel has TTL level low.
'''+ ret_val = 1: data channel has TTL level high.
'''module: module address (1..15)
'''channel: SPI channel (1..2) 
'''****************************************************************************
Function P2_SPI_Master_Get_Static_Input(module, channel) as long
  CHECK_CARD(module)
  P2_SPI_Master_Get_Static_Input = Peek_P2 ((60038B00h + (channel - 1) * 16) OR shift_left(module, 20))
Endfunction

'<ENDREGION>

'<REGION> MIL 1553

'******************************************************************************
'''Reads register from MIL controller HI6130.
'''+Return: a 16 bit value.
'''module: module address (1..15)
'''reg_addr: 15 bit address
'''****************************************************************************
FUNCTION P2_MIL_Get_Register(module, reg_addr) AS LONG
  CHECK_CARD(module)
 
  POKE (60000010h OR shift_left(module, 20), shift_left(reg_addr, 17))  'Adress Register schreiben
  p2_sleep(16)                                              'MIL BUS Zeit abwarten
  P2_MIL_Get_Register = Peek_P2 (60000000h OR shift_left(module, 20))

ENDFUNCTION

'******************************************************************************
'''Writes register of MIL HI6130.
'''module: module address (1..15)
'''reg_addr: 15 bit address
'''value: 16 bit value
'''****************************************************************************
SUB P2_MIL_Set_Register(module, reg_addr, value)
  CHECK_CARD(module)
  POKE (60000000h OR shift_left(module, 20), shift_left(reg_addr, 17) or value))
  poke(syst_hw_nop, 4)                                      '80 ns bus sleep
ENDSUB

'******************************************************************************
'''Sets module LED.
'''module: module address (1..15)
'''pattern: LED pattern
'''****************************************************************************
SUB P2_MIL_Set_LED(module, pattern)
  CHECK_CARD(module)
  POKE (68041070h OR shift_left(module, 20), pattern)
ENDSUB

'******************************************************************************
'''Initalises MIL module and reset all registers.
'''+Return: 0 = OK, <>0 = Error
'''module: module address (1..15)
'''****************************************************************************
Function P2_MIL_Reset(module) as long
  dim state as long
  dim cnt, i as long
  
  CHECK_CARD(module)
  POKE (68041000h OR shift_left(module, 20), 0)             'Reset aktiv (default) 

  p2_sleep(1000)                                            '10 s time? OK? 
  POKE (68041000h OR shift_left(module, 20), 1)             'Reset inaktiv
  p2_sleep(1000)                                            '10 s time? OK?
  cnt = 0
  
  do 
    state = Peek_P2 (68041010h OR shift_left(module, 20))
    inc cnt
    state = shift_right(state, 4) and 1      
  until ((state = 1) or (cnt > 10000))
  
  
  if (cnt > 10000) then
    P2_MIL_Reset = -1 
  else 
    P2_MIL_Reset = 0
  endif
  
endfunction


''' timeTagMode: Mode IMT/IRIG with 48Bit or SMT with 16/48 bit time tag
'''+             MT Operation      Time Tag Mode  
'''+ 0           IMT (IRIG - 106)   48 - bit time tag
'''+ 1           SMT (simple)       16 - bit time tag
'''+ 3           SMT (simple)       48 - bit time tag

'******************************************************************************
'''Initializes MIL interface for SMT mode.
'''module: module address (1..15)
'''timetag_mode: time tag mode for SMT bus monitor.
'''+         1:  SMT 16-bit time tag
'''clock_source: clock source for time tag counter.
'''+         0:  Time tag counter disabled.
'''+         2:  Internally generated 2s clock.
'''+         3:  Internally generated 4s clock.
'''+         4:  Internally generated 8s clock.
'''+         5:  Internally generated 16s clock.
'''+         6:  Internally generated 32s clock.
'''+         7:  Internally generated 64s clock.
'''+         8:  Internally generated 100s clock.
'''****************************************************************************
Sub P2_MIL_SMT_Init(module, timetag_mode, clock_source)
  dim SMT_Bus_Monitor_Adr as long
  'SMT Time Tag Konfiguration
  dim HWIntEnableReg as long
  dim TimeTagPattern as long

  CHECK_CARD(module)
  
  P2_MIL_Set_Register(module, 0, 0100h)                     ' MTENA
  P2_MIL_Set_Register(module, 011h, 08h)                    ' MTEOM
  P2_MIL_Set_Register(module, 29h, 01)                      ' SMT-Mode
    
  POKE (68041010h OR shift_left(module, 20), 1)             ' en MT

  SMT_Bus_Monitor_Adr = P2_Mil_Get_register(module, 2FH)    'def: 0B0h

  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr, MIL_CMDBUFF_BA)  'Com. Buf. Start Adr. Word 0
  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr + 1, MIL_CMDBUFF_BA)  'Com. Buf. Next Adr. Word 1
  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr + 2, MIL_CMDBUFF_BA + MIL_CMDBUFF_LEN - 1)  'Com. Buf. End Adr. Word 2
  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr + 3, MIL_CMDBUFF_BA + (MIL_CMDBUFF_LEN / 2))  'Com. Buf. Int Adr. Word 3

  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr + 4, MIL_DATBUFF_BA)  'Dat. Buf. Start Adr. Word 4
  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr + 5, MIL_DATBUFF_BA)  'Dat. Buf. Next Adr. Word 5
  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr + 6, MIL_DATBUFF_BA + MIL_DATBUFF_LEN - 1)  'Dat. Buf. End Adr. Word 6
  P2_MIL_Set_Register(module, SMT_Bus_Monitor_Adr + 7, MIL_DATBUFF_BA + (MIL_DATBUFF_LEN / 2))  'Dat. Buf. Int Adr. Word 7
   

  'TimeTagMode Bit No. 14, 15       
  'MT Configuration        MT Operation     Time Tag Mode   
  'Register, bits 1..0
  ' 00 or 10               IMT (IRIG - 106)   48 - bit time tag 'ACHTUNG: Handbuch HI-6130 verwendet nur "00", nicht "10".
  ' 01                     SMT (simple)       16 - bit time tag
  ' 11                     SMT (simple)       48 - bit time tag
    
  ' MT Time Tag Clock Selection Bits 3..0.
  ' These three bits select the clock source for the BC, RT1 and RT2 Time
  ' Tag Counters from the following options:

  'clock_source Bit No. 4, 5, 6, 7
  'Bits 3-2-1-0 MT Time Tag Counter Clock Source  
  '0 - 0 - 0 - 0 Time Tag Counter Disabled.
  '0 - 0 - 0 - 1 External clock provided at the MTTCLK input pin.
  '0 - 0 - 1 - 0 Internally generated 2s clock.
  '0 - 0 - 1 - 1 Internally generated 4s clock.
  '0 - 1 - 0 - 0 Internally generated 8s clock.
  '0 - 1 - 0 - 1 Internally generated 16s clock.
  '0 - 1 - 1 - 0 Internally generated 32s clock.
  '0 - 1 - 1 - 1 Internally generated 64s clock.
  '1 - x - x - x Internally generated 100s clock.
  TimeTagPattern = shift_left(timeTag_Mode, 14) OR shift_left(clock_source, 4) 
  P2_MIL_Set_Register(module, 039h, TimeTagPattern)         'Verwendete Bit 15, 14 und 7,6,5,4 setzen in Adr. 39h im HI6130
ENDSUB

' Nachricht zurckgeben
' Kommandodaten und Nachrichtendaten
'******************************************************************************
'''Reads Command Buffer and Data Buffer Block for a message
'''module: module address (1..15)
'''cmd_dat[]: Command Buffer for a single Message Block
'''+16 Bit length
'''+cmd_dat[1] = Block Status Word for Message
'''+cmd_dat[2] = Message Time Stamp
'''+cmd_dat[3] = Data Block Pointer 
'''+cmd_dat[4] = Message Command Word
''' msg_dat[]: Data Buffer Block for the Message
'''+16 Bit length 
'''+The number of words stored in the Data Buffer varies from message to message, based on message type.
'''****************************************************************************
Function P2_MIL_SMT_Message_Read(module, cmd_dat[], msg_dat[]) as long
  dim i as long
  dim ba as long
  dim ra as long
  dim dbea as long
  dim dbna as long
  dim dbsa as long
  dim dbpsa as long
  dim len as long
  dim temp as long

  len = -1                                                  ' Keine Nachricht empfangen
  'temp = P2_Mil_Get_register(module, 06h)        ' MTIP
  temp = P2_Mil_Get_register(module, 08h)                   ' INT vorhanden und reset
  if (temp <> 0) then
    ba = P2_Mil_Get_register(module, 031h)                  ' SMT Last Message Command Buffer Address
    for i = 0 to 3
      ra = ba + i
      if (ra >= MIL_CMDBUFF_BA + MIL_CMDBUFF_LEN) then ra = ra - MIL_CMDBUFF_LEN
      cmd_dat[i + 1] = P2_Mil_Get_register(module, ra)
    next
    ba = P2_Mil_Get_register(module, 02fh)
    dbsa = P2_Mil_Get_register(module, ba + 4)              ' Data Buffer Start Address
    dbna = P2_Mil_Get_register(module, ba + 5)              ' Data Buffer Next Address
    dbea = P2_Mil_Get_register(module, ba + 6)              ' Data Buffer End Address
    dbpsa = cmd_dat[3]                                      ' data block pointer start address
    if (dbpsa <> 0) then
      len = dbna - dbpsa
      if (len < 0) then len = (dbea - dbpsa) + (dbna - dbsa) + 1  ' berlauf
      if (len > 0) then
        
        len = min_long(len, Get_Array_Length(msg_dat))      'mf 3.4.2013
        
        for i = 0 to len - 1
          ra = dbpsa + i
          if (ra >= MIL_DATBUFF_BA + MIL_DATBUFF_LEN) then ra = ra - MIL_DATBUFF_LEN
          msg_dat[i + 1] = P2_Mil_Get_register(module, ra)
        next
      endif
    endif
  endif
  P2_MIL_SMT_Message_Read = len
endfunction

'******************************************************************************
'''Sets enable/disable SMT Message Filter Table for all Addresses and Subaddresses.
'''module: module address (1..15)
'''disable_receive: 
'''+                1 = disables all 32 Addresses and their Receive Subaddresses 0 to 31
'''+                0 = enables all 32 Addresses and their Receive Subaddresses 0 to 31
'''disable_transmit:
'''+                1 = disables all 32 Addresses and their Transmit Subaddresses 0 to 31
'''+                0 = enables all 32 Addresses and their Transmit Subaddresses 0 to 31
'''****************************************************************************
Sub P2_MIL_SMT_Set_All_Filters(module, disable_receive, disable_transmit)
  dim FilterTableAddress as Long
  
  dim ReceivePattern, TransmitPattern as long 
  
  if (disable_receive = 1) then
    'Alle Receive Subaddressen disablen
    ReceivePattern = 0FFFFh
  else
    'Alle Receive Subaddressen enablen
    ReceivePattern = 0h
  endif
  
  if (disable_transmit = 1) then
    'Alle Transmit Subaddressen disablen
    TransmitPattern = 0FFFFh
  else
    'Alle Transmit Subaddressen enablen
    TransmitPattern = 0h
  endif
  
  for FilterTableAddress = 0100h to 017Fh step 4
    P2_MIL_Set_Register(module, FilterTableAddress + 3, TransmitPattern)  'Transmit Subaddresses 31 to 16
    P2_MIL_Set_Register(module, FilterTableAddress + 2, TransmitPattern)  'Transmit Subaddresses 15 to 0
    P2_MIL_Set_Register(module, FilterTableAddress + 1, ReceivePattern)  'Receive Subaddresses 31 to 16
    P2_MIL_Set_Register(module, FilterTableAddress, ReceivePattern)  'Receive Subaddresses 15 to 0
  next FilterTableAddress
EndSub

'******************************************************************************
'''Sets SMT Message Filter Table.
'''+ Return = 0, OK
'''+        = 1, Error, rt_address out of range
'''+The Simple Monitor Terminal can select messages for monitoring through the use of a 128-word MT Filter Table, 
'''+When the table bit corresponding to a new message Command Word is logic 1,
'''+that message is ignored by the monitor. If the table bit is logic 0, that message is recorded.
'''+After /MR master reset, 100% of MIL-STD-1553 messages are monitored.
''' module: = module address
''' rt_address: RT Address to filter 0..31
''' receiveSubAddrPattern: set the receive sub addresses 0..31. The Bitno. represents the subaddress.
'''+e.g SA=30 so the receiveSubAddrPattern=040000000h
''' transmitSubAddrPattern: set the transmit sub addresses 0..31. The Bitno. represents the subaddress.
'''+e.g SA=17 so the receiveSubAddrPattern=010000h
'''****************************************************************************
Function P2_MIL_SMT_Set_Filter(module, rt_address, receiveSubAddrPattern, transmitSubAddrPattern) as long
  dim FilterTableAddress as Long
  dim TransmitSubAddrPattern_H, TransmitSubAddrPattern_L as Long
  dim ReceiveSubAddrPattern_H, ReceiveSubAddrPattern_L as Long
  
  if ((RT_Address > 31) or (RT_Address < 0)) then 
    'Fehler Adresse out of range. Erlaubt: 0..31
    P2_MIL_SMT_SET_FILTER = 1
  else
    ReceiveSubAddrPattern_H = shift_right(receiveSubAddrPattern, 16)
    ReceiveSubAddrPattern_L = receiveSubAddrPattern AND 0FFFFh
    TransmitSubAddrPattern_H = shift_right(transmitSubAddrPattern, 16)
    TransmitSubAddrPattern_L = transmitSubAddrPattern AND 0FFFFh
    FilterTableAddress = 0100h + RT_Address * 4
    P2_MIL_Set_Register(module, FilterTableAddress + 3, TransmitSubAddrPattern_H)  'Transmit Subaddresses 31 to 16
    P2_MIL_Set_Register(module, FilterTableAddress + 2, TransmitSubAddrPattern_L)  'Transmit Subaddresses 15 to 0
    P2_MIL_Set_Register(module, FilterTableAddress + 1, ReceiveSubAddrPattern_H)  'Receive Subaddresses 31 to 16
    P2_MIL_Set_Register(module, FilterTableAddress, ReceiveSubAddrPattern_L)  'Receive Subaddresses 15 to 0
    P2_MIL_SMT_SET_FILTER = 0
  endif
  'Function P2_MIL_SMT_Set_Filter(module, rt_address, receiveSubAddrPattern_L, receiveSubAddrPattern_H, transmitSubAddrPattern_L, transmitSubAddrPattern_H) as long  
EndFunction


'Time Tag Counter Configuration Register (0x0039)
'0C070h = Capture current 16- or 48-bit value in the MT Time 
'Tag Count Register(s) into the BCMT Time Tag Utility 
'Register(s). 
'Internally generated 64s clock.
'Note: External clock provided at MTTCLK input pin is not supported.

'******************************************************************************
''' Sets the Time Tag Counter Configuration.
''' module: module address (1..15)
'''TimeTagMode: Mode IMT/IRIG with 48Bit or SMT with 16/48 bit time tag
'''+             MT Operation      Time Tag Mode  
'''+ 0 or 2      IMT (IRIG - 106)   48-bit time tag
'''+             monitor mode 
'''+ 1           SMT (simple)       16-bit time tag
'''+             monitor mode       
'''+ 3           SMT (simple)       48-bit time tag
'''+             monitor mode
'''TimeTagCounterClockSource: clock source of the time tag counter
'''+0: Time Tag Counter Disabled.
'''+2: Internally generated 2?s clock.
'''+3: Internally generated 4?s clock.
'''+4: Internally generated 8?s clock.
'''+5: Internally generated 16?s clock.
'''+6: Internally generated 32?s clock.
'''+7: Internally generated 64?s clock.
'''+8: Internally generated 100?s clock.
'''****************************************************************************
Sub P2_MIL_SMT_Set_Time_Tag(module, TimeTagMode, TimeTagCounterClockSource)  '<HIDE>
  dim HWIntEnableReg as long
  dim TimeTagPattern as long

  'TimeTackMode Bit No. 14, 15       
  '                        MT Operation     Time Tag Mode  
  'MT Configuration 
  'Register, bits 1 - 0
  ' 00 or 10               IMT (IRIG - 106)   48 - bit time tag
  '                        monitor mode 
  ' 01                     SMT (simple)       16 - bit time tag
  '                        monitor mode       
  ' 11                     SMT (simple)       48 - bit time tag
  '                        monitor mode 
    
  ' MT Time Tag Clock Selection Bits 3-0.
  ' These three bits select the clock source for the BC, RT1 and RT2 Time
  ' Tag Counters from the following options:
  
  'TimeTagCounterClockSource Bit No. 4, 5, 6, 7
  'Bits 3-2-1-0 MT Time Tag Counter Clock Source  
  '0 - 0 - 0 - 0 Time Tag Counter Disabled.
  '0 - 0 - 0 - 1 External clock provided at the MTTCLK input pin.
  '0 - 0 - 1 - 0 Internally generated 2?s clock.
  '0 - 0 - 1 - 1 Internally generated 4?s clock.
  '0 - 1 - 0 - 0 Internally generated 8?s clock.
  '0 - 1 - 0 - 1 Internally generated 16?s clock.
  '0 - 1 - 1 - 0 Internally generated 32?s clock.
  '0 - 1 - 1 - 1 Internally generated 64?s clock.
  '1 - x - x - x Internally generated 100?s clock.
  TimeTagPattern = shift_left(TimeTagMode, 14) OR shift_left(TimeTagCounterClockSource, 4) 
  P2_MIL_Set_Register(module, 039h, TimeTagPattern)         'Verwendete Bit 15, 14 und 7,6,5,4 setzen in Adr. 39h im HI6130 
EndSub

'<ENDREGION>

'<REGION> ARINC 429

'******************************************************************************
'''Does a Master Reset on the ARINC module.
'''+On a Master Reset data transmission and reception are immediately terminated,
'''+all three FIFOs are cleared as are the FIFO flags and the Status Register.
'''+The Control Register is not affected by a Master Reset.
'''module: module address (1..15)
'''****************************************************************************
SUB P2_ARINC_Reset(module)
  dim ARINC_busy as long
  CHECK_CARD(module)   
  POKE (68041000h OR shift_left(module, 20), 0)             'nMReset = 0
  p2_sleep(20)     
  POKE (68041000h OR shift_left(module, 20), 1)             'nMReset = 1
  p2_sleep(20)  
  POKE (60000000h OR shift_left(module, 20), 020H)          'Alle Bits in diesem Register sind am Anfang "0".
  do
    ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
  until (ARINC_busy <> 1)                                   'angeforderte Daten gltig / Ready fr neuen Befehl 

endSub


'******************************************************************************
'''Configures the transmit settings on the specified ARINC module.
'''module: module address (1..15)
'''clk: data rate
'''+      0: 100kHz (high speed)
'''+      1: 12.5kHz (low speed)
'''parity_enable: 
'''+      0: No parity, bit 32 is part of transmitted data 
'''+      1: Bit 32 is parity bit
'''parity:  
'''+      0: Odd parity
'''+      1: Even parity
'''****************************************************************************
SUB P2_ARINC_Config_Transmit(module, clk, parity_enable, parity)
  dim ARINC_busy as long
  dim old as long
  
  CHECK_CARD(module)
  'Control Register (CR) lesen (16Bit)
  POKE (60000030h OR shift_left(module, 20), 1)
  do
    old = Peek_P2 (60000000h OR shift_left(module, 20))
  until (old >= 0)
  
  old = old AND 0CFEFH
  old = old or shift_left(clk, 13) or shift_left(parity, 12) or shift_left(parity_enable, 4)

  'Write Control Word Register
  POKE (60000000h OR shift_left(module, 20), old)
                                                                       
  do 
    ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
  until (ARINC_busy <> 1)                                   'angeforderte Daten gltig / Ready fr neuen Befehl 
ENDSUB


'******************************************************************************
'''Configures the receiver settings on the specified ARINC module.
'''module: module address (1..15)
'''channel: number (1,2) of receive channel
'''clk: data rate 
'''+      0: 100kHz (high speed)
'''+      1: 12.5kHz (low speed)
'''enable_label: Enable or disable label matching
'''+      0: disable label matching, all incoming values are read into
'''+         receiver FIFO.
'''+      1: enable label matching, only values matching one of the labels are
'''+         read into receiver FIFO.
'''enable_decoder: Enable or disable receiver decoding
'''+      0: disable receiver decoding.
'''+      1: enable receiver decoding, only values matching decoder_sdi are read
'''+         into receiver FIFO.
'''decoder_value: Bit pattern (2 bits, 00b..11b) for receiver decoding. If
'''+             enabled, bits 0 and 1 must match the SDI bits of incoming values.
'''****************************************************************************
SUB P2_ARINC_Config_Receive(module, channel, clk, enable_label, enable_decoder, decoder_value)
  dim ARINC_busy as long
  dim old as long
  'Control Register (CR) lesen (16Bit)
  POKE (60000030h OR shift_left(module, 20), 1)

  do 
    old = Peek_P2 (60000000h OR shift_left(module, 20))
  until (old >= 0)
 
  if (channel = 1) then 
    old = old AND 0FE3AH
    old = old or shift_left(clk, 0) or shift_left(enable_label, 2) or shift_left(enable_decoder, 6) or shift_left(decoder_value, 7) 
  else
    old = old AND 0B1F7H
    old = old or shift_left(clk, 14) or shift_left(enable_Label, 3) or shift_left(enable_decoder, 9) or shift_left(decoder_value, 10) 
  endif
  
  'Write Control Word Register
  CHECK_CARD(module)   
  POKE (60000000h OR shift_left(module, 20), old)
                                                              
  do 
    ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
  until (ARINC_busy <> 1)                                   'angeforderte Daten gltig / Ready fr neuen Befehl 
ENDSUB


'******************************************************************************
'''Gets status of the transmit FIFO of the ARINC module.
'''+The transmitter's FIFO can store 32 words maximum.
'''+ return value: 
'''+      0: Transmit FIFO is not full.
'''+      1: Transmit FIFO is full.
'''module: module address (1..15)
'''****************************************************************************
Function P2_ARINC_Transmit_Fifo_Full(module) as long
  dim TransmitterFIFO_Status as long
  TransmitterFIFO_Status = Peek_P2 (68041040h OR shift_left(module, 20))
  P2_ARINC_Transmit_Fifo_Full = (shift_right(TransmitterFIFO_Status, 2) AND 1) xor 1  ' Transmitter ready Flag lesen und warten bis es auf 1=Ready steht, dann ist das bertragen fertig
EndFunction


'******************************************************************************
'''Gets status of the transmit FIFO of the ARINC module.
'''+The transmitter's FIFO can store 32 words maximum. 
'''+ return value: 
'''+      0: Transmit FIFO contains data.
'''+      1: Transmit FIFO is empty.
'''module: module address (1..15)
'''****************************************************************************
Function P2_ARINC_Transmit_Fifo_Empty(module) as long
  dim TransmitterFIFO_Status as long
  TransmitterFIFO_Status = Peek_P2 (68041040h OR shift_left(module, 20))
  P2_ARINC_Transmit_Fifo_Empty = TransmitterFIFO_Status AND 1  ' Transmitter ready Flag lesen und warten bis es auf 1=Ready steht, dann ist das bertragen fertig
  
EndFunction


'******************************************************************************
'''Writes a 32 bit value into the transmitter FIFO of the ARINC module.
'''+The transmitter FIFO can store 32 words maximum and ignores attempts to load
'''+ additional data if full.
'''+Use P2_ARINC_Transmit_Fifo_Full to check for free space in the transmitter
'''+Fifo before writing a new value into.
'''module: module address (1..15)
'''value:  32 bit data word to be transmitted.
'''+      Use ARINC_Create_Value32 to create the 32 bit value.
'''****************************************************************************
SUB P2_ARINC_Write_Transmit_Fifo(module, value) 
  dim ARINC_busy as long
  CHECK_CARD(module)    
  '**********************************
  POKE (60000010h OR shift_left(module, 20), value)
  do 
    ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
  until (ARINC_busy <> 1)                                   'angeforderte Daten gltig / Ready fr neuen Befehl
  
ENDSUB


'******************************************************************************
'''Enables or disables transmitting data from the transmit FIFO.
'''module: module address (1..15)
'''enable: transmitter flag
'''+      0: disable transmitting
'''+      1: enable transmitting
'''****************************************************************************
SUB P2_ARINC_Transmit_Enable(module, enable)
  CHECK_CARD(module)
  POKE (68041010h OR shift_left(module, 20), enable))       'ENTX Enable Transmittion
ENDSUB 


'******************************************************************************
'''Gets status of the receiver (IN) FIFO of the ARINC module.
'''+The receiver's FIFO can store 32 words maximum. 
'''+ return value: 
'''+      0: Receiver FIFO has at least one value
'''+      1: Receiver FIFO is empty
'''module: module address (1..15)
'''channel: number (1,2) of receive channel
'''****************************************************************************
Function P2_ARINC_Receive_Fifo_Empty(module, channel) as long
  dim ReceiverFIFO_Status as long

  ReceiverFIFO_Status = Peek_P2 ((68041010h + (channel) * 16) OR shift_left(module, 20))
  P2_ARINC_Receive_Fifo_Empty = (ReceiverFIFO_Status AND 1)  '
EndFunction


'******************************************************************************
'''Gets a 32 bit value from a receiver FIFO of the ARINC module.
'''+The receiver's FIFO can store 32 words maximum.
'''+Use P2_ARINC_Receive_Fifo_Empty to check for data in the receiver Fifo before
'''+reading a new value. 
'''+ return value: 32 bit data value.
'''+      Use ARINC_Split_Value32 to get the components of the 32 bit value.
'''module: module address (1..15)
'''channel: number (1,2) of receive channel
'''****************************************************************************
FUNCTION P2_ARINC_Read_Receive_Fifo(module, channel) as long
  dim ARINC_busy as long
 
        
  POKE (60000040h OR shift_left(module, 20), shift_left(channel - 1, 1))

  'read low word
  do
    ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
  until (ARINC_busy <> 1)                                   'angeforderte Daten gltig / Ready fr neuen Befehl

  
  P2_ARINC_Read_Receive_Fifo = Peek_P2 (60000010h OR shift_left(module, 20))

  
EndFunction

 
'******************************************************************************
'''Sets 16 labels in the receiver label memory of the ARINC module.
'''+All 16 labels should be set.
'''module: module address (1..15)
'''channel: number (1,2) of receive channel
'''labels[]: Array with 16 labels for a receive channel. Each label has 8 bit length.
'''array_start_index: Index 1..n of the first value in the labels array to be read.
'''****************************************************************************
SUB P2_ARINC_Set_Labels(module, channel, labels[], array_start_index)
  dim ARINC_busy as long
  dim i as long
  dim control_register_merken as long                       'cr_tmp ist zum Wiederherstellen des Control Registers nachdem die Labels gelesen wurden
  
  'flipLabel Variablen
  dim bit1, bit2, bit3, bit4, bit5, bit6, bit7, bit8 as long
  dim ARINC_label as long
   
  
  CHECK_CARD(module)
  'Set SEL = 1; nEN1 = receiver 1;  nEN2 = receiver 2 = EN1=1
  '(Bit 0) SEL = 1 erforderlich laut Doku S.6 READING LABELS 
  'Control Register (CR) lesen (16Bit) 
     
  POKE (60000030h OR shift_left(module, 20), 1)

  
  
  do
    control_register_merken = Peek_P2 (60000000h OR shift_left(module, 20))
  until (control_register_merken >= 0)
  'Set CR1 = 1 ;CR2/3 = 0 
  'Write Control Word Register
   
  POKE (60000000h OR shift_left(module, 20), 0010B) 

  
                                                                   
  do
    ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
  until (ARINC_busy <> 1)                                   '
  'Schreibe 16 Labels von Receiver 1/2 in die Label Memorys
  'Load 16 labels into the memory
  for i = 0 to 15
    
    
    'flip label
    ARINC_Label = labels[i + array_start_index] AND 0FFh
     
    bit1 = shift_right(ARINC_label, 7) AND 1 
    bit2 = shift_right(ARINC_label, 5) AND 2
    bit3 = shift_right(ARINC_label, 3) AND 4
    bit4 = shift_right(ARINC_label, 1) AND 8
  
    bit5 = shift_left(ARINC_label, 1) AND 16 
    bit6 = shift_left(ARINC_label, 3) AND 32
    bit7 = shift_left(ARINC_label, 5) AND 64
    bit8 = shift_left(ARINC_label, 7) AND 128
  
    '
    ARINC_Label = bit1 OR bit2 OR bit3 OR bit4 OR bit5 OR bit6 OR bit7 OR bit8
    
    
    POKE ((60000050h + (channel) * 16) OR shift_left(module, 20), ARINC_Label)


    
    do
      ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
    until (ARINC_busy <> 1) 
  next i

  'Wiederherstellen des Control Registers und Sicherstellen das CR1=0 (normal operation) ist.
  'Write Control Word Register                                                                  
  POKE (60000000h OR shift_left(module, 20), control_register_merken)
  
  do
    ARINC_busy = Peek_P2 (68041050h OR shift_left(module, 20))
  until (ARINC_busy <> 1)  
EndSub

    
'******************************************************************************
'''Creates a 32 bit value from 4 components: label, SSM, SDI, and data value.
'''+ The created value refers to the following format:
'''+      Bits  0..7 : Label 1..8
'''+      Bits  9..10: SSM 1..2
'''+      Bits 11..12: SDI
'''+      Bits 13..31: Data 1..19
'''+ Use P2_ARINC_Write_Transmit_Fifo to write the value into the transmitter FIFO. The parity bit 8 is automatically set (if parity is enabled).
'''+ return value: 32 bit value to be sent to the ARINC bus.
'''arinc_label: ARINC label, 8 bits (0..255)
'''ssm: Sign / Status Matrix, 2 bits (0..3)
'''sdi: Source / Destination Identifier, 2 bits (0..3)
'''data: Data value, 19 bits (0..524287 = 0..7FFFFh)
'''****************************************************************************
FUNCTION ARINC_Create_Value32(arinc_label, ssm, sdi, data) as long
  'ARINC format
  'ARINC_Create_Value32 = arinc_label OR shift_left(sdi, 8) OR shift_left(data, 10) OR shift_left(ssm, 29)
  'scrambled format
  ARINC_Create_Value32 = arinc_label OR shift_left(sdi, 11) OR shift_left(data, 13) OR shift_left(ssm, 9)

ENDFUNCTION


'******************************************************************************
'''Splits a 32 bit ARINC value into 5 components label, SSM, SDI, data value,
'''+and parity bit.
''' value: 32 bit ARINC value to be split, format expected as follows:
'''+      Bits  0..7 : Label 1..8
'''+      Bit      8 : Parity bit
'''+      Bits  9..10: SSM 1..2
'''+      Bits 11..12: SDI
'''+      Bits 13..31: Data 1..19
'''arinc_label: ARINC label, 8 bits (0..255)
'''ssm: Sign / Status Matrix, 2 bits (0..3)
'''sdi: Source / Destination Identifier, 2 bits (0..3)
'''data: Data value, 19 bits (0..524287 = 0..7FFFFh)
'''parity: Parity bit.
'''+      0: value has odd parity.
'''+      1: value has even parity.
'''****************************************************************************
'''#C;P2:BR;P3:BR;P4:BR;P5:BR;P6:BR;
SUB ARINC_Split_Value32(value, arinc_label, ssm, sdi, data, parity)
  arinc_label = value AND 0FFh
  sdi = shift_right(value, 11) AND 03h
  data = shift_right(value, 13) AND 07FFFFh
  ssm = shift_right(value, 9) AND 03h
  parity = shift_right(value, 8) AND 1
ENDSUB

'<ENDREGION>

'<REGION> LS-Bus

'---------------------------------------------------------------
' Function only For internal use!
' Receives LS-Bus.
' module  : module address (1..15)
' channel : number of the LS interface on the LS-bus module (1..2)
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function P2_I_Receive(module, channel, dev_adr, reg_adr, cnt_dat, buf[]) As Long  '<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart, th As Long
  Dim ret As Long
  Dim addr As Long
  CHECK_CARD(module)
  
  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 

  Do 
    ftc = Peek_P2 (addr + 5 * 16)                           ' tx FIFO count
  Until ((ftc < 28) or (ftc = 12345678H))

  if (ftc = 12345678H) then
    ret = -1
  else
    Sub_begin_critical_section
    poke(addr, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))     'data write Header 1
    poke(addr, reg_adr)                                     'data write Header 2   
    Sub_End_critical_section
  
    P2_sleep(20)
  
    Do
      ftc = Peek_P2 (addr + 5 * 16)                         ' tx FIFO count
    Until (ftc = 0)

    th = 10000                                
    For cnt_i = 1 To cnt_dat                                ' data count
      tmstart = Read_Timer_DSB()
      Do                                                    ' rx wait
        tmout = Read_Timer_DSB() - tmstart
        frc = Peek_P2 (addr + 2 * 16)                       '  rx wait
      Until ((frc >= 1) Or (tmout > th))
 
      buf[cnt_i] = Peek_P2 (addr)
    
      th = 1800 * 4                                         '  6 mikrosec
    Next cnt_i
    tmstart = Read_Timer_DSB()
    Do                                                      ' ack wait
      tmout = Read_Timer_DSB() - tmstart                    ' rx count
      frc = Peek_P2 (addr + 2 * 16)                         '  rx wait
    Until ((frc >= 1) Or (tmout > 1800 * 4))                ' 6 mikrosec
  
    If (frc >= 1) Then
      ret = Peek_P2 (addr)                                  'data
    Else
      ret = -1
    EndIf

  endif
    
  P2_I_Receive = ret
EndFunction

'---------------------------------------------------------------
' Function only For internal use!
' Sends LS-Bus.
' module  : module address (1..15)
' channel : number of the LS interface on the LS-bus module (1..2)
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
' return  : error code (0->ok)
'---------------------------------------------------------------
Function P2_I_Send(module, channel, dev_adr, reg_adr, cnt_dat, buf[]) As Long  '<HIDE>
  Dim cnt_i, frc, ftc, tmout, tmstart As Long
  Dim ret As Long
  Dim addr As Long
  CHECK_CARD(module)
 
  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 

  Do
    ftc = Peek_P2 (addr + 5 * 16)                           ' tx FIFO count
  Until ((ftc < (28 - cnt_dat)) OR ftc = 12345678H)
  
  if (ftc = 12345678H) then
    ret = -1
  else
  
    Sub_begin_critical_section
    poke(addr, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))     'data write Header 1
    poke(addr, (80h Or reg_adr))                            'data write Header 1
 
    For cnt_i = 1 To cnt_dat                                ' data count
      poke(addr, buf[cnt_i])  
    Next cnt_i
 
    Sub_End_critical_section
  

    P2_sleep(20)
  
    Do 
      ftc = Peek_P2 (addr + 5 * 16)                         'tx wait
    
    Until ((ftc = 0) or (ftc = 12345678H))

    tmstart = Read_Timer_DSB()
    Do                                                      ' ack wait
      tmout = Read_Timer_DSB() - tmstart
      frc = Peek_P2 (addr + 2 * 16)                         'rx wait
    Until ((frc >= 1) Or (tmout > 1800 * 4))                ' 6 mikrosec

    If (frc >= 1) Then
      ret = Peek_P2 (addr)                                  'data
    Else
      ret = -1
    EndIf
    
  endif
    
  P2_I_Send = ret
EndFunction

'---------------------------------------------------------------
' Function only For internal use!
' Sends LS-Bus no acknowlege.
' module  : module address (1..15)
' channel : number of the LS interface on the LS-bus module (1..2)
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub P2_I_Send_NA(module, channel, dev_adr, reg_adr, cnt_dat, buf[])  '<HIDE>
  Dim cnt_i, ftc As Long
  Dim addr As Long
  CHECK_CARD(module)
  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 

  Do 
    ftc = Peek_P2 (addr + 5 * 16)                           ' tx FIFO count
  Until ((ftc < (28 - cnt_dat)) or (ftc = 12345678H))
  
  if (ftc = 12345678H) then
  
  else
    Sub_begin_critical_section
    poke(addr, (Shift_Left(cnt_dat - 1, 4) Or dev_adr))     'data write Header 1
    poke(addr, (80h Or reg_adr))                            'data write Header 2
 
    For cnt_i = 1 To cnt_dat                                ' data count
      poke(addr, buf[cnt_i])  
    Next cnt_i
 
    Sub_End_critical_section    
  endif
    
EndSub

'---------------------------------------------------------------
' Function only For internal use!
' Sends LS-Bus broadcast no acknowlege.
' module  : module address (1..15)
' channel : number of the LS interface on the LS-bus module (1..2)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
' buf[]   : array
'---------------------------------------------------------------
Sub P2_I_Send_BC(module, channel, reg_adr, cnt_dat, buf[])  '<HIDE>
  Dim cnt_i, ftc As Long
  Dim addr As Long
  CHECK_CARD(module)

  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 

  
  Do
    ftc = Peek_P2 (addr + 5 * 16)                           ' tx FIFO count
  Until ((ftc < (28 - cnt_dat)) or (ftc = 12345678H))
  
  
  
  Sub_begin_critical_section
  poke(addr, (Shift_Left(cnt_dat - 1, 4)))                  'data write Header 1
  poke(addr, (80h Or reg_adr))                              'data write Header 2
 
  For cnt_i = 1 To cnt_dat                                  ' data count
    poke(addr, buf[cnt_i])  
  Next cnt_i
 
  Sub_End_critical_section
  
EndSub

'---------------------------------------------------------------
' Requests to read data.
' module  : module address (1..15)
' channel : number of the LS interface on the LS-bus module (1..2)
' dev_adr : device nr lsbus (1..15)
' reg_adr : adress of register (JX/FPGA)
' cnt_dat : count of data  (1..16)
'---------------------------------------------------------------
Sub P2_LS_Read_Req(module, channel, ls_module, reg_adr, cnt_dat)  '<HIDE>
  Dim addr, ftc As Long
  CHECK_CARD(module)
  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 

  
  Do
    ftc = Peek_P2 (addr + 5 * 16)                           ' tx FIFO count
  Until ((ftc < 28) or (ftc = 12345678H))

  
  Sub_begin_critical_section
  poke(addr, (Shift_Left(cnt_dat - 1, 4) Or ls_module))     'data write Header 1
  poke(addr, (reg_adr))                                     'data write Header 2
  Sub_End_critical_section
  
EndSub

'---------------------------------------------------------------
' Reads response (only DIG_IO request).
' module  : module address (1..15)
' channel : number of the LS interface on the LS-bus module (1..2)
' return  : state of digital outputs and inputs
'---------------------------------------------------------------
Function P2_LS_Read_Resp_DIO(module, channel) As Long       '<HIDE>
  
  Dim ld[4] As Long 
  Dim cnt_i As Long
  Dim addr As Long
  CHECK_CARD(module)

  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 


  For cnt_i = 1 To 4                                        ' rx data read
    ld[cnt_i] = Peek_P2 (addr)
  Next cnt_i
  P2_LS_Read_Resp_DIO = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))
EndFunction

'---------------------------------------------------------------
' Reads response.
' module  : module address (1..15)
' channel : number of the LS interface on the LS-bus module (1..2)
' cnt_dat : count of data  (1..16)
' buf[]   : array (min len is cnt_dat)
' return  : error code (0->ok)
'---------------------------------------------------------------
Function P2_LS_Read_Resp(module, channel, cnt_dat, buf[]) As Long  '<HIDE>
  Dim cnt_i As Long
  Dim addr As Long
  CHECK_CARD(module)
  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 


  For cnt_i = 1 To cnt_dat                                  ' rx data read
    buf[cnt_i] = Peek_P2 (addr)
  Next cnt_i

 
  P2_LS_Read_Resp = Peek_P2 (addr)
  
EndFunction

'******************************************************************************
''' Resets the watchdog timer, sets digital outputs and
'''+ reads digital inputs.
'''+ Return: state of digital outputs and inputs
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
'''+ ls_module: device nr lsbus (FIX 1)
'''value: each bit corresponds to a channel
'''****************************************************************************
Function P2_LS_Dig_IO(module, channel, value) As Long
  Dim cnt_i As Long
  Dim addr As Long
  dim ld[4] as long
  dim ls[1] as long                                         'speed optimize 
  
  CHECK_CARD(module)
  addr = Shift_Left(module, 20) Or 60010100h + (((channel) - 1) * 256) 
 
  For cnt_i = 1 To 4                                        ' rx data read
    ld[cnt_i] = Peek_P2 (addr)
  Next cnt_i
  ls[1] = 1                                                 ' WD trigger  
  p2_I_Send_BC(module, channel, 44h, 1, ls)
  
  P2_LS_Dig_IO = ld[1] Or (Shift_Left(ld[2], 8)) Or (Shift_Left(ld[3], 16)) Or (Shift_Left(ld[4], 24))

  
  P2_I_Send_NA32(module, channel, 1, 7Ch, value)            ' c' tx data transmit

  P2_LS_Read_Req(module, channel, 1, 7Ch, 4)                ' request new in data
EndFunction

'******************************************************************************
''' Enables, disables and configures the watchdog.
'''+Return: error code (0->ok)
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr lsbus (1..15)
''' enable:  
'''+           0->disable
'''+           1->enable
''' time: trigger time [ms]
'''****************************************************************************
Function P2_LS_Watchdog_Init(module, channel, ls_module, enable, time) As Long

  Dim ld[2] As Long

  Dim ret, t As Long

  CHECK_CARD(module)
  
  'Watchdog disable
  ld[1] = 0ADh
  ld[2] = 0
  ret = P2_I_Send_lib(module, channel, ls_module, 45h, 2, ld)

  'Watchdog time
  t = time / 25e-6
  ret = ret Or (P2_I_Send32(module, channel, ls_module, 48h, t))

  ' Watchdog enable
  ld[1] = 0ADh
  ld[2] = enable And 1
  P2_LS_Watchdog_Init = ret Or (P2_I_Send_lib(module, channel, ls_module, 45h, 2, ld))
EndFunction


'******************************************************************************
''' Resets the watchdog timer.
'''+ If the watchdog is activated, the user program has to call
'''+ this Function at least every ....
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
'''****************************************************************************
Sub P2_LS_Watchdog_Reset(module, channel)

  Dim ld[1] As Long

  CHECK_CARD(module)
  ld[1] = 1
  P2_I_Send_BC(module, channel, 44h, 1, ld)
EndSub


'******************************************************************************
''' Initialises a digital I/O module (channel 0 - 31).
'''+Return: error code (0->ok)
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr LS-bus (1..15)
''' value:     each bit corresponds to 8 channel
'''+           0 -> input
'''+           1 -> output
'''+           bit 0: channels 1..8
'''+               1: channels 9..16
'''+               2: channels 17..24
'''+               3: channels 25..32
'''****************************************************************************
Function P2_LS_DigProg(module, channel, ls_module, value) As Long

  Dim ld[2] As Long
  Dim ret As Long
  CHECK_CARD(module)
  
  ld[1] = (Shift_Left(value, 3) And 8h) Or (Shift_Left(value, 7) And 80h) OR 11h
  ld[2] = (Shift_Left(value, 2) And 8h) Or (Shift_Left(value, 6) And 80h) OR 11h
  
  ret = P2_I_Send_lib(module, channel, ls_module, 16h, 2, ld)

  ld[1] = (Shift_Left(value, 1) And 8h) Or (Shift_Left(value, 5) And 80h) OR 11h
  ld[2] = (value And 8h) Or (Shift_Left(value, 4) And 80h) OR 11h

  P2_LS_DigProg = ret Or (P2_I_Send_lib(module, channel, ls_module, 20h + 16h, 2, ld))
EndFunction

'******************************************************************************
''' Sets the digital outputs (channel 0 - 31).
''' module: module address  (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr LS-bus (1..15)
''' value: each bit corresponds to a channel
'''****************************************************************************
Sub P2_LS_Digout_Long(module, channel, ls_module, value) 
  CHECK_CARD(module)  
  P2_I_Send_NA32(module, channel, ls_module, 7Ch, value)    ' channel 1..32
EndSub

'******************************************************************************
''' Sets the digital outputs and read error code (channel 0 - 31).
''' module: module address  (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr LS-bus (1..15)
''' value: each bit corresponds to a channel
''' BUS_stat: Error Code 0=OK 
'''****************************************************************************
'''#C;P5:BR;
Sub P2_LS_Digout_Long_BS(module, channel, ls_module, value, BUS_stat)
  CHECK_CARD(module)
  BUS_stat = P2_I_Send32(module, channel, ls_module, 7Ch, value)  ' channel 1..32
EndSub

'******************************************************************************
''' Reads the digital inputs (channel 0 - 31).
'''+Return: state of digital outputs and inputs
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr LS-bus (1..15)
'''****************************************************************************
Function P2_LS_Digin_Long(module, channel, ls_module) As Long
  Dim ret As Long 
  ret = P2_I_Receive32(module, channel, ls_module, 7Ch, P2_LS_Digin_Long)
EndFunction

'******************************************************************************
''' Reads the digital inputs (channel 0 - 31).
'''+Return: state of digital outputs and inputs
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr LS-bus (1..15)
''' BUS_stat: Error Code 0=OK 
'''****************************************************************************
'''#C;P4:BR;
Function P2_LS_Digin_Long_BS(module, channel, ls_module, BUS_stat) As Long
  CHECK_CARD(module)
  BUS_stat = P2_I_Receive32(module, channel, ls_module, 7Ch, P2_LS_Digin_Long_BS)
EndFunction

'******************************************************************************
''' Reads the digital output status (overcurrent) (channel 0 - 31).
'''+Return: each bit corresponds a channel 0 = OK 1 = Error
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr LS-bus (1..15)
'''****************************************************************************
Function P2_LS_Get_Output_Status(module, channel, ls_module) As Long 
  Dim t As Long
  CHECK_CARD(module)
  t = P2_I_Receive32(module, channel, ls_module, 50h, P2_LS_Get_Output_Status)
EndFunction

'******************************************************************************
''' Initialises the LS-Module.
'''+Return: error code (0->ok)
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
''' ls_module: device nr LS-bus (1..15)
'''****************************************************************************
Function P2_LS_DIO_Init(module, channel, ls_module) As Long


  Dim ld[1] As Long
  Dim ret As Long
  Dim addr As Long

  CHECK_CARD(module)

  addr = Shift_Left(module, 20) Or 60010100h + ((channel - 1) * 256) 
  poke(addr + 3 * 16, 1)                                    'autoreset rx ON
  
  ld[1] = 3
  ret = P2_I_Send_lib(module, channel, ls_module, 40h, 1, ld)  ' Reset JX 1, 2
  ld[1] = 1
  ret = ret Or (P2_I_Send_lib(module, channel, ls_module, 5Ch, 1, ld))  ' timeout reset

  ld[1] = 4
  ret = ret Or (P2_I_Send_lib(module, channel, ls_module, 4Ch, 1, ld))  ' Set default direction time

  
  P2_LS_DIO_Init = ret Or (P2_I_Send32(module, channel, ls_module, 50h, 0))  ' overcurrent reset

  ld[1] = 30h
  P2_LS_DIO_Init = ret Or (P2_I_Send_lib(module, channel, ls_module, 43h, 1, ld))  ' overtemperature reset
EndFunction

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
''' Reset the LS - Controller
''' module: module address (1..15)
''' channel: number of the LS interface on the LS-bus module (1..2)
'''****************************************************************************
SUB P2_LS_Reset(module, channel)
  dim addw as long
  
  CHECK_CARD(module)
  addw = Shift_Left(module, 20) Or 60010110h + ((channel - 1) * 256) 
  poke(addw, 11B)                                           'clear rx und tx  
  p2_sleep(24)
ENDSUB


'<ENDREGION>

'<REGION> SG/DMS 

''' Sets the operating mode.
''' module: module address  (1..15)
'''mode:
'''+     0->single mode for zero or gain calib
'''+     1->single shot mode
'''+     3->continuous mode max Speed
'''channels: selected channels in binary
'''+Bit 0   UB 1
'''+Bit 1   UB 2
'''+Bit 2   UB 3
'''+Bit 3   UB 4
'''+Bit 4   USense 1 (6 wire mode)
'''+Bit 5   USense 2
'''+Bit 6   USense 3
'''+Bit 7   USense 4
'''+Bit 8   UEx 1   (4 wire mode)
'''+Bit 9   UEx 2
'''+Bit 10  UEx 3
'''+Bit 11  UEx 4
'''+Bit 12  Channel 13
'''+Bit 13  Channel 14
'''******************************************************************************
SUB P2_SG_Mode(module, mode, channels)
  P2_SEQ_Init(module, mode, 0, channels, 250)
ENDSUB

'******************************************************************************
''' Starts SG SEQ-Mode.
''' module_pattern: bit pattern to set the module addresses
'''******************************************************************************
SUB P2_SG_Start(module_pattern)
  P2_SEQ_Start(module_pattern)
ENDSUB

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
''' Waits until the sequence control has converted and stored all channels of the channel group on the specified module.
''' module: module address (1..15)
'''******************************************************************************
SUB P2_SG_Wait(module)
  P2_SEQ_Wait(module)
ENDSUB


'******************************************************************************
''' Transfers the input data to an array (24 Bit Long).
''' module: module address  (1..15)
''' count: number of values
''' array[]: destination array
''' index: start index at the destination array
'''******************************************************************************
SUB P2_SG_Read(module, count, array[], index) 
  P2_SEQ_Read24(module, count, array, index)
endsub



''' Convert 24 Bit Value to mV
''' value: 24 Bit input value
''' gain: Us 0=1 
'''+      Ud 1=20
'''+      Ud 2=40
'''+      Ud 3=80
'''+      Ud 4=160
'''+      Ud 5=320
'''+      Ud 6=640
'''******************************************************************************
'''#C;R:F;
Function P2_SG_Convert(value, gain) as float
  dim help as long
  dim gh as long
  help = value - 8388607
  if (gain = 0) then 
    gh = 1
  else
    gh = shift_left(1, gain) * 10
  endif 
  
  P2_SG_Convert = (20000 / 16777216) / (gh) * help
ENDFUNCTION 


''' Init SG Channel 
''' module: module address (1..15)
''' channel: channel number of sg(1..4)
''' gain:
'''+ 1=20
'''+ 2=40
'''+ 3=80
'''+ 4=160
'''+ 5=320
'''+ 6=640
''' filter: 
'''+ 0 = 2 KHz
'''+ 1 = 200 Hz
''' excitation:
'''+ 0 = 1.25 V
'''+ 1 = 2.50 V
'''+ 2 = 3.75 V
'''+ 3 = 5.00 V
'''+ 4 = 6.25 V
'''+ 5 = 7.50 V
'''+ 6 = 8.70 V
'''+ 7 = 9.80 V
'''******************************************************************************
SUB P2_SG_Init(module, channel, gain, filter, excitation)
  dim offset as long
  dim gainV as long
  dim offsetF as long
  
  check_card(module)
  if (excitation <> -1) then                                'don't change for internal use 
    poke((60070940h + (channel - 1) * 32) or shift_left(module, 20), excitation) 
  endif
  
  poke((60070800h + (channel - 1) * 32) or shift_left(module, 20), gain or shift_left(filter, 3)) 
  poke(60070880h or shift_left(module, 20), 1)              '
  p2_sleep(800000)                                          '8 ms  
  offset = P2_System_Get_Offset_Digital_Mux(module, 16, ((channel) - 1), 0)  'read g offset lesen
 
  
  if (gain < 4) then 
    gainV = P2_System_Get_Gain_Digital_Mux(module, (channel) * 2 - 1, gain, 1)  '
    offsetF = P2_System_Get_Offset_Digital_Mux(module, (channel) * 2 - 1, gain, 1)  '
  else
    gainV = P2_System_Get_Gain_Digital_Mux(module, (channel) * 2, gain - 4, 1)  '
    offsetF = P2_System_Get_Offset_Digital_Mux(module, (channel) * 2, gain - 4, 1)  '
  endif
  
  
  P2_System_Set_OFFSET_Digital_Mux(Module, channel, 0, offsetF, 0)  '<HIDE>
  P2_System_Set_Gain_Digital_Mux(Module, channel, 0, gainV, 0)  '<HIDE>
  
  P2_SG_Set_Offset(module, channel, offset)

endsub



'''SG Mode must set to zero mode
'''+ 0: 0K 
'''+ -1: error low prio only
'''+ -2: wrong module type
'''+ -3: sg_mode is <> 0
''' module: module address (1..15)
''' channel: channel number of sg(1..4)
''' save: 
'''+0 do not write new setup to module eeprom, old data is back if system turns off/on
'''+1 write new setup to module eeprom, overwrite old setting
'''******************************************************************************
Function P2_SG_Zero(module, channel, save) as long 
  check_card(module)
#IF PRIORITAET = HIGH
  P2_SG_Zero = -1
  
#else  
  dim i, p, v as long
  dim t as long
  dim m as long
  dim out[3] as long
  dim test[255] as long 
  dim pga as long
  dim ch as long
  dim pgaP as long
  dim oldpga, oldfilter as long
  dim modeSe as long
  m = P2_System_Read_MC(module)
  if (m = 6659) then 
    
    
    modeSe = peek_p2 (60070200h OR shift_left(module, 20)) AND 111B
    
    if (modeSe = 0) then 
      P2_SG_GET_PGA(module, channel, oldpga, oldFilter)
      P2_System_Set_OFFSET_Digital_Mux(module, channel, 0, 0, 0)  'fein offset=0
      P2_System_Set_GAIN_Digital_Mux(module, channel, 0, 65536, 0)  'gain 65536
  
 
      poke((60070800h + (channel - 1) * 32) or shift_left(module, 20), 1 or shift_left(1, 3)) 
      poke(60070880h or shift_left(module, 20), 1)          '
      p2_sleep(800000)                                      '8 ms  
   
      P2_SG_Set_Offset(module, channel, -127)
      p2_sleep(1600000)                                     '16 ms  
    
    
      for i = 1 to 255
        P2_SG_Set_Offset(module, channel, i - 128)
  
        test[i] = 0
        for m = 1 to 50
          test[i] = test[i] + (shift_right(p2_adc24(module, channel), 6) - 131072)
        next
        test[i] = test[i] / 50
      next

      p = 1111111110
      t = 0
      for i = 1 to 255
        if (abs(test[i]) < p) then 
          p = abs(test[i])
          t = i - 128
        endif
      next
 
      P2_SG_Set_Offset(module, channel, t)
      p2_sleep(1600000)                                     '16 ms  
      if (save = 1) then p2_System_Set_Offset_Digital_Mux_EEPROM(module, 16, (channel) - 1, t, 0)  'grob offstet
  
      for pga = 1 to 6 
        P2_SG_INIT(module, channel, pga, 1, -1)
        P2_System_Set_OFFSET_Digital_Mux(module, channel, 0, 0, 0)  'fein offset=0
        'mittelwert
        m = 0
  
        for i = 1 to 2000
          v = shift_right(p2_adc24(module, channel), 6) - 131072
          m = m + v
        next
        v = -m / 2000
   
        ch = (channel * 2) - 1
        pgap = pga
        if (pga > 3) then 
          ch = ch + 1
          pgap = pga - 4
        endif
    
    
    
        P2_System_Set_OFFSET_Digital_Mux(module, ch, pgap, v, 1)  
  
        if (save = 1) then p2_System_Set_Offset_Digital_Mux_EEPROM(module, ch, pgap, v, 1)  ' normal offset

  
      next
      P2_SG_INIT(module, channel, oldpga, oldfilter, -1)
      P2_SG_Zero = 0
    else
      P2_SG_Zero = -3
    endif
    
  else 
    P2_SG_Zero = -2
  endif
  
#endif

  
  
endfunction

''set SG gain and return status
'''+ >0: calib value
'''+ -1: error low prio only
'''+ -2: wrong module type
'''+ -3: overflow
'''+ -4: underflow
'''+ -5: new gain out of range 
'''+ -6: sg_mode is <> 0
''' module: module address (1..15)
''' channel: channel number of dms(1..4)
''' mode:
'''+ 1: 6-wire mode readback ex voltage on sense input
'''+ 2: 4-wire mode readback ex voltage on ex input
'''+ 3: set value only
''' value: sg value mv/V   (mode3 calib value [digit])
''' save: 
'''+0: do not write new setup to module eeprom, old data is back if system turns off/on
'''+1: write new setup to module eeprom, overwrite old setting
'''******************************************************************************
Function P2_SG_Set_Gain(module, channel, mode, value, save) as long 

#IF PRIORITAET = HIGH
  P2_SG_Set_Gain = -1
#else  
  dim m, ch, pgap as long
  dim v as float
  dim e, cv as long
  dim ub as float
  dim choffset as long
  dim uref as float
  dim pga, filter as long
  dim i as long
  dim modeSe as long
  check_card(module)
  choffset = 0
  if (mode = 1) then choffset = 4
  if (mode = 2) then choffset = 8
  
  m = P2_System_Read_MC(module)
    
  if (m = 6659) then 
    
    
    modeSe = peek_p2 (60070200h OR shift_left(module, 20)) AND 111B
    if (modeSe = 0) then 
      P2_System_Set_GAIN_Digital_Mux(module, channel, 0, 65536, 0)  'gain 65536 
      P2_SG_GET_PGA(module, channel, PGA, Filter)
   
      if (mode < 3) then 
        m = 0 
        for i = 1 to 2000
          v = shift_right(p2_adc24(module, channel + chOffset), 6) - 131072
          m = m + v
        next
        v = m / 2000
        v = v + 131072  
        ub = P2_SG_Convert((v * 64), 0) / 1000              'ub [V]
  
        uref = value * ub
    
        m = 0
        e = 0
        for i = 1 to 2000
          v = shift_right(p2_adc24(module, channel), 6) - 131072
          m = m + v
        next
        v = m / 2000
    
        if (absf(v - 131071) < 1) then e = -3
        if (absf(v + 131072) < 1) then e = -4
    
        v = v + 131072    
        v = P2_SG_Convert((v * 64), pga)
    
 
      
        cv = uref / v * 65536    

        if (absf(cv - 65536) > 10000) then e = -5
   
      else
        e = 0
        cv = value
      endif
      

      if (e = 0) then 
        e = cv
     
        ch = (channel * 2) - 1
        pgap = pga
        if (pga > 3) then 
          ch = ch + 1
          pgap = pga - 4
        endif
   
        P2_System_Set_GAIN_Digital_Mux(module, ch, pgap, cv, 0)  'gain 65536
        P2_System_Set_GAIN_Digital_Mux(module, channel, 0, cv, 0) 
        if (save = 1) then p2_System_Set_Gain_Digital_Mux_EEPROM(module, ch, pgap, cv, 1)  ' normal gain

      endif
    
      P2_SG_Set_Gain = e
    else
      P2_SG_Set_Gain = -6
    endif
    
  else
    P2_SG_Set_Gain = -2
  endif 
#endif

ENDFUNCTION




FUNCTION P2_System_Get_Gain_Digital_Mux(module, channel, gain, diff) AS LONG  '<HIDE>
  '******************************************************************
  '* read gain calib value from card workspace 
  '* card          [INTEGER]  : Moduladresse
  '* channel      [INTEGER]  : Kanal (1..n)
  '* gain          [INTEGER]  : 0 - PGA-Gain = 1
  '*                          1 - PGA-Gain = 2
  '*                          2 - PGA-Gain = 4
  '*                          3 - PGA-Gain = 8
  '* diff          [INTEGER]  :  Inputs
  '*                            0 - Differentiell
  '*                            1 - Single Ended
  '* only for P2 Ain with multiplexer
  '******************************************************************
  DIM help AS LONG
  check_card(module)
  help = (gain) * 256 * 16
  IF (diff = 1) THEN help = help + 8000h
    
  P2_System_Get_Gain_Digital_Mux = peek((68070000h + ((channel) * 16) - 10h + help) OR SHIFT_LEFT(module, 20))
  
ENDFUNCTION


FUNCTION P2_System_Get_Offset_Digital_Mux(module, channel, gain, diff) AS LONG  '<HIDE>
  '******************************************************************
  '* read offset calib value from card workspace 
  '* channel      [INTEGER]  : Kanal (1..n)
  '* gain          [INTEGER]  : 0 - PGA-Gain = 1
  '*                          1 - PGA-Gain = 2
  '*                          2 - PGA-Gain = 4
  '*                          3 - PGA-Gain = 8
  '* diff          [INTEGER]  :  Inputs
  '*                            0 - differentiell
  '*                            1 - single ended
  '* only for P2 Ain with multiplexer
  '******************************************************************
  DIM help AS LONG
  dim offset as long
  check_card(module)
  help = (gain) * 256 * 16
  IF (diff = 1) THEN help = help + 8000h
  
  offset = peek((68060000h + (channel) * 16 - 10H + help) OR SHIFT_LEFT(module, 20))
  
  if (offset AND 8000H > 1) then offset = offset OR 0FFFF0000H 
  P2_System_Get_Offset_Digital_Mux = offset

ENDFUNCTION



SUB P2_System_Set_Offset_Digital_Mux(module, channel, gain, value, diff)  '<HIDE>
  '******************************************************************
  '* write offset calib value to card workspace 
  '* card          [INTEGER]  : Moduladresse 
  '* channel      [INTEGER]  : Kanal (1..n)
  '* gain          [INTEGER]  : 0 - PGA-Gain = 1
  '*                          1 - PGA-Gain = 2
  '*                          2 - PGA-Gain = 4
  '*                          3 - PGA-Gain = 8
  '* value        [INTEGER]  : 
  '* diff          [INTEGER]  : inputs
  '*                            0 - differentiell
  '*                            1 - single ended
  '* only for P2 Ain with multiplexer
  '******************************************************************
  DIM help AS LONG
  check_card(module)
  help = (gain) * 256 * 16
  IF (diff = 1) THEN help = help + 8000h
  
  POKE(((68060000h + (channel) * 16 - 10H + help) OR SHIFT_LEFT(module, 20)), value)
  
ENDSUB





SUB P2_System_Set_Gain_Digital_Mux(module, channel, gain, value, diff)  '<HIDE>
  '******************************************************************
  '* write gain calib value to card workspace 
  '*                          aber im EEPROM.
  '* card          [INTEGER]  : Moduladresse (0 = CPU)
  '* channel      [INTEGER]  : Kanal (1..n)
  '* gain          [INTEGER]  : 0 - PGA-Gain = 1
  '*                          1 - PGA-Gain = 2
  '*                          2 - PGA-Gain = 4
  '*                          3 - PGA-Gain = 8
  '* value        [INTEGER]  :  
  '* diff          [INTEGER]  :  inputs
  '*                            0 - differentiell
  '*                            1 - single ended
  '* only for P2 Ain with multiplexer
  '******************************************************************
  DIM help AS LONG
  check_card(module)
  help = (gain) * 256 * 16 
  IF (diff = 1) THEN help = help + 8000h
  POKE(((68070000h + (channel) * 16 - 10H + help) OR SHIFT_LEFT(module, 20)), value)
ENDSUB


''' Set DMS OFFSET
''' module: module address (1..15)
''' channel: channel number of dms(1..4)
''' offset:  +-127
'''******************************************************************************
SUB P2_SG_Set_Offset(module, channel, offset)               '<HIDE>
  check_card(module)
  
  poke((600708A0h + (channel - 1) * 32) or shift_left(module, 20), offset) 
  poke(60070920h or shift_left(module, 20), 1) 
  
  P2_System_Set_OFFSET_Digital_Mux(module, 16, ((channel) - 1), offset, 0)  
  
  p2_sleep(200000)                                          '2 ms  
ENDSUB

''' Get PGA and filter set
''' module: module address (1..15)
''' channel: channel number of dms(1..4)
''' pga: return by ref [long]
''' filter: return by ref[long]
'''#C;P3:BR;P4:BR;
SUB P2_SG_GET_PGA(module, channel, pga, filter)             '<HIDE>
  dim back as long
  dim pga2 as long
  dim fi as long
  check_card(module)
  back = PEEK((60070800h + ((channel) - 1) * 32) or shift_left(module, 20))
  pga = back AND 111B
  filter = shift_right(back, 3) AND 1
ENDSub
 

'<ENDREGION>

'<REGION> ECAT Master 

'******************************************************************************
'''Reads values from an array and writes them into memory on the specified module.
'''module: module address (1..15)    
'''count: number of data elements to be transferred.
'''startadr: start adr memory
'''array[]: source array
'''array_start_index: start index in the source array.
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''****************************************************************************
SUB P2_ECAT_Master_Write_Mem(module, count, startadr, array[], array_start_index, flowrate) 
  dim ilen as Long
  dim iindex as Long
  dim pointer as Long
  dim maxburst as Long
  dim anzcount as Long
  dim istart as long
  
  CHECK_TYPE_LONG (array[1])


#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 8
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)
  
  ilen = count 
  iindex = array_start_index
  istart = startadr
  
  if (ilen > 0) then
    do 
      anzcount = min_long(ilen, maxburst)
      System_Array_Debug_Check(array, iindex, anzcount)  
      
      sub_Begin_critical_section
      POKE (600E8000h OR shift_left(module, 20), istart)
      Write_Fast_Bus_LB_nocritL(array[iindex], anzcount, 640E8100h or shift_left(module, 20))
      sub_END_critical_section
    
      
      ilen = ilen - anzcount
      iindex = iindex + anzcount
      istart = istart + anzcount
    until (ilen = 0)
  endif
ENDSUB
  


'******************************************************************************
'''Reads values from memory on the specified module and writes them into an array                                                           
'''module: module address (1..15)   
'''count: number of data elements to be transferred.
'''startadr: start adr memory
'''array[]: destination array
'''array_start_index: start index in the destination array.
'''flowrate: 
'''+         1=low
'''+         2=medium
'''+         3=fast
'''****************************************************************************
SUB P2_ECAT_Master_Read_Mem(module, count, startadr, array[], array_start_index, flowrate)
  dim ilen as Long
  dim iindex as Long
  dim maxburst as Long
  dim anzcount as Long
  dim istart as long
  CHECK_TYPE_LONG (array[1])
  
#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 8
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  check_card(module)
  istart = startadr
  ilen = count 

  iindex = array_start_index
  if (ilen > 0) then
    do
      anzcount = min_long(ilen, maxburst)
      System_Array_Debug_Check(array, iindex, anzcount)
          
      sub_Begin_critical_section
      POKE (600E8010h OR shift_left(module, 20), istart)
      Read_Fast_Bus_LB_nocritL(array[iindex], anzcount, 640E8104h OR shift_left(module, 20))
      sub_END_critical_section
      
      ilen = ilen - anzcount
      istart = istart + anzcount
      iindex = iindex + anzcount
    until (ilen = 0)
  endif
ENDSUB


'''restart ecat master 
'''+return value:
'''+   0 - Data transfer successful
'''+   1 - no module found
'''+   2   Timeout module not restart
'''+   3   Timeout module not run after restart
'''+  -1 - Error: Instruction may only be used with low priority.
''' module:Specified module address (1.15).
Function P2_EtherCAT_Master_Reboot(module) as long
  Dim Led_Status, old as Integer
  dim Error as long
  dim t1, td as long 
  dim tmax1, tmax2 as long
  
#IF PRIORITAET = LOW then    
  old = p2_check_led(module)
  
  if (old = 12345678) then 
    P2_EtherCAT_Master_Reboot = 1 
  else
    p2_set_led(module, 1)
  
#if prozessor = T12 
    POKE(68000260h OR shift_left(module, 20), 02590152h)    '02590152h = 
    tmax1 = 45000
    tmax2 = 1700000000
#else
    POKE_fast_bus(32800026h OR shift_left(module, 16),02590152h) '02590152h =  Code zum Re-booten
    tmax1=15000
    tmax2=500000000
#endif
    t1 = read_timer()
    'cpu_sleep ?
    Do
      '    wait for timeout value to make sure that reboot has begun
      td = read_timer() - t1
      Led_Status = P2_Check_LED(module)
      
    Until (((Led_Status = 012345678h) or (LED_Status = 0)) or (td > tmax1))
    
    if (led_status = 1) then 
      P2_EtherCAT_Master_Reboot = 2
    else
    
      t1 = read_timer()
      
'''cpu_sleep ?
      
      Do
        td = read_timer() - t1
        Led_Status = P2_Check_LED(module)
        ' wait for meaningful value to make sure that reboot has finished
      Until ((Led_Status <> 12345678H) or (td > tmax2))
      if (led_status <> 12345678H) then
        P2_EtherCAT_Master_Reboot = 0
      else
        P2_EtherCAT_Master_Reboot = 3
      endif
    endif
  endif
  
  p2_set_led(module, old)
#else
  P2_EtherCAT_Master_Reboot = -1
#endif  
  
EndFunction


'<ENDREGION>

'<REGION> CAN FD
'******************************************************************************
''' Sets CAN LEDs on/off for a CAN channel.
''' module: module address (1..15)
''' channel: number (1..2) of the CAN interface.
''' led: Status of CAN LED:
'''+          0: LED off
'''+          1: LED on
'''******************************************************************************
SUB P2_CANFD_Set_LED(module, channel, led)
  CHECK_CARD(module)
  POKE(((60001500h + ((channel) * 10000h)) OR shift_left(module, 20)), led)
ENDSUB



'***************************************************************************
'''Sets a 32 Bit register of the CAN controller via SPI interface.
'''+SPI stream consists of 
'''+ bits   0..3: Command code
'''+ bits  4..15: Address
'''+ bits 16..47: Value
'''module: module address (1..15)
'''channel: number (1..2) of the CAN interface.
'''adress: register adress
'''value: value to be set
'''****************************************************************************
SUB P2_CANFD_Set_Reg(module, channel, adress, value)        '<HIDE>
  CHECK_CARD(module)
  P2_CANFD_Set_Reg_LIB(module, channel, adress, value) 
ENDSUB


'***************************************************************************
'''Reads a 32 Bit register of the CAN controller via SPI interface.
'''+SPI stream consists of 
'''+ bits   0..3: Command code
'''+ bits  4..15: Address
'''+ bits 16..47: Value
'''module: module address (1..15)
'''channel: number (1..2) of the CAN interface.
'''adress: register adress
'''****************************************************************************
FUNCTION P2_CANFD_Get_Reg(module, channel, address) AS LONG  '<HIDE>
  CHECK_CARD(module)
  P2_CANFD_Get_Reg = P2_CANFD_Get_Reg_LIB(module, channel, address) 
ENDFUNCTION

'***************************************************************************
''' Resets the CAN controller via SPI interface.
'''+SPI stream consists of 
'''+ bits   0..3: Command code
'''+ bits  4..15: Address
'''+ bits 16..47: Value
'''module: module address (1..15)
'''channel: number (1..2) of the CAN interface.
'''****************************************************************************
SUB P2_CANFD_Reset(module, channel)                         '<HIDE>
  P2_CANFD_Reset_LIB(module, channel)
ENDSUB

'***************************************************************************
'''Calculates the number of bytes required in the RAM area to create the
'''+corresponding Fifo or queue.
'''pls: Payload size (0..7)
'''+     0:  8 bytes
'''+     1: 12 bytes
'''+     2: 16 bytes
'''+     3: 20 bytes
'''+     4: 24 bytes
'''+     5: 32 bytes
'''+     6: 48 bytes
'''+     7: 64 bytes
'''fifo_size: number of fifo elements + 1
'''timestamp: set timestamp mode:
'''+     0: Timestamp disabled
'''+     1: Timestamp enabled
'''****************************************************************************
FUNCTION P2_CANFD_Calc_RAM_Size(pls, fifo_size, timestamp) AS LONG  '<HIDE>
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1

  P2_CANFD_CALC_RAM_SIZE = P2_CANFD_CALC_RAM_SIZE_LIB(PLS, MY_FIFO_SIZE, TIMESTAMP)
ENDFUNCTION


'***************************************************************************
'''Calculates  the number of data bytes based on the DLC.
'''+return value: number of data bytes
'''DLC: Data length code:
'''+ 0..8: 0..8 bytes
'''+    9: 12 bytes
'''+   10: 16 bytes
'''+   11: 20 bytes
'''+   12: 24 bytes
'''+   13: 32 bytes
'''+   14: 48 bytes
'''+   15: 64 bytes
'''****************************************************************************
FUNCTION P2_CANFD_CALC_No_Data_BYTES(DLC) AS LONG           '<HIDE>
  IF (DLC <= 8) THEN P2_CANFD_CALC_No_Data_BYTES = DLC
  IF (DLC = 9) THEN P2_CANFD_CALC_No_Data_BYTES = 12
  IF (DLC = 10) THEN P2_CANFD_CALC_No_Data_BYTES = 16
  IF (DLC = 11) THEN P2_CANFD_CALC_No_Data_BYTES = 20
  IF (DLC = 12) THEN P2_CANFD_CALC_No_Data_BYTES = 24
  IF (DLC = 13) THEN P2_CANFD_CALC_No_Data_BYTES = 32
  IF (DLC = 14) THEN P2_CANFD_CALC_No_Data_BYTES = 48
  IF (DLC = 15) THEN P2_CANFD_CALC_No_Data_BYTES = 64
ENDFUNCTION


'***************************************************************************
'''Calculates  the number of registers of a message object.
'''+return value: number of registers
'''DLC: Data length code:
'''+ 0..8: 0..8 bytes
'''+    9: 12 bytes
'''+   10: 16 bytes
'''+   11: 20 bytes
'''+   12: 24 bytes
'''+   13: 32 bytes
'''+   14: 48 bytes
'''+   15: 64 bytes
'''timestamp: set timestamp mode:
'''+    0: Timestamp disabled
'''+    1: Timestamp enabled
'''****************************************************************************
FUNCTION P2_CANFD_CALC_NO_DATA_REG(DLC, timestamp) AS LONG  '<HIDE>
  P2_CANFD_CALC_NO_DATA_REG = P2_CANFD_CALC_NO_DATA_REG_LIB(DLC, TIMESTAMP) 
ENDFUNCTION 


'***************************************************************************
'''Reads a received message from a receive Fifo.
'''+return value:
'''+   -1: No message received
'''+  >=0: Message was received, value is the identifier of the message.
'''fifo_no: Number (1..31) of the receive fifo.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512.
'''can_msg[]: Array where the message is stored. Min size 20.
'''****************************************************************************
FUNCTION P2_CANFD_Read_RMO(Fifo_no, canfd_datatable[], can_msg[]) AS LONG
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Read_RMO = P2_CANFD_Read_RMO_LIB(Fifo_no, CANFD_datatable, CAN_MSG) 
ENDFUNCTION

'***************************************************************************
'''Sets the mode variable in the CANFD datatable.
'''mode: Operating mode of controller
'''+    CANFD_MODE_CANFD: CAN FD bus
'''+    CANFD_MODE_CAN:   CAN bus (CAN 2.0)
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512 .
'''****************************************************************************
SUB P2_CANFD_Set_Mode(mode, canfd_datatable[]) 
  P2_CANFD_Set_Mode_LIB(mode, CANFD_datatable) 
ENDSUB

'***************************************************************************
'''Initializes the CAN controller with the prepared settings in canfd_datatable[].
'''+return value: Controller status
'''+    0: OK, controller is initialized.
'''+  <>0: Error during initialization.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
Function P2_CANFD_Init_Controller(canfd_datatable[]) as long
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Init_Controller = P2_CANFD_Init_Controller_LIB(CANFD_datatable)
ENDfunction


'***************************************************************************
'''Returns the state of a Fifo.
'''+return value: bit pattern with status bits of the Fifo.
'''+The status applies if the bit is set:
'''+  bit     receive Fifo                       transmit FIFO
'''+   0  Fifo is not empty.                   Fifo is not full.
'''+   1  Fifo is more than or is half full.   Fifo is less than or is half full.
'''+   2  Fifo is empty.                       Fifo is empty.
'''+   3  Fifo overflow happened.               
'''+   5                                     Error detected during transmission.
'''+   6                                     Message lost arbitration.
'''+   7                                     Message was aborted.
'''module: Module address (1..15).
'''channel: Number (1, 2) of CAN channel.
'''fifo_no: Number (031) of the Fifo. Number 0 refers to the transmit queue.
'''****************************************************************************
FUNCTION P2_CANFD_Get_Fifo_State(module, channel, fifo_no) AS LONG
  CHECK_CARD(module)
  P2_CANFD_GET_FIFO_STATE = P2_CANFD_GET_FIFO_STATE_LIB(module, channel, Fifo_no) 
ENDFUNCTION

'***************************************************************************
'''Calculates the values for can_msg[1] and can_msg[2] and writes it to the array
'''ID: Identifier
'''SEQ: Sequence to keep track of transmitted messages in Transmit event FIFO
'''FDF: FD Frame
'''BRS: Bit rate switch
'''RTR: Remote transmition request; not used in FD mode
'''IDE: Identifier extension flag:
'''+      0: 11/12 bit identifier
'''+      1: 29 bit identifier
'''+      For a 12 bit identifier see P2_CANFD_Set_SID11.
'''DLC: Data length code 
'''+ 0...8: 0...8 byte(s)
'''+     9: 12 bytes
'''+    10: 16 bytes
'''+    11: 20 bytes
'''+    12: 32 bytes
'''+    13: 32 bytes
'''+    14: 48 bytes
'''+    15: 64 bytes
'''can_msg[]: array to which the values should be written; the length must be at least 20 elements
'''+         can_msg[1] = Header 
'''+         can_msg[2] = Header
'''+         can_msg[3..n] = Payload; n depends on DLC
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
SUB P2_CANFD_Write_TMO_Header(ID, SEQ, FDF, BRS, RTR, IDE, DLC, can_msg[], canfd_datatable[])  '<HIDE>
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  P2_CANFD_Write_TMO_Header_LIB(ID, SEQ, FDF, BRS, RTR, IDE, DLC, CAN_MSG, CANFD_datatable)
ENDSUB

* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
'''Writes to a transmit message object to the RAM area of the CAN controller
'''+return value: -1: Fifo full ; data is not set
'''+               0: OK
'''fifo_no: number of the fifo from which the object should be read
'''DLC: Data length code
'''can_msg[]: array to which the object should be written; the length must be at least 20 elements
'''+        CAN_MSG[1] = Header ; must be set before this function; e.g. by sub P2_CANFD_Write_TMO_Header_LIB
'''+        CAN_MSG[2] = Header ; must be set before this function; e.g. by sub P2_CANFD_Write_TMO_Header_LIB
'''+        CAN_MSG[3..n] = Payload; n depends on DLC
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION P2_CANFD_Write_TMO_RAM(fifo_no, DLC, can_msg[], canfd_datatable[]) AS LONG  '<HIDE>
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Write_TMO_RAM = P2_CANFD_Write_TMO_RAM_LIB(Fifo_no, DLC, CAN_MSG, CANFD_datatable) 
ENDFUNCTION

'***************************************************************************
'''Writes a message to a fifo in the CAN controller.
'''+return value: -1: Fifo full, message has not been stored
'''+               0: OK
'''fifo_no: number (0..31) of the Fifo. Number 0 refers to the transmit queue.
'''ID:  Identifier of the CAN message.
'''+    Bit no. refers to settings of IDE or P2_CANFD_Set_SID11.
'''SEQ: Specific value (0..63) to track the message in the transmit event Fifo.
'''FDF: CAN format (CAN FD only):
'''+      0: Format CAN (high speed)
'''+      1: Format CAN FD.
'''BRS: Baud rate switch (CAN FD only):
'''+      0: Nominal baud rate.
'''+      1: Switches between nominal and data baud rate.
'''RTR: Remote transmission request (CAN 2.0 only).
'''+      0: RTR not used.
'''+      1: RTR enabled.
'''IDE: Identifier extension flag:
'''+      0: 11/12 bit identifier
'''+      1: 29 bit identifier
'''+      For a 12 bit identifier see P2_CANFD_Set_SID11.
'''DLC: Data length code:
'''+ 0...8: 0...8 bytes
'''+     9: 12 bytes
'''+    10: 16 bytes
'''+    11: 20 bytes
'''+    12: 32 bytes
'''+    13: 32 bytes
'''+    14: 48 bytes
'''+    15: 64 bytes
'''can_msg[]: array with a CAN message. The length must be at least 20 elements.
'''+    can_msg[1]: Header, part 1, is set automatically from passed parameters.
'''+    can_msg[2]: Header, part 2, is set automatically from passed parameters.
'''+    can_msg[3..n] = CAN message (payload); n depends on DLC
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512 
'''****************************************************************************
FUNCTION P2_CANFD_Write_TMO(fifo_no, ID, SEQ, FDF, BRS, RTR, IDE, DLC, can_msg[], canfd_datatable[]) AS LONG
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Write_TMO = P2_CANFD_Write_TMO_LIB(Fifo_no, ID, SEQ, FDF, BRS, RTR, IDE, DLC, CAN_MSG, CANFD_datatable) 
ENDFUNCTION

'+***************************************************************************
'''Extracts the header information from a CAN message object in can_msg[].
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512.
'''ID: Identifier
'''ESI: Error status indicator (CAN FD only):
'''+      0: Transmitting node is error active.
'''+      1: Transmitting node is error passive.
'''FDF: CAN format (CAN FD only):
'''+      0: Format CAN (high speed)
'''+      1: Format CAN FD.
'''BRS: Baud rate switch (CAN FD only):
'''+      0: Nominal baud rate.
'''+      1: Switches between nominal and data baud rate.
'''RTR: Remote transmission request (CAN 2.0 only).
'''+      0: RTR not used.
'''+      1: RTR enabled.
'''IDE: Identifier extension flag:
'''+      0: 11/12 bit identifier
'''+      1: 29 bit identifier
'''+      For a 12 bit identifier see P2_CANFD_Set_SID11.
'''DLC: Data length code:
'''+ 0...8: 0...8 bytes
'''+     9: 12 bytes
'''+    10: 16 bytes
'''+    11: 20 bytes
'''+    12: 32 bytes
'''+    13: 32 bytes
'''+    14: 48 bytes
'''+    15: 64 bytes
'''***************************************************************************
'''#C;P3:BR;P4:BR;P5:BR;P6:BR;P7:BR;P8:BR;P9:BR;
SUB P2_CANFD_Get_Header_Parts(can_msg[], canfd_datatable[], ID, ESI, FDF, BRS, RTR, IDE, DLC)
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  ID = P2_CANFD_Get_ID(can_msg, canfd_datatable, IDE)
  ESI = P2_CANFD_Get_ESI(CAN_MSG)
  FDF = P2_CANFD_Get_FDF(CAN_MSG)
  BRS = P2_CANFD_Get_BRS(CAN_MSG)
  RTR = P2_CANFD_Get_RTR(CAN_MSG)
  IDE = P2_CANFD_Get_IDE(CAN_MSG)
  DLC = P2_CANFD_Get_DLC(CAN_MSG)
ENDSUB


'***************************************************************************
'''Extracts the identifier ID from the header of a CAN message object in can_msg[].
'''+return value: Identifier ID.
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512.
'''IDE: Identifier extension flag:
'''+      0: 11/12 bit identifier
'''+      1: 29 bit identifier
'''+      For a 12 bit identifier see P2_CANFD_Set_SID11.
'''***************************************************************************
FUNCTION P2_CANFD_Get_ID(can_msg[], canfd_datatable[], IDE) AS LONG 
  DIM SID11_Enabled AS LONG 
  System_Array_Debug_Check(can_msg, 1, 20)
  System_Array_Debug_Check(canfd_datatable, 1, 512)
  SID11_Enabled = SHIFT_RIGHT(canfd_datatable[CANFD_IDX_C1TDC], 24) AND 01H
  IF (IDE = 0) THEN 
    IF (SID11_Enabled = 0) THEN                             '11BIt ID
      P2_CANFD_Get_ID = CAN_MSG[1] AND 07FFH
    ELSE                                                    '12BIt ID
      P2_CANFD_Get_ID = CAN_MSG[1] AND 07FFH or SHIFT_RIGHT((CAN_MSG[1] AND 20000000H), 18)
    ENDIF
  ELSE                                                      '29BIt ID 
    P2_CANFD_Get_ID = SHIFT_LEFT((CAN_MSG[1] AND 7FFH), 18) OR SHIFT_RIGHT((CAN_MSG[1] AND 1FFFF800H), 11)
  ENDIF
ENDFUNCTION

'***************************************************************************
'''Extracts the parameter ESI from the header of a CAN message object in can_msg[].
'''+return value: ESI: Error status indicator (CAN FD only):
'''+      0: Transmitting node is error active.
'''+      1: Transmitting node is error passive.
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''***************************************************************************
FUNCTION P2_CANFD_Get_ESI(can_msg[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  P2_CANFD_Get_ESI = SHIFT_RIGHT(CAN_MSG[2], 8) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts the parameter FDF from the header of a CAN message object in can_msg[].
'''+return value: FDF, CAN format (CAN FD only):
'''+      0: Format CAN (high speed)
'''+      1: Format CAN FD.
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''***************************************************************************
FUNCTION P2_CANFD_Get_FDF(can_msg[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  P2_CANFD_Get_FDF = SHIFT_RIGHT(CAN_MSG[2], 7) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts the parameter BRS from the header of a CAN message object in can_msg[].
'''+return value: BRS: Baud rate switch (CAN FD only):
'''+      0: Nominal baud rate.
'''+      1: Switches between nominal and data baud rate.
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''***************************************************************************
FUNCTION P2_CANFD_Get_BRS(can_msg[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  P2_CANFD_Get_BRS = SHIFT_RIGHT(CAN_MSG[2], 6) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts the parameter RTR from the header of a CAN message object in can_msg[].
'''+return value: RTR: Remote transmission request (CAN 2.0 only).
'''+      0: RTR not used.
'''+      1: RTR enabled.
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''***************************************************************************
FUNCTION P2_CANFD_Get_RTR(can_msg[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  P2_CANFD_Get_RTR = SHIFT_RIGHT(CAN_MSG[2], 5) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts the parameter IDE from the header of a CAN message object in can_msg[].
'''+return value: Identifier extension flag:
'''+      0: 11/12 bit identifier
'''+      1: 29 bit identifier
'''+      For a 12 bit identifier see P2_CANFD_Set_SID11.
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''***************************************************************************
FUNCTION P2_CANFD_Get_IDE(can_msg[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  P2_CANFD_Get_IDE = SHIFT_RIGHT(CAN_MSG[2], 4) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts the parameter DLC from the header of a CAN message object in can_msg[].
'''+return value: DLC: Data length code:
'''+ 0...8: 0...8 bytes
'''+     9: 12 bytes
'''+    10: 16 bytes
'''+    11: 20 bytes
'''+    12: 32 bytes
'''+    13: 32 bytes
'''+    14: 48 bytes
'''+    15: 64 bytes
'''can_msg[]: Array with a CAN Message object; the length must be at least 20 elements.
'''***************************************************************************
FUNCTION P2_CANFD_Get_DLC(can_msg[]) AS LONG
  System_Array_Debug_Check(CAN_MSG, 1, 20)
  P2_CANFD_Get_DLC = CAN_MSG[2] AND 0FH
ENDFUNCTION

'***************************************************************************
'''Extracts the parameter SEQ from a CAN event Fifo object (EFO) in msg[].
'''+return value: Parameter SEQ. Specific value (063) of the sent message.
'''+The parameter SEQ is given to the controller with P2_CANFD_Write_TMO.
'''msg[]: Array with an Event Fifo object (EFO) from the event Fifo.
'''+   The array is read with P2_CANFD_Read_EFO. The length must be at least 3 elements.
'''***************************************************************************
FUNCTION P2_CANFD_Get_SEQ(msg[]) AS LONG 
  System_Array_Debug_Check(msg, 1, 3)
  P2_CANFD_Get_SEQ = Shift_Right(msg[2], 9) AND 07FH
ENDFUNCTION

'***************************************************************************
'''Initializes the datatable. This should be the first command sent
'''+to a CAN interface. Followed by the configuration commands
'''+enable_XXX_FIFO; enable_XXX_queue; SET_XXX_Baudrate, ...
'''module: Module address (1..15)
'''channel: Number (1..2) of the CAN interface.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512.
'''****************************************************************************
SUB P2_CANFD_Init_Datatable(module, channel, CANFD_datatable[])
  CHECK_CARD(module)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Init_datatable_LIB(module, channel, CANFD_datatable)
ENDSUB

'***************************************************************************
'''Defines a receive Fifo for incoming CAN messages and stores the information
'''+in a CANFD array.
'''+This instruction does not access the CAN controller. Use P2_CANFD_Init_Controller
'''+to initilize the controller using the CANFD array.
'''+return value: Controller status:
'''+    -1: RAM full; Fifo is not set
'''+     0: OK
'''fifo_no: Number (1..31) of the Fifo.
'''pls: Payload size (0..7)
'''+     0:  8 bytes
'''+     1: 12 bytes
'''+     2: 16 bytes
'''+     3: 20 bytes
'''+     4: 24 bytes
'''+     5: 32 bytes
'''+     6: 48 bytes
'''+     7: 64 bytes
'''fifo_size: Number (132) of CAN messages which the Fifo can store.
'''timestamp: Timestamp mode:
'''+     0: no timestamp.
'''+     1: Timestamp of the CAN message is stored.
'''id: Identifier to filter messages to be received with this Fifo.
'''+    Bit no. refers to settings of IDE or P2_CANFD_Set_SID11.
'''+    Set significant bits with parameter mask.
'''mask: Mask, which sets significant bits of the identifier id:
'''+     0: Dont care, bit is not relevant.
'''+     1: Must match, bit must be correct.
'''ide: Identifier extension flag:
'''+      0: 11/12 bit identifier
'''+      1: 29 bit identifier
'''+      For a 12 bit identifier see P2_CANFD_Set_SID11.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512.
'''****************************************************************************
FUNCTION P2_CANFD_Enable_Receive_Fifo(fifo_no, pls, fifo_size, timestamp, id, mask, ide, canfd_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Enable_Receive_Fifo = P2_CANFD_Enable_Receive_Fifo_LIB(Fifo_no, PLS, MY_Fifo_size, Timestamp, ID, Mask, ide, CANFD_datatable) 
ENDFUNCTION
'***************************************************************************
'''Defines a transmit event Fifo for outgoing CAN messages and stores the 
'''+information in a CANFD array. The Fifo can stores the header and timestamp
'''+(if indicated) of each sent CAN Message.
'''+This instruction does not access the CAN controller. Use P2_CANFD_Init_Controller
'''+to initilize the controller using the CANFD array.
'''+return value: Controller status:
'''+    -1: RAM full; Fifo is not set
'''+     0: OK
'''fifo_size: Number (1..32) of CAN messages which the Fifo can store.
'''timestamp: Timestamp mode:
'''+     0: no timestamp is stored
'''+     1: timestamp of the CAN message is stored
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512.
'''****************************************************************************
FUNCTION P2_CANFD_Enable_Transmit_Event_Fifo(fifo_size, timestamp, CANFD_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  P2_CANFD_Enable_Transmit_Event_Fifo = P2_CANFD_Enable_Transmit_Event_Fifo_LIB(MY_Fifo_size, Timestamp, CANFD_datatable) 
ENDFUNCTION
'***************************************************************************
'''Defines a transmit Fifo for outgoing CAN messages and stores the 
'''+information in a CANFD array.
'''+This instruction does not access the CAN controller. Use P2_CANFD_Init_Controller
'''+to initilize the controller using the CANFD array.
'''+return value: Controller status:
'''+    -1: RAM full; Fifo is not set
'''+     0: OK
'''fifo_no: Number (1..31) of the Fifo.
'''pls: Payload size (0..7)
'''+     0:  8 bytes
'''+     1: 12 bytes
'''+     2: 16 bytes
'''+     3: 20 bytes
'''+     4: 24 bytes
'''+     5: 32 bytes
'''+     6: 48 bytes
'''+     7: 64 bytes
'''fifo_size: Number (1..32) of CAN messages which the Fifo can store.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512.
'''****************************************************************************
FUNCTION P2_CANFD_Enable_Transmit_Fifo(fifo_no, pls, fifo_size, canfd_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Enable_Transmit_Fifo = P2_CANFD_Enable_Transmit_Fifo_LIB(Fifo_no, PLS, MY_Fifo_size, CANFD_datatable)
ENDFUNCTION
'***************************************************************************
'''Defines the transmit queue for outgoing CAN messages and stores the 
'''+information in a CANFD array.
'''+This instruction does not access the CAN controller. Use P2_CANFD_Init_Controller
'''+to initilize the controller using the CANFD array.
'''+return value: Controller status:
'''+    -1: RAM full; Fifo is not set
'''+     0: OK
'''pls: Payload size (0..7)
'''+     0:  8 bytes
'''+     1: 12 bytes
'''+     2: 16 bytes
'''+     3: 20 bytes
'''+     4: 24 bytes
'''+     5: 32 bytes
'''+     6: 48 bytes
'''+     7: 64 bytes
'''fifo_size: Number (1..32) of CAN messages which the Fifo can store.
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512.
'''****************************************************************************
FUNCTION P2_CANFD_Enable_Transmit_Queue(pls, fifo_size, canfd_datatable[]) AS LONG
  DIM My_fifo_size AS LONG
  My_fifo_size = fifo_size - 1
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Enable_Transmit_Queue = P2_CANFD_Enable_Transmit_Queue_LIB(PLS, MY_Fifo_size, CANFD_datatable) 
ENDFUNCTION

'***************************************************************************
'''Calculates the values for tseg1, tseg2 and bpr depending on the passed
'''+baudrate. This command makes no access to the CAN controller. 
'''+The CAN controller is accessed by P2_CANFD_Init_Controller.
'''+return value: 0 : Baudrate is set
'''+              1 : Baudrate is not allowed
'''baud: baudrate
'''canfd_register: Register value, which contains settings for data transfer.
'''****************************************************************************
Function P2_CANFD_Calc_Baudrate(baud, canfd_register) AS LONG  '<HIDE>    
  P2_CANFD_CALC_Baudrate = P2_CANFD_CALC_Baudrate_LIB(baud, CANFD_register,60) 
EndFunction


'***************************************************************************
'''Calculates the values for tseg1, tseg2 and bpr depending on the passed
'''+baudrate. This command makes no access to the CAN-Controller. 
'''+The CAN-Controller is accessed by P2_CANFD_Init_Controller.
'''+ return value : 0 : Baudrate is set
'''+                1 : Baudrate is not allowed
'''baud: baudrate
'''canfd_register: CAN register
'''sp: sample_point [%]
'''****************************************************************************
Function P2_CANFD_Calc_Baudrate_SP(baud, canfd_register,sp) AS LONG  ''<HIDE>    
  P2_CANFD_CALC_Baudrate_sp = P2_CANFD_CALC_Baudrate_LIB(baud, canfd_register,sp) 
EndFunction





'***************************************************************************
'''Modifies the datatable by setting the nominal baudrate. 
'''+This command makes no access to the CAN controller. The CAN controller 
'''+is accessed by P2_CANFD_Init_Controller.
'''+The CAN controller is accessed by P2_CANFD_Init_Controller.
'''+return value: 0 : Baudrate is set
'''+              1 : Baudrate is not allowed
'''baud: baudrate
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION P2_CANFD_Set_Baudrate_Nominal(baud, canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  DIM CANFD_register AS LONG
  P2_CANFD_Set_Baudrate_Nominal = P2_CANFD_CALC_Baudrate(baud, CANFD_register)
  CANFD_datatable[CANFD_IDX_C1NBTCFG] = CANFD_register
ENDFUNCTION
'***************************************************************************
'''Modifies the datatable by setting the data baudrate. 
'''+This command makes no access to the CAN controller. The CAN controller 
'''+is accessed by P2_CANFD_Init_Controller.
'''+The CAN controller is accessed by P2_CANFD_Init_Controller.
'''+return value: 0 : Baudrate is set
'''+              1 : Baudrate is not allowed
'''baud: baudrate
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION P2_CANFD_Set_Baudrate_Data(baud, canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  DIM CANFD_register AS LONG
  P2_CANFD_Set_Baudrate_Data = P2_CANFD_CALC_Baudrate(baud, CANFD_register)
  CANFD_datatable[CANFD_IDX_C1DBTCFG] = CANFD_register
ENDFUNCTION


'***************************************************************************
'''Modifies the datatable by setting the nominal baudrate. 
'''+This command makes no access to the CAN-Controller. The CAN-Controller 
'''+is accessed by P2_CANFD_Init_Controller.
'''+The CAN-Controller is accessed by P2_CANFD_Init_Controller.
'''+ return value : 0 : Baudrate is set
'''+                1 : Baudrate is not allowed
'''baud: baudrate
'''sample_point: samplepoint % 
'''canfd_datatable: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION P2_CANFD_Set_Baudrate_Nominal_SP(baud,sample_point, canfd_datatable[]) AS LONG
  System_Array_Debug_Check(canfd_datatable, 1, 512)
  DIM CANFD_register AS LONG
  P2_CANFD_Set_Baudrate_Nominal_SP = P2_CANFD_CALC_Baudrate_sp(baud, CANFD_register,sample_point)
  canfd_datatable[CANFD_IDX_C1NBTCFG] = CANFD_register
ENDFUNCTION

'***************************************************************************
'''Modifies the datatable by setting the data baudrate. 
'''+This command makes no access to the CAN-Controller. The CAN-Controller 
'''+is accessed by P2_CANFD_Init_Controller.
'''+The CAN-Controller is accessed by P2_CANFD_Init_Controller.
'''+return value: 0 : Baudrate is set
'''+              1 : Baudrate is not allowed
'''baud: baudrate
''sample_point: samplepoint % 
'''canfd_datatable: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
FUNCTION P2_CANFD_Set_Baudrate_Data_SP(baud,sample_point, canfd_datatable[]) AS LONG
  System_Array_Debug_Check(canfd_datatable, 1, 512)
  CHECK_CARD(canfd_datatable[CANFD_IDX_MODUL])
  DIM CANFD_register AS LONG
  P2_CANFD_Set_Baudrate_Data_sp = P2_CANFD_CALC_Baudrate_sp(baud, CANFD_register,sample_point)
  canfd_datatable[CANFD_IDX_C1DBTCFG] = CANFD_register
ENDFUNCTION










'***************************************************************************
'''Modifies the datatable by setting the Transmitter delay compensation. 
'''+This command makes no access to the CAN controller. The CAN controller 
'''+is accessed by P2_CANFD_Init_Controller.
'''+The CAN controller is accessed by P2_CANFD_Init_Controller.
'''TDCMOD: TDC Mode 0 = disabled; 1 = manual; 2 = auto
'''TDCO: TDC Offset -64..63
'''TDCV: TDC value 0..63
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
SUB P2_CANFD_Set_TDC(TDCMOD, TDCO, TDCV, canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  DIM CANFD_register AS LONG
  CANFD_register = CANFD_datatable[CANFD_IDX_C1TDC] AND 0FF000000H
  CANFD_register = CANFD_register OR SHIFT_LEFT(TDCMOD, 16)
  CANFD_register = CANFD_register OR SHIFT_LEFT(TDCO, 08)
  CANFD_register = CANFD_register OR TDCV
  CANFD_datatable[CANFD_IDX_C1TDC] = CANFD_register
ENDSUB

'***************************************************************************
'''This command makes no access to the CAN controller. The CAN controller 
'''+The CAN controller is accessed by P2_CANFD_Init_Controller.
'''+Globally sets the CAN FD basic message length to 11 bit or 12 bit for the CAN controller.
'''EN_SID11: 0 = disable; 1 = enable
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''****************************************************************************
SUB P2_CANFD_Set_SID11(EN_SID11, canfd_datatable[]) AS LONG
  System_Array_Debug_Check(canfd_datatable, 1, 512)
  DIM CANFD_register AS LONG
  CANFD_register = canfd_datatable[CANFD_IDX_C1TDC] AND 000FFFFFFH
  CANFD_register = CANFD_register OR SHIFT_LEFT(EN_SID11, 24)
  canfd_datatable[CANFD_IDX_C1TDC] = CANFD_register
ENDSUB


'***************************************************************************
'''Reads the register TREC form the CAN controller and writes the value to
'''+the CANFD_datatable. 
'''+return value: value of register TREC
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_TREC(canfd_datatable[]) AS LONG
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_datatable[CANFD_TREC] = P2_CANFD_Get_Reg(CANFD_datatable[CANFD_IDX_MODUL], CANFD_datatable[CANFD_IDX_Channel], CANFD_ADR_C1TREC)
  P2_CANFD_GET_TREC = CANFD_datatable[CANFD_TREC]
ENDFUNCTION
'***************************************************************************
'''Extracts TXBO: Transmitter in Bus Off State (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+ return value: TXBO
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION P2_CANFD_GET_TXBO(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_TXBO = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 20) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts TXBP: Transmitter in Error Passive State (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+return value: TXBP
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION P2_CANFD_GET_TXBP(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_TXBP = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 19) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts RXBP: Receiver in Error Passive State (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+return value: RXBP
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION P2_CANFD_GET_RXBP(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_RXBP = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 18) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts TXWARN: Transmitter in Error Warning State (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+return value: TXWARN
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_TXWARN(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_TXWARN = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 17) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts RXWARN: Receiver in Error Warning State (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+ return value: RXWARN
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_RXWARN(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_RXWARN = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 16) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts EWARN: Transmitter or Receiver in Error Warning State (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+return value: EWARN
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_EWARN(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_EWARN = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 15) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts TEC: Transmitter Error Count (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+ return value: TEC
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_TEC(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_TEC = SHIFT_RIGHT(CANFD_datatable[CANFD_TREC], 8) AND 0FFH
ENDFUNCTION
'***************************************************************************
'''Extracts REC: Receiver Error Count (Register TREC)
'''+The command P2_CANFD_GET_TREC must be executed before.
'''+ return value: REC
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_REC(canfd_datatable[]) AS LONG
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_REC = CANFD_datatable[CANFD_TREC] AND 0FFH
ENDFUNCTION
'***************************************************************************
'''Reads a event message object form the CAN controller
'''+return value: -1 : No new message
'''+             >=0 : ID
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''msg: Array to which the object should be written; the length must be at least 3 elements
'''+        msg[1] = Header 
'''+        msg[2] = Header
'''+        msg[3] = Transmit message timestamp
'''****************************************************************************
FUNCTION P2_CANFD_Read_EFO(canfd_datatable[], msg[]) AS LONG
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(MSG, 1, 3)
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_Read_EFO = P2_CANFD_Read_EFO_LIB(CANFD_datatable, MSG)
ENDFUNCTION
'***************************************************************************
'''Enables the transmit of messages which are stroed before in a transmit fifo
'''module: number of CAN module
'''channel: number of the CAN interface on the CAN module
'''Fifo_no: Number of the transmit fifo
'''****************************************************************************
SUB P2_CANFD_Transmit_MSG(module, channel, Fifo_no)
  CHECK_CARD(module)
  P2_CANFD_Set_Reg(module, channel, CANFD_ADR_C1TXREQ, SHIFT_LEFT(01H, Fifo_no))
ENDSUB
'***************************************************************************
'''Enables the transmit of messages which are stroed before in transmit fifos
'''module: number of CAN module
'''channel: number of the CAN interface on the CAN module
'''Fifo_pattern: Pattern of the fifos which objects should be send
'''****************************************************************************
SUB P2_CANFD_Transmit_Multi_MSG(module, channel, Fifo_pattern)
  CHECK_CARD(module)
  P2_CANFD_Set_Reg(module, channel, CANFD_ADR_C1TXREQ, SHIFT_LEFT(Fifo_pattern, 01H))
ENDSUB
'***************************************************************************
'''Reads the register BDIAG0 form the CAN controller and writes the value to
'''+the CANFD_datatable. 
'''+return value: value of register BDIAG0
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION P2_CANFD_GET_BDIAG0(CANFD_datatable[]) AS LONG
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_datatable[CANFD_BDIAG0] = P2_CANFD_Get_Reg(CANFD_datatable[CANFD_IDX_MODUL], CANFD_datatable[CANFD_IDX_Channel], CANFD_ADR_C1BDIAG0)
  P2_CANFD_GET_BDIAG0 = CANFD_datatable[CANFD_BDIAG0]
ENDFUNCTION
'***************************************************************************
'''Reads the register BDIAG1 form the CAN controller and writes the value to
'''+the CANFD_datatable. 
'''+return value: value of register BDIAG1
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                  ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_BDIAG1(CANFD_datatable[]) AS LONG
  CHECK_CARD(CANFD_datatable[CANFD_IDX_MODUL])
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  CANFD_datatable[CANFD_BDIAG1] = P2_CANFD_Get_Reg(CANFD_datatable[CANFD_IDX_MODUL], CANFD_datatable[CANFD_IDX_Channel], CANFD_ADR_C1BDIAG1)
  P2_CANFD_GET_BDIAG1 = CANFD_datatable[CANFD_BDIAG1]
ENDFUNCTION
'***************************************************************************
'''Extracts DTERRCNT: Data Bit Rate Transmit Error Count (Register BDIAG0)
'''+The command P2_CANFD_GET_BDIAG0 must be executed before.
'''+ return value: DTERRCNT
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_DTERRCNT(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DTERRCNT = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG0], 24) AND 0FFH
ENDFUNCTION
'***************************************************************************
'''Extracts DRERRCNT: Data Bit Rate Receive Error Count (Register BDIAG0)
'''+The command P2_CANFD_GET_BDIAG0 must be executed before.
'''+return value: DRERRCNT
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
''' ***************************************************************************
FUNCTION P2_CANFD_GET_DRERRCNT(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DRERRCNT = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG0], 16) AND 0FFH
ENDFUNCTION
'***************************************************************************
'''Extracts NTERRCNT: Nominal Bit Rate Transmit Error Count (Register BDIAG0)
'''+The command P2_CANFD_GET_BDIAG0 must be executed before.
'''+return value: NTERRCNT
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NTERRCNT(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NTERRCNT = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG0], 8) AND 0FFH
ENDFUNCTION
'***************************************************************************
'''Extracts NRERRCNT: Nominal Bit Rate Receive Error Count (Register BDIAG0)
'''+The command P2_CANFD_GET_BDIAG0 must be executed before.
'''+return value: NRERRCNT
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NRERRCNT(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NRERRCNT = CANFD_datatable[CANFD_BDIAG0] AND 0FFH
ENDFUNCTION
'***************************************************************************
'''Extracts EFMSGCNT: Error Free Message Count (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: EFMSGCNT
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_EFMSGCNT(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_EFMSGCNT = CANFD_datatable[CANFD_BDIAG1] AND 0FFFFH
ENDFUNCTION
'***************************************************************************
'''Extracts DLCMM: DLC mismatch (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: DLCMM
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_DLCMM(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DLCMM = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 31) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts ESI: ESI Flag was set (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: ESI
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_ESI_Flag(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_ESI_Flag = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 30) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts DCRCERR: Data rate CRC Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: DCRCERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_DCRCERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DCRCERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 29) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts DSTUFERR: Data rate Stuff bit Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: DSTUFERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_DSTUFERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DSTUFERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 28) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts DFORMERR: Data rate fixed format Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: DFORMERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_DFORMERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DFORMERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 27) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts DBIT1ERR: Data rate recessive bit was monitored dominant Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: DBIT1ERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_DBIT1ERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DBIT1ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 25) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts DBIT0ERR: Data rate recessive bit was monitored dominant Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: DBIT0ERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_DBIT0ERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_DBIT0ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 24) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts TXBOERR: Bus Off Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: TXBOERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_TXBOERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_TXBOERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 23) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts NCRCERR: Nominal rate CRC Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: NCRCERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NCRCERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NCRCERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 21) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts NSTUFERR: Nominal rate Stuff bit Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+ return value: NSTUFERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NSTUFERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NSTUFERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 20) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts NFORMERR: Nominal rate fixed format Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: NFORMERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NFORMERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NFORMERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 19) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts NACKERR: Nominal Transmit message was not acknowledged (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: NACKERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NACKERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NACKERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 18) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts NBIT1ERR: Nominal rate recessive bit was monitored dominant Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+return value: NBIT1ERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NBIT1ERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NBIT1ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 17) AND 01H
ENDFUNCTION
'***************************************************************************
'''Extracts NBIT0ERR: Nominal rate recessive bit was monitored dominant Error (Register BDIAG1)
'''+The command P2_CANFD_GET_BDIAG1 must be executed before.
'''+ return value: NBIT0ERR
'''canfd_datatable[]: Array, which contains settings for data transfer between 
'''+                ADwin CPU and the CANFD module. Min size 512
'''***************************************************************************
FUNCTION P2_CANFD_GET_NBIT0ERR(CANFD_datatable[]) AS LONG'<HIDE>
  System_Array_Debug_Check(CANFD_datatable, 1, 512)
  P2_CANFD_GET_NBIT0ERR = SHIFT_RIGHT(CANFD_datatable[CANFD_BDIAG1], 16) AND 01H
ENDFUNCTION

'<ENDREGION>

'<REGION> Anybus M40

'''Writes array content into RAM
'''module: 1..15
'''source_ar: source array (data type Long)
'''startindex: start index (1..n) in source_ar
'''startindex_ram: start index (0..n) in Anybus RAM
'''count: number (1..n) of words; word size is set with word_length
'''flowrate: flow rate, depending on process priority
'''+   low priority  -> 1=slow (up to 16 x long), 2=middle (up to 128 x long), 3=fast (up to 1024 x long)
'''+   high priority -> 1,2,3 (up to 32768 x long)
'''word_length:
'''+   32   use 32 bit values in source_ar 
'''+   16   use 16 bit values in source_ar 
SUB p2_M40_SET_RAM(module,source_ar[],startindex,startindex_ram,count,flowrate,word_length) '<HIDE>
  dim i as long
  dim adr as long
  dim anzcount as Long
  DIM maxburst as Long
  dim icount as long
  DIM iindex as Long
  dim ready as long
    
  CHECK_TYPE_LONG (source_ar)
  System_Array_Debug_Check(source_ar,startindex,count)
  check_card(module)
   
  if (count > 0) then   
    if ((word_length=16) AND (count<6)) then 
      adr=shift_left(startindex_ram,4)
      iindex=startindex
      for i=1 to count 
        POKE((60000000h or adr OR shift_left(module, 20)), source_ar[iindex])
        poke(syst_hw_nop, 1)                                      '20 ns bus sleep
     
        adr=adr+16
        inc iindex
      next
    else
      if (word_length=16) then       
        POKE(60070800h or (shift_left(module, 20)), startindex_ram)  '
      else
        POKE(60070800h or (shift_left(module, 20)), (startindex_ram) or shift_left(1,31))   
      endif 
      poke(syst_hw_nop, 1)  
#IF PRIORITAET = LOW
      maxburst = 128
      if (flowrate = 1) then maxburst = 16
      if (flowrate = 3) then maxburst = 1024
#ELSE
      maxburst = 32768
#ENDIF     
      iindex = startindex
      icount=count 
      do 
        anzcount = min_long(icount, maxburst)          
        Write_Fast_Bus_LB(source_ar[iindex], anzcount, 64070900h or shift_left(module, 20))
        icount = icount - anzcount
        iindex = iindex + anzcount
      until (icount = 0)
       
      poke(syst_hw_nop, 1)                                      '80 ns bus sleep
  
      do  'wait   
        ready=peek_p2(68070800h OR shift_left(module, 20))
      until ((ready=1) or (ready=12345678H))
        
    endif
  endif
    
      
ENDSUB


'''Reads RAM content into an array
'''module: 1...15
'''destination_ar: destination array (data type Long)
'''startindex: start index (1..n) in destination_ar
'''startindex_ram: start index (0..n) in Anybus RAM
'''count: number (1..n) of words; word size is set with word_length
'''flowrate: flow rate, depending on process priority
'''+   low priority  -> 1=slow (up to 16 x long), 2=middle (up to 128 x long), 3=fast (up to 1024 x long)
'''+   high priority -> 1,2,3 (up to 32768 x long)
'''word_length:
'''+   32   use 32 bit values in destination_ar 
'''+   16   use 16 bit values in destination_ar 
SUB P2_M40_GET_RAM(module,destination_ar[],startindex,startindex_ram,count,flowrate,word_length) '<HIDE>
  dim i as long
  dim anzcount as Long
  DIM maxburst as Long
  dim icount as long
  DIM iindex as Long
      
  check_card(module)
  CHECK_TYPE_LONG (destination_ar)
  System_Array_Debug_Check(destination_ar,startindex,count)
  '
  if ((word_length=16) AND (count=1)) then 
    destination_ar[startindex]=Peek_P2(60000000h or shift_left((startindex_ram),4) OR shift_left(module, 20))
  else
    if (word_length=32) then 
      POKE(60070850h or (shift_left(module, 20)), (startindex_ram) or shift_left(1,31))
    else
      POKE(60070850h or (shift_left(module, 20)), startindex_ram)
    endif
 
#IF PRIORITAET = LOW
    maxburst = 128
    if (flowrate = 1) then maxburst = 16
    if (flowrate = 3) then maxburst = 1024
#ELSE
    maxburst = 32768
#ENDIF   
    icount=count
    if (icount > 0) then
      iindex=startindex
      do
        anzcount = min_long(icount, maxburst)       
        Read_Fast_Bus_LB(destination_ar[iindex], anzcount, 64070904h OR shift_left(module, 20))
        iindex = iindex + anzcount
        icount = icount - anzcount
      until (icount = 0)
    endif
  endif   
ENDSUB
  

SUB P2_ABM40_Reset(module)     '<HIDE>'
  
  check_card(module)
  
  POKE(((60040000h) OR shift_left(module, 20)),1) 'Reset low '1  ms
  P2_sleep(100000)
  POKE(((60040000h) OR shift_left(module, 20)),0) 'Reset high
  P2_sleep(150000000)                                     '1.5sec (in 10 nsec)
  
  
ENDSUB


'<ENDREGION>

'<REGION> DRAM
************************************************************************
''' Transfers the modul memory to an array
''' module: module address (1..15)
''' count: number of values
''' startadr: startadr. ram
''' array[]: destination array
''' array_start_index: startindex at the destination array
'''flowrate: 
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_DRAM_Read(module, count, startadr, array[], array_start_index, flowrate) ''<HIDE>
  dim ilen as Long
  dim iindex as Long
  dim maxburst as Long
  dim anzcount as Long
  dim busy as long
  dim istart as long

#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 8
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  
  ilen = count 

  if (ilen > 0) then
    iindex = array_start_index
    istart=startadr
    
    check_card(module)
    System_Array_Debug_Check(array, iindex, ilen)
    do
      busy=Peek_p2((68070800h OR shift_left(module, 20)))
    until ((busy = 1) or (busy = 12345678H))
   
  
      
    do
      anzcount = min_long(ilen, maxburst)
      
      SUB_BEGIN_CRITICAL_SECTION
      POKE (60070850h OR shift_left(module, 20), istart)
      poke(syst_hw_nop, 2)                                     
      
      if (if_type_fifo (array) = 1) then
        Read_Fast_Bus_LB(array, anzcount, 64070904h OR shift_left(module, 20))
      else
        Read_Fast_Bus_LB(array[iindex], anzcount, 64070904h OR shift_left(module, 20))
      endif
      
      SUB_END_CRITICAL_SECTION
      
      ilen = ilen - anzcount
      istart=istart+anzcount
      iindex = iindex + anzcount
    until (ilen = 0)
    
  endif
ENDSUB


'******************************************************************************
''' Transfers data to Modul memory
''' module: module address (1..15)
''' count: number of values
''' startadr: startadr. ram
''' array[]: source array
''' array_start_index: startindex at the source array
''' flowrate:
'''+         1->low
'''+         2->medium
'''+         3->fast
'''******************************************************************************
SUB P2_DRAM_Write(module, count, startadr, array[], array_start_index, flowrate) '<HIDE>
  dim ilen as Long
  dim iindex as Long
  dim pointer as Long
  dim maxburst as Long
  dim anzcount as Long
  dim busy as long
  dim istart as long
  
  CHECK_TYPE_LONG (array[1])


#IF PRIORITAET = LOW
  maxburst = 128
  if (flowrate = 1) then maxburst = 8
  if (flowrate = 3) then maxburst = 1024
#ELSE
  maxburst = 32768
#ENDIF

  ilen = count

  if (ilen > 0) then
    check_card(module)
    
    iindex = array_start_index
    istart=startadr
    
    do
      busy=Peek_p2((68070800h OR shift_left(module, 20)))
    until ((busy = 1) or (busy = 12345678H))
    POKE (60070800h OR shift_left(module, 20), istart)
    poke(syst_hw_nop, 2)
    
    System_Array_Debug_Check(array, iindex, ilen)   
    do
      anzcount = min_long(ilen, maxburst)   
      SUB_BEGIN_CRITICAL_SECTION
     
       
      Write_Fast_Bus_LB(array[iindex], anzcount, 64070900h or shift_left(module, 20)) 
      SUB_END_CRITICAL_SECTION
      ilen = ilen - anzcount
      iindex = iindex + anzcount
      istart=istart+anzcount
    until (ilen = 0)
  endif
ENDSUB

'<ENDREGION>
#ELSE
#ERROR("This include file can only be used with the processor T12.")
#ENDIF



